import { SizeStyle } from "./attributors/font-size.es.mjs";
import { FontStyle } from "./attributors/font-style.es.mjs";
import { LineHeightStyle } from "./attributors/line-height.es.mjs";
import { TextIndentStyle } from "./attributors/text-indent.es.mjs";
import FluentEditor from "./core/fluent-editor.es.mjs";
import SoftBreak from "./formats/soft-break.es.mjs";
import StrikeBlot from "./formats/strike.es.mjs";
import Video from "./formats/video.es.mjs";
import Counter from "./modules/counter.es.mjs";
import CustomClipboard from "./modules/custom-clipboard.es.mjs";
import BlotFormatter from "./modules/custom-image/BlotFormatter.es.mjs";
import CustomUploader from "./modules/custom-uploader.es.mjs";
import DividerBlot from "./modules/divider.es.mjs";
import Emoji from "./modules/emoji/index.es.mjs";
import FileModule from "./modules/file/index.es.mjs";
import I18N from "./modules/i18n.es.mjs";
import Link from "./modules/link/index.es.mjs";
import MathliveModule from "./modules/mathlive/index.es.mjs";
import MathliveBlot from "./modules/mathlive/formats.es.mjs";
import Mention from "./modules/mention/Mention.es.mjs";
import CustomSyntax from "./modules/syntax.es.mjs";
import BetterTable from "./modules/table/better-table.es.mjs";
import BetterToolbar from "./modules/toolbar/index.es.mjs";
import SnowTheme from "./themes/snow.es.mjs";
import Icons from "./ui/icons.es.mjs";
FluentEditor.register(
  {
    "formats/emoji": Emoji.EmojiBlot,
    "formats/font": FontStyle,
    "formats/line-height": LineHeightStyle,
    [`formats/${MathliveBlot.blotName}`]: MathliveBlot,
    "formats/size": SizeStyle,
    "formats/softBreak": SoftBreak,
    "formats/strike": StrikeBlot,
    "formats/text-indent": TextIndentStyle,
    "formats/video": Video,
    "modules/clipboard": CustomClipboard,
    "modules/counter": Counter,
    "modules/divider": DividerBlot,
    "modules/emoji-shortname": Emoji.ShortNameEmoji,
    "modules/emoji-toolbar": Emoji.ToolbarEmoji,
    "modules/file": FileModule,
    // 'modules/global-link': GlobalLink, // TODO
    "modules/i18n": I18N,
    "modules/image": BlotFormatter,
    "modules/link": Link,
    "modules/mathlive": MathliveModule,
    "modules/mention": Mention,
    // 'modules/quickmenu': QuickMenu, // TODO
    "modules/syntax": CustomSyntax,
    "modules/toolbar": BetterToolbar,
    "modules/uploader": CustomUploader,
    // make sure register after `HeaderList`
    "modules/better-table": BetterTable,
    "themes/snow": SnowTheme,
    "ui/icons": Icons
  },
  true
  // 覆盖内部模块
);
export {
  FluentEditor as default
};
