import { getColor, codeToRGB } from "../../util/color.mjs";
import chartToken from "./chartToken.mjs";
function handleColor(params, baseOption) {
  handleDepthFirst(params, baseOption);
  handleDepthMore(params, baseOption);
}
var handleDepthFirst = function handleDepthFirst2(params, baseOption) {
  var depthFirst = params.depthFirst, type = params.type;
  var hasRecord = [];
  baseOption.legend.data = [];
  depthFirst.forEach(function(item) {
    if (!baseOption.legend.data.includes(item.type)) {
      var typeColor = getColor(params.color, hasRecord.length);
      baseOption.legend.data.push(item.type);
      hasRecord.push({
        type: item.type,
        color: typeColor
      });
      item.color = typeColor;
      item.borderColor = typeColor;
      if (type === "nested") {
        item.color = codeToRGB(typeColor, 0.2);
      }
    } else {
      hasRecord.forEach(function(record) {
        if (record.type === item.type) {
          item.color = record.color;
        }
      });
    }
  });
};
var handleDepthMore = function handleDepthMore2(params, baseOption) {
  var depthMore = params.depthMore, depthFirst = params.depthFirst;
  baseOption.dataset[0].source.forEach(function(item) {
    item.textColor = chartToken.labelColor;
  });
  if (depthMore && depthMore.length) {
    depthMore.forEach(function(item) {
      depthFirst.forEach(function(parent) {
        if (parent.id === item.id.substring(0, item.id.lastIndexOf("."))) {
          item.color = codeToRGB(parent.borderColor, 0.2);
          item.borderColor = parent.borderColor;
        }
      });
    });
  }
};
export {
  handleColor
};
