import tooltip from "../../option/config/tooltip/index.mjs";
import legend from "../../option/config/legend/index.mjs";
import _defendXSS from "../../util/defendXSS.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
function setLegend(iChartOption) {
  var _iChartOption$legend = iChartOption.legend, itemGap = _iChartOption$legend.itemGap, itemWidth = _iChartOption$legend.itemWidth, itemHeight = _iChartOption$legend.itemHeight;
  var chartLegend = legend(iChartOption);
  chartLegend.itemGap = itemGap !== void 0 ? itemGap : 28;
  chartLegend.itemWidth = itemWidth || 14;
  chartLegend.itemHeight = itemHeight || 14;
  Object.assign(chartLegend, iChartOption.legend);
  return chartLegend;
}
function setTooltip(iChartOption) {
  var tipHtml = iChartOption.tipHtml;
  var formatter;
  if (tipHtml) {
    formatter = tipHtml;
  } else {
    formatter = function formatter2(params) {
      var htmlString = "";
      var bgColor = params.data.borderColor || params.data.color;
      htmlString += '<span style="display:inline-block;margin-right:5px;border-radius:50%;width:10px;height:10px;background-color\n        :' + _defendXSS(bgColor) + ';"></span>' + ('<span style="display:inline-block;margin-left:5px">' + _defendXSS(params.data.type) + "</span>") + "<br/>" + ('<span style="display:inline-block;">' + _defendXSS(params.data.label) + "</span>") + ('<span style="display:inline-block;margin-left:10px;">' + _defendXSS(params.data.value) + "</span>") + "<br/>";
      return htmlString;
    };
  }
  return _extends({}, tooltip(iChartOption, CHART_TYPE.ASSEMBLE_BUBBLE), {
    formatter,
    trigger: "item"
  });
}
export {
  setLegend,
  setTooltip
};
