function handleSeriesData(iChartOption, baseOption) {
  var data = iChartOption.data, type = iChartOption.type;
  if (!data || !data.length) throw new Error("聚合气泡图必须定义data数据");
  if (!type) throw new Error("聚合气泡图必须定义type,值为nested或non-nested或non-nested-aggregate");
  var rootData = [{
    depth: 0,
    id: "option",
    value: 1255,
    type: "",
    label: 0
  }];
  var depthFirst = [];
  var depthMore = [];
  if (data.length) {
    if (type === "non-nested" || type === "non-nested-aggregate") {
      var nurId = 0;
      data.forEach(function(item) {
        nurId++;
        item.depth = 1;
        item.id = "option." + nurId;
        depthFirst.push(item);
      });
      baseOption.dataset[0].source = [].concat(rootData, depthFirst, depthMore);
    } else if (type === "nested") {
      var _nurId2 = 0;
      var _nurId = 0;
      data.forEach(function(item) {
        _nurId2++;
        item.depth = 1;
        item.id = "option." + _nurId2;
        depthFirst.push(item);
        item.children.forEach(function(i) {
          i.type = item.type;
          _nurId++;
          i.depth = 2;
          i.id = item.id + "." + _nurId;
          depthMore.push(i);
        });
      });
      baseOption.dataset[0].source = [].concat(rootData, depthFirst, depthMore);
    }
  }
  return {
    depthFirst,
    depthMore
  };
}
export {
  handleSeriesData
};
