import cloneDeep from "../../util/cloneDeep.mjs";
import BaseOption from "./BaseOption.mjs";
import { setTooltip, setLegend } from "./handleOption.mjs";
import { handleColor } from "./handleColor.mjs";
import { handleRootData } from "./handleRootData.mjs";
import { handleVirtualLengend } from "./handleVirtualLengend.mjs";
import { handleSeriesData } from "./handleSeriesData.mjs";
import { legendDisappear, legendShow } from "./legendSelectChanged.mjs";
import init from "../../option/init/index.mjs";
import { isArray } from "../../util/type.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var AssembleBubbleChart = /* @__PURE__ */ function() {
  function AssembleBubbleChart2(iChartOption, chartInstance, plugins) {
    this.baseOption = cloneDeep(BaseOption);
    this.iChartOption = init(iChartOption);
    this.chartInstance = chartInstance;
    this.plugins = plugins;
    this.updateOption(chartInstance);
  }
  var _proto = AssembleBubbleChart2.prototype;
  _proto.updateOption = function updateOption(chartInstance) {
    var _this$baseOption$seri;
    var d3 = this.plugins.d3;
    if (!d3) throw new Error("您必须安装d3才可以使用聚合气泡图");
    if (!isArray(this.iChartOption.color)) {
      this.iChartOption.color = [this.iChartOption.color];
    }
    var _this$iChartOption = this.iChartOption, color = _this$iChartOption.color, type = _this$iChartOption.type;
    this.baseOption.color = color;
    this.baseOption.tooltip = setTooltip(this.iChartOption);
    this.baseOption.legend = setLegend(this.iChartOption);
    var _handleSeriesData = handleSeriesData(this.iChartOption, this.baseOption), depthFirst = _handleSeriesData.depthFirst, depthMore = _handleSeriesData.depthMore;
    handleColor({
      depthFirst,
      depthMore,
      color,
      type
    }, this.baseOption);
    (_this$baseOption$seri = this.baseOption.series).unshift.apply(_this$baseOption$seri, handleVirtualLengend(this.baseOption.legend.data));
    handleRootData({
      d3,
      baseOption: this.baseOption,
      chartInstance,
      iChartOption: this.iChartOption
    });
    var baseOption = this.baseOption;
    chartInstance.on("legendselectchanged", function(params) {
      if (!params.selected[params.name]) {
        legendDisappear({
          seriesData: baseOption.dataset[0].source,
          params,
          type,
          baseOption,
          chartInstance
        });
      } else {
        handleColor({
          depthFirst,
          depthMore,
          color,
          type
        }, baseOption);
        legendShow({
          seriesData: baseOption.dataset[0].source,
          type,
          params,
          baseOption,
          chartInstance
        });
      }
    });
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption(option) {
    this.baseOption = option;
  };
  return AssembleBubbleChart2;
}();
_defineProperty(AssembleBubbleChart, "name", CHART_TYPE.ASSEMBLE_BUBBLE);
export {
  AssembleBubbleChart as default
};
