import BaseChart from "../BaseChart/index.mjs";
import "../../../../../../echarts@5.4.1/node_modules/echarts/index.mjs";
import "../../../../../../echarts@5.4.1/node_modules/echarts/extension/bmap/bmap.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
import { init } from "../../../../../../echarts@5.4.1/node_modules/echarts/lib/core/echarts.mjs";
function _inheritsLoose(t, o) {
  t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o);
}
function _setPrototypeOf(t, e) {
  return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(t2, e2) {
    return t2.__proto__ = e2, t2;
  }, _setPrototypeOf(t, e);
}
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var mapApiLoaded = false;
var BaiduMapChart = /* @__PURE__ */ function(_BaseChart) {
  function BaiduMapChart2() {
    var _this;
    _this = _BaseChart.call(this) || this;
    _this.echartsIns = null;
    _this.dom = null;
    _this.option = null;
    _this.data = null;
    _this.resizeObserver = null;
    return _this;
  }
  _inheritsLoose(BaiduMapChart2, _BaseChart);
  var _proto = BaiduMapChart2.prototype;
  _proto.init = function init2(dom) {
    this.uninstall();
    this.dom = dom;
  };
  _proto.setSimpleOption = function setSimpleOption(chartName, option) {
    this.option = option;
  };
  _proto.loadMap = function loadMap(_ref) {
    var key = _ref.key, version = _ref.version, url = _ref.url;
    return new Promise(function(resolve) {
      if (mapApiLoaded) {
        resolve(window.BMap);
        return;
      }
      var cbName = "bmap" + Date.now();
      var script = document.createElement("script");
      var ver = version || "2.0";
      window[cbName] = function() {
        mapApiLoaded = true;
        resolve(window.BMap);
      };
      script.src = [url + "?" + ver, "ak=" + key, "callback=" + cbName].join("&");
      document.body.appendChild(script);
    });
  };
  _proto.render = function render() {
    var _this2 = this;
    var url = this.option.url;
    var ver = this.option.v || "2.0";
    var key = this.option.key;
    this.loadMap({
      key,
      version: ver,
      url
    }).then(function() {
      _this2.renderInit();
    });
  };
  _proto.renderInit = function renderInit() {
    this.echartsIns = init(this.dom);
    this.setOption(this.option);
    this.setResizeObserver();
    this.renderCallBack && this.renderCallBack(this.echartsIns);
  };
  _proto.setOption = function setOption(option) {
    this.echartsIns.setOption(option);
  };
  _proto.onRenderReady = function onRenderReady(callback) {
    this.renderCallBack = callback;
  };
  _proto.setResizeObserver = function setResizeObserver() {
    var _this3 = this;
    this.resizeObserver = new ResizeObserver(function(entries) {
      _this3.resizeDom();
    });
    this.resizeObserver.observe(this.dom);
  };
  _proto.resizeDom = function resizeDom() {
    this.echartsIns && this.echartsIns.resize && this.echartsIns.resize();
  };
  _proto.refresh = function refresh(iChartOption) {
    this.iChartOption = iChartOption;
    this.setSimpleOption(this.chartName, iChartOption);
    this.render();
  };
  _proto.refreshData = function refreshData(data) {
    this.iChartOption.series[0].data = data;
    this.refresh(this.iChartOption);
  };
  _proto.setResize = function setResize() {
    this.resizeDom();
  };
  _proto.uninstall = function uninstall() {
    window.removeEventListener("resize", this.throttleResize);
    if (this.resizeObserver) {
      this.resizeObserver.disconnect();
      this.resizeObserver = null;
    }
    this.echartsDisposed();
    this.echartsIns = null;
    this.dom = null;
  };
  _proto.echartsDisposed = function echartsDisposed() {
    if (this.echartsIns && !this.echartsIns.isDisposed()) {
      this.echartsIns.dispose();
    }
  };
  return BaiduMapChart2;
}(BaseChart);
_defineProperty(BaiduMapChart, "name", CHART_TYPE.BAIDU_MAP);
export {
  BaiduMapChart as default
};
