import _defendXSS from "../../util/defendXSS.mjs";
function setDirection(baseOption, direction) {
  if (direction && direction === "horizontal") {
    var temp = baseOption.xAxis;
    baseOption.xAxis = baseOption.yAxis;
    baseOption.yAxis = temp;
  }
}
function tooltipFormatter(params) {
  var data = params.data, color = params.color, seriesType = params.seriesType;
  var labels = ["最大值", "上四分位数", "中位数", "下四分位数", "最小值"];
  var labeLen = labels.length;
  var htmlString = "";
  if (seriesType === "boxplot") {
    var arr = [];
    labels.forEach(function(item, index) {
      htmlString = '<div>\n                            <span style="display:inline-block;width:10px;height:10px;\n                            margin-right:4px;border-radius:5px;border-style: solid;border-width:1px;\n                            border-color:' + _defendXSS(color) + ";background-color:" + _defendXSS(color) + ';"></span>\n                            <span style="display:inline-block;width:90px">' + _defendXSS(item) + ":</span><span>" + _defendXSS(data[labeLen - index]) + "</span>\n                       </div>";
      arr.push(htmlString);
    });
    htmlString = arr.join("<br/>");
  } else {
    htmlString = '<div>\n                            <span style="display:inline-block;width:10px;height:10px;\n                            margin-right:4px;border-radius:5px;border-style: solid;border-width:1px;\n                            border-color:' + _defendXSS(color) + ";background-color:" + _defendXSS(color) + ';"></span>\n                            <span style="display:inline-block;width:90px">离散点</span><span>' + _defendXSS(data[1]) + "</span>\n                       </div>";
  }
  return htmlString;
}
function setTooltip(baseOpt) {
  if (!baseOpt.tooltip.formatter) {
    baseOpt.tooltip.formatter = tooltipFormatter;
  }
}
export {
  setDirection,
  setTooltip
};
