import { changeRgbaOpacity } from "../../util/color.mjs";
import _defendXSS from "../../util/defendXSS.mjs";
function tooltipFormatter(params) {
  var seriesName = params.seriesName;
  var color = params.color;
  var data = params.data;
  var x = data[0], y = data[1], radius = data[2], name = data[3];
  var htmlString = '<div style="margin-bottom:4px;">\n                                ' + _defendXSS(seriesName) + "\n                         </div>";
  htmlString += '<div style="margin-bottom:4px;">\n                            <span style="display:inline-block;width:10px;height:10px;\n                            margin-right:8px;border-radius:5px;border-style: solid;border-width:1px;\n                            border-color:' + _defendXSS(changeRgbaOpacity(color, 1)) + ";background-color:" + _defendXSS(color) + ';"></span>\n                            <span>' + _defendXSS(name) + "</span>\n                       </div>";
  htmlString += '\n            <div>\n                <span style="display:inline-block;margin-right:8px;min-width:60px;">x维度</span> \n                <span>' + _defendXSS(x) + "</span>\n            </div>\n        ";
  htmlString += '\n            <div>\n                <span style="display:inline-block;margin-right:8px;min-width:60px;">y维度</span> \n                <span>' + _defendXSS(y) + "</span>\n            </div>\n        ";
  htmlString += '\n            <div>\n                <span style="display:inline-block;margin-right:8px;min-width:60px;">半径维度</span> \n                <span>' + _defendXSS(radius) + "</span>\n            </div>\n        ";
  return htmlString;
}
function setTooltip(baseOpt, iChartOption) {
  baseOpt.tooltip.trigger = "item";
  if (iChartOption.trigger === "axis") {
    baseOpt.tooltip.trigger = "axis";
    baseOpt.tooltip.axisPointer.type = "shadow";
  }
  if (!baseOpt.tooltip.formatter) {
    baseOpt.tooltip.formatter = tooltipFormatter;
  }
}
export {
  setTooltip
};
