import min from "../../util/sort/min.mjs";
import max from "../../util/sort/max.mjs";
function setVisualMap(baseOption, iChartOption, legendData) {
  var visualMap = [];
  var bubbleSize = iChartOption.bubbleSize || [10, 70];
  var radius = baseOption.dataset[0].source.map(function(item) {
    return item[2];
  });
  var minValue = min(radius);
  var maxValue = max(radius);
  var seriesIndex = new Array(legendData.length).fill(0).map(function(item, index) {
    return index;
  });
  visualMap.push({
    show: false,
    dimension: 2,
    min: minValue,
    max: maxValue,
    seriesIndex,
    inRange: {
      symbolSize: bubbleSize
    }
  });
  return visualMap;
}
function setDataset(baseOption, iChartOption) {
  var source = [];
  Object.keys(iChartOption.data).forEach(function(key) {
    source = source.concat(iChartOption.data[key]);
  });
  return [{
    source
  }];
}
export {
  setDataset,
  setVisualMap
};
