import init from "../../option/init/index.mjs";
import base from "../../option/base/index.mjs";
import cloneDeep from "../../util/cloneDeep.mjs";
import { getLegendData, getXAxisData } from "./handleData.mjs";
import { setSeries, handleSeriesExtra } from "./handleSeries.mjs";
import { setTooltip } from "./handleOptipn.mjs";
import { handleTrendLine } from "./handleTrendLine.mjs";
import { setDataset, setVisualMap } from "./handleVisualMap.mjs";
import RectCoordSys from "../../option/RectSys/index.mjs";
import { mergeSeries, mergeVisualMap } from "../../util/merge.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var BubbleChart = /* @__PURE__ */ function() {
  function BubbleChart2(iChartOption, chartInstance, plugins) {
    this.baseOption = {};
    this.baseOption = cloneDeep(base);
    this.iChartOption = {};
    this.chartInstance = chartInstance;
    this.iChartOption = init(iChartOption);
    this.updateOption(plugins);
  }
  var _proto = BubbleChart2.prototype;
  _proto.updateOption = function updateOption(plugins) {
    var iChartOption = this.iChartOption;
    RectCoordSys(this.baseOption, this.iChartOption, CHART_TYPE.BUBBLE);
    setTooltip(this.baseOption, iChartOption);
    var legendData = getLegendData(iChartOption.data);
    var xAxisType = iChartOption.xAxisType;
    if (legendData && legendData[0] && iChartOption.data[legendData[0]] && iChartOption.data[legendData[0]][0] && iChartOption.data[legendData[0]][0][0] && typeof iChartOption.data[legendData[0]][0][0] === "string") {
      this.baseOption.xAxis.forEach(function(item) {
        item.type = xAxisType || "category";
        item.data = getXAxisData(iChartOption.data);
      });
    } else {
      this.baseOption.xAxis.forEach(function(item) {
        item.type = xAxisType || "value";
      });
    }
    this.baseOption.legend.data = this.baseOption.legend.data || legendData;
    this.baseOption.series = setSeries({
      legendData,
      data: iChartOption.data,
      markLine: iChartOption.markLine,
      color: this.baseOption.color,
      iChartOption
    });
    this.baseOption.dataset = setDataset(this.baseOption, iChartOption);
    this.baseOption.visualMap = setVisualMap(this.baseOption, iChartOption, legendData);
    handleTrendLine(this.baseOption, iChartOption, plugins);
    handleSeriesExtra(this.baseOption, iChartOption);
    mergeSeries(iChartOption, this.baseOption);
    mergeVisualMap(iChartOption, this.baseOption);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  return BubbleChart2;
}();
_defineProperty(BubbleChart, "name", CHART_TYPE.BUBBLE);
export {
  BubbleChart as default
};
