import "../../feature/token/index.mjs";
import _defendXSS from "../../util/defendXSS.mjs";
import "../../util/constants.mjs";
function toolTipFormatter(params) {
  if (params.seriesIndex > 1) {
    return;
  }
  var htmlString = '<div style="margin-bottom:4px;">' + _defendXSS(params.name) + "</div>";
  htmlString += '\n		<div>\n			<span style="display:inline-block;width:10px;height:10px;border-radius:5px;background-color:' + _defendXSS(params.color) + ';">\n			</span>\n			<span style="margin-left:5px;">\n                            <span style="display:inline-block;margin-right:8px;min-width:60px;">' + _defendXSS(params.seriesName) + '</span>\n			<span style="font-weight:bold">\n				' + _defendXSS(params.value) + "\n			</span>\n		</div>\n	";
  return htmlString;
}
function handleTooltip(baseOpts, iChartOpt) {
  var _iChartOpt$tooltip;
  if (!iChartOpt.tipHtml && !(iChartOpt != null && (_iChartOpt$tooltip = iChartOpt.tooltip) != null && _iChartOpt$tooltip.formatter)) {
    baseOpts.tooltip.formatter = toolTipFormatter;
  }
}
function setDirection(baseOption, direction) {
  if (direction && direction === "horizontal") {
    var temp = baseOption.xAxis;
    baseOption.xAxis = baseOption.yAxis;
    baseOption.yAxis = temp;
  }
}
export {
  handleTooltip,
  setDirection
};
