import { handleSeries } from "./handleSeries.mjs";
import init from "../../option/init/index.mjs";
import updateWidth from "./bulletChartOption.mjs";
import { handleTooltip, setDirection } from "./handleOptipn.mjs";
import RectCoordSys from "../../option/RectSys/index.mjs";
import { ADAPTIVE_THEME, CHART_TYPE } from "../../util/constants.mjs";
import xkey from "../../option/config/xAxis/xkey.mjs";
import xdata from "../../option/config/xAxis/xdata.mjs";
import ldata from "../../option/config/legend/ldata.mjs";
import ydata from "../../option/config/yAxis/ydata.mjs";
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var BulletChart = /* @__PURE__ */ function() {
  function BulletChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.iChartOption = {};
    this.iChartOption = init(iChartOption);
    this.chartInstance = chartInstance;
    this.updateOption();
  }
  var _proto = BulletChart2.prototype;
  _proto.updateOption = function updateOption() {
    var iChartOption = this.iChartOption;
    RectCoordSys(this.baseOption, iChartOption, CHART_TYPE.BULLET);
    var xAxisKey = xkey(iChartOption);
    var xAxisData = xdata(iChartOption.data, xAxisKey);
    this.baseOption.xAxis.forEach(function(item) {
      item.data = xAxisData;
    });
    var legendData = ldata(iChartOption.data, xAxisKey);
    var seriesData = ydata(iChartOption.data, legendData);
    handleTooltip(this.baseOption, iChartOption);
    handleSeries(this.baseOption, iChartOption, legendData, seriesData);
    setDirection(this.baseOption, iChartOption.direction);
  };
  _proto.updateOptionAgain = function updateOptionAgain() {
    var baseOption = this.baseOption;
    if (ADAPTIVE_THEME.includes(this.iChartOption.theme)) {
      updateWidth(baseOption, this.chartInstance, this.iChartOption);
    }
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  _proto.resize = function resize(callback) {
    if (ADAPTIVE_THEME.includes(this.iChartOption.theme)) {
      updateWidth(this.baseOption, this.chartInstance, this.iChartOption);
      callback && callback(this.baseOption);
    }
  };
  return BulletChart2;
}();
_defineProperty(BulletChart, "name", CHART_TYPE.BULLET);
export {
  BulletChart as default
};
