import init from "../../option/init/index.mjs";
import RectCoordSys from "../../option/RectSys/index.mjs";
import { handleData, handleGrid, handleAxis, handleTooltip, handleDataZoom, handleLegend, handleAxisPointer } from "./hanleOption.mjs";
import { handleSeries } from "./hanleSeries.mjs";
import { mergeSeries } from "../../util/merge.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var CandlestickChart = /* @__PURE__ */ function() {
  function CandlestickChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.iChartOption = {};
    this.chartInstance = chartInstance;
    this.iChartOption = init(iChartOption);
    this.updateOption();
  }
  var _proto = CandlestickChart2.prototype;
  _proto.updateOption = function updateOption() {
    var iChartOption = this.iChartOption;
    var volume = this.iChartOption.volume;
    var data = handleData(iChartOption);
    if (!data) return;
    handleSeries(this.baseOption, iChartOption, data, this.chartInstance);
    RectCoordSys(this.baseOption, iChartOption);
    handleGrid(this.baseOption, iChartOption);
    handleAxis(this.baseOption, data, volume);
    handleTooltip(this.baseOption, iChartOption);
    handleDataZoom(this.baseOption, iChartOption);
    handleLegend(this.baseOption, iChartOption);
    handleAxisPointer(this.baseOption);
    mergeSeries(iChartOption, this.baseOption);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption(option) {
    this.baseOption = option;
  };
  return CandlestickChart2;
}();
_defineProperty(CandlestickChart, "name", CHART_TYPE.CANDLESTICK);
export {
  CandlestickChart as default
};
