import BaseChart from "../BaseChart/index.mjs";
import NodeManager from "./NodeManager.mjs";
import LineManager from "./LineManager.mjs";
import { initContainer } from "./insert.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
function _inheritsLoose(t, o) {
  t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o);
}
function _setPrototypeOf(t, e) {
  return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(t2, e2) {
    return t2.__proto__ = e2, t2;
  }, _setPrototypeOf(t, e);
}
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var FlowChart = /* @__PURE__ */ function(_BaseChart) {
  function FlowChart2() {
    var _this;
    _this = _BaseChart.call(this) || this;
    _this.dom = void 0;
    _this.data = void 0;
    _this.padding = 30;
    _this.container = void 0;
    _this.svgContainer = void 0;
    _this.htmlContainer = void 0;
    _this.resizeObserver = null;
    _this.draggingNode = {
      node: null,
      nodePosn: null,
      initDisX: 0,
      initDisY: 0
    };
    _this.lineManager = void 0;
    _this.nodeManager = void 0;
    _this.dom = null;
    _this.option = null;
    _this.resizeObserver = null;
    return _this;
  }
  _inheritsLoose(FlowChart2, _BaseChart);
  var _proto = FlowChart2.prototype;
  _proto.init = function init(dom) {
    this.dom = dom;
  };
  _proto.setSimpleOption = function setSimpleOption(name, option) {
    this.option = option;
  };
  _proto.render = function render() {
    var _this2 = this;
    initContainer(this.dom);
    this.container = this.dom.getElementsByClassName("fc-container")[0];
    this.svgContainer = this.dom.getElementsByClassName("fc-line-container")[0];
    this.tagContainer = this.dom.getElementsByClassName("fc-tag-container")[0];
    this.htmlContainer = this.dom.getElementsByClassName("fc-node-container")[0];
    this.containerPosn = this.container.getBoundingClientRect();
    this.resetContainerPosn();
    this.createNodes();
    this.createLines();
    this.setResizeObserver();
    setTimeout(function() {
      _this2.svgContainer.setAttribute("style", "height:" + _this2.container.scrollHeight + "px");
    }, 10);
  };
  _proto.onRenderReady = function onRenderReady(callback) {
    this.renderCallBack = callback;
  };
  _proto.refresh = function refresh(option) {
    this.option = option;
    if (this.resizeObserver) {
      this.resizeObserver.disconnect();
      this.resizeObserver = null;
    }
    this.dom.innerHTML = "";
    this.nodeManager = null;
    this.lineManager = null;
    this.render();
  };
  _proto.refreshData = function refreshData(data) {
    this.option.data = data;
    this.refresh(this.option);
  };
  _proto.setResize = function setResize() {
    if (this.nodeManager && this.lineManager) {
      this.containerPosn = this.container.getBoundingClientRect();
      this.nodeManager.layoutNodes(this.data, this.containerPosn);
      this.lineManager.updateAllLine();
    }
  };
  _proto.createNodes = function createNodes() {
    var _this3 = this;
    this.data = this.option.data;
    this.nodeManager = new NodeManager(this.data, this.option, this.htmlContainer);
    setTimeout(function() {
      _this3.nodeManager.layoutNodes(_this3.data, _this3.containerPosn);
    }, 0);
  };
  _proto.createLines = function createLines() {
    var _this4 = this;
    setTimeout(function() {
      var gContainer = _this4.svgContainer.getElementsByClassName("fc-line-g")[0];
      _this4.lineManager = new LineManager(_this4.data, gContainer, _this4.tagContainer, _this4.containerPosn, _this4.option);
      _this4.renderCallBack && _this4.renderCallBack(_this4);
    }, 10);
  };
  _proto.initEvent = function initEvent() {
    var _this5 = this;
    this.htmlContainer.childNodes.forEach(function(item, index) {
      item.onmousedown = function(mousedownEvent) {
        _this5.containerPosn = _this5.container.getBoundingClientRect();
        item.style.zIndex = 2;
        var itemPosn = item.getBoundingClientRect();
        _this5.draggingNode.node = item;
        _this5.draggingNode.nodePosn = itemPosn;
        _this5.draggingNode.initDisX = mousedownEvent.clientX - itemPosn.left + _this5.containerPosn.left;
        _this5.draggingNode.initDisY = mousedownEvent.clientY - itemPosn.top + _this5.containerPosn.top;
      };
    });
    document.onmousemove = function(mousemoveEvent) {
      if (_this5.draggingNode.node) {
        var moveX = mousemoveEvent.clientX - _this5.draggingNode.initDisX;
        var moveY = mousemoveEvent.clientY - _this5.draggingNode.initDisY;
        if (moveX <= 0) {
          moveX = 0;
        }
        if (moveX + _this5.draggingNode.nodePosn.width >= _this5.containerPosn.width) {
          moveX = _this5.containerPosn.width - _this5.draggingNode.nodePosn.width;
        }
        if (moveY <= 0) {
          moveY = 0;
        }
        if (moveY + _this5.draggingNode.nodePosn.height >= _this5.container.scrollHeight) {
          moveY = _this5.container.scrollHeight - _this5.draggingNode.nodePosn.height;
        }
        _this5.draggingNode.node.style.left = moveX + "px";
        _this5.draggingNode.node.style.top = moveY + "px";
        var domId = _this5.draggingNode.node.id;
        _this5.nodeManager.updateNode(domId, moveX, moveY);
        _this5.lineManager.updateLine(domId);
      }
    };
    document.onmouseup = function(e) {
      if (_this5.draggingNode.node) {
        _this5.draggingNode.node.style.zIndex = 1;
        _this5.draggingNode = {
          initDisX: 0,
          initDisY: 0,
          node: null,
          nodePosn: null
        };
      }
    };
    document.onmouseleave = function(e) {
      if (_this5.draggingNode.node) {
        _this5.draggingNode.node.style.zIndex = 1;
        _this5.draggingNode = {
          node: null,
          nodePosn: null,
          initDisX: 0,
          initDisY: 0
        };
      }
    };
  };
  _proto.setResizeObserver = function setResizeObserver() {
    var _this6 = this;
    this.resizeObserver = new ResizeObserver(function(entries) {
      if (_this6.nodeManager && _this6.lineManager) {
        _this6.containerPosn = _this6.container.getBoundingClientRect();
        _this6.resetContainerPosn();
        _this6.nodeManager.layoutNodes(_this6.data, _this6.containerPosn);
        _this6.lineManager.updateAllLine();
      }
    });
    this.resizeObserver.observe(this.dom);
  };
  _proto.resetContainerPosn = function resetContainerPosn() {
    var transformOption = getComputedStyle(this.dom)["transform"];
    var scaleX = 1;
    var scaleY = 1;
    if (transformOption !== "none") {
      var transfromStr = transformOption.replace("matrix(", "").split(",");
      scaleX = Number(transfromStr[0]);
      scaleY = Number(transfromStr[3]);
    }
    this.containerPosn = _extends({}, this.containerPosn, {
      width: this.containerPosn.width / scaleX,
      height: this.containerPosn.height / scaleY,
      scaleX,
      scaleY
    });
  };
  _proto.destory = function destory() {
    this.resizeObserver.disconnect();
    this.dom.innerHTML = "";
  };
  _proto.uninstall = function uninstall() {
    this.destory();
  };
  return FlowChart2;
}(BaseChart);
_defineProperty(FlowChart, "name", CHART_TYPE.FLOW);
export {
  FlowChart as default
};
