import { appendNode, createEl, className, appendEL } from "./util.mjs";
import TimeLine from "./TimeLine.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var GanttChart = /* @__PURE__ */ function() {
  function GanttChart2() {
    this.container = void 0;
    this.option = void 0;
    this.timeLine = void 0;
  }
  var _proto = GanttChart2.prototype;
  _proto.init = function init(container) {
    this.container = container;
  };
  _proto.setOption = function setOption(option) {
    if (this.container) {
      appendNode(this.container, "");
    }
    this.option = option;
    this.chartWidth = this.container.offsetWidth - 108 - 28;
    this.chartHeight = this.container.offsetHeight - 56;
    this.render();
  };
  _proto.render = function render() {
    var wrapper = createEl("div");
    className(wrapper, "ev_GanttChart_wrapper");
    appendEL(this.container, wrapper);
    this.timeLine = new TimeLine(wrapper, this.option, this.chartWidth, this.chartHeight);
    this.timeLine.init();
  };
  return GanttChart2;
}();
_defineProperty(GanttChart, "name", CHART_TYPE.GANTT);
export {
  GanttChart as default
};
