import "./BaseOption.mjs";
import handleSeries from "./handleSeries.mjs";
import cloneDeep from "../../util/cloneDeep.mjs";
import { handleTooltip } from "./handleOptipn.mjs";
import { mergeSeries } from "../../util/merge.mjs";
import init from "../../option/init/index.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
import base from "../../option/base/index.mjs";
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var GaugeChart = /* @__PURE__ */ function() {
  function GaugeChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.iChartOption = {};
    this.baseOption = cloneDeep(base);
    this.iChartOption = init(iChartOption);
    this.updateOption(iChartOption, chartInstance);
  }
  var _proto = GaugeChart2.prototype;
  _proto.updateOption = function updateOption(iChartOption, chartInstance) {
    this.baseOption.color = iChartOption.color;
    this.baseOption.tooltip = handleTooltip(iChartOption, CHART_TYPE.GAUGE);
    this.baseOption.series = handleSeries(iChartOption, this.baseOption.color);
    this.baseOption.legend.show = false;
    mergeSeries(iChartOption, this.baseOption);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  return GaugeChart2;
}();
_defineProperty(GaugeChart, "name", CHART_TYPE.GAUGE);
export {
  GaugeChart as default
};
