import { lightColor, darkColor, virtualNodeSymbol, lightArrow, darkArrow } from "./BaseOption.mjs";
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var handleCategories = function handleCategories2(iChartOption, baseOption, theme) {
  var baseCategories = [
    // 根节点样式
    {
      symbol: "circle",
      symbolSize: 12,
      itemStyle: {
        color: "#dfba3f"
      }
    },
    // 子节点样式
    {
      symbol: "circle",
      symbolSize: 12,
      itemStyle: {
        color: theme.indexOf("light") !== -1 ? lightColor : darkColor
      }
    },
    // 虚拟节点样式(方形小黄块)
    {
      symbol: virtualNodeSymbol,
      symbolSize: 20,
      // symbol: 'path://M10 10,L20 10,L20 20, L10 20 Z',
      itemStyle: {
        color: "#dfba3f"
      }
    }
  ];
  var iChartCategories = [];
  if (iChartOption.categories && iChartOption.categories.length) {
    iChartOption.categories.forEach(function(item, index) {
      item = Object.assign(baseCategories[index], item);
      iChartCategories.push(item);
    });
  }
  var categories = iChartOption.categories && iChartOption.categories.length ? iChartCategories : baseCategories;
  baseOption.series[0].categories = categories;
};
var handleForce = function handleForce2(iChartOption, baseOption) {
  var baseForce = {
    repulsion: 10,
    gravity: 0.12,
    edgeLength: [16, 28],
    layoutAnimation: false,
    friction: 0.05
  };
  var force = iChartOption.force;
  if (force) {
    baseOption.series[0].force = Object.assign(baseForce, force);
  } else {
    baseOption.series[0].force = _extends({}, baseForce);
  }
};
var handleArrow = function handleArrow2(iChartOption, baseOption, theme) {
  baseOption.series[0].edgeSymbol = iChartOption.edgeSymbol !== void 0 ? iChartOption.edgeSymbol : theme.indexOf("light") !== -1 ? [lightArrow, "none"] : [darkArrow, "none"];
};
var handlePosition = function handlePosition2(iChartOption, baseOption) {
  var chartPosition = iChartOption.chartPosition;
  if (chartPosition && chartPosition.length) {
    switch (chartPosition.length) {
      case 1:
        baseOption.series[0].top = iChartOption.chartPosition[0];
        baseOption.series[0].left = iChartOption.chartPosition[0];
        break;
      case 2:
        baseOption.series[0].top = iChartOption.chartPosition[0];
        baseOption.series[0].left = iChartOption.chartPosition[1];
        break;
    }
  } else {
    chartPosition = ["center", "center"];
    baseOption.series[0].top = chartPosition[0];
    baseOption.series[0].left = chartPosition[1];
  }
};
var handleLineStyle = function handleLineStyle2(iChartOption, baseOption, theme) {
  var baseLineStyle = {
    width: 1,
    type: "solid",
    color: theme.indexOf("light") !== -1 ? lightColor : darkColor,
    opacity: 1
  };
  var lineStyle = iChartOption.lineStyle;
  if (lineStyle) {
    baseOption.series[0].lineStyle = Object.assign(baseLineStyle, lineStyle);
  } else {
    baseOption.series[0].lineStyle = _extends({}, baseLineStyle);
  }
};
export {
  handleArrow,
  handleCategories,
  handleForce,
  handleLineStyle,
  handlePosition
};
