import init from "../../option/init/index.mjs";
import { BaseOption } from "./BaseOption.mjs";
import cloneDeep from "../../util/cloneDeep.mjs";
import { handleData, updateData } from "./handleData.mjs";
import { handleCategories, handleForce, handleArrow, handlePosition, handleLineStyle } from "./handleOption.mjs";
import { mixTree } from "./mixTree.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var GraphTreeChart = /* @__PURE__ */ function() {
  function GraphTreeChart2(iChartOption, chartInstance) {
    this.rootData = {};
    this.baseOption = cloneDeep(BaseOption);
    this.iChartOption = init(iChartOption);
    this.updateOption(iChartOption, chartInstance);
  }
  var _proto = GraphTreeChart2.prototype;
  _proto.updateOption = function updateOption(iChartOption, chartInstance) {
    var theme = iChartOption.theme || "light";
    handleCategories(iChartOption, this.baseOption, theme);
    var _handleData = handleData(iChartOption.data, this.baseOption), rootData = _handleData.rootData;
    this.rootData = _extends({}, rootData);
    handleForce(iChartOption, this.baseOption);
    handleArrow(iChartOption, this.baseOption, theme);
    handlePosition(iChartOption, this.baseOption);
    handleLineStyle(iChartOption, this.baseOption, theme);
    mixTree(this, chartInstance, this.baseOption);
  };
  _proto.updateNodesData = function updateNodesData(positionArr, idArr) {
    updateData(this.rootData, this.baseOption, positionArr, idArr);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  return GraphTreeChart2;
}();
_defineProperty(GraphTreeChart, "name", CHART_TYPE.GRAPH_TREE);
export {
  GraphTreeChart as default
};
