import min from "../../util/sort/min.mjs";
import max from "../../util/sort/max.mjs";
import { CHARTTYPE } from "./BaseOption.mjs";
import merge from "../../util/merge.mjs";
import visualMap from "../../option/config/visualMap/index.mjs";
function handleCalendar(iChartOption, visualUnit, maxValue, minValue, visualType) {
  visualUnit.show = !!iChartOption.handle;
  if (visualType === "continuous") visualUnit.itemHeight = 400;
  visualUnit.text = [maxValue, minValue];
  visualUnit.right = "4%";
  visualUnit.bottom = "6%";
  if (iChartOption.handle) {
    merge(visualUnit, iChartOption.handle);
    if (iChartOption.handle.width) {
      visualUnit.itemWidth = iChartOption.handle.width;
      delete visualUnit.width;
    }
    if (iChartOption.handle.height) {
      visualUnit.itemHeight = iChartOption.handle.height;
      delete visualUnit.height;
    }
    if (iChartOption.handle.position) {
      merge(visualUnit, iChartOption.handle.position);
      delete visualUnit.position;
    }
  }
  visualUnit.inRange = !iChartOption.changeProperty || iChartOption.changeProperty === "opcity" ? {
    opacity: [0, 1]
  } : {
    color: iChartOption.color
  };
}
function getVisualType(iChartOption) {
  var _ref, _handle$type;
  var visualMap2 = iChartOption.visualMap, handle = iChartOption.handle;
  var type = (_ref = (_handle$type = handle == null ? void 0 : handle.type) != null ? _handle$type : visualMap2 == null ? void 0 : visualMap2.type) != null ? _ref : "continuous";
  return type;
}
function setVisualMap(baseOpt, type, data, iChartOption) {
  var baseVisualMap = [];
  var visualType = getVisualType(iChartOption);
  var visualUnit = visualMap(visualType);
  var intervalData = {
    RectangularHeatMapChart: data,
    CalendarHeatMapChart: data[2],
    HexagonHeatMapChart: data[0]
  };
  var intervalArr = intervalData[type].map(function(item) {
    return item[2];
  });
  var minValue = min(intervalArr);
  var maxValue = max(intervalArr);
  visualUnit.min = minValue;
  visualUnit.max = maxValue;
  visualUnit.dimension = 2;
  if (type === CHARTTYPE[0]) {
    visualUnit.inRange = {
      colorAlpha: [0, 1]
    };
  }
  if (type === CHARTTYPE[1]) {
    handleCalendar(iChartOption, visualUnit, maxValue, minValue, visualType);
  }
  if (type === CHARTTYPE[2]) {
    visualUnit.inRange = {
      color: iChartOption.color
    };
  }
  if (iChartOption.visualMap) {
    merge(visualUnit, iChartOption.visualMap);
  }
  baseVisualMap.push(visualUnit);
  baseOpt.visualMap = baseVisualMap;
}
export {
  setVisualMap
};
