import getBaseOption from "./baseOption.mjs";
import { handleData, handleColor, handleText, handlePadding, handleCoincide, setGradientColor, handleMarkLine } from "./handleOption.mjs";
import { handleEmphasis } from "./handleSeries.mjs";
import init from "../../option/init/index.mjs";
import title from "../../option/config/rectTitle/index.mjs";
import tooltip from "../../option/config/tooltip/index.mjs";
import xAxis from "../../option/config/xAxis/index.mjs";
import yAxis from "../../option/config/yAxis/index.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var HillChart = /* @__PURE__ */ function() {
  function HillChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.iChartOption = {};
    this.baseOption = getBaseOption();
    this.iChartOption = init(iChartOption);
    this.updateOption(iChartOption, chartInstance);
  }
  var _proto = HillChart2.prototype;
  _proto.updateOption = function updateOption(iChartOption, chartInstance) {
    this.baseOption.xAxis = xAxis(iChartOption)[0];
    if (iChartOption.axis && iChartOption.axis.show) {
      this.baseOption.yAxis = yAxis(this.baseOption, iChartOption, CHART_TYPE.HILL);
    } else {
      this.baseOption.xAxis["axisLine"] = {
        show: false
      };
      this.baseOption.xAxis["axisTick"] = {
        show: false
      };
      this.baseOption.yAxis.show = false;
      this.baseOption.title = title(iChartOption, CHART_TYPE.HILL, iChartOption.yAxis && iChartOption.yAxis.nameTextStyle);
    }
    handleData(iChartOption, this.baseOption);
    handleColor(iChartOption, this.baseOption);
    handleText(iChartOption, this.baseOption);
    handlePadding(iChartOption, this.baseOption);
    handleCoincide(iChartOption, this.baseOption);
    this.baseOption.tooltip = tooltip(iChartOption, CHART_TYPE.HILL);
    this.baseOption.tooltip.trigger = "item";
    setGradientColor(this.baseOption, iChartOption.color, iChartOption.gradientColor, iChartOption.opacity, iChartOption);
    handleMarkLine(this.baseOption, iChartOption);
    handleEmphasis(this.baseOption, iChartOption);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  return HillChart2;
}();
_defineProperty(HillChart, "name", CHART_TYPE.HILL);
export {
  HillChart as default
};
