import init from "../../option/init/index.mjs";
import BaseOption from "./BaseOption.mjs";
import cloneDeep from "../../util/cloneDeep.mjs";
import { setSeriesData } from "./handleSeries.mjs";
import { handleLabelFormatter } from "./labelFormatter.mjs";
import PolarCoordSys from "../../option/PolarSys/index.mjs";
import { setbarWidth, setStartAngle, handleLegendData } from "./handleOption.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var JadeJueChart = /* @__PURE__ */ function() {
  function JadeJueChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.iChartOption = {};
    this.baseOption = cloneDeep(BaseOption);
    this.iChartOption = init(iChartOption);
    this.updateOption(chartInstance);
  }
  var _proto = JadeJueChart2.prototype;
  _proto.updateOption = function updateOption(chartInstance) {
    var iChartOption = this.iChartOption;
    iChartOption.position = iChartOption.position || iChartOption.chartPosition;
    iChartOption.max = iChartOption.max || iChartOption.calibrationValue;
    PolarCoordSys(this.baseOption, iChartOption, CHART_TYPE.JADGEJUE);
    handleLabelFormatter(iChartOption, this.baseOption);
    setSeriesData(iChartOption, this.baseOption);
    setbarWidth(iChartOption, this.baseOption);
    setStartAngle(iChartOption, this.baseOption);
    handleLegendData(iChartOption, this.baseOption);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  return JadeJueChart2;
}();
_defineProperty(JadeJueChart, "name", CHART_TYPE.JADGEJUE);
export {
  JadeJueChart as default
};
