var setChildMax = function setChildMax2(data, max) {
  data.forEach(function(dataItem) {
    if (dataItem.children) {
      dataItem.children.forEach(function(child) {
        child.max = max;
      });
    } else {
      dataItem.max = max;
    }
  });
};
var setNoChildDefaultMax = function setNoChildDefaultMax2(data, angleAxis, fill) {
  data.forEach(function(dataItem) {
    if (!dataItem.children) {
      var sum = 0;
      data.forEach(function(item) {
        sum += item.value;
      });
      if (sum === 0) {
        sum = 1;
      }
      angleAxis.max = sum * 4 / 3;
      angleAxis.sum = sum;
      if (fill) {
        angleAxis.max = sum;
      }
    }
  });
};
var setChildDefaultMax = function setChildDefaultMax2(data, angleAxis, fill) {
  data.forEach(function(dataItem) {
    if (dataItem.children) {
      var sum = 0;
      data.forEach(function(item) {
        item.children.forEach(function(item_) {
          sum += item_.value;
        });
      });
      if (sum === 0) {
        sum = 1;
      }
      angleAxis.sum = sum;
      angleAxis.max = sum * 4 / 3;
      if (fill) {
        angleAxis.max = sum;
      }
    }
  });
};
var setAxisLabel = function setAxisLabel2(sum, iChartOption, baseOpt) {
  if (iChartOption.max) {
    baseOpt.angleAxis.sum = iChartOption.max;
    var formatter = function formatter2(params) {
      if (params === iChartOption.max) {
        return "100%";
      }
      if (params / iChartOption.max * 100 > 100) {
        return "";
      }
      var x = Math.ceil(params / iChartOption.max * 100);
      return Math.ceil(x / 10) * 10 + "%";
    };
    return formatter;
  } else {
    var _formatter = function _formatter2(params) {
      if (params === sum) {
        return "100%";
      }
      if (params / sum * 100 > 100) {
        return "";
      }
      var x = Math.ceil(params / sum * 100);
      return Math.ceil(x / 10) * 10 + "%";
    };
    return _formatter;
  }
};
var handleLabelFormatter = function handleLabelFormatter2(iChartOption, baseOpt) {
  var max = iChartOption.max, data = iChartOption.data, _iChartOption$fill = iChartOption.fill, fill = _iChartOption$fill === void 0 ? false : _iChartOption$fill, _iChartOption$type = iChartOption.type, type = _iChartOption$type === void 0 ? "base" : _iChartOption$type;
  var angleAxis = baseOpt.angleAxis;
  if (type === "process") {
    fill = true;
  }
  if (max) {
    angleAxis.sum = max;
    angleAxis.max = max * 4 / 3;
    setChildMax(data, max);
    if (fill) {
      angleAxis.max = max;
    }
  } else {
    if (type === "process") {
      angleAxis.max = 100;
      angleAxis.sum = 100;
    } else if (type === "base") {
      setNoChildDefaultMax(data, angleAxis, fill);
    } else {
      setChildDefaultMax(data, angleAxis, fill);
    }
  }
  var formatter = angleAxis.axisLabel.formatter;
  switch (formatter) {
    case "percent":
      formatter = setAxisLabel(angleAxis.sum, iChartOption, baseOpt);
      break;
    case "number":
      formatter = void 0;
      break;
    case void 0:
      formatter = setAxisLabel(angleAxis.sum, iChartOption, baseOpt);
      break;
  }
  if (type === "process") {
    angleAxis.axisLabel.show = false;
    return;
  }
  angleAxis.axisLabel.formatter = formatter;
  angleAxis.axisTick.show = true;
};
export {
  handleLabelFormatter
};
