import "../../../../../../../echarts@5.4.1/node_modules/echarts/index.mjs";
import max from "../../../util/sort/max.mjs";
import { isNumber } from "../../../util/type.mjs";
import { getColor, codeToRGB } from "../../../util/color.mjs";
import chartToken from "./chartToken.mjs";
import Theme from "../../../feature/token/index.mjs";
import LinearGradient from "../../../../../../../zrender@5.4.1/node_modules/zrender/lib/graphic/LinearGradient.mjs";
function markLineArea(baseOption, iChartOption, YAxiMin) {
  if (iChartOption.area && iChartOption.markLine && iChartOption.markLine.top && isNumber(iChartOption.markLine.top) && iChartOption.markLine.topChangeColor !== false) {
    var colors = baseOption.color;
    var markLine = iChartOption.markLine;
    var topColor = codeToRGB(markLine.topColor, 0.15) || codeToRGB(Theme.config.colorState.colorError, 0.15);
    baseOption.series.forEach(function(item, index) {
      var maxValue = max(item.data);
      var color = getColor(colors, index);
      var colorTo = codeToRGB(color, 0);
      var colorFrom = codeToRGB(color, 0.15);
      var percent = (maxValue - markLine.top) / (maxValue - YAxiMin);
      if (maxValue > markLine.top) {
        item.areaStyle = {
          color: {
            type: "linear",
            x: 0,
            y: 0,
            x2: 0,
            y2: 1,
            colorStops: [{
              offset: 0,
              color: topColor
            }, {
              offset: percent,
              color: topColor
            }, {
              offset: percent + 1e-5,
              color: colorFrom
            }, {
              offset: 1,
              color: colorTo
            }]
          }
        };
      }
    });
  }
}
function defaultArea(baseOption, iChartOption, YAxiMin) {
  if (iChartOption.area) {
    var colors = baseOption.color;
    baseOption.series.forEach(function(item, index$1) {
      var color = getColor(colors, index$1);
      var colorTo = codeToRGB(color, 0);
      var colorFrom = codeToRGB(color, 0.15);
      item.areaStyle = {
        opacity: 1,
        color: new LinearGradient(0, 0, 0, 1, [{
          offset: 0,
          color: colorFrom
        }, {
          offset: 1,
          color: colorTo
        }])
      };
    });
  }
}
function splitArea(baseOption, iChartOption, YAxiMin) {
  if (iChartOption.area && iChartOption.splitLine) {
    var colors = baseOption.color;
    var splitLine = iChartOption.splitLine;
    baseOption.series.forEach(function(item, index) {
      var maxValue = max(item.data);
      var color = getColor(colors, index);
      var colorTo = codeToRGB(color, 0.15);
      var colorFrom = codeToRGB(color, 0.15);
      var percent = (maxValue - splitLine) / (maxValue - YAxiMin);
      item.areaStyle = {
        color: {
          type: "linear",
          x: 0,
          y: 0,
          x2: 0,
          y2: 1,
          colorStops: [{
            offset: 0,
            color: colorFrom
          }, {
            offset: percent,
            color: colorTo
          }, {
            offset: percent + 1e-5,
            color: chartToken.colorAreaTP
          }, {
            offset: 1,
            color: chartToken.colorAreaTP
          }]
        }
      };
    });
  }
}
function topArea(baseOption, iChartOption, YAxiMin) {
  defaultArea(baseOption, iChartOption);
  markLineArea(baseOption, iChartOption, YAxiMin);
  splitArea(baseOption, iChartOption, YAxiMin);
}
export {
  topArea as default
};
