import Layout from "./Layout.mjs";
import { insertIcon } from "./insertIcon.mjs";
import _defendXSS from "../../util/defendXSS.mjs";
import tips from "../../util/tips.mjs";
import { insertSvg } from "./insertSvg.mjs";
var NodeManager = /* @__PURE__ */ function() {
  function NodeManager2(data, option, container) {
    this.data = void 0;
    this.layoutNodes = void 0;
    this.dom = void 0;
    this.scaleCon = null;
    this.NODE_ID_PREFIX = "mc-node-";
    this.defaultColor = "#F3F3F3";
    this.option = option;
    this.dom = container;
    this.render = option.render;
  }
  var _proto = NodeManager2.prototype;
  _proto.create = function create(data, option, Theme) {
    this.option.Theme = Theme;
    this.scaleCon = this.dom.getElementsByClassName("mc-scales")[0];
    this.layoutNodes = new Layout(data, option, this.dom);
    this.createNodes(this.option, this.scaleCon);
    if (this.option.assign == "date") {
      this.option = this.layoutNodes.computePositions(this.option);
    } else {
      this.option = this.layoutNodes.computeAveragePositions(this.option);
    }
    this.layoutNodes.setTipsPosition(this.option);
    if (this.option.current) this.createCurrentNode(this.option.current, this.dom.getElementsByClassName("mc-current")[0]);
  };
  _proto.createTooltipDom = function createTooltipDom(nodeDom, data) {
    var tooltipDom = document.createElement("div");
    tooltipDom.classList.add("mc-scales-item-tooltip");
    if (this.option.tooltip) {
      this.option.tooltip(tooltipDom, data);
    } else {
      var date = new Date(data.date * 1e3);
      var year = date.getFullYear();
      var month = date.getMonth() + 1;
      var day = date.getDate();
      tooltipDom.textContent = year + "/" + month + "/" + day;
    }
    nodeDom.appendChild(tooltipDom);
  };
  _proto.createNode = function createNode(ndata, nextData, size) {
    var _nodeDom$classList;
    var id = ndata.id, render = ndata.render, date = ndata.date, icon = ndata.icon;
    ndata.tilte;
    var tooltip = ndata.tooltip, prompt = ndata.prompt, promptIcon = ndata.promptIcon;
    if (!date) tips.error("The second parameter date is required");
    this.getDefBg(ndata, this.option.Theme);
    var nodeDom = document.createElement("div");
    var lineBg = _defendXSS(nextData && nextData.line && (nextData.line.color || nextData.line.defColor) || ndata.line.defColor);
    var lineHeight = _defendXSS(nextData && nextData.line && nextData.line.height || ndata.line && ndata.line.height || 8);
    var classList = [];
    var tooltipClass = tooltip && tooltip.show ? "tooltip" : "";
    var firstLine = "";
    size = size > 48 ? 48 : size;
    if (this.option.data && this.option.data.length === 1) {
      ndata.width = this.dom.offsetWidth - 40;
      lineBg = _defendXSS(ndata.line.color || ndata.line.defColor);
      firstLine = "block";
    }
    nodeDom.innerHTML = '<div class="mc-scales-item-line" style="background:' + lineBg + ";height:" + lineHeight + "px;width: " + _defendXSS(ndata.width || ndata.tipsWidth) + "px;display:" + firstLine + `"></div>
                         <div class='mc-scales-item-icon ` + tooltipClass + `' style="width:` + _defendXSS(size) + "px;height:" + _defendXSS(size) + 'px;">\n                         </div>';
    nodeDom.style.left = ndata.x + "px";
    classList.push("mc-scales-item");
    if (icon && icon.name) classList.push(icon.name);
    if (ndata.position) classList.push(ndata.position);
    if (this.option.line) classList.push("line");
    (_nodeDom$classList = nodeDom.classList).add.apply(_nodeDom$classList, classList);
    nodeDom.id = this.NODE_ID_PREFIX + id;
    var iconDom = nodeDom.getElementsByClassName("mc-scales-item-icon")[0];
    insertSvg(iconDom, {
      theme: this.option.theme,
      icon
    }, this.option.Theme);
    if (prompt) {
      var promptDom = document.createElement("img");
      promptDom.classList.add("prompt");
      promptDom.src = promptIcon ? promptIcon : insertIcon("prompt");
      iconDom.appendChild(promptDom);
    }
    if (tooltip && tooltip.show) {
      this.createTooltipDom(nodeDom, ndata);
    }
    var renderFun = render || this.render;
    var tipsDom = this.createTips(renderFun, ndata);
    tipsDom && nodeDom.appendChild(tipsDom);
    return nodeDom;
  };
  _proto.getDefBg = function getDefBg(data, Theme) {
    var color = "";
    var name = data.icon.name || "";
    switch (name) {
      case "success":
        color = Theme.config.colorState.colorSuccess;
        break;
      case "done":
        color = Theme.config.colorState.colorSuccess;
        break;
      case "doing":
        color = Theme.config.colorState.colorInfo;
        break;
      case "todo":
        color = Theme.config.colorState.colorNone;
        break;
      default:
        color = Theme.config.colorState.colorNone;
        break;
    }
    if (!data.line) data.line = {};
    data.line.defColor = color;
    data.icon.defColor = color;
  };
  _proto.createTips = function createTips(renderFun, ndata) {
    var tipsDom = document.createElement("div");
    tipsDom.style["border-color"] = ndata.line && (ndata.icon.color || ndata.icon.defColor) || this.defaultColor;
    tipsDom.classList.add("mc-scales-item-tips");
    tipsDom.style["max-width"] = (ndata.width || ndata.tipsWidth) + "px";
    if (renderFun) {
      renderFun(tipsDom, ndata);
      this.createTipsDom(tipsDom, ndata);
    } else {
      var date = new Date(ndata.date * 1e3);
      var year = date.getFullYear();
      var month = date.getMonth() + 1;
      var day = date.getDate();
      tipsDom.textContent = year + "/" + month + "/" + day;
      this.createTipsDom(tipsDom, ndata);
    }
    return tipsDom;
  };
  _proto.createTipsDom = function createTipsDom(tipsDom, data) {
    var cloneNode = tipsDom.cloneNode(true);
    cloneNode.style.opacity = 0;
    document.body.appendChild(cloneNode);
    var prevWidth = cloneNode.offsetWidth;
    document.body.removeChild(cloneNode);
    data.tipsWidth = prevWidth;
    return tipsDom;
  };
  _proto.createNodes = function createNodes(option, scaleCon) {
    var _this = this;
    var self = this;
    option.data.forEach(function(node, index) {
      var nodeDom = _this.createNode(node, option.data[index + 1], node.icon && node.icon.size || option.itemStyle && option.itemStyle.iconSize || 12);
      node.dom = nodeDom;
      scaleCon.appendChild(nodeDom);
    });
    this.initHoverEvent();
    this.initItemClickEvent();
    setTimeout(function() {
      self.setActions();
    }, 100);
  };
  _proto.setActions = function setActions() {
    var domWidth = this.dom.offsetWidth;
    var contentWidth = this.dom.scrollWidth;
    if (domWidth < contentWidth) {
      var prevDom = this.dom.getElementsByClassName("mc-btn-prev")[0];
      var nextDom = this.dom.getElementsByClassName("mc-btn-next")[0];
      prevDom.style.display = "block";
      nextDom.style.display = "block";
      this.initHandoffEvent();
    }
  };
  _proto.createCurrentNode = function createCurrentNode(current, dom) {
    var className = "top";
    var data = this.option.data;
    data.forEach(function(item, index) {
      var prev = data[index - 1];
      var tipsWidth = item.dom && item.dom.getElementsByClassName("mc-scales-item-tips")[0].scrollWidth || 0;
      var prevTipsWidth = prev && prev.dom.getElementsByClassName("mc-scales-item-tips")[0].scrollWidth || 0;
      var itemPos = item.position.split("-");
      var prevPos = prev && prev.position.split("-") || "";
      if (current.x === item.x) {
        if (itemPos[0] === "up") {
          className = "bottom";
        }
      } else if (prev && prev.x < current.x && current.x < item.x) {
        if (prevPos[0] === "up" && current.x < prev.x + prevTipsWidth) {
          className = "bottom";
        }
        if (itemPos[0] === "up" && current.x > item.x - tipsWidth) {
          className = "bottom";
        }
      }
    });
    dom.classList.add(className);
    dom.getElementsByClassName("mc-current-text")[0].textContent = current.tip;
    dom.style.left = current.x + "px";
    if (current.x == void 0) {
      dom.style.display = "none";
    }
    insertSvg(dom, {
      theme: this.option.theme,
      icon: {
        src: current.icon || "",
        name: "current"
      }
    }, this.option.Theme);
  };
  _proto.initHoverEvent = function initHoverEvent() {
    var elements = this.scaleCon.getElementsByClassName("tooltip");
    Array.prototype.forEach.call(elements, function(element) {
      element.addEventListener("mouseover", function() {
        var parentNode = element.parentNode;
        var tooltipDom = parentNode.getElementsByClassName("mc-scales-item-tooltip")[0];
        tooltipDom.style.display = "block";
        element.style.zIndex = 2;
        var x = parentNode.offsetLeft;
        tooltipDom.style.left = "-" + (x - tooltipDom.offsetWidth / 2 >= 0 ? tooltipDom.offsetWidth / 2 : 0) + "px";
        tooltipDom.style.top = "calc(50% - " + (tooltipDom.offsetHeight / 2 + 24) + "px)";
      });
      element.addEventListener("mouseout", function() {
        var parentNode = element.parentNode;
        var tooltipDom = parentNode.getElementsByClassName("mc-scales-item-tooltip")[0];
        tooltipDom.style.display = "none";
      });
    });
  };
  _proto.initItemClickEvent = function initItemClickEvent() {
    var elements = this.scaleCon.getElementsByClassName("mc-scales-item");
    var onClick = this.option.onClick && this.option.onClick;
    this.option.data.forEach(function(item, index) {
      elements[index].addEventListener("click", function() {
        onClick(elements[index], item);
      });
    });
  };
  _proto.initHandoffEvent = function initHandoffEvent() {
    var position = 0;
    var prev = false;
    var next = true;
    var num = this.option.newPitch;
    var alignment = this.option.alignment;
    num = alignment === "left" ? 30 : alignment === "right" ? num[0] + 10 : num;
    var domWidth = this.dom.offsetWidth;
    var contentWidth = this.dom.getElementsByClassName("mc-content")[0].scrollWidth;
    var contentDom = this.dom.getElementsByClassName("mc-content")[0];
    var prevDom = this.dom.getElementsByClassName("mc-btn-prev")[0];
    var nextDom = this.dom.getElementsByClassName("mc-btn-next")[0];
    prevDom.onmousedown = function() {
      if (!prev) return;
      next = true;
      position -= 0.5;
      var left = position * domWidth;
      var newnum = alignment == "center" ? num[0] : num;
      if (left <= newnum) {
        left = 0;
        position = 0;
        prev = false;
      }
      contentDom.style.left = -left + "px";
    };
    nextDom.onmousedown = function() {
      if (!next) return;
      prev = true;
      position += 0.5;
      var left = position * domWidth;
      var newnum = alignment == "center" ? num[1] : num;
      if (domWidth + left > contentWidth) {
        left = contentWidth - domWidth + newnum;
        next = false;
      }
      contentDom.style.left = -left + "px";
    };
  };
  return NodeManager2;
}();
export {
  NodeManager as default
};
