import BaseChart from "../BaseChart/index.mjs";
import NodeManager from "./Node.mjs";
import { initContainer } from "./insertDom.mjs";
import Theme from "../../feature/token/index.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _inheritsLoose(t, o) {
  t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o);
}
function _setPrototypeOf(t, e) {
  return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(t2, e2) {
    return t2.__proto__ = e2, t2;
  }, _setPrototypeOf(t, e);
}
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var MilestoneChart = /* @__PURE__ */ function(_BaseChart) {
  function MilestoneChart2() {
    var _this;
    _this = _BaseChart.call(this) || this;
    _this.dom = void 0;
    _this.data = void 0;
    _this.Node = void 0;
    _this.dom = null;
    _this.option = null;
    _this.resizeObserver = null;
    return _this;
  }
  _inheritsLoose(MilestoneChart2, _BaseChart);
  var _proto = MilestoneChart2.prototype;
  _proto.init = function init(dom) {
    this.dom = dom;
  };
  _proto.setSimpleOption = function setSimpleOption(chartName, option) {
    this.option = option;
  };
  _proto.render = function render() {
    this.createDom();
    this.setResizeObserver();
  };
  _proto.onRenderReady = function onRenderReady(callback) {
    this.renderCallBack = callback;
  };
  _proto.createDom = function createDom() {
    this.dom.innerHTML = "";
    initContainer(this.dom, this.option);
    this.data = this.option.data;
    var container = this.dom.getElementsByClassName("mc-container")[0];
    this.Node = new NodeManager(this.data, this.option, container);
    this.Node.create(this.data, this.option, Theme);
    container.style.setProperty("--operationButtonBgColor", Theme.config.colorBoard.blue.colorBlue50);
    container.style.setProperty("--tooltipBgColor", Theme.config.tooltipBg);
    container.style.setProperty("--tooltipBoxShadow", "0 " + Theme.config.tooltipShadowOffsetY + "px " + Theme.config.tooltipShadowBlur + "px 0 " + Theme.config.tooltipShadowColor);
    container.style.setProperty("--currentTextColor", Theme.config.titleTextColor);
    container.style.setProperty("--newPitch", this.option.padding || "0, 20px");
    container.style.setProperty("--maxWidth", this.option.itemStyle.maxWidth + "px" || "160px");
    container.style.setProperty("--maxHeight", this.option.itemStyle.maxHeight + "px" || "120px");
    this.renderCallBack && this.renderCallBack(this);
  };
  _proto.refresh = function refresh(option) {
    this.option = option;
    this.createDom();
  };
  _proto.refreshData = function refreshData() {
    this.createDom();
  };
  _proto.setResize = function setResize() {
    this.createDom();
  };
  _proto.setResizeObserver = function setResizeObserver() {
    var _this2 = this;
    this.resizeObserver = new ResizeObserver(function(entries) {
      _this2.setResize();
    });
    this.resizeObserver.observe(this.dom);
  };
  _proto.uninstall = function uninstall() {
    if (this.resizeObserver) {
      this.resizeObserver.disconnect();
      this.resizeObserver = null;
    }
    this.dom.innerHTML = "";
  };
  return MilestoneChart2;
}(BaseChart);
_defineProperty(MilestoneChart, "name", CHART_TYPE.MILESTONE);
export {
  MilestoneChart as default
};
