import _defendXSS from "../../util/defendXSS.mjs";
function getSeriesData(data, type) {
  var seriesData = [];
  if (type === "normal") {
    data.forEach(function(item, i) {
      seriesData[i] = [];
      for (var j = 0; j < data.length; j++) {
        if (i == j) {
          seriesData[i][j] = item.value;
        } else {
          seriesData[i][j] = 0;
        }
      }
    });
  } else {
    data.forEach(function(item) {
      seriesData.push(item.value);
    });
  }
  return seriesData;
}
function angleText(i, num) {
  var everyAngle = 360 / num;
  var currentAngle = i * everyAngle + everyAngle / 2;
  if (currentAngle >= 90 && currentAngle <= 270) {
    return 180 - currentAngle;
  } else {
    return 360 - currentAngle;
  }
}
function getLabelData(data) {
  var labelData = [];
  var length = data.length;
  data.forEach(function(item, i) {
    var obj = {
      name: item.name + " ",
      value: 1,
      label: {
        rotate: angleText(i, length)
      }
    };
    labelData.push(obj);
  });
  return labelData;
}
function tooltipFormatter(params) {
  var seriesName = params.name;
  var color = params.color;
  var value = params.value;
  var htmlString = '<div>\n                            <span style="display:inline-block;width:10px;height:10px;\n                            margin-right:8px;border-radius:5px;border-style: solid;border-width:1px;\n                            border-color:' + _defendXSS(color) + ";background-color:" + _defendXSS(color) + ';"></span>\n                            <span style="margin-right:16px">' + _defendXSS(seriesName) + "</span>\n                            <span>" + _defendXSS(value) + "</span>\n                       </div>";
  return htmlString;
}
function setTooltip(baseOpt) {
  if (!baseOpt.tooltip.formatter) {
    baseOpt.tooltip.formatter = tooltipFormatter;
  }
}
export {
  getLabelData,
  getSeriesData,
  setTooltip
};
