import init from "../../option/init/index.mjs";
import { setTooltip, getSeriesData, getLabelData } from "./handleOption.mjs";
import { setSeries } from "./handleSeries.mjs";
import PolarCoordSys from "../../option/PolarSys/index.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var PolarBarChart = /* @__PURE__ */ function() {
  function PolarBarChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.iChartOption = {};
    this.iChartOption = init(iChartOption);
    this.updateOption(chartInstance);
  }
  var _proto = PolarBarChart2.prototype;
  _proto.updateOption = function updateOption(chartInstance) {
    var _this = this;
    var iChartOption = this.iChartOption;
    var data = iChartOption.data;
    PolarCoordSys(this.baseOption, iChartOption, CHART_TYPE.POLAR_BAR);
    var type = iChartOption.type || "normal";
    this.baseOption.angleAxis.data = [];
    if (type !== "normal") {
      this.baseOption.angleAxis.axisLabel.show = true;
    }
    if (data) {
      data.forEach(function(item) {
        _this.baseOption.angleAxis.data.push(item.name);
      });
      setTooltip(this.baseOption);
      this.baseOption.legend.data = type === "normal" ? data : [];
      var seriesData = getSeriesData(data, type);
      var labelData = getLabelData(data);
      this.baseOption.series = setSeries(seriesData, labelData, iChartOption, this.baseOption.polar, type);
    }
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  return PolarBarChart2;
}();
_defineProperty(PolarBarChart, "name", CHART_TYPE.POLAR_BAR);
export {
  PolarBarChart as default
};
