var CHARTTYPENAME = {
  ProcessBarChart: "ProcessBarChart"
};
var PROCESSBARTYPE = "double-sides";
var BASICUNIT = "%";
var BASICBARWIDTH = {
  ProcessBarChart: 8,
  StackProcessBarChart: 20
};
var BASICSERIES = [{
  // 用来做前面的文本显示
  name: "seriesName",
  type: "bar",
  barWidth: 8,
  barGap: "-100%",
  // 这条series不响应鼠标事件
  silent: true,
  label: {
    show: true,
    color: void 0,
    position: [0, -20],
    fontSize: 14,
    formatter: void 0
  },
  data: void 0
}, {
  // 底色 +右侧label文本显示
  name: "background",
  type: "bar",
  barWidth: 8,
  barGap: "-100%",
  itemStyle: {
    color: void 0,
    borderRadius: 4
  },
  cursor: "auto",
  emphasis: {
    disabled: true
  },
  label: {
    show: true,
    color: void 0,
    offset: [0, -24],
    position: "insideTopRight",
    fontSize: 14,
    formatter: void 0
  },
  data: void 0
}];
var BASICDATASERIES = {
  name: void 0,
  type: "bar",
  zlevel: 2,
  barWidth: 8,
  cursor: "pointer",
  itemStyle: {
    borderRadius: 4,
    color: void 0
  },
  data: void 0,
  label: {
    show: false,
    color: void 0,
    formatter: void 0
  }
};
var DOUBLEBASICOPTION = {
  grid: [
    // 左边的坐标系
    {
      left: "4%",
      width: "46%",
      top: 0,
      bottom: 0,
      containLabel: false
    },
    // 右边的坐标系
    {
      right: "4%",
      width: "46%",
      top: 0,
      bottom: 0,
      containLabel: false
    }
  ],
  xAxis: [
    // 左侧的x轴
    {
      show: true,
      type: "value",
      gridIndex: 0,
      inverse: true,
      axisLabel: {
        show: false
      },
      splitLine: {
        lineStyle: {
          type: [8, 4]
        }
      },
      max: "dataMax"
    },
    // 右侧的x轴
    {
      show: true,
      type: "value",
      gridIndex: 1,
      splitLine: {
        lineStyle: {
          type: [8, 4]
        }
      },
      axisLabel: {
        show: false
      },
      max: "dataMax"
    }
  ],
  yAxis: [{
    // 左侧的y轴
    type: "category",
    gridIndex: 0,
    show: true,
    inverse: true,
    axisLabel: {
      show: false
    },
    splitLine: {
      show: false
    },
    axisTick: {
      show: false
    },
    axisLine: {
      show: true,
      lineStyle: {
        color: void 0
      }
    },
    position: "right",
    data: void 0
  }, {
    // 右侧的y轴
    type: "category",
    gridIndex: 1,
    inverse: true,
    show: false,
    data: void 0
  }],
  series: [{
    // 实际数据 + 左侧数值
    name: "",
    xAxisIndex: 0,
    yAxisIndex: 0,
    type: "bar",
    zlevel: 2,
    barWidth: 8,
    itemStyle: {
      borderRadius: [4, 0, 0, 4],
      color: void 0
    },
    data: void 0,
    emphasis: {
      disabled: true
    },
    label: {
      show: false
    }
  }, {
    // 左侧底色
    name: "backgroundLeft",
    type: "bar",
    xAxisIndex: 0,
    yAxisIndex: 0,
    barWidth: 8,
    barGap: "-100%",
    itemStyle: {
      color: void 0,
      borderRadius: [4, 0, 0, 4]
    },
    emphasis: {
      disabled: true
    },
    label: {
      show: true,
      offset: [0, 0],
      position: "insideBottomLeft",
      formatter: void 0,
      rich: {
        nameLeft: {
          fontSize: 14,
          color: void 0,
          lineHeight: 14,
          padding: [0, 0, 20, 0]
        },
        valueLeft: {
          fontSize: 14,
          color: void 0,
          lineHeight: 14,
          fontWeight: "bold"
        }
      }
    },
    data: void 0
  }, {
    // 实际数据 + 右侧数值
    name: "",
    xAxisIndex: 1,
    yAxisIndex: 1,
    type: "bar",
    zlevel: 2,
    barWidth: 8,
    itemStyle: {
      borderRadius: [0, 4, 4, 0],
      color: void 0
    },
    emphasis: {
      disabled: true
    },
    label: {
      show: false
    },
    data: void 0
  }, {
    // 右侧底色
    name: "backgroundRight",
    xAxisIndex: 1,
    yAxisIndex: 1,
    type: "bar",
    barWidth: 8,
    barGap: "-100%",
    itemStyle: {
      color: void 0,
      borderRadius: [0, 4, 4, 0]
    },
    emphasis: {
      disabled: true
    },
    label: {
      show: true,
      offset: [0, 0],
      position: "insideBottomRight",
      formatter: void 0,
      rich: {
        nameRight: {
          fontSize: 14,
          color: "",
          lineHeight: 14,
          padding: [0, 0, 20, 0],
          align: "right"
        },
        valueRight: {
          fontSize: 14,
          color: "",
          lineHeight: 14,
          align: "right",
          fontWeight: "bold"
        }
      }
    },
    data: void 0
  }]
};
export {
  BASICBARWIDTH,
  BASICDATASERIES,
  BASICSERIES,
  BASICUNIT,
  CHARTTYPENAME,
  DOUBLEBASICOPTION,
  PROCESSBARTYPE
};
