import init from "../../option/init/index.mjs";
import mini from "../../feature/mini/miniProcessChart.mjs";
import RectCoordSys from "../../option/RectSys/index.mjs";
import { PROCESSBARTYPE } from "./BaseOption.mjs";
import handleData from "./handleData.mjs";
import { handleGrid, handleYaxis, handleXaxis, handleDataZoom, handleLegend, handleTooltip } from "./handleOption.mjs";
import handleSeries from "./handleSeries.mjs";
import cloneDeep from "../../util/cloneDeep.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var ProcessChart = /* @__PURE__ */ function() {
  function ProcessChart2(iChartOption, chartInstance) {
    this.initIchartOption = cloneDeep(iChartOption);
    this.baseOption = {};
    this.iChartOption = {};
    this.chartInstance = chartInstance;
    this.iChartOption = init(iChartOption);
    this.updateOption();
  }
  var _proto = ProcessChart2.prototype;
  _proto.updateOption = function updateOption() {
    var iChartOption = this.iChartOption;
    if (!iChartOption.name) {
      throw new Error("ProcessChart must have a name");
    }
    RectCoordSys(this.baseOption, iChartOption, iChartOption.name);
    var doubleSide = iChartOption.type && iChartOption.type === PROCESSBARTYPE;
    var dataSet = handleData(iChartOption, doubleSide);
    if (!dataSet) return;
    handleGrid(this.baseOption, iChartOption, doubleSide, this.chartInstance);
    handleYaxis(this.baseOption, iChartOption, dataSet, doubleSide);
    handleXaxis(this.baseOption, doubleSide, iChartOption);
    handleDataZoom(this.baseOption, this.initIchartOption);
    handleLegend(this.baseOption, dataSet, doubleSide, this.initIchartOption);
    handleSeries(this.baseOption, iChartOption, dataSet, doubleSide);
    handleTooltip(this.baseOption, iChartOption, dataSet, doubleSide);
    mini(iChartOption, this.baseOption);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption(option) {
    this.baseOption = option;
  };
  return ProcessChart2;
}();
_defineProperty(ProcessChart, "name", CHART_TYPE.PROCESS);
export {
  ProcessChart as default
};
