import init from "../../option/init/index.mjs";
import { isArray } from "../../util/type.mjs";
import { setSeries, setMarkLineSeries } from "./handleSeries.mjs";
import { mergeSeries } from "../../util/merge.mjs";
import { initRadarSys, getRadarKeys, getRadarMax, setRadar, setMarkLine, setTooltip } from "./handleOptipn.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
import GradientRadar from "./GradientRadar/index.mjs";
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var RadarChart = /* @__PURE__ */ function() {
  function RadarChart2(iChartOption, chartInstance) {
    this.gradientRadar = null;
    this.baseOption = {};
    this.iChartOption = {};
    this.chartInstance = chartInstance;
    this.iChartOption = init(iChartOption);
    this.updateOption(chartInstance);
  }
  var _proto = RadarChart2.prototype;
  _proto.updateOption = function updateOption(chartInstance) {
    var _iChartOption$radar;
    var iChartOption = this.iChartOption;
    var isCustomMaxVal = !!(isArray(iChartOption.radarMax) || iChartOption != null && (_iChartOption$radar = iChartOption.radar) != null && _iChartOption$radar.indicator);
    initRadarSys(this.baseOption, iChartOption);
    var radarKeys = getRadarKeys(iChartOption.data);
    iChartOption.radarMax = iChartOption.radarMax || getRadarMax(iChartOption.data, iChartOption, isCustomMaxVal);
    if (iChartOption.gradient) {
      this.gradientRadar = new GradientRadar(chartInstance, {
        iChartOption,
        baseOption: this.baseOption,
        radarKeys
      });
    }
    setRadar(this.baseOption, iChartOption, radarKeys, isCustomMaxVal);
    setSeries(this.baseOption, iChartOption, radarKeys, iChartOption.data);
    setMarkLine(this.baseOption, iChartOption, radarKeys);
    setTooltip(this.baseOption, iChartOption, radarKeys, iChartOption.data);
    setMarkLineSeries(this.baseOption, iChartOption, radarKeys);
    mergeSeries(iChartOption, this.baseOption);
    if (iChartOption.gradient) {
      this.gradientRadar.init();
      this.gradientRadar.setLegend();
      this.gradientRadar.setTooltip();
      this.gradientRadar.setSeries();
    }
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.resize = function resize() {
    if (this.gradientRadar) this.gradientRadar.resize();
  };
  return RadarChart2;
}();
_defineProperty(RadarChart, "name", CHART_TYPE.RADAR);
export {
  RadarChart as default
};
