import tooltip from "../../option/config/tooltip/index.mjs";
import _defendXSS from "../../util/defendXSS.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function defaultFormatter(params, iChartOption) {
  var _iChartOption$emptySt = iChartOption.emptyStatus, emptyStatus = _iChartOption$emptySt === void 0 ? "node" : _iChartOption$emptySt;
  var htmlString = "";
  if (params.name.includes(">")) {
    params.name = params.name.replace(">", "---");
  }
  var value = params.data.empty ? 0 : params.data.value || params.value;
  if (emptyStatus === "node" && params.dataType === "edge" && value === 0) {
    return;
  }
  htmlString += '<span style="display:inline-block;margin-right:5px;border-radius:50%;height:10px;">' + _defendXSS(params.name) + '</span><br/><span style="display:inline-block;margin-right:5px;border-radius:50%;height:10px;">value' + ("  :  " + _defendXSS(value) + "</span>");
  return htmlString;
}
function handleSankeyFormatter(formatter, sankeyTooltip, iChartOption) {
  if (formatter) {
    sankeyTooltip.formatter = formatter;
  } else {
    sankeyTooltip.formatter = function(params) {
      var html = defaultFormatter(params, iChartOption);
      return html;
    };
  }
}
function setTooltip(iChartOption, formatter, baseOpt) {
  var sankeyTooltip = tooltip(iChartOption, CHART_TYPE.SANKEY);
  handleSankeyFormatter(formatter, sankeyTooltip, iChartOption);
  sankeyTooltip.trigger = "item";
  baseOpt.tooltip = sankeyTooltip;
}
export {
  setTooltip
};
