import Theme from "../../feature/token/index.mjs";
import { isObject } from "../../util/type.mjs";
import chartToken from "./chartToken.mjs";
function handleMarkPoint(iChartOpt) {
  var markData = {};
  var series = [];
  var markPoint = iChartOpt.markPoint;
  var data = iChartOpt.data;
  data && isObject(data) && Object.keys(data).forEach(function(key) {
    var errorSeriesName = "";
    var errorSeriesData = [];
    data[key].forEach(function(item, index) {
      markPoint && Object.keys(markPoint).forEach(function(v) {
        if (v === key) {
          var flagArr = [];
          markPoint[v].forEach(function(axis, i) {
            var flag = true;
            if (Number(item[i]) < Number(axis)) {
              flag = false;
            }
            flagArr.push(flag);
          });
          if (!flagArr.includes(false)) {
            errorSeriesName = v;
            errorSeriesData.push(item);
            data[key].splice(index, 1);
          }
        }
      });
    });
    errorSeriesName && (markData["" + errorSeriesName] = errorSeriesData);
  });
  var colorError = Theme.config.colorState.colorError;
  Object.keys(markData).forEach(function(item) {
    var seriesItem = {
      // 将error的series数据和原图例的name保持一致，让echarts只渲染正确的图例数
      name: item,
      symbolSize: iChartOpt.symbolSize || 10,
      data: markData[item],
      type: "scatter",
      emphasis: {
        focus: "series",
        scale: 1.3,
        itemStyle: {
          color: chartToken.color,
          borderWidth: 4
        }
      },
      itemStyle: {
        color: colorError,
        borderColor: colorError,
        borderWidth: 0
      }
    };
    if (seriesItem.data.length) {
      series.push(seriesItem);
    }
  });
  return series;
}
export {
  handleMarkPoint as default
};
