import xAxis from "../../option/config/xAxis/index.mjs";
import yAxis from "../../option/config/yAxis/index.mjs";
import grid from "../../option/config/grid/index.mjs";
import tooltip from "../../option/config/tooltip/index.mjs";
import _defendXSS from "../../util/defendXSS.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function toolTipFormatter(params) {
  var data = params.data;
  var x = data[0], y = data[1], name = data[2];
  var htmlStrings = '<div style="margin-bottom:4px;">\n  名称' + (name || "") + "\n                            </div>";
  htmlStrings += '\n                            <div>\n                                <span style="display:inline-block;margin-right:8px;min-width:60px;">x维度</span>\n                                <span>' + _defendXSS(x) + "</span>\n                            </div>";
  htmlStrings += '\n                            <div>\n                                <span style="display:inline-block;margin-right:8px;min-width:60px;">y维度</span>\n                                <span>' + _defendXSS(y) + "</span>\n                            </div>";
  return htmlStrings;
}
function handleXaxis(baseOpt, iChartOpt) {
  var basicXaxis = xAxis(iChartOpt);
  basicXaxis[0].type = "value";
  baseOpt.xAxis = basicXaxis;
}
function handleYaxis(baseOpt, iChartOpt) {
  var basicYaxis = yAxis(baseOpt, iChartOpt, CHART_TYPE.SCATTER);
  baseOpt.yAxis = basicYaxis;
}
function handleTooltip(baseOpts, iChartOpt) {
  var _iChartOpt$tooltip;
  var basicTooltip = tooltip(iChartOpt, CHART_TYPE.SCATTER);
  if (!iChartOpt.tipHtml && !(iChartOpt != null && (_iChartOpt$tooltip = iChartOpt.tooltip) != null && _iChartOpt$tooltip.formatter)) {
    basicTooltip.formatter = toolTipFormatter;
  }
  basicTooltip.trigger = "item";
  baseOpts.tooltip = basicTooltip;
}
function handleGrid(baseOpt, iChartOpt) {
  var basicGrid = grid(iChartOpt);
  baseOpt.grid = basicGrid;
}
export {
  handleGrid,
  handleTooltip,
  handleXaxis,
  handleYaxis
};
