import { getColor } from "../../util/color.mjs";
import chartToken from "./chartToken.mjs";
import handleMarkPoint from "./handleMarkPoint.mjs";
import { isObject } from "../../util/type.mjs";
function handleSeries(baseOpt, iChartOpt) {
  var series = [];
  var errorSeries = handleMarkPoint(iChartOpt);
  var data = iChartOpt.data;
  data && isObject(data) && Object.keys(data).forEach(function(item) {
    var seriesItem = {
      name: item,
      symbolSize: iChartOpt.symbolSize || 10,
      data: data[item],
      type: "scatter",
      emphasis: {
        itemStyle: {
          color: chartToken.color,
          borderWidth: 4
        },
        focus: "series",
        scale: 1.3
      },
      itemStyle: {
        color: function color(param) {
          return getColor(iChartOpt.color, param.seriesIndex);
        },
        borderColor: function borderColor() {
        },
        borderWidth: 0
      }
    };
    series.push(seriesItem);
  });
  series.push.apply(series, errorSeries);
  baseOpt.series = series;
}
export {
  handleSeries
};
