import NodeManager from "./NodeManager.mjs";
import LineManager from "./line/index.mjs";
import TagManager from "./TagManager.mjs";
import { moveToCenter, judgeDisabled, getCssNumber } from "./util.mjs";
var LeafManager = /* @__PURE__ */ function() {
  function LeafManager2(data, container, deg, branchInstance) {
    this.node = void 0;
    this.line = void 0;
    this.tag = void 0;
    var imageList = branchInstance.imageList, option = branchInstance.option;
    this.data = data;
    this.imageList = imageList;
    this.option = option;
    this.mount(container, deg, branchInstance);
    moveToCenter(branchInstance, this, false);
  }
  var _proto = LeafManager2.prototype;
  _proto.mount = function mount(container, deg, branchInstance) {
    this.grouping(container, deg, branchInstance);
    this.insertContent();
    this.renderLine(container, deg, branchInstance);
  };
  _proto.grouping = function grouping(container, deg, branchInstance) {
    var nodeWrapper = container.nodeWrapper, tagWrapper = container.tagWrapper;
    this.node = new NodeManager(nodeWrapper, this.data, deg, false, branchInstance);
    this.tag = new TagManager(tagWrapper, this.data, this.option, deg, false, branchInstance.drag);
  };
  _proto.insertContent = function insertContent() {
    var nodeContainer = this.node.returnWrapper();
    var tagContainer = this.tag.returnWrapper();
    var renderFun = this.data.render || this.option.render;
    judgeDisabled(this.option, [nodeContainer.parentNode, tagContainer.parentNode], true, this.data);
    if (renderFun) {
      renderFun({
        nodeContainer,
        tagContainer
      }, this.data, this.option);
    }
    this.node.setAngle();
    this.tag.setAngle();
  };
  _proto.renderLine = function renderLine(container, deg, branchInstance) {
    var lineWrapper = container.lineWrapper;
    var tagWidth = getCssNumber(this.tag.dom, "width");
    this.line = new LineManager({
      lineWrapper,
      leafNode: this.node
    }, this.data, deg, branchInstance, false, tagWidth);
  };
  _proto.refreshData = function refreshData(data) {
    this.data = data !== void 0 ? data : this.data;
    this.insertContent();
  };
  return LeafManager2;
}();
export {
  LeafManager as default
};
