import { degPositive, setDirection, insertDom, createDom, pxToNumber, getStyle, setStyle, judgeDisabled } from "./util.mjs";
import { tagPosition, direction } from "./CommonConstant.mjs";
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var TagManager = /* @__PURE__ */ function() {
  function TagManager2(container, data, option, deg, isCenter, drag) {
    this.wrapper = void 0;
    this.container = container;
    this.data = data;
    this.option = option;
    this.deg = degPositive(deg);
    this.isCenter = isCenter;
    this.direction = setDirection(this.deg);
    this.tagPositionVal = tagPosition;
    this.drag = drag;
    this.mount();
  }
  var _proto = TagManager2.prototype;
  _proto.mount = function mount() {
    this.dom = insertDom(this.container, {
      "class": "sfc-tag-item"
    });
    this.wrapper = insertDom(this.dom);
    this.isCenter && this.insertContent();
  };
  _proto.returnWrapper = function returnWrapper() {
    return this.wrapper || createDom();
  };
  _proto.setAngle = function setAngle() {
    var containerWidth = pxToNumber(getStyle(this.container, "width"));
    var tagItemWidth = pxToNumber(getStyle(this.wrapper, "width"));
    var originPoint;
    var tagStyle = {};
    if (this.direction === direction["left"]) {
      originPoint = containerWidth * ((this.tagPositionVal - 50) / 100) + tagItemWidth / 2;
      tagStyle = {
        right: this.tagPositionVal + "%",
        transformOrigin: originPoint + "px center",
        transform: "translate(50%,-50%) rotate(" + (this.deg - 180) + "deg)"
      };
    } else {
      originPoint = -1 * (containerWidth * ((this.tagPositionVal - 50) / 100) - tagItemWidth / 2);
      tagStyle = {
        left: this.tagPositionVal + "%",
        transformOrigin: originPoint + "px center",
        transform: "translate(-50%,-50%) rotate(" + this.deg + "deg)"
      };
    }
    setStyle(this.dom, _extends({}, tagStyle));
  };
  _proto.insertContent = function insertContent() {
    judgeDisabled(this.option, [this.dom]);
    var renderFun = this.data.render || this.option.render;
    if (renderFun) {
      renderFun({
        nodeContainer: createDom(),
        tagContainer: this.wrapper
      }, this.data, this.option, this.drag.scale);
    }
    this.setAngle();
  };
  _proto.refreshData = function refreshData(data) {
    this.data = data;
    this.insertContent();
  };
  return TagManager2;
}();
export {
  TagManager as default
};
