import cloneDeep from "../../util/cloneDeep.mjs";
import chartToken from "./chartToken.mjs";
var seriesInit = {
  center: ["50%", "50%"],
  radius: ["12%", "70%"],
  type: "sunburst",
  sort: void 0,
  emphasis: {
    focus: "descendant"
  },
  itemStyle: {
    borderRadius: 4,
    borderWidth: 2,
    borderColor: ""
  },
  data: [],
  label: {
    rotate: 0,
    color: ""
  },
  levels: []
};
function setSeries(iChartOption) {
  var data = iChartOption.data;
  var series = cloneDeep(seriesInit);
  series.data = data;
  series.itemStyle.borderColor = chartToken.itemBorderColor;
  series.label.color = chartToken.labelColor;
  return series;
}
export {
  seriesInit,
  setSeries
};
