import { initContainer } from "./insertDom.mjs";
import BaseChart from "../BaseChart/index.mjs";
import TimeLine from "./timeline.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function _inheritsLoose(t, o) {
  t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o);
}
function _setPrototypeOf(t, e) {
  return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(t2, e2) {
    return t2.__proto__ = e2, t2;
  }, _setPrototypeOf(t, e);
}
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var TimelineChart = /* @__PURE__ */ function(_BaseChart) {
  function TimelineChart2() {
    var _this;
    _this = _BaseChart.call(this) || this;
    _this.dom = null;
    _this.option = null;
    _this.resizeObserver = null;
    _this.timeline = null;
    return _this;
  }
  _inheritsLoose(TimelineChart2, _BaseChart);
  var _proto = TimelineChart2.prototype;
  _proto.init = function init(dom) {
    this.dom = dom;
  };
  _proto.setSimpleOption = function setSimpleOption(chartName, option) {
    this.option = option;
  };
  _proto.render = function render() {
    this.initDom();
    this.setResizeObserver();
    this.renderCallBack && this.renderCallBack(this);
  };
  _proto.onRenderReady = function onRenderReady(callback) {
    this.renderCallBack = callback;
  };
  _proto.initDom = function initDom() {
    initContainer(this.dom);
    this.container = document.getElementsByClassName("timeline_container")[0];
    this.chartContainer = document.getElementById("timeline_chart");
    this.canvas = document.getElementById("timeline");
    this.resizeDom();
  };
  _proto.uninstall = function uninstall() {
    if (this.resizeObserver) {
      this.resizeObserver.disconnect();
      this.resizeObserver = null;
    }
    this.dom.innerHTML = "";
  };
  _proto.resizeDom = function resizeDom() {
    var width = this.container.offsetWidth;
    var height = this.container.offsetHeight;
    this.canvas.setAttribute("width", width);
    this.canvas.setAttribute("height", height);
  };
  _proto.refresh = function refresh(option) {
    this.option = option;
    this.dom.innerHTML = "";
    this.initDom();
    this.timeline = new TimeLine("timeline", (/* @__PURE__ */ new Date()).getTime(), this.option);
  };
  _proto.setResizeObserver = function setResizeObserver() {
    var _this2 = this;
    this.resizeObserver = new ResizeObserver(function(entries) {
      _this2.resizeDom();
      _this2.timeline = new TimeLine("timeline", (/* @__PURE__ */ new Date()).getTime(), _this2.option);
    });
    this.resizeObserver.observe(this.dom);
  };
  _proto.refreshData = function refreshData() {
  };
  _proto.setResize = function setResize() {
    this.resizeDom();
  };
  return TimelineChart2;
}(BaseChart);
_defineProperty(TimelineChart, "name", CHART_TYPE.TIME_LINE);
export {
  TimelineChart as default
};
