import merge from "../../util/merge.mjs";
import tooltip from "../../option/config/tooltip/index.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function setTooltip(baseOpt, iChartOpt) {
  var basicTip = tooltip(iChartOpt, CHART_TYPE.TREE);
  basicTip.trigger = "item";
  baseOpt.tooltip = basicTip;
}
function setChartPadding(seriesItem, type, iChartOption) {
  var position;
  if (type === "RingTreeChart") {
    position = {
      top: 100,
      right: 150,
      bottom: 100,
      left: 150
    };
  }
  if (type === "LineTreeChart") {
    var positionMap = {
      left: {
        top: 100,
        right: 150,
        bottom: 100,
        left: 150
      },
      top: {
        top: 80,
        right: 20,
        bottom: 150,
        left: 20
      },
      bottom: {
        top: 150,
        right: 20,
        bottom: 80,
        left: 20
      },
      right: {
        top: 20,
        right: 150,
        bottom: 20,
        left: 150
      }
    };
    var direction = iChartOption.direction || "left";
    position = positionMap[direction];
  }
  if (iChartOption.padding && iChartOption.padding.length > 0) {
    if (iChartOption.padding.length === 1) {
      position.top = iChartOption.padding[0];
      position.right = iChartOption.padding[0];
      position.bottom = iChartOption.padding[0];
      position.left = iChartOption.padding[0];
    }
    if (iChartOption.padding.length === 2) {
      position.top = iChartOption.padding[0];
      position.right = iChartOption.padding[1];
      position.bottom = iChartOption.padding[0];
      position.left = iChartOption.padding[1];
    }
    if (iChartOption.padding.length === 3) {
      position.top = iChartOption.padding[0];
      position.right = iChartOption.padding[1];
      position.bottom = iChartOption.padding[2];
      position.left = iChartOption.padding[1];
    }
    if (iChartOption.padding.length === 4) {
      position.top = iChartOption.padding[0];
      position.right = iChartOption.padding[1];
      position.bottom = iChartOption.padding[2];
      position.left = iChartOption.padding[3];
    }
  }
  merge(seriesItem, position);
}
export {
  setChartPadding,
  setTooltip
};
