import grid from "../../option/config/grid/index.mjs";
import tooltip from "../../option/config/tooltip/index.mjs";
import _defendXSS from "../../util/defendXSS.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
function toolTipFormatter(params) {
  var data = params.data;
  var value = data.value, name = data.name;
  var htmlString = '<div style="margin-bottom:4px;">\n  树节点' + (name || "") + "\n                            </div>";
  htmlString += '\n                            <div>\n                                <span style="display:inline-block;margin-right:8px;min-width:60px;">value:</span>\n                                <span>' + _defendXSS(value) + "</span>\n                            </div>";
  return htmlString;
}
function handleGrid(baseOpt, iChartOpt) {
  var basicGrid = grid(iChartOpt);
  baseOpt.grid = basicGrid;
}
function handleTitle(baseOpt, iChartOpt) {
  if (iChartOpt.title) {
    baseOpt.title = iChartOpt.title;
  }
}
function handleTooltip(baseOpt, iChartOpt) {
  var _iChartOpt$tooltip;
  var basicTooltip = tooltip(iChartOpt, CHART_TYPE.TREE_MAP);
  if (!iChartOpt.tipHtml && !(iChartOpt != null && (_iChartOpt$tooltip = iChartOpt.tooltip) != null && _iChartOpt$tooltip.formatter)) {
    basicTooltip.formatter = toolTipFormatter;
  }
  basicTooltip.trigger = "item";
  baseOpt.tooltip = basicTooltip;
}
export {
  handleGrid,
  handleTitle,
  handleTooltip
};
