import { isArray } from "../../util/type.mjs";
function handleSeries(baseOpt, iChartOpt) {
  var series = [];
  var data = iChartOpt.data;
  var color = iChartOpt.color;
  var roam = iChartOpt.roam;
  var optionLabel = iChartOpt.label || {};
  var label = Object.assign({
    fontFamily: "HarmonyHeiTi",
    fontSize: "14px",
    align: "center",
    formatter: "{b}",
    fontStyle: "normal"
  }, optionLabel);
  if (data && isArray(data)) {
    var seriesItem = {
      data,
      type: "treemap",
      roam: roam || false,
      nodeClick: roam ? "zoomToNode" : false,
      breadcrumb: {
        show: false
      },
      label,
      itemStyle: {
        borderRadius: 4,
        gapWidth: 1,
        borderColor: "transparent"
      },
      levels: [{
        color
      }]
    };
    series.push(seriesItem);
  }
  baseOpt.series = series;
}
export {
  handleSeries
};
