import "./BaseOption.mjs";
import cloneDeep from "../../util/cloneDeep.mjs";
import { setTooltip } from "./handleOptipn.mjs";
import handleSeries from "./handleSeries.mjs";
import init from "../../option/init/index.mjs";
import { CHART_TYPE } from "../../util/constants.mjs";
import base from "../../option/base/index.mjs";
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var WordCloudChart = /* @__PURE__ */ function() {
  function WordCloudChart2(iChartOption) {
    this.baseOption = {};
    this.iChartOption = {};
    this.baseOption = cloneDeep(base);
    this.iChartOption = init(iChartOption);
    this.updateOption();
  }
  var _proto = WordCloudChart2.prototype;
  _proto.updateOption = function updateOption() {
    var iChartOption = this.iChartOption;
    this.baseOption.color = iChartOption.color;
    this.baseOption.tooltip = setTooltip(iChartOption);
    this.baseOption.series = handleSeries({
      data: iChartOption.data,
      width: iChartOption.width,
      height: iChartOption.height,
      gridSize: iChartOption.gridSize,
      sizeRang: iChartOption.sizeRange,
      rotationRange: iChartOption.rotationRange,
      rotationStep: iChartOption.rotationStep,
      shape: iChartOption.shape,
      maskImage: iChartOption.maskImage,
      textColor: iChartOption.textColor,
      colors: this.baseOption.color
    });
    this.baseOption.grid.top = iChartOption.padding[0];
    this.baseOption.grid.right = iChartOption.padding[1];
    this.baseOption.grid.bottom = iChartOption.padding[2];
    this.baseOption.grid.left = iChartOption.padding[3];
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  return WordCloudChart2;
}();
_defineProperty(WordCloudChart, "name", CHART_TYPE.WORD_CLOUD);
export {
  WordCloudChart as default
};
