import tips from "./util/tips.mjs";
import "../../../../echarts@5.4.1/node_modules/echarts/index.mjs";
import Theme from "./feature/token/index.mjs";
import xssOption from "./feature/xss/index.mjs";
import throttle from "./util/throttle.mjs";
import axistip from "./feature/axistip/index.mjs";
import BaseChart from "./components/BaseChart/index.mjs";
import readScreen from "./feature/readScreen/index.mjs";
import mediaScreen from "./feature/mediaScreen/index.mjs";
import animation from "./option/config/animation/index.mjs";
import merge, { mergeExtend } from "./util/merge.mjs";
import WcagObserver from "./feature/wcag/index.mjs";
import chartLinter from "./feature/linter/index.mjs";
import { event } from "./util/event.mjs";
import { init } from "../../../../echarts@5.4.1/node_modules/echarts/lib/core/echarts.mjs";
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
function _inheritsLoose(t, o) {
  t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o);
}
function _setPrototypeOf(t, e) {
  return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(t2, e2) {
    return t2.__proto__ = e2, t2;
  }, _setPrototypeOf(t, e);
}
var SELF_CHART = ["FlowChart", "WaveChart", "TerraceChart", "RiverChart", "GanttChart", "BaiduMapChart", "HoneycombChart", "OrganizationChart", "AutonaviMapChart", "SnowFlakeChart", "TimelineChart", "MilestoneChart"];
var CoreChart = /* @__PURE__ */ function(_BaseChart) {
  function CoreChart2() {
    var _this;
    _this = _BaseChart.call(this) || this;
    _this.echartsIns = null;
    _this.ichartsIns = null;
    _this.eChartOption = null;
    _this.iChartOption = null;
    _this.dom = null;
    _this.chartClass = null;
    _this.plugins = {};
    _this.hasRender = false;
    _this.renderCallBack = null;
    _this.resizeThrottle = 0;
    _this.resizeObserver = null;
    _this.mediaScreenObserver = void 0;
    _this.wcagObserver = void 0;
    return _this;
  }
  _inheritsLoose(CoreChart2, _BaseChart);
  CoreChart2.registerTheme = function registerTheme(name, config) {
    if (!config) {
      tips.error("The second parameter config is required");
      return;
    }
    Theme.set(name, config);
  };
  CoreChart2.registerConfig = function registerConfig(name, config) {
    if (!config) {
      tips.error("The second parameter config is required");
      return;
    }
    Theme.setConfig(name, config);
  };
  CoreChart2.theme = function theme(name) {
    Theme.setDefaultTheme(name);
  };
  CoreChart2.resetThemeCongfig = function resetThemeCongfig() {
    Theme.resetThemeCongfig();
  };
  var _proto = CoreChart2.prototype;
  _proto.mediaScreen = function mediaScreen$1(dom, screenOption) {
    var _this2 = this;
    this.mediaScreenObserver = new mediaScreen(dom, screenOption, function(option) {
      _this2.setSimpleOption(_this2.chartClass, option, _this2.plugins, false);
      _this2.render();
    });
  };
  _proto.init = function init$1(chartDom, initOpts, theme) {
    if (theme === void 0) {
      theme = {};
    }
    var defaultInit = {
      domResize: true,
      windowResize: true,
      resizeThrottle: this.resizeThrottle
    };
    initOpts = merge(defaultInit, initOpts);
    this.dom = chartDom;
    this.echartsIns = init(chartDom, theme, initOpts);
    this.throttleResize = initOpts.resizeThrottle === 0 ? this.setResize.bind(this) : throttle(initOpts.resizeThrottle, this.setResize.bind(this));
    initOpts.domResize && this.setResizeObserver();
    initOpts.windowResize && window.addEventListener("resize", this.throttleResize);
  };
  _proto.setResizeObserver = function setResizeObserver() {
    var _this3 = this;
    this.resizeObserver = new ResizeObserver(function() {
      window.requestAnimationFrame(function() {
        _this3.throttleResize();
      });
    });
    this.resizeObserver.observe(this.dom);
  };
  _proto.setResize = function setResize() {
    var _this4 = this;
    this.mediaScreenObserver && this.mediaScreenObserver.observe();
    this.echartsIns && this.echartsIns.resize && this.echartsIns.resize({
      width: "auto"
    });
    this.ichartsIns && this.ichartsIns.resize && this.ichartsIns.resize(function(resizedOption) {
      _this4.setOption(resizedOption);
    });
  };
  _proto.setSimpleOption = function setSimpleOption(ChartClass, iChartOption, plugins, isInit) {
    if (plugins === void 0) {
      plugins = {};
    }
    if (isInit === void 0) {
      isInit = true;
    }
    iChartOption = xssOption(iChartOption);
    if (isInit) {
      Theme.setDefaultTheme(iChartOption.theme);
      this.mediaScreenObserver && this.mediaScreenObserver.setInitOption(iChartOption, ChartClass);
    }
    if (iChartOption.readScreen) {
      readScreen(this.dom, iChartOption.readScreen);
    }
    if (this.isSelfChart(ChartClass)) {
      this.redirectSelfChart(ChartClass, iChartOption, plugins);
      return;
    }
    this.plugins = plugins;
    this.chartClass = ChartClass;
    this.iChartOption = iChartOption;
    this.ichartsIns = new ChartClass(iChartOption, this.echartsIns, this.plugins);
    this.eChartOption = this.ichartsIns.getOption();
    event(this.echartsIns, iChartOption.event);
    axistip(this.dom, this.echartsIns, this.eChartOption, this.iChartOption.axistip);
    mergeExtend(this.iChartOption, this.eChartOption);
  };
  _proto.redirectSelfChart = function redirectSelfChart(SelfChart, option, plugins) {
    var stateDom = this.dom.getElementsByClassName("huicharts-state-container")[0];
    this.uninstall();
    this.dom.innerHTML = "";
    var instance = new SelfChart();
    instance.init(this.dom);
    instance.setSimpleOption(SelfChart, option, plugins);
    instance.renderCallBack = this.renderCallBack;
    if (stateDom) {
      this.dom.appendChild(stateDom);
    }
    Object.setPrototypeOf(this, instance);
    for (var key in this) {
      if (Object.hasOwnProperty.call(this, key)) {
        delete this[key];
      }
    }
  };
  _proto.isSelfChart = function isSelfChart(chartClass) {
    return SELF_CHART.includes(chartClass.name);
  };
  _proto.render = function render(option) {
    this.hasRender = true;
    this.setOption(this.eChartOption, option);
    this.setOptionAgain(this.eChartOption);
    this.renderCallBack && this.renderCallBack(this.echartsIns);
    this.keyboardFocus();
  };
  _proto.setOption = function setOption(eChartOption, option) {
    option = merge({
      notMerge: true
    }, option);
    var animationConfig = animation();
    eChartOption && merge(animationConfig, eChartOption);
    eChartOption && this.echartsIns.setOption(animationConfig, option);
  };
  _proto.setOptionAgain = function setOptionAgain() {
    if (this.ichartsIns && this.ichartsIns.updateOptionAgain) {
      this.ichartsIns.updateOptionAgain(this.echartsIns);
      this.setOption(this.eChartOption);
    }
  };
  _proto.keyboardFocus = function keyboardFocus() {
    var _this$iChartOption = this.iChartOption, keyboardFocus2 = _this$iChartOption.keyboardFocus, theme = _this$iChartOption.theme;
    if (keyboardFocus2) {
      if (this.wcagObserver) {
        this.wcagObserver.unobserve();
      }
      this.wcagObserver = new WcagObserver(keyboardFocus2, theme, this.echartsIns, this.eChartOption);
    }
  };
  _proto.linter = function linter(action, displayMode) {
    if (action !== "check" && action !== "fix") {
      console.error("Invalid action");
      return;
    }
    chartLinter(this.chartClass.name, this.eChartOption, this.dom, action, displayMode);
  };
  _proto.refresh = function refresh(iChartOption) {
    this.iChartOption = iChartOption;
    this.setSimpleOption(this.chartClass, iChartOption, this.plugins);
    this.render();
    this.mediaScreenObserver && this.mediaScreenObserver.refresh();
  };
  _proto.refreshData = function refreshData(data) {
    this.iChartOption.data = data;
    this.refresh(this.iChartOption);
  };
  _proto.onRenderReady = function onRenderReady(callback) {
    this.renderCallBack = callback;
  };
  _proto.on = function on() {
    var _this$echartsIns;
    this.echartsIns && (_this$echartsIns = this.echartsIns).on.apply(_this$echartsIns, arguments);
  };
  _proto.off = function off() {
    var _this$echartsIns2;
    this.echartsIns && (_this$echartsIns2 = this.echartsIns).off.apply(_this$echartsIns2, arguments);
  };
  _proto.bindEvents = function bindEvents(events) {
    var _this5 = this;
    if (events && events.length !== 0) {
      events.forEach(function(item) {
        if (item.query) {
          _this5.off(item.eventName, item.handler);
          _this5.on(item.eventName, item.query, item.handler);
        } else {
          _this5.off(item.eventName, item.handler);
          _this5.on(item.eventName, item.handler);
        }
      });
    }
  };
  _proto.unbindEvents = function unbindEvents(events) {
    var _this6 = this;
    if (events && events.length !== 0) {
      events.forEach(function(item) {
        if (item.handler) {
          _this6.off(item.eventName, item.handler);
        } else {
          _this6.off(item.eventName);
        }
      });
    }
  };
  _proto.uninstall = function uninstall() {
    window.removeEventListener("resize", this.throttleResize);
    if (this.resizeObserver) {
      this.resizeObserver.unobserve(this.dom);
      this.resizeObserver.disconnect();
      this.resizeObserver = null;
    }
    if (this.wcagObserver) {
      this.wcagObserver.unobserve();
    }
    if (this.echartsIns && !this.echartsIns.isDisposed()) {
      this.echartsIns.dispose();
    }
    this.echartsIns = null;
  };
  _proto.getEchartsInstance = function getEchartsInstance() {
    return this.echartsIns;
  };
  _proto.setEchartsOption = function setEchartsOption(option) {
    option && (this.eChartOption = option);
  };
  _proto.getEchartsOption = function getEchartsOption() {
    return this.eChartOption;
  };
  _proto.dispatchAction = function dispatchAction(payload) {
    this.echartsIns && this.echartsIns.dispatchAction(payload);
  };
  _proto.toggleZoomSelectCursor = function toggleZoomSelectCursor(payload) {
    if (payload === void 0) {
      payload = {};
    }
    var mixPayload = _extends({
      type: "takeGlobalCursor",
      key: "dataZoomSelect",
      // 启动或关闭
      dataZoomSelectActive: true
    }, payload);
    this.dispatchAction(mixPayload);
  };
  _proto.restoreToolbox = function restoreToolbox() {
    this.dispatchAction({
      type: "restore"
    });
  };
  return CoreChart2;
}(BaseChart);
export {
  CoreChart as default
};
