import { isNumber } from "../../util/type.mjs";
function accumulateArray(arr) {
  return arr.reduce(function(acc, current, index) {
    if (index === 0) {
      acc.push(current);
    } else {
      acc.push(acc[index - 1] + current);
    }
    return acc;
  }, []);
}
function divideIntoIntegers(number, parts) {
  if (parts <= 1 || number <= 0) {
    throw new Error("Invalid input");
  }
  var quotient = Math.floor(number / parts);
  var remainder = number % parts;
  var result = [];
  for (var i = 0; i < parts - 1; i++) {
    result.push(quotient);
    if (remainder > 0) {
      result[i]++;
      remainder--;
    }
  }
  result.push(quotient);
  return accumulateArray(result);
}
function equalLabel(iChartOption, xAxisItem, xAxisUnit) {
  var sharing = xAxisItem.sharing;
  if (isNumber(sharing)) {
    var dataLength = iChartOption.data.length;
    var sharingArr = divideIntoIntegers(dataLength - 1, sharing);
    xAxisUnit.axisLabel.interval = function(index) {
      if (sharingArr.includes(index) || index === 0) {
        return true;
      } else {
        return false;
      }
    };
  }
  if (sharing === "auto") {
    xAxisUnit.axisLabel.showMaxLabel = true;
  }
}
export {
  equalLabel as default
};
