import { isArray } from "../../util/type.mjs";
var transformData = function transformData2(origindata) {
  var newData = {};
  var count = Object.keys(origindata[0]).length;
  var _loop = function _loop2(i2) {
    var arr = [];
    origindata.forEach(function(key) {
      var firstKey = Object.keys(key)[i2];
      var firstValue = key[firstKey];
      arr.push(firstValue);
      newData[firstKey] = arr;
    });
  };
  for (var i = 1; i < count; i++) {
    _loop(i);
  }
  return newData;
};
var fluctuation = function fluctuation2(data, allowRange) {
  var min = Infinity;
  var max = -Infinity;
  var range = allowRange || [-Infinity, Infinity];
  var dataKeys = Object.keys(data);
  dataKeys.forEach(function(key) {
    data[key].forEach(function(item) {
      if (isArray(item)) {
        var arr = item.filter(function(t) {
          return !isNaN(Number(t)) && Number(t) > range[0] && Number(t) < range[1];
        });
        var curMin = Math.min.apply(Math, arr);
        var curMax = Math.max.apply(Math, arr);
        min = Math.min(min, curMin);
        max = Math.max(max, curMax);
      } else {
        var num = Number(item);
        if (num < range[0] || num > range[1]) {
          return;
        }
        min = Math.min(min, num);
        max = Math.max(max, num);
      }
    });
  });
  var axisMin = Math.floor(min - (max - min) / 5 * 4);
  if (min > 0 && axisMin < 0) {
    axisMin = 0;
  }
  var axisMax = Math.ceil(max + (max - min) / 5);
  return [axisMin, axisMax];
};
export {
  fluctuation as default,
  transformData
};
