import Theme from "../../../token/index.mjs";
import { generatedMatchedUiRule, axisCommonPropertyPermissions } from "./util.mjs";
function getAngleAxisToken(echartsModule) {
  var token = Theme.getToken();
  var uiRule = {
    axisLine: {
      lineStyle: {
        color: token.angleAxisLineColor,
        width: token.angleAxisLineWidth,
        type: token.angleAxisLineType
      }
    },
    splitLine: {
      lineStyle: {
        color: token.angleAxisSplitLineColor,
        width: token.angleAxisSplitLineWidth,
        type: token.angleAxisSplitLineType
      }
    },
    axisTick: {
      lineStyle: {
        color: token.angleAxisTickLineColor,
        width: token.angleAxisTickLineWidth,
        type: token.angleAxisTickLineType
      }
    },
    axisLabel: {
      fontSize: token.angleAxisLabelFontSize,
      color: token.angleAxisLabelColor
    }
  };
  return generatedMatchedUiRule(echartsModule, uiRule, axisCommonPropertyPermissions);
}
export {
  getAngleAxisToken as default
};
