import Theme from "../../../token/index.mjs";
import { codeToRGB } from "../../../../util/color.mjs";
function getDataZoomToken() {
  var token = Theme.getToken();
  var color = Theme.themeName.includes("dark") ? "#1B3F86" : "#8CA3FA";
  return {
    borderColor: token.dataZoomBackgroundColor,
    backgroundColor: token.dataZoomBackgroundColor,
    fillerColor: codeToRGB(token.colorState.colorInfo, 0.1),
    handleStyle: {
      color: token.dataZoomHandleColor,
      shadowColor: token.dataZoomHandleShadowColor,
      borderColor: token.dataZoomHandleBorderColor
    },
    dataBackground: {
      lineStyle: {
        color: token.dataBackgroundLineColor
      },
      areaStyle: {
        color: token.dataBackgroundAreaColor
      }
    },
    selectedDataBackground: {
      lineStyle: {
        color
      },
      areaStyle: {
        color
      }
    },
    emphasis: {
      handleStyle: {
        color: token.dataZoomEmphasisHandleColor,
        borderColor: token.dataZoomEmphasisHandleBorderColor
      }
    }
  };
}
export {
  getDataZoomToken as default
};
