import getAngleAxisToken from "./angleAxis.mjs";
import getColorToken from "./color.mjs";
import getDataZoomToken from "./dataZoom.mjs";
import getLegendToken from "./legend.mjs";
import getRadarToken from "./radar.mjs";
import getRadiusAxisToken from "./radiusAxis.mjs";
import getTitleToken from "./title.mjs";
import getTooltipToken from "./tooltip.mjs";
import getxAxisToken from "./xAxis.mjs";
import getyAxisToken from "./yAxis.mjs";
var moduleMap = {
  angleAxis: getAngleAxisToken,
  color: getColorToken,
  dataZoom: getDataZoomToken,
  legend: getLegendToken,
  radar: getRadarToken,
  radiusAxis: getRadiusAxisToken,
  title: getTitleToken,
  tooltip: getTooltipToken,
  xAxis: getxAxisToken,
  yAxis: getyAxisToken
};
var moduleSourceCommon = [
  "dataZoom",
  "legend",
  // 暂时屏蔽title的检测
  // 'title',
  "tooltip",
  "xAxis",
  "yAxis"
];
var moduleSourceSpecial = ["angleAxis", "color", "radar", "radiusAxis"];
function getComonRule(moudle, moduleName) {
  if (moudle && (moduleSourceSpecial.includes(moduleName) || moduleSourceCommon.includes(moduleName) && moudle.show !== false)) return moduleMap[moduleName](moudle);
  return null;
}
export {
  getComonRule as default
};
