import Theme from "../../../token/index.mjs";
import { generatedMatchedUiRule } from "./util.mjs";
function getLegendToken(echartsModule) {
  var token = Theme.getToken();
  var uiRule = {
    padding: token.legendPadding,
    inactiveColor: token.legendInactiveColor,
    inactiveBorderColor: token.legendInactiveBorderColor,
    inactiveBorderWidth: token.legendInactiveBorderWidth,
    borderWidth: token.legendBorderWidth,
    textStyle: {
      fontSize: token.legendTextFontSize,
      color: token.legendTextColor,
      padding: token.legendTextPadding
    },
    pageTextStyle: {
      color: token.legendPageTextColor
    },
    pageIconColor: token.legendPageIconColor,
    pageIconInactiveColor: token.legendPageIconInactiveColor,
    itemGap: token.legendItemGap,
    itemStyle: {
      borderWidth: token.legendItemBorderWidth
    }
  };
  var commonProperty = ["padding", "inactiveColor", "inactiveBorderColor", "inactiveBorderWidth", "borderWidth", "textStyle", "itemGap", "itemStyle"];
  var propertyPermissions = [{
    name: "type",
    extraCondition: function extraCondition(val) {
      return val && val === "scroll";
    },
    correlationProperty: ["pageTextStyle", "pageIconColor", "pageIconInactiveColor"]
  }];
  return generatedMatchedUiRule(echartsModule, uiRule, propertyPermissions, commonProperty);
}
export {
  getLegendToken as default
};
