import Theme from "../../../token/index.mjs";
import { generatedMatchedUiRule, judgeAxisComonProperty, axisCommonPropertyPermissions } from "./util.mjs";
function getRadarToken(echartsModule) {
  var token = Theme.getToken();
  var uiRule = {
    axisLine: {
      lineStyle: {
        color: token.radarAxisLineColor,
        width: token.radarAxisLineWidth,
        type: token.radarAxisLineType
      }
    },
    axisTick: {
      lineStyle: {
        color: token.radarAxisTickLineColor,
        width: token.radarAxisTickLineWidth,
        type: token.radarAxisTickLineType
      }
    },
    axisLabel: {
      color: token.radarAxisLabelColor,
      fontSize: token.radarAxisLabelFontSize
    },
    splitLine: {
      lineStyle: {
        color: token.radarSplitLineColor,
        width: token.radarSplitLineWidth,
        type: token.radarSplitLineType
      }
    },
    axisName: {
      color: token.radarAxisNameColor,
      fontSize: token.radarAxisNameFontSize
    }
  };
  var propertyPermissions = [{
    name: "axisName",
    extraCondition: judgeAxisComonProperty,
    correlationProperty: ["axisName"]
  }].concat(axisCommonPropertyPermissions);
  return generatedMatchedUiRule(echartsModule, uiRule, propertyPermissions);
}
export {
  getRadarToken as default
};
