import Theme from "../../../token/index.mjs";
import { generatedMatchedUiRule, axisCommonPropertyPermissions } from "./util.mjs";
function getRadiusAxisToken(echartsModule) {
  var token = Theme.getToken();
  var uiRule = {
    axisLine: {
      lineStyle: {
        color: token.radiusAxisLineColor,
        width: token.radiusAxisLineWidth,
        type: token.radiusAxisLineType
      }
    },
    axisTick: {
      lineStyle: {
        color: token.radiusAxisTickLineColor,
        width: token.radiusAxisTickLineWidth,
        type: token.radiusAxisTickLineType
      }
    },
    axisLabel: {
      color: token.radiusAxisLabelColor,
      fontSize: token.radiusAxisLabelFontSize,
      margin: token.radiusAxisLabelGap * 5
    },
    splitLine: {
      lineStyle: {
        type: token.radiusAxisSplitLineType,
        color: token.radiusAxisSplitLineColor,
        width: token.radiusAxisSplitLineWidth
      }
    }
  };
  return generatedMatchedUiRule(echartsModule, uiRule, axisCommonPropertyPermissions);
}
export {
  getRadiusAxisToken as default
};
