import Theme from "../../../token/index.mjs";
import { generatedMatchedUiRule } from "./util.mjs";
function getTitleToken(echartsModule) {
  var token = Theme.getToken();
  var uiRule = {
    itemGap: token.titleItemGap,
    textStyle: {
      color: token.titleTextColor,
      fontSize: token.titleTextFontSize
    },
    subtextStyle: {
      color: token.titleSubTextColor,
      fontSize: token.titleSubtextFontSize
    }
  };
  var commonProperty = ["itemGap"];
  var propertyPermissions = [{
    name: "text",
    extraCondition: function extraCondition(val) {
      return val || val === 0;
    },
    correlationProperty: ["textStyle"]
  }, {
    name: "subtext",
    extraCondition: function extraCondition(val) {
      return val || val === 0;
    },
    correlationProperty: ["subtextStyle"]
  }];
  return generatedMatchedUiRule(echartsModule, uiRule, propertyPermissions, commonProperty);
}
export {
  getTitleToken as default
};
