var axisNamePropertyPermissions = [{
  name: "name",
  // 额外判定条件
  extraCondition: function extraCondition(val) {
    return val || val === 0;
  },
  // 需要添加的属性名称
  correlationProperty: ["nameGap", "nameTextStyle"]
}];
var axisCommonPropertyPermissions = [{
  name: "splitLine",
  extraCondition: judgeAxisComonProperty,
  correlationProperty: ["splitLine"]
}, {
  name: "axisLine",
  extraCondition: judgeAxisComonProperty,
  correlationProperty: ["axisLine"]
}, {
  name: "axisTick",
  extraCondition: judgeAxisComonProperty,
  correlationProperty: ["axisTick"]
}, {
  name: "axisLabel",
  extraCondition: judgeAxisComonProperty,
  correlationProperty: ["axisLabel"]
}];
var rectSysAxisPropertyPermissions = [].concat(axisNamePropertyPermissions, axisCommonPropertyPermissions);
function judgeAxisComonProperty(val) {
  return val && val.show !== false || !val;
}
function assignmentPropertyToMatchedUiRule(moudle, propertyConfig, matchedUiRule, uiRule) {
  var propertyVal = moudle[propertyConfig.name];
  if (propertyConfig.extraCondition(propertyVal)) {
    propertyConfig.correlationProperty.forEach(function(item) {
      matchedUiRule[item] = uiRule[item];
    });
  }
}
function generatedMatchedUiRule(echartsModule, uiRule, propertyPermissions, commonProperty) {
  if (commonProperty === void 0) {
    commonProperty = [];
  }
  var matchedUiRule = {};
  propertyPermissions.forEach(function(propertyConfig) {
    assignmentPropertyToMatchedUiRule(echartsModule, propertyConfig, matchedUiRule, uiRule);
  });
  if (commonProperty.length > 0) {
    commonProperty.forEach(function(property) {
      matchedUiRule[property] = uiRule[property];
    });
  }
  return matchedUiRule;
}
export {
  axisCommonPropertyPermissions,
  generatedMatchedUiRule,
  judgeAxisComonProperty,
  rectSysAxisPropertyPermissions
};
