import merge from "../../util/merge.mjs";
import cloneDeep from "../../util/cloneDeep.mjs";
import { isArrayEqual } from "../../util/equal.mjs";
import defaultOption from "../adaptive/index.mjs";
var mediaScreen = /* @__PURE__ */ function() {
  function mediaScreen2(dom, option, callback) {
    this.dom = dom;
    this.userOption = option;
    this.callback = callback;
    this.curRange = [];
    this.initOption = {};
  }
  var _proto = mediaScreen2.prototype;
  _proto.observe = function observe() {
    var _this = this;
    if (!this.dom) return;
    var defaultChartOption = defaultOption[this.chartName] ? defaultOption[this.chartName] : [];
    this.option = this.userOption || defaultChartOption;
    var domWidth = this.dom.getBoundingClientRect().width;
    var range = this.getRange(domWidth, this.option);
    if (!isArrayEqual(this.curRange, range)) {
      var tempOption = cloneDeep(this.initOption);
      this.curRange = range;
      this.curRange.forEach(function(rangeIndex) {
        merge(tempOption, _this.option[rangeIndex].option);
      });
      this.callback(tempOption);
    }
  };
  _proto.refresh = function refresh() {
    this.curRange = [];
    this.observe();
  };
  _proto.setInitOption = function setInitOption(option, chartName) {
    this.initOption = cloneDeep(option);
    this.chartName = chartName;
  };
  _proto.getRange = function getRange(domWidth, option) {
    var range = [];
    option.forEach(function(item, index) {
      if (item.maxWidth !== void 0 && item.minWidth !== void 0) {
        if (domWidth <= item.maxWidth && domWidth >= item.minWidth) {
          range.push(index);
        }
      } else if (item.maxWidth === void 0 && item.minWidth === void 0) {
        range.push(index);
      } else if (item.maxWidth !== void 0 && item.minWidth === void 0) {
        if (domWidth <= item.maxWidth) {
          range.push(index);
        }
      } else if (item.maxWidth === void 0 && item.minWidth !== void 0) {
        if (domWidth >= item.minWidth) {
          range.push(index);
        }
      }
    });
    range = Array.from(new Set(range));
    return range;
  };
  return mediaScreen2;
}();
export {
  mediaScreen as default
};
