import { isArray } from "../../util/type.mjs";
import merge from "../../util/merge.mjs";
function mini(iChartOption, baseOption) {
  if (iChartOption.mini) {
    baseOption.grid.forEach(function(item) {
      Object.assign(item, {
        top: 0,
        left: 0,
        right: 0,
        bottom: 0,
        containLabel: false
      });
    });
    baseOption.legend = Object.assign(baseOption.legend, {
      show: false
    });
    baseOption.title = merge(baseOption.title, {
      show: false
    });
    baseOption.tooltip = Object.assign(baseOption.tooltip, {
      show: false
    });
    if (!isArray(baseOption.xAxis)) {
      baseOption.xAxis = [baseOption.xAxis];
    }
    if (!isArray(baseOption.yAxis)) {
      baseOption.yAxis = [baseOption.yAxis];
    }
    baseOption.xAxis.forEach(function(item) {
      Object.assign(item, {
        show: false,
        boundaryGap: true
      });
    });
    baseOption.yAxis.forEach(function(item) {
      Object.assign(item, {
        show: false,
        max: "dataMax"
      });
    });
  }
}
export {
  mini as default
};
