import board from "./board.mjs";
import { getThemeColor, getColorGroup } from "../util.mjs";
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var gray = _extends({}, board.gray, board.transparent);
var colorState = {
  // 紧急色
  colorError: board.red.colorRed60,
  colorAlert: board.orange.colorOrange60,
  colorWarning: board.yellow.colorYellow60,
  // 成功色
  colorSuccess: board.kelly.colorKelly60,
  // 提示色
  colorInfo: board.blue.colorBlue60,
  // 失效
  colorNone: board.gray.colorGray50
};
var colorChart = {
  colorChart1: board.blue.colorBlue60,
  colorChart2: board.mint.colorMint70,
  colorChart3: board.indigo.colorIndigo50,
  colorChart4: board.kelly.colorKelly60,
  colorChart5: board.yellow.colorYellow60,
  colorChart6: board.sky.colorSky60,
  colorChart7: board.purple.colorPurple50,
  colorChart8: board.rose.colorRose50
  // (原色 '#EB4696')
};
var colorGroup = getColorGroup(colorChart);
var light = getThemeColor(gray, colorState, colorGroup, board);
export {
  light as default
};
