import board from "./board.mjs";
import { getThemeColor, getColorGroup } from "../util.mjs";
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var gray = _extends({}, board.gray, board.transparent);
var colorState = {
  // 紧急色
  colorError: "#F43146",
  colorAlert: "#EC6F1A",
  colorWarning: "#EEBA18",
  // 成功色
  colorSuccess: "#2DA769",
  // 提示色
  colorInfo: "#5990FD",
  // 失效
  colorNone: board.gray.colorGray30
};
var colorChart = {
  colorChart1: board.blue.colorBlue40,
  colorChart2: board.mint.colorMint40,
  colorChart3: board.purple.colorPurple40,
  colorChart4: board.cyan.colorCyan30,
  colorChart5: board.yellow.colorYellow20,
  colorChart6: board.indigo.colorIndigo40,
  colorChart7: board.cyan.colorCyan40
};
var colorGroup = getColorGroup(colorChart);
var light = getThemeColor(gray, colorState, colorGroup, board);
export {
  light as default
};
