import { aliasTokenMap } from "./getAliasToken.mjs";
import getGlobalToken from "./getGlobalToken.mjs";
import getModelToken from "./getModelToken.mjs";
import getChartsToken from "./chartsToken/index.mjs";
import { TOKENCHARTNAMES } from "../../../util/constants.mjs";
import color from "../color/index.mjs";
import merge from "../../../util/merge.mjs";
import cloneDeep from "../../../util/cloneDeep.mjs";
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
function getBasicToken(name, config) {
  return _extends({}, getGlobalToken(name), config);
}
function getMapToken(name, config) {
  return _extends({}, aliasTokenMap[name](config), config);
}
function getConfigModelToken(config) {
  return _extends({}, getModelToken(config), config);
}
function mergeSpecialToken(name, chartsConfig, config) {
  TOKENCHARTNAMES.forEach(function(item) {
    if (config[item]) merge(chartsConfig, config[item]);
  });
  var colorState = config.colorState;
  if (colorState) {
    var newColorState = merge(cloneDeep(color[name].colorSet.colorState), colorState);
    return _extends({}, chartsConfig, {
      colorState: newColorState
    });
  }
  return _extends({}, chartsConfig);
}
function mergeToken(name, config) {
  var basicConfig = getBasicToken(name, config);
  var mapConfig = getMapToken(name, basicConfig);
  var modelConfig = getConfigModelToken(mapConfig);
  var chartsConfig = getChartsToken(mapConfig);
  var specialConfig = mergeSpecialToken(name, chartsConfig, config);
  return _extends({
    colorGroup: basicConfig.colorGroup
  }, modelConfig, specialConfig);
}
export {
  mergeToken as default
};
