import { codeToRGB } from "../../../../util/color.mjs";
function getAliasToken(globalToken, light) {
  if (light === void 0) {
    light = true;
  }
  var colorGray0 = globalToken.colorGray0, colorGray5 = globalToken.colorGray5, colorGray10 = globalToken.colorGray10, colorGray20 = globalToken.colorGray20, colorGray50 = globalToken.colorGray50, colorGray60 = globalToken.colorGray60, colorGray70 = globalToken.colorGray70, colorGray80 = globalToken.colorGray80, colorGray90 = globalToken.colorGray90, colorGray100 = globalToken.colorGray100, fontSizeBase = globalToken.fontSizeBase, fontSizeMd = globalToken.fontSizeMd, space2x = globalToken.space2x, spaceBase = globalToken.spaceBase, lineTypeSolid = globalToken.lineTypeSolid, colorTransparent = globalToken.colorTransparent, borderNone = globalToken.borderNone, borderBase = globalToken.borderBase, borderRadiusBase = globalToken.borderRadiusBase, border2x = globalToken.border2x, fontSizeLg = globalToken.fontSizeLg, borderRadiusNone = globalToken.borderRadiusNone, fontSize4xl = globalToken.fontSize4xl, space6x = globalToken.space6x, size05x = globalToken.size05x, size3x = globalToken.size3x, size2x = globalToken.size2x, spaceNone = globalToken.spaceNone, space8x = globalToken.space8x, space4x = globalToken.space4x, size6x = globalToken.size6x, size5x = globalToken.size5x;
  return {
    //  初级底色 图表背景
    colorBgPrimary: light ? colorGray0 : colorGray90,
    // 确定
    // 次级背景色 tip背景
    colorBgSecondary: light ? colorGray0 : colorGray70,
    // datazoom背景色
    colorBgTertiary: light ? colorGray5 : colorGray80,
    // datazoom手柄填充背景和主要文本色一致
    colorBgQuaternary: light ? colorGray90 : colorGray0,
    // datazoom选中区域外的线条颜色和面积颜色
    colorFill: light ? colorGray20 : colorGray70,
    // symbol等填充颜色
    colorFillSecondary: light ? colorGray0 : colorGray90,
    // 确定
    // 主要文本色
    colorTextPrimary: light ? colorGray90 : colorGray5,
    // 确定
    // 次级文本色
    colorTextSecondary: light ? colorGray60 : colorGray20,
    // 确定
    // 三级文本色
    colorTextTertiary: light ? colorGray60 : colorGray20,
    // 确定
    // 禁用文本色
    colorTextDisabled: light ? codeToRGB(colorGray90, 0.3) : codeToRGB(colorGray10, 0.3),
    // 确定
    // 图标激活色（legend翻页的颜色）
    colorIconPrimary: light ? colorGray90 : colorGray10,
    // 确定
    // 控件失效色（legend失效的颜色）
    colorInactive: light ? colorGray20 : colorGray50,
    // 确定
    // 图标禁用色（legend翻页图标禁用的颜色）
    colorIconDisabled: light ? codeToRGB(colorGray90, 0.3) : codeToRGB(colorGray10, 0.3),
    // 确定
    // 坐标轴线颜色
    colorAxisLine: light ? colorGray10 : codeToRGB(colorGray10, 0.1),
    // 确定
    // 用于极坐标的径向轴和雷达坐标的分隔线颜色，和坐标轴线颜色保持一致，特殊处理专用
    colorAxisLineSecondary: light ? colorGray10 : codeToRGB(colorGray10, 0.1),
    // 确定
    // 刻度线颜色
    colorAxisTickLine: light ? colorGray10 : codeToRGB(colorGray10, 0.1),
    // 确定
    // 分隔线颜色
    colorAxisSplitLine: light ? codeToRGB(colorGray90, 0.1) : codeToRGB(colorGray10, 0.1),
    // 确定
    // 坐标轴指示器悬浮线
    colorAxisPointerLine: light ? colorGray20 : colorGray50,
    // 确定
    // 透明边框色
    colorBorderTransparent: colorTransparent,
    // 文本透明
    colorTextTransparent: colorTransparent,
    // 指示器阴影
    colorAxisPointerShadow: light ? codeToRGB(colorGray90, 0.05) : codeToRGB(colorGray10, 0.08),
    // tip阴影
    colorShadow: light ? codeToRGB(colorGray100, 0.16) : codeToRGB(colorGray100, 0.5),
    // datazoom手柄阴影
    colorShadowSecondary: light ? codeToRGB(colorGray100, 0.04) : codeToRGB(colorGray100, 0.24),
    // 确定
    // 边框颜色
    colorBorder: light ? colorGray0 : colorGray90,
    // 边框反选色
    colorBorderInverse: light ? colorGray90 : colorGray0,
    // 确定
    // datazoom手柄边框色 把手容器色
    colorBorderSecondary: light ? colorGray0 : colorGray70,
    // 禁用边框颜色和图表colorBgPrimary保持一致（聚合气泡图用todo）
    colorBorderDisabled: light ? colorGray0 : colorGray90,
    // 确定
    // label颜色
    colorLabel: light ? colorGray90 : colorGray5,
    // label禁用颜色（和文本禁用色保持一致）
    colorLabelDisabled: light ? codeToRGB(colorGray90, 0.3) : codeToRGB(colorGray10, 0.3),
    // 确定
    // 虚线的颜色
    colorDash: light ? colorGray0 : colorGray90,
    // 背景透明
    colorBgTransparent: colorTransparent,
    // 无数据占位背景
    colorBgEmpty: light ? colorGray10 : codeToRGB(colorGray10, 0.1),
    // 确定
    // labelLine颜色
    colorLabelLine: light ? colorGray90 : colorGray5,
    // 确定
    // 线透明
    colorLineTransparent: colorTransparent,
    // tip阴影垂直偏移
    shadowOffsetY: space2x,
    // tip阴影模糊
    shadowBlur: space6x,
    // 主文本字号
    textFontSize: fontSizeMd,
    // 确定
    // 次级文本字号
    subtextFontSize: fontSizeBase,
    // 确定
    // 标题文本字号
    titleFontSize: fontSize4xl,
    // 副标题文本字号
    subtitleFontSize: fontSizeLg,
    // 坐标轴线宽 2
    axisLineWidth: border2x,
    // 确定
    // 用于极坐标系和雷达坐标系
    axisLineWidthSecondary: borderBase,
    // 确定
    // 刻度线线宽 2
    axisTickLineWidth: border2x,
    // 确定
    // 分隔线线宽 1
    axisSplitLineWidth: borderBase,
    // 确定
    // 极坐标系分隔线类型
    axisSplitLineTypeSecondary: lineTypeSolid,
    // 坐标轴指示器的标线线宽 1
    axisPointerLineWidth: borderBase,
    // 坐标轴类型
    axisLineType: lineTypeSolid,
    // 刻度线类型
    axisTickLineType: lineTypeSolid,
    // 坐标轴名称间距
    axisNameSpace: space2x,
    // 直角坐标系分隔线类型
    axisSplitLineType: lineTypeSolid,
    // 坐标轴指示器标线类型
    axisPointerLineType: lineTypeSolid,
    // 坐标轴文本间距
    axisLabelSpace: spaceBase,
    // 标识线高亮宽度
    markLineEmphasisWidth: borderBase,
    //  border 0
    borderWidthNone: borderNone,
    // 标题文本间距
    titleSpace: space2x,
    // 标识线宽度
    markLineWidth: borderBase,
    // 容器的间距
    containerGap: spaceBase,
    // 容器的圆角
    containerBoderRadius: borderRadiusBase,
    // 图元
    symbolSize: size3x,
    // 图元 线形图用
    symbolSizeSM: size2x,
    // 图元的边框0
    symbolBorderWidthNone: borderNone,
    // 图元的边框
    symbolBorderWidth: border2x,
    // 柱条的宽度
    barWidth: size2x,
    // 堆叠进度图宽度 20
    barWidthLG: size5x,
    // label字号
    labelFontSize: fontSizeBase,
    // labelLine的长度
    labelLineLength: size6x,
    // 边框 细
    borderWidth: borderBase,
    // 边框
    borderWidthLG: border2x,
    // 圆角 0
    borderRadiusNone,
    // 圆角 小
    borderRadius: borderRadiusBase,
    lineWidth: border2x,
    lineWidthNone: borderNone,
    // 图例单元尺寸
    legendItemSize: size05x,
    // 图例圆形单元尺寸
    legendCircleItemSize: size3x,
    // 图例的间距
    legendSpace: space8x,
    // 无padding
    paddingNone: spaceNone,
    paddingSM: spaceBase,
    padding: space2x,
    paddingLG: space4x
  };
}
export {
  getAliasToken as default,
  getAliasToken as getIctAliasToken
};
