import Theme from "../../../feature/token/index.mjs";
import merge from "../../../util/merge.mjs";
function getThresholdLabelBgColor() {
  var redGroup = Theme.config.colorBoard.red;
  return Object.values(redGroup)[0];
}
function getThresholdMarkLineLabel() {
  var colorError = Theme.config.colorState.colorError;
  var bg = getThresholdLabelBgColor();
  return {
    label: {
      color: colorError,
      backgroundColor: bg,
      fontSize: Theme.config.markLineLabelFontSize,
      borderColor: colorError,
      borderWidth: Theme.config.markLineLabelBorderWidth,
      borderRadius: Theme.config.markLineLabelBorderRadius,
      padding: Theme.config.markLineLabelPadding,
      position: "insideEnd"
    },
    lineStyle: {
      color: colorError
    }
  };
}
function setThresholdMarkLineLabel(markLine) {
  var thresholdLabel = getThresholdMarkLineLabel();
  merge(markLine, thresholdLabel);
}
function getMarkLineDefault(isThreshold) {
  if (isThreshold === void 0) {
    isThreshold = false;
  }
  var lineStyle = {
    width: Theme.config.markLineWidth
  };
  if (isThreshold) lineStyle.color = Theme.config.colorState.colorError;
  return {
    symbol: "none",
    silent: true,
    label: {
      show: false
    },
    lineStyle,
    emphasis: {
      label: {
        show: false
      },
      lineStyle: {
        width: Theme.config.markLineEmphasisWidth
      }
    },
    data: []
  };
}
function getMarkPointDefault() {
  return {
    symbol: "path://M50 0 L0 50 L100 50 Z",
    symbolSize: [10, 6],
    label: {
      color: Theme.config.markPointLabelColor
    },
    data: []
  };
}
export {
  getMarkLineDefault,
  getMarkPointDefault,
  setThresholdMarkLineLabel
};
