import base from "./base.mjs";
import textStyle from "./textStyle.mjs";
import merge from "../../../util/merge.mjs";
import subtextStyle from "./subtextStyle.mjs";
function title(iChartOption) {
  var text = iChartOption.text, title2 = iChartOption.title;
  if (!title2 && !text) return;
  var titleOption = base();
  if (title2) {
    merge(titleOption, title2);
    return titleOption;
  }
  var pieMain = text.main, pieSub = text.sub, textPosition = text.position, itemGap = text.itemGap;
  titleOption.textAlign = "center";
  titleOption.left = "49.5%";
  titleOption.text = (pieMain == null ? void 0 : pieMain.text) || (text == null ? void 0 : text.text) || "";
  titleOption.subtext = (pieSub == null ? void 0 : pieSub.text) || (text == null ? void 0 : text.subtext) || "";
  if (itemGap) {
    titleOption.itemGap = itemGap;
  }
  textStyle(titleOption, pieMain);
  subtextStyle(titleOption, pieSub);
  merge(titleOption, text);
  if (textPosition) {
    merge(titleOption, textPosition);
  }
  return titleOption;
}
export {
  title as default
};
