import Theme from "../../../feature/token/index.mjs";
var chartType = ["CircleProcessChart", "GaugeChart", "RadarChart", "FunnelChart", "JadeJueChart", "LiquidfillChart", "PieChart", "PolarBarChart", "SunburstChart", "BulletChart", "HeatMapChart", "WordCloudChart"];
function base(chartName) {
  var trigger = chartName && chartType.includes(chartName) ? "item" : "axis";
  return {
    trigger,
    confine: true,
    borderRadius: Theme.config.tooltipBorderRaduis,
    axisPointer: {
      z: 0,
      type: "line",
      lineStyle: {
        type: Theme.config.tooltipAxisPointerLineType,
        width: Theme.config.tooltipAxisPointerLineWidth,
        color: Theme.config.tooltipAxisPointerLineColor
      },
      shadowStyle: {
        color: Theme.config.tooltipAxisPointerShadowColor
      }
    },
    textStyle: {
      color: Theme.config.tooltipTextColor,
      fontSize: Theme.config.tooltipTextFontSize
    },
    borderWidth: Theme.config.tooltipBorderWidth,
    padding: Theme.config.tooltipPadding,
    backgroundColor: Theme.config.tooltipBg,
    formatter: void 0,
    extraCssText: "box-shadow:0 " + Theme.config.tooltipShadowOffsetY + "px " + Theme.config.tooltipShadowBlur + "px 0 " + Theme.config.tooltipShadowColor + ";"
  };
}
export {
  base as default
};
