import base from "./base.mjs";
import axisPointer from "./axisPointer.mjs";
import merge from "../../../util/merge.mjs";
function tooltip(iChartOption, chartName, callBack) {
  var formatter = iChartOption.tipHtml;
  var formatterStyle = iChartOption.tipHtmlStyle;
  var tooltip2 = base(chartName);
  var extraCssText = tooltip2.extraCssText;
  if (formatter) {
    tooltip2.formatter = formatter;
  }
  if (formatterStyle) {
    tooltip2.padding = formatterStyle.padding || tooltip2.padding;
    tooltip2.backgroundColor = formatterStyle.backgroundColor || tooltip2.backgroundColor;
  }
  axisPointer(tooltip2, chartName);
  callBack && callBack(tooltip2);
  merge(tooltip2, iChartOption.tooltip);
  if (tooltip2.extraCssText) {
    tooltip2.extraCssText = tooltip2.extraCssText + extraCssText;
  }
  return tooltip2;
}
export {
  tooltip as default
};
