import base from "./base.mjs";
import name from "./name.mjs";
import axisLine from "./axisLine.mjs";
import axisLabel from "./axisLabel.mjs";
import axisMargin from "./axisMargin.mjs";
import boundaryGap from "./boundaryGap.mjs";
import merge from "../../../util/merge.mjs";
import { toArray } from "../../../util/type.mjs";
function xAxis(iChartOpt, callBack) {
  var xAxisResult = iChartOpt.xAxis || {};
  xAxisResult = toArray(xAxisResult).map(function(xAxisItem, xAxisItemIndex) {
    var xAxisUnit = base();
    name(xAxisUnit, xAxisItem, iChartOpt);
    boundaryGap(xAxisUnit, xAxisItem, iChartOpt);
    axisLabel(xAxisUnit, xAxisItem, iChartOpt);
    axisLine(xAxisUnit, xAxisItem, iChartOpt);
    axisMargin(xAxisUnit, xAxisItem);
    callBack && callBack(xAxisUnit, xAxisItemIndex);
    merge(xAxisUnit, xAxisItem);
    return xAxisUnit;
  });
  return xAxisResult;
}
export {
  xAxis as default
};
