import base from "./base.mjs";
import title from "../rectTitle/index.mjs";
import { isArray } from "../../../util/type.mjs";
import merge from "../../../util/merge.mjs";
import axisOptimization from "./axisOptimization.mjs";
function isNeedTitle(yAxisOpt, yAxisName) {
  if (yAxisName) {
    return true;
  }
  if (yAxisOpt.length === 1 && yAxisOpt[0] && yAxisOpt[0].position !== "right") {
    return true;
  }
  return false;
}
function yAxis(baseOpt, iChartOpt, chartName, callback) {
  var yAxisOpt = iChartOpt.yAxis;
  var yAxisName = iChartOpt.yAxisName;
  var data = iChartOpt.data;
  if (!isArray(yAxisOpt)) {
    yAxisOpt = [yAxisOpt];
  }
  if (isNeedTitle(yAxisOpt, yAxisName)) {
    var _yAxisOpt$;
    baseOpt.title = title(iChartOpt, chartName, (_yAxisOpt$ = yAxisOpt[0]) == null ? void 0 : _yAxisOpt$.nameTextStyle);
  }
  var yAxis2 = [];
  yAxisOpt.forEach(function(item, index) {
    var temp = base();
    if (item && item.unit) {
      temp.axisLabel.formatter = "{value} " + item.unit;
    }
    if (item && item.formatter) {
      temp.axisLabel.formatter = item.formatter;
    }
    if (item && item.name) {
      item.nameTextStyle = Object.assign(temp.nameTextStyle, item.nameTextStyle);
    }
    if (item && item.labelTextStyle) {
      item.labelTextStyle = Object.assign(temp.axisLabel, item.labelTextStyle);
    }
    if (item && item.splitLine) {
      item.splitLine = Object.assign(temp.splitLine, item.splitLine);
    }
    axisOptimization(item, temp, data);
    callback && callback(temp, index);
    temp = merge(temp, item);
    if (index === 0 && yAxisOpt.length === 1 && temp.position !== "right") {
      delete temp.name;
    }
    yAxis2.push(temp);
  });
  return yAxis2;
}
export {
  yAxis as default
};
