import LineChart from "./components/LineChart/index.mjs";
import BarChart from "./components/BarChart/index.mjs";
import PieChart from "./components/PieChart/index.mjs";
import RadarChart from "./components/RadarChart/index.mjs";
import GaugeChart from "./components/GaugeChart/index.mjs";
import BubbleChart from "./components/BubbleChart/index.mjs";
import WordCloudChart from "./components/WordCloudChart/index.mjs";
import SankeyChart from "./components/SankeyChart/index.mjs";
import HeatMapChart from "./components/HeatMapChart/index.mjs";
import ScatterChart from "./components/ScatterChart/index.mjs";
import JadeJueChart from "./components/JadeJueChart/index.mjs";
import TreeChart from "./components/TreeChart/index.mjs";
import TreeMapChart from "./components/TreeMapChart/index.mjs";
import HillChart from "./components/HillChart/index.mjs";
import GraphTreeChart from "./components/GraphTreeChart/index.mjs";
import ProcessChart from "./components/ProcessChart/index.mjs";
import PolarBarChart from "./components/PolarBarChart/index.mjs";
import CircleProcessChart from "./components/CircleProcessChart/index.mjs";
import SunburstChart from "./components/SunburstChart/index.mjs";
import FunnelChart from "./components/FunnelChart/index.mjs";
import LiquidfillChart from "./components/LiquidfillChart/index.mjs";
import BoxplotChart from "./components/BoxplotChart/index.mjs";
import RegionChart from "./components/RegionChart/index.mjs";
import CandlestickChart from "./components/CandlestickChart/index.mjs";
import GraphChart from "./components/GraphChart/index.mjs";
import AssembleBubbleChart from "./components/AssembleBubbleChart/index.mjs";
import BulletChart from "./components/BulletChart/index.mjs";
function Register() {
  this.registeredComp = {};
}
function registerComp(options) {
  this.registeredComp[options.name] = options.component;
}
function getRegisteredComp(name) {
  if (name in this.registeredComp) {
    return this.registeredComp[name];
  }
  return null;
}
Register.prototype.registerComp = registerComp;
Register.prototype.getRegisteredComp = getRegisteredComp;
var register = new Register();
var components = [{
  name: "AreaChart",
  component: LineChart
}, {
  name: "LineChart",
  component: LineChart
}, {
  name: "BarChart",
  component: BarChart
}, {
  name: "PieChart",
  component: PieChart
}, {
  name: "GaugeChart",
  component: GaugeChart
}, {
  name: "BubbleChart",
  component: BubbleChart
}, {
  name: "RadarChart",
  component: RadarChart
}, {
  name: "WordCloudChart",
  component: WordCloudChart
}, {
  name: "HeatMapChart",
  component: HeatMapChart
}, {
  name: "ScatterChart",
  component: ScatterChart
}, {
  name: "SankeyChart",
  component: SankeyChart
}, {
  name: "JadeJueChart",
  component: JadeJueChart
}, {
  name: "TreeChart",
  component: TreeChart
}, {
  name: "TreeMapChart",
  component: TreeMapChart
}, {
  name: "HillChart",
  component: HillChart
}, {
  name: "GraphTreeChart",
  component: GraphTreeChart
}, {
  name: "ProcessChart",
  component: ProcessChart
}, {
  name: "PolarBarChart",
  component: PolarBarChart
}, {
  name: "CircleProcessChart",
  component: CircleProcessChart
}, {
  name: "SunburstChart",
  component: SunburstChart
}, {
  name: "FunnelChart",
  component: FunnelChart
}, {
  name: "LiquidfillChart",
  component: LiquidfillChart
}, {
  name: "BoxplotChart",
  component: BoxplotChart
}, {
  name: "RegionChart",
  component: RegionChart
}, {
  name: "CandlestickChart",
  component: CandlestickChart
}, {
  name: "GraphChart",
  component: GraphChart
}, {
  name: "AssembleBubbleChart",
  component: AssembleBubbleChart
}, {
  name: "BulletChart",
  component: BulletChart
}];
components.forEach(function(comp) {
  register.registerComp(comp);
});
export {
  register as default
};
