var matchHtmlRegExp = /["'&<>/]/;
function escapeHtml(string) {
  var str = "" + string;
  var match = matchHtmlRegExp.exec(str);
  if (!match) {
    return str;
  }
  var escape;
  var html = "";
  var index;
  var lastIndex = 0;
  for (index = match.index; index < str.length; index++) {
    switch (str.charCodeAt(index)) {
      case 34:
        escape = "&quot;";
        break;
      case 38:
        escape = "&amp;";
        break;
      case 39:
        escape = "&#x27;";
        break;
      case 60:
        escape = "&lt;";
        break;
      case 62:
        escape = "&gt;";
        break;
      case 47:
        escape = "&#x2F;";
        break;
      default:
        continue;
    }
    if (lastIndex !== index) {
      html += str.substring(lastIndex, index);
    }
    lastIndex = index + 1;
    html += escape;
  }
  return lastIndex !== index ? html + str.substring(lastIndex, index) : html;
}
var _defendXSS = function defendXSS(obj) {
  if (typeof obj === "string") {
    return escapeHtml(obj);
  } else if (typeof obj === "number") {
    return obj;
  } else if (typeof obj === "object") {
    for (var key in obj) {
      if (Object.hasOwnProperty.call(obj, key)) {
        obj[key] = _defendXSS(obj[key]);
      }
    }
    return obj;
  } else {
    return obj;
  }
};
export {
  _defendXSS as default,
  escapeHtml
};
