var percentToDecimal = function percentToDecimal2(percent) {
  return parseFloat(percent) / 100;
};
var getEdge = function getEdge2(a, b, angle) {
  var edgeSqrt = Math.pow(a, 2) + Math.pow(b, 2) - 2 * a * b * Math.cos(angle / 180 * Math.PI);
  return Math.sqrt(edgeSqrt);
};
var getAngle = function getAngle2(a, b, c) {
  var cosA = (b * b + c * c - a * a) / (2 * b * c);
  var cosB = (a * a + c * c - b * b) / (2 * a * c);
  var cosC = (a * a + b * b - c * c) / (2 * a * b);
  var angleA = Math.acos(cosA) * 180 / Math.PI;
  var angleB = Math.acos(cosB) * 180 / Math.PI;
  var angleC = Math.acos(cosC) * 180 / Math.PI;
  return [angleA, angleB, angleC];
};
var getAngleByPoints = function getAngleByPoints2(a, b, c) {
  var edgeA = Math.sqrt(Math.pow(b.x - a.x, 2) + Math.pow(b.y - a.y, 2));
  var edgeB = Math.sqrt(Math.pow(b.x - c.x, 2) + Math.pow(b.y - c.y, 2));
  var edgeC = Math.sqrt(Math.pow(a.x - c.x, 2) + Math.pow(a.y - c.y, 2));
  return getAngle(edgeA, edgeB, edgeC);
};
var pointsDirection = function pointsDirection2(a, b, c) {
  var x1 = a.x, y1 = a.y;
  var x2 = b.x, y2 = b.y;
  var x3 = c.x, y3 = c.y;
  var ABx = x2 - x1;
  var ABy = y2 - y1;
  var ACx = x3 - x1;
  var ACy = y3 - y1;
  var crossProduct = ABx * ACy - ABy * ACx;
  if (crossProduct > 0) {
    return true;
  } else if (crossProduct < 0) {
    return false;
  } else {
    return false;
  }
};
var getItemCount = function getItemCount2(arr, item) {
  var count = 0;
  arr.forEach(function(key) {
    if (key === item) {
      count++;
    }
  });
  return count;
};
export {
  getAngle,
  getAngleByPoints,
  getEdge,
  getItemCount,
  percentToDecimal,
  pointsDirection
};
