import { isObject, isArray } from "./type.mjs";
function merge(target, task) {
  if (target === void 0) {
    target = task;
    return target;
  }
  if (isObject(task)) {
    for (var key in task) {
      if (target[key] === void 0 || target[key] === null) {
        target[key] = task[key];
      } else if (isObject(task[key]) && !isArray(task[key])) {
        merge(target[key], task[key]);
      } else {
        target[key] = task[key];
      }
    }
  }
  return target;
}
function mergeSeries(iChartOption, baseOption) {
  var userSeries = iChartOption.series;
  var baseSeries = baseOption.series;
  userSeries && userSeries.forEach(function(uitem) {
    var isNewSeries = true;
    baseSeries.forEach(function(bitem) {
      if (bitem.name === uitem.name) {
        isNewSeries = false;
        merge(bitem, uitem);
      }
    });
    if (isNewSeries) {
      baseSeries.push(uitem);
    }
  });
}
function mergeVisualMap(iChartOption, baseOption) {
  var userVisualMap = iChartOption.visualMap;
  if (userVisualMap) {
    baseOption.visualMap = userVisualMap;
  }
}
function mergeExtend(iChartOption, baseOption) {
  if (!iChartOption) return;
  var extend = iChartOption.extend;
  if (!extend) return;
  for (var key in extend) {
    if (Object.hasOwnProperty.call(extend, key)) {
      baseOption[key] = extend[key];
    }
  }
}
export {
  merge as default,
  mergeExtend,
  mergeSeries,
  mergeVisualMap
};
