function max(arr) {
  function handle(arr2) {
    return arr2.filter(function(item) {
      return Object.prototype.toString.call(item) === "[object Number]";
    });
  }
  function heapAjust(data, i, length) {
    var child = 2 * i + 1;
    while (child <= length) {
      var temp = data[i];
      if (child + 1 <= length && data[child] < data[child + 1]) {
        child = child + 1;
      }
      if (data[i] < data[child]) {
        data[i] = data[child];
        data[child] = temp;
        i = child;
        child = 2 * i + 1;
      } else {
        break;
      }
    }
  }
  function buildHeap(data) {
    for (var i = Math.floor(data.length / 2); i >= 0; i--) {
      heapAjust(data, i, data.length);
    }
  }
  function swap(arr2, i, j) {
    var temp = arr2[i];
    arr2[i] = arr2[j];
    arr2[j] = temp;
  }
  function heapSort(arr2) {
    var data = handle(arr2).slice(0);
    if (!(data instanceof Array)) return;
    if (data instanceof Array && data.length === 1) {
      return data;
    }
    buildHeap(data);
    for (var i = data.length - 1; i >= 0; i--) {
      swap(data, i, 0);
      heapAjust(data, 0, i - 1);
    }
    return data[data.length - 1];
  }
  return heapSort(arr);
}
export {
  max as default
};
