function throttle(delay, callback) {
  var timeoutID;
  var lastExec = 0;
  function clearExistingTimeout() {
    timeoutID && clearTimeout(timeoutID);
  }
  return function wrapper() {
    for (var _len = arguments.length, arguments_ = new Array(_len), _key = 0; _key < _len; _key++) {
      arguments_[_key] = arguments[_key];
    }
    var __self = this;
    var elapsed = Date.now() - lastExec;
    function exec() {
      lastExec = Date.now();
      callback.apply(__self, arguments_);
    }
    clearExistingTimeout();
    if (elapsed > delay) {
      exec();
    } else {
      timeoutID = setTimeout(exec, delay - elapsed);
    }
  };
}
export {
  throttle as default
};
