import { draggable } from "../utils/use-drag.mjs";
import { initState, useDrag, initWatch, useUpdate } from "./index.mjs";
const api = ["state", "wrapper", "cursor"];
const renderless = (props, hooks, utils) => {
  const state = initState(props, hooks);
  const { ref, onMounted } = hooks;
  const { emit } = utils;
  const wrapper = ref();
  const update = useUpdate(state, props, wrapper);
  const onDrag = useDrag(state, wrapper, props, utils);
  initWatch(state, update, hooks);
  onMounted(() => {
    const drag = {
      drag: (event) => {
        onDrag(event);
      },
      end: (event) => {
        onDrag(event);
      }
    };
    draggable(wrapper.value, drag);
    update();
    emit("ready", update);
  });
  const api2 = { state, wrapper };
  return api2;
};
export {
  api,
  renderless
};
