import rules_default from "../rules/index.mjs";
import { isEmptyValue } from "../util.mjs";
import { hasOwn } from "../../type.mjs";
function date_default(rule, checkValue, callback, source, options) {
  const errors = [];
  const validate = rule.required || !rule.required && hasOwn.call(source, rule.field);
  const isValidDateStr = (value) => value && typeof value === "string" && new Date(value).toString() !== "Invalid Date";
  if (validate) {
    if (isEmptyValue(checkValue) && !rule.required) {
      return callback();
    }
    rules_default.required({ rule, checkValue, source, errors, options });
    if (!isEmptyValue(checkValue)) {
      let dateObject;
      if (typeof checkValue === "number" || isValidDateStr(checkValue)) {
        dateObject = new Date(checkValue);
      } else {
        dateObject = checkValue;
      }
      rules_default.type(rule, dateObject, source, errors, options);
      if (dateObject && typeof dateObject.getTime === "function") {
        rules_default.range(rule, dateObject.getTime(), source, errors, options);
      }
    }
  }
  callback(errors);
}
export {
  date_default as default
};
