import rules_default from "../rules/index.mjs";
import { isEmptyValue } from "../util.mjs";
import { hasOwn } from "../../type.mjs";
const ENUM = "enum";
function enum_default(rule, checkValue, callback, source, options) {
  const errors = [];
  const validate = rule.required || !rule.required && hasOwn.call(source, rule.field);
  if (validate) {
    if (isEmptyValue(checkValue) && !rule.required) {
      return callback();
    }
    rules_default.required({ rule, checkValue, source, errors, options });
    if (checkValue !== void 0) {
      rules_default[ENUM](rule, checkValue, source, errors, options);
    }
  }
  callback(errors);
}
export {
  enum_default as default
};
