import rules_default from "../rules/index.mjs";
import { isEmptyValue } from "../util.mjs";
import { hasOwn } from "../../type.mjs";
function string_default(rule, checkValue, callback, source, options) {
  const errors = [];
  const validate = rule.required || !rule.required && hasOwn.call(source, rule.field);
  if (validate) {
    if (isEmptyValue(checkValue, "string") && !rule.required) {
      return callback();
    }
    rules_default.required({
      rule,
      checkValue,
      source,
      errors,
      options,
      type: "string"
    });
    if (!isEmptyValue(checkValue, "string")) {
      rules_default.type(rule, checkValue, source, errors, options);
      rules_default.range(rule, checkValue, source, errors, options);
      rules_default.pattern(rule, checkValue, source, errors, options);
      if (rule.whitespace === true) {
        rules_default.whitespace(rule, checkValue, source, errors, options);
      }
    }
  }
  callback(errors);
}
export {
  string_default as default
};
