import arrayEach_default from "./arrayEach.mjs";
import toArray_default from "./toArray.mjs";
import map_default from "./map.mjs";
import isFunction_default from "../base/isFunction.mjs";
import isUndefined_default from "../base/isUndefined.mjs";
import isNull_default from "../base/isNull.mjs";
import get_default from "../base/get.mjs";
import property_default from "../function/property.mjs";
const sortByDef = (v1, v2) => {
  if (isUndefined_default(v1) || isUndefined_default(v2)) {
    return isUndefined_default(v2) ? 1 : -1;
  }
  if (isNull_default(v1) || isNull_default(v2)) {
    return isNull_default(v2) ? 1 : -1;
  }
  return v1 && v1.localeCompare ? v1.localeCompare(v2) : v1 > v2 ? 1 : -1;
};
const sortMultis = (name, compares) => (item1, item2) => {
  let v1 = item1[name];
  let v2 = item2[name];
  if (v1 === v2) {
    return compares ? compares(item1, item2) : 0;
  }
  return sortByDef(v1, v2);
};
const getSortPros = (arr, list, iterate, context) => {
  iterate = Array.isArray(iterate) ? iterate : [iterate];
  arrayEach_default(iterate, (prop, index) => {
    let eachCallback;
    if (isFunction_default(prop)) {
      eachCallback = (val, key) => {
        val[index] = prop.call(context, val.data, key, arr);
      };
    } else {
      eachCallback = (val) => {
        val[index] = get_default(val.data, prop);
      };
    }
    arrayEach_default(list, eachCallback);
  });
  return iterate;
};
const sortBy = (arr, iterate, context, STR_UNDEFINED) => {
  if (arr) {
    if (iterate === STR_UNDEFINED) {
      return toArray_default(arr).sort(sortByDef);
    }
    let compares;
    let list = map_default(arr, (item) => ({ data: item }));
    let sortPros = getSortPros(arr, list, iterate, context);
    let len = sortPros.length;
    if (len) {
      while (len >= 0) {
        compares = sortMultis(len, compares);
        len--;
      }
      list = list.sort(compares);
    }
    return map_default(list, property_default("data"));
  }
  return [];
};
var sortBy_default = sortBy;
export {
  sortBy_default as default
};
