import each_default from "../base/each.mjs";
import isFunction_default from "../base/isFunction.mjs";
import toNumber_default from "../number/toNumber.mjs";
const sum = (array, iterate, context) => {
  let result = 0;
  let eachCallback;
  if (iterate) {
    if (isFunction_default(iterate)) {
      eachCallback = (...args) => {
        result += toNumber_default(iterate.apply(context, args));
      };
    } else {
      eachCallback = (val) => {
        result += toNumber_default(val[iterate]);
      };
    }
  } else {
    eachCallback = (val) => {
      result += toNumber_default(val);
    };
  }
  each_default(array, eachCallback);
  return result;
};
var sum_default = sum;
export {
  sum_default as default
};
