import isNull_default from "./isNull.mjs";
import isObject_default from "./isObject.mjs";
import assign_default from "../object/assign.mjs";
import isPlainObject_default from "./isPlainObject.mjs";
import objectEach_default from "../object/objectEach.mjs";
import helperDeleteProperty_default from "./helperDeleteProperty.mjs";
const clear = function(obj, defs, assigns) {
  if (!obj) {
    return obj;
  }
  let isDefs = arguments.length > 1 && (isNull_default(defs) || !isObject_default(defs));
  let extds = isDefs ? assigns : defs;
  if (isPlainObject_default(obj)) {
    let eachCallback;
    if (isDefs) {
      eachCallback = (val, key) => {
        obj[key] = defs;
      };
    } else {
      eachCallback = (val, key) => {
        helperDeleteProperty_default(obj, key);
      };
    }
    objectEach_default(obj, eachCallback);
    if (extds) {
      assign_default(obj, extds);
    }
  } else if (Array.isArray(obj)) {
    if (isDefs) {
      let len = obj.length;
      while (len > 0) {
        len--;
        obj[len] = defs;
      }
    } else {
      obj.length = 0;
    }
    if (extds) {
      obj.push.apply(obj, extds);
    }
  }
  return obj;
};
var clear_default = clear;
export {
  clear_default as default
};
