import eqNull_default from "./eqNull.mjs";
import hasOwnProp_default from "./hasOwnProp.mjs";
import isUndefined_default from "./isUndefined.mjs";
import helperGetHGSKeys_default from "./helperGetHGSKeys.mjs";
import staticHGKeyRE_default from "../static/staticHGKeyRE.mjs";
const valGet = (obj, key) => {
  const matchs = key ? key.match(staticHGKeyRE_default) : "";
  return matchs ? matchs[1] ? obj[matchs[1]] ? obj[matchs[1]][matchs[2]] : void 0 : obj[matchs[2]] : obj[key];
};
const pathGet = (obj, property) => {
  if (!obj) {
    return;
  }
  let rest;
  let index = 0;
  const getRest = (len, props) => {
    for (rest = obj; index < len; index++) {
      rest = valGet(rest, props[index]);
      if (eqNull_default(rest)) {
        return;
      }
    }
  };
  if (obj[property] || hasOwnProp_default(obj, property)) {
    return obj[property];
  } else {
    const props = helperGetHGSKeys_default(property);
    const len = props.length;
    if (len) {
      getRest(len, props);
    }
    return rest;
  }
};
const get = (obj, property, defaultValue) => {
  if (eqNull_default(obj)) {
    return defaultValue;
  }
  const result = pathGet(obj, property);
  return isUndefined_default(result) ? defaultValue : result;
};
var get_default = get;
export {
  get_default as default
};
