import isFunction_default from "./isFunction.mjs";
import isString_default from "./isString.mjs";
import hasOwnProp_default from "./hasOwnProp.mjs";
const helperCreateiterateIndexOf = (callback) => (obj, iterate, context) => {
  if (!obj || !isFunction_default(iterate)) {
    return -1;
  }
  if (Array.isArray(obj) || isString_default(obj)) {
    return callback(obj, iterate, context);
  }
  for (let key of Object.keys(obj)) {
    if (hasOwnProp_default(obj, key) && iterate.call(context, obj[key], key, obj)) {
      return key;
    }
  }
  return -1;
};
var helperCreateiterateIndexOf_default = helperCreateiterateIndexOf;
export {
  helperCreateiterateIndexOf_default as default
};
