import helperDeleteProperty_default from "./helperDeleteProperty.mjs";
import isFunction_default from "./isFunction.mjs";
import each_default from "./each.mjs";
import arrayEach_default from "../array/arrayEach.mjs";
import lastEach_default from "./lastEach.mjs";
import clear_default from "./clear.mjs";
import eqNull_default from "./eqNull.mjs";
const pluckProperty = (name) => (obj, key) => key === name;
const remove = (obj, iterate, context) => {
  if (obj) {
    if (!eqNull_default(iterate)) {
      let removeIndexs = [];
      let rest = [];
      if (!isFunction_default(iterate)) {
        iterate = pluckProperty(iterate);
      }
      each_default(obj, (item, index, rest2) => {
        if (iterate.call(context, item, index, rest2)) {
          removeIndexs.push(index);
        }
      });
      if (Array.isArray(obj)) {
        lastEach_default(removeIndexs, (item) => {
          rest.push(obj[item]);
          obj.splice(item, 1);
        });
      } else {
        rest = {};
        arrayEach_default(removeIndexs, (key) => {
          rest[key] = obj[key];
          helperDeleteProperty_default(obj, key);
        });
      }
      return rest;
    }
    return clear_default(obj);
  }
  return obj;
};
var remove_default = remove;
export {
  remove_default as default
};
