import each_default from "../base/each.mjs";
import isFunction_default from "../base/isFunction.mjs";
import property_default from "../function/property.mjs";
const objectMap = (obj, iterate, context) => {
  let result = {};
  if (obj) {
    if (iterate) {
      if (!isFunction_default(iterate)) {
        iterate = property_default(iterate);
      }
      each_default(obj, (val, index) => {
        result[index] = iterate.call(context, val, index, obj);
      });
    } else {
      return obj;
    }
  }
  return result;
};
var objectMap_default = objectMap;
export {
  objectMap_default as default
};
