var timezone_default = {
  "enUS": [
    {
      name: "(UTC-12:00)International Date Line West",
      code: "001-12",
      offset: -12,
      tz: "Etc/GMT+12"
    },
    {
      name: "(UTC+13:00)Samoa",
      code: "002-11",
      offset: 14,
      tz: "Pacific/Apia"
    },
    {
      name: "(UTC-11:00)Coordinated Universal Time-11",
      code: "003-11",
      offset: -11,
      tz: "Etc/GMT+11"
    },
    {
      name: "(UTC-10:00)Hawaii",
      code: "004-10",
      offset: -10,
      tz: "Pacific/Honolulu"
    },
    {
      name: "(UTC-09:00)Alaska",
      code: "005-9",
      offset: -9,
      tz: "America/Anchorage"
    },
    {
      name: "(UTC-08:00)Pacific Time (US & Canada)",
      code: "006-8",
      offset: -8,
      tz: "America/Los_Angeles"
    },
    {
      name: "(UTC-08:00)Baja California",
      code: "007-8",
      offset: -8,
      tz: "America/Santa_Isabel"
    },
    {
      name: "(UTC-07:00)Chihuahua, La Paz, Mazatlan",
      code: "008-7",
      offset: -7,
      tz: "America/Chihuahua"
    },
    {
      name: "(UTC-07:00)Mountain Time (US & Canada)",
      code: "009-7",
      offset: -7,
      tz: "America/Denver"
    },
    {
      name: "(UTC-07:00)Arizona",
      code: "010-7",
      offset: -7,
      tz: "America/Phoenix"
    },
    {
      name: "(UTC-06:00)Guadalajara, Mexico City, Monterey",
      code: "011-6",
      offset: -6,
      tz: "America/Mexico_City"
    },
    {
      name: "(UTC-06:00)Saskatchewan",
      code: "012-6",
      offset: -6,
      tz: "America/Regina"
    },
    {
      name: "(UTC-06:00)Central Time (US & Canada)",
      code: "013-6",
      offset: -6,
      tz: "America/Chicago"
    },
    {
      name: "(UTC-06:00)Central America",
      code: "014-6",
      offset: -6,
      tz: "America/Guatemala"
    },
    {
      name: "(UTC-05:00)Bogota, Lima, Quito",
      code: "015-5",
      offset: -5,
      tz: "America/Bogota"
    },
    {
      name: "(UTC-05:00)Eastern Time (US & Canada)",
      code: "016-5",
      offset: -5,
      tz: "America/New_York"
    },
    {
      name: "(UTC-05:00)Indiana(East)",
      code: "017-5",
      offset: -5,
      tz: "America/Indiana/Indianapolis"
    },
    {
      name: "(UTC-04:30)Caracas",
      code: "018-4.5",
      offset: -4,
      tz: "America/Caracas"
    },
    {
      name: "(UTC-04:00)Atlantic Time (Canada)",
      code: "019-4",
      offset: -4,
      tz: "America/Halifax"
    },
    {
      name: "(UTC-04:00)Cuiaba",
      code: "020-4",
      offset: -4,
      tz: "America/Cuiaba"
    },
    {
      name: "(UTC-04:00)Georgetown, La Paz, Manaus, San Juan",
      code: "021-4",
      offset: -4,
      tz: "America/La_Paz"
    },
    {
      name: "(UTC-04:00)Santiago",
      code: "022-4",
      offset: -3,
      tz: "America/Santiago"
    },
    {
      name: "(UTC-04:00)Asuncion",
      code: "023-4",
      offset: -3,
      tz: "America/Asuncion"
    },
    {
      name: "(UTC-03:30)Newfoundland",
      code: "024-3.5",
      offset: -3.5,
      tz: "America/St_Johns"
    },
    {
      name: "(UTC-03:00)Brasilia",
      code: "025-3",
      offset: -3,
      tz: "America/Sao_Paulo"
    },
    {
      name: "(UTC-03:00)Buenos Aires",
      code: "026-3",
      offset: -3,
      tz: "America/Argentina/Buenos_Aires"
    },
    {
      name: "(UTC-03:00)Greenland",
      code: "027-3",
      offset: -3,
      tz: "America/Godthab"
    },
    {
      name: "(UTC-03:00)Cayenne, Fortaleza",
      code: "028-3",
      offset: -3,
      tz: "America/Cayenne"
    },
    {
      name: "(UTC-03:00)Montevideo",
      code: "029-3",
      offset: -3,
      tz: "America/Montevideo"
    },
    {
      name: "(UTC-11:00)Coordinated Universal Time-11",
      code: "030-2",
      offset: -11,
      tz: "Etc/GMT+11"
    },
    {
      name: "(UTC-02:00)Mid-Atlantic",
      code: "031-2",
      offset: -4,
      tz: "America/Halifax"
    },
    {
      name: "(UTC-01:00)Cape Verde Is",
      code: "032-1",
      offset: -1,
      tz: "Atlantic/Cape_Verde"
    },
    {
      name: "(UTC-01:00)Azores",
      code: "033-1",
      offset: -1,
      tz: "Atlantic/Azores"
    },
    {
      name: "(UTC)Dublin, Edinburgh, Lisbon, London",
      code: "034-0",
      offset: 0,
      tz: "Europe/London"
    },
    {
      name: "(UTC)Casablanca",
      code: "035-0",
      offset: 1,
      tz: "Africa/Casablanca"
    },
    {
      name: "(UTC)Monrovia, Reykjavik",
      code: "036-0",
      offset: 0,
      tz: "Atlantic/Reykjavik"
    },
    {
      name: "(UTC)Coordinated Universal Time",
      code: "037-0",
      offset: 0,
      tz: "Etc/GMT"
    },
    {
      name: "(UTC+01:00)Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna",
      code: "038+1",
      offset: 1,
      tz: "Europe/Berlin"
    },
    {
      name: "(UTC+01:00)Belgrade, Bratislava, Budapest, Ljubljana, Prague",
      code: "039+1",
      offset: 1,
      tz: "Europe/Budapest"
    },
    {
      name: "(UTC+01:00)Brussels, Copenhagen, Madrid, Paris",
      code: "040+1",
      offset: 1,
      tz: "Europe/Paris"
    },
    {
      name: "(UTC+01:00)Sarajevo, Skopje, Warsaw, Zagreb",
      code: "041+1",
      offset: 1,
      tz: "Europe/Warsaw"
    },
    {
      name: "(UTC+01:00)Windhoek",
      code: "042+1",
      offset: 2,
      tz: "Africa/Windhoek"
    },
    {
      name: "(UTC+01:00)West Central Africa",
      code: "043+1",
      offset: 1,
      tz: "Africa/Lagos"
    },
    {
      name: "(UTC+02:00)Amman",
      code: "044+2",
      offset: 2,
      tz: "Asia/Amman"
    },
    {
      name: "(UTC+02:00)Beirut",
      code: "045+2",
      offset: 2,
      tz: "Asia/Beirut"
    },
    {
      name: "(UTC+02:00)Damascus",
      code: "046+2",
      offset: 2,
      tz: "Asia/Damascus"
    },
    {
      name: "(UTC+02:00)Harare, Pretoria",
      code: "047+2",
      offset: 2,
      tz: "Africa/Johannesburg"
    },
    {
      name: "(UTC+02:00)Helsinki, Kiev, Riga, Sofia, Tallinn, Vilnius",
      code: "048+2",
      offset: 2,
      tz: "Europe/Kiev"
    },
    {
      name: "(UTC+02:00)Cairo",
      code: "049+2",
      offset: 2,
      tz: "Africa/Cairo"
    },
    {
      name: "(UTC+02:00)Minsk",
      code: "050+2",
      offset: 3,
      tz: "Europe/Minsk"
    },
    {
      name: "(UTC+02:00)Athens, Bucharest, Istanbul",
      code: "051+2",
      offset: 3,
      tz: "Europe/Istanbul"
    },
    {
      name: "(UTC+02:00)Jerusalem",
      code: "052+2",
      offset: 2,
      tz: "Asia/Jerusalem"
    },
    {
      name: "(UTC+03:00)Baghdad",
      code: "053+3",
      offset: 3,
      tz: "Asia/Baghdad"
    },
    {
      name: "(UTC+03:00)Kuwait, Riyadh",
      code: "054+3",
      offset: 3,
      tz: "Asia/Riyadh"
    },
    {
      name: "(UTC+03:00)Moscow, St. Petersburg, Volgograd",
      code: "055+3",
      offset: 3,
      tz: "Europe/Moscow"
    },
    {
      name: "(UTC+03:00)Nairobi",
      code: "056+3",
      offset: 3,
      tz: "Africa/Nairobi"
    },
    {
      name: "(UTC+03:30)Teheran",
      code: "057+3.5",
      offset: 3.5,
      tz: "Asia/Tehran"
    },
    {
      name: "(UTC+04:00)Abu Dhabi, Muscat",
      code: "058+4",
      offset: 4,
      tz: "Asia/Dubai"
    },
    {
      name: "(UTC+04:00)Yerevan",
      code: "059+4",
      offset: 4,
      tz: "Asia/Yerevan"
    },
    {
      name: "(UTC+04:00)Baku",
      code: "060+4",
      offset: 4,
      tz: "Asia/Baku"
    },
    {
      name: "(UTC+04:00)Tbilisi",
      code: "061+4",
      offset: 4,
      tz: "Asia/Tbilisi"
    },
    {
      name: "(UTC+04:00)Port Louis",
      code: "062+4",
      offset: 4,
      tz: "Indian/Mauritius"
    },
    {
      name: "(UTC+04:30)Kabul",
      code: "063+4.5",
      offset: 4.5,
      tz: "Asia/Kabul"
    },
    {
      name: "(UTC+05:00)Tashkent",
      code: "064+5",
      offset: 5,
      tz: "Asia/Tashkent"
    },
    {
      name: "(UTC+05:00)Yekaterinburg",
      code: "065+5",
      offset: 5,
      tz: "Asia/Yekaterinburg"
    },
    {
      name: "(UTC+05:00)Islamabad, Karachi",
      code: "066+5",
      offset: 5,
      tz: "Asia/Karachi"
    },
    {
      name: "(UTC+05:30)Chennai, Kolkata, Mumbai, New Delhi",
      code: "067+5.5",
      offset: 5.5,
      tz: "Asia/Kolkata"
    },
    {
      name: "(UTC+05:30)Sri Jayawardenepura",
      code: "068+5.5",
      offset: 5.5,
      tz: "Asia/Colombo"
    },
    {
      name: "(UTC+05:45)Katmandu",
      code: "069+5.75",
      offset: 5.75,
      tz: "Asia/Kathmandu"
    },
    {
      name: "(UTC+06:00)Astana",
      code: "070+6",
      offset: 6,
      tz: "Asia/Almaty"
    },
    {
      name: "(UTC+06:00)Dhaka",
      code: "071+6",
      offset: 6,
      tz: "Asia/Dhaka"
    },
    {
      name: "(UTC+07:00)Novosibirsk",
      code: "072+6",
      offset: 7,
      tz: "Asia/Novosibirsk"
    },
    {
      name: "(UTC+06:30)Yangon(Rangoon)",
      code: "073+6.5",
      offset: 6.5,
      tz: "Asia/Yangon"
    },
    {
      name: "(UTC+07:00)Krasnoyarsk",
      code: "074+7",
      offset: 7,
      tz: "Asia/Krasnoyarsk"
    },
    {
      name: "(UTC+07:00)Bangkok, Hanoi, Jakarta",
      code: "075+7",
      offset: 7,
      tz: "Asia/Bangkok"
    },
    {
      name: "(UTC+08:00)Beijing, Chongqing, Hong Kong, Urumqi",
      code: "076+8",
      offset: 8,
      tz: "Asia/Shanghai"
    },
    {
      name: "(UTC+08:00)Kuala Lumpur, Singapore",
      code: "077+8",
      offset: 8,
      tz: "Asia/Singapore"
    },
    {
      name: "(UTC+08:00)Perth",
      code: "078+8",
      offset: 8,
      tz: "Australia/Perth"
    },
    {
      name: "(UTC+08:00)Taipei",
      code: "079+8",
      offset: 8,
      tz: "Asia/Taipei"
    },
    {
      name: "(UTC+08:00)Ulaanbaatar",
      code: "080+8",
      offset: 8,
      tz: "Asia/Ulaanbaatar"
    },
    {
      name: "(UTC+08:00)Irkutsk",
      code: "081+8",
      offset: 8,
      tz: "Asia/Irkutsk"
    },
    {
      name: "(UTC+09:00)Osaka, Sapporo, Tokyo",
      code: "082+9",
      offset: 9,
      tz: "Asia/Tokyo"
    },
    {
      name: "(UTC+09:00)Seoul",
      code: "083+9",
      offset: 9,
      tz: "Asia/Seoul"
    },
    {
      name: "(UTC+09:00)Yakutsk",
      code: "084+9",
      offset: 9,
      tz: "Asia/Yakutsk"
    },
    {
      name: "(UTC+09:30)Adelaide",
      code: "085+9.5",
      offset: 10.5,
      tz: "Australia/Adelaide"
    },
    {
      name: "(UTC+09:30)Darwin",
      code: "086+9.5",
      offset: 9.5,
      tz: "Australia/Darwin"
    },
    {
      name: "(UTC+10:00)Brisbane",
      code: "087+10",
      offset: 10,
      tz: "Australia/Brisbane"
    },
    {
      name: "(UTC+10:00)Vladivostok",
      code: "088+10",
      offset: 10,
      tz: "Asia/Vladivostok"
    },
    {
      name: "(UTC+10:00)Guam, Port Moresby",
      code: "089+10",
      offset: 10,
      tz: "Pacific/Port_Moresby"
    },
    {
      name: "(UTC+10:00)Hobart",
      code: "090+10",
      offset: 11,
      tz: "Australia/Hobart"
    },
    {
      name: "(UTC+10:00)Canberra, Melbourne, Sydney",
      code: "091+10",
      offset: 11,
      tz: "Australia/Sydney"
    },
    {
      name: "(UTC+11:00)Magadan",
      code: "092+11",
      offset: 11,
      tz: "Asia/Magadan"
    },
    {
      name: "(UTC+11:00)Solomon Is, New Caledonia",
      code: "093+11",
      offset: 11,
      tz: "Pacific/Guadalcanal"
    },
    {
      name: "(UTC+12:00)Auckland, Wellington",
      code: "094+12",
      offset: 13,
      tz: "Pacific/Auckland"
    },
    {
      name: "(UTC+12:00)Fiji",
      code: "095+12",
      offset: 13,
      tz: "Pacific/Fiji"
    },
    {
      name: "(UTC+12:00)Coordinated Universal Time+12",
      code: "096+12",
      offset: 12,
      tz: "Etc/GMT-12"
    },
    {
      name: "(UTC+13:00)Nuku`alofa",
      code: "097+13",
      offset: 13,
      tz: "Pacific/Tongatapu"
    }
  ],
  "zhCN": [
    {
      name: "(UTC-12:00)国际日期变更线西",
      code: "001-12",
      offset: -12,
      tz: "Etc/GMT+12"
    },
    {
      name: "(UTC+13:00) 萨摩亚群岛",
      code: "002-11",
      offset: 14,
      tz: "Pacific/Apia"
    },
    {
      name: "(UTC-11:00)协调世界时-11",
      code: "003-11",
      offset: -11,
      tz: "Etc/GMT+11"
    },
    {
      name: "(UTC-10:00)夏威夷",
      code: "004-10",
      offset: -10,
      tz: "Pacific/Honolulu"
    },
    {
      name: "(UTC-09:00)阿拉斯加",
      code: "005-9",
      offset: -9,
      tz: "America/Anchorage"
    },
    {
      name: "(UTC-08:00)太平洋时间(美国和加拿大)",
      code: "006-8",
      offset: -8,
      tz: "America/Los_Angeles"
    },
    {
      name: "(UTC-08:00)下加利福尼亚州",
      code: "007-8",
      offset: -8,
      tz: "America/Santa_Isabel"
    },
    {
      name: "(UTC-07:00)奇瓦瓦，拉巴斯，马萨特兰",
      code: "008-7",
      offset: -7,
      tz: "America/Chihuahua"
    },
    {
      name: "(UTC-07:00)山地时间(美国和加拿大)",
      code: "009-7",
      offset: -7,
      tz: "America/Denver"
    },
    {
      name: "(UTC-07:00)亚利桑那",
      code: "010-7",
      offset: -7,
      tz: "America/Phoenix"
    },
    {
      name: "(UTC-06:00)瓜达拉哈拉，墨西哥城，蒙特雷",
      code: "011-6",
      offset: -6,
      tz: "America/Mexico_City"
    },
    {
      name: "(UTC-06:00)萨斯喀彻温",
      code: "012-6",
      offset: -6,
      tz: "America/Regina"
    },
    {
      name: "(UTC-06:00)中部时间(美国和加拿大)",
      code: "013-6",
      offset: -6,
      tz: "America/Chicago"
    },
    {
      name: "(UTC-06:00)中美洲",
      code: "014-6",
      offset: -6,
      tz: "America/Guatemala"
    },
    {
      name: "(UTC-05:00)波哥大，利马，基多",
      code: "015-5",
      offset: -5,
      tz: "America/Bogota"
    },
    {
      name: "(UTC-05:00)东部时间(美国和加拿大)",
      code: "016-5",
      offset: -5,
      tz: "America/New_York"
    },
    {
      name: "(UTC-05:00)印地安那州(东部)",
      code: "017-5",
      offset: -5,
      tz: "America/Indiana/Indianapolis"
    },
    {
      name: "(UTC-04:30)加拉加斯",
      code: "018-4.5",
      offset: -4,
      tz: "America/Caracas"
    },
    {
      name: "(UTC-04:00)大西洋时间(加拿大)",
      code: "019-4",
      offset: -4,
      tz: "America/Halifax"
    },
    {
      name: "(UTC-04:00)库亚巴",
      code: "020-4",
      offset: -4,
      tz: "America/Cuiaba"
    },
    {
      name: "(UTC-04:00)乔治敦，拉巴斯，马瑙斯，圣胡安",
      code: "021-4",
      offset: -4,
      tz: "America/La_Paz"
    },
    {
      name: "(UTC-04:00)圣地亚哥",
      code: "022-4",
      offset: -3,
      tz: "America/Santiago"
    },
    {
      name: "(UTC-04:00)亚松森",
      code: "023-4",
      offset: -3,
      tz: "America/Asuncion"
    },
    {
      name: "(UTC-03:30)纽芬兰",
      code: "024-3.5",
      offset: -3.5,
      tz: "America/St_Johns"
    },
    {
      name: "(UTC-03:00)巴西利亚",
      code: "025-3",
      offset: -3,
      tz: "America/Sao_Paulo"
    },
    {
      name: "(UTC-03:00)布宜诺斯艾利斯",
      code: "026-3",
      offset: -3,
      tz: "America/Argentina/Buenos_Aires"
    },
    {
      name: "(UTC-03:00)格陵兰",
      code: "027-3",
      offset: -3,
      tz: "America/Godthab"
    },
    {
      name: "(UTC-03:00)卡宴，福塔雷萨",
      code: "028-3",
      offset: -3,
      tz: "America/Cayenne"
    },
    {
      name: "(UTC-03:00)蒙得维的亚",
      code: "029-3",
      offset: -3,
      tz: "America/Montevideo"
    },
    {
      name: "(UTC-11:00)协调世界时-11",
      code: "030-2",
      offset: -11,
      tz: "Etc/GMT+11"
    },
    {
      name: "(UTC-02:00)中大西洋",
      code: "031-2",
      offset: -4,
      tz: "America/Halifax"
    },
    {
      name: "(UTC-01:00)佛得角群岛",
      code: "032-1",
      offset: -1,
      tz: "Atlantic/Cape_Verde"
    },
    {
      name: "(UTC-01:00)亚速尔群岛",
      code: "033-1",
      offset: -1,
      tz: "Atlantic/Azores"
    },
    {
      name: "(UTC)都柏林，爱丁堡，里斯本，伦敦",
      code: "034-0",
      offset: 0,
      tz: "Europe/London"
    },
    {
      name: "(UTC)卡萨布兰卡",
      code: "035-0",
      offset: 1,
      tz: "Africa/Casablanca"
    },
    {
      name: "(UTC)蒙罗维亚，雷克雅未克",
      code: "036-0",
      offset: 0,
      tz: "Atlantic/Reykjavik"
    },
    {
      name: "(UTC)协调世界时",
      code: "037-0",
      offset: 0,
      tz: "Etc/GMT"
    },
    {
      name: "(UTC+01:00)阿姆斯特丹，柏林，伯尔尼，罗马，斯德哥尔摩，维也纳",
      code: "038+1",
      offset: 1,
      tz: "Europe/Berlin"
    },
    {
      name: "(UTC+01:00)贝尔格莱德，布拉迪斯拉发，布达佩斯，卢布尔雅那，布拉格",
      code: "039+1",
      offset: 1,
      tz: "Europe/Budapest"
    },
    {
      name: "(UTC+01:00)布鲁塞尔，哥本哈根，马德里，巴黎",
      code: "040+1",
      offset: 1,
      tz: "Europe/Paris"
    },
    {
      name: "(UTC+01:00)萨拉热窝，斯科普里，华沙，萨格勒布",
      code: "041+1",
      offset: 1,
      tz: "Europe/Warsaw"
    },
    {
      name: "(UTC+01:00)温得和克",
      code: "042+1",
      offset: 2,
      tz: "Africa/Windhoek"
    },
    {
      name: "(UTC+01:00)中非西部",
      code: "043+1",
      offset: 1,
      tz: "Africa/Lagos"
    },
    {
      name: "(UTC+02:00)安曼",
      code: "044+2",
      offset: 2,
      tz: "Asia/Amman"
    },
    {
      name: "(UTC+02:00)贝鲁特",
      code: "045+2",
      offset: 2,
      tz: "Asia/Beirut"
    },
    {
      name: "(UTC+02:00)大马士革",
      code: "046+2",
      offset: 2,
      tz: "Asia/Damascus"
    },
    {
      name: "(UTC+02:00)哈拉雷，比勒陀利亚",
      code: "047+2",
      offset: 2,
      tz: "Africa/Johannesburg"
    },
    {
      name: "(UTC+02:00)赫尔辛基，基辅，里加，索非亚，塔林，维尔纽斯",
      code: "048+2",
      offset: 2,
      tz: "Europe/Kiev"
    },
    {
      name: "UTC+02:00)开罗",
      code: "049+2",
      offset: 2,
      tz: "Africa/Cairo"
    },
    {
      name: "(UTC+02:00)明斯克",
      code: "050+2",
      offset: 3,
      tz: "Europe/Minsk"
    },
    {
      name: "(UTC+02:00)雅典，布加勒斯特，伊斯坦布尔",
      code: "051+2",
      offset: 3,
      tz: "Europe/Istanbul"
    },
    {
      name: "(UTC+02:00)耶路撒冷",
      code: "052+2",
      offset: 2,
      tz: "Asia/Jerusalem"
    },
    {
      name: "(UTC+03:00)巴格达",
      code: "053+3",
      offset: 3,
      tz: "Asia/Baghdad"
    },
    {
      name: "(UTC+03:00)科威特，利雅得",
      code: "054+3",
      offset: 3,
      tz: "Asia/Riyadh"
    },
    {
      name: "(UTC+03:00)莫斯科，圣彼得堡，伏尔加格勒",
      code: "055+3",
      offset: 3,
      tz: "Europe/Moscow"
    },
    {
      name: "(UTC+03:00)内罗毕",
      code: "056+3",
      offset: 3,
      tz: "Africa/Nairobi"
    },
    {
      name: "(UTC+03:30)德黑兰",
      code: "057+3.5",
      offset: 3.5,
      tz: "Asia/Tehran"
    },
    {
      name: "(UTC+04:00)阿布扎比，马斯喀特",
      code: "058+4",
      offset: 4,
      tz: "Asia/Dubai"
    },
    {
      name: "(UTC+04:00)埃里温",
      code: "059+4",
      offset: 4,
      tz: "Asia/Yerevan"
    },
    {
      name: "(UTC+04:00)巴库",
      code: "060+4",
      offset: 4,
      tz: "Asia/Baku"
    },
    {
      name: "(UTC+04:00)第比利斯",
      code: "061+4",
      offset: 4,
      tz: "Asia/Tbilisi"
    },
    {
      name: "(UTC+04:00)路易港",
      code: "062+4",
      offset: 4,
      tz: "Indian/Mauritius"
    },
    {
      name: "(UTC+04:30)喀布尔",
      code: "063+4.5",
      offset: 4.5,
      tz: "Asia/Kabul"
    },
    {
      name: "(UTC+05:00)塔什干",
      code: "064+5",
      offset: 5,
      tz: "Asia/Tashkent"
    },
    {
      name: "(UTC+05:00)叶卡捷琳堡",
      code: "065+5",
      offset: 5,
      tz: "Asia/Yekaterinburg"
    },
    {
      name: "(UTC+05:00)伊斯兰堡，卡拉奇",
      code: "066+5",
      offset: 5,
      tz: "Asia/Karachi"
    },
    {
      name: "(UTC+05:30)钦奈，加尔各答，孟买，新德里",
      code: "067+5.5",
      offset: 5.5,
      tz: "Asia/Kolkata"
    },
    {
      name: "(UTC+05:30)斯里加亚渥登普拉",
      code: "068+5.5",
      offset: 5.5,
      tz: "Asia/Colombo"
    },
    {
      name: "(UTC+05:45)加德满都",
      code: "069+5.75",
      offset: 5.75,
      tz: "Asia/Kathmandu"
    },
    {
      name: "(UTC+06:00)阿斯塔纳",
      code: "070+6",
      offset: 6,
      tz: "Asia/Almaty"
    },
    {
      name: "(UTC+06:00)达卡",
      code: "071+6",
      offset: 6,
      tz: "Asia/Dhaka"
    },
    {
      name: "(UTC+07:00)新西伯利亚",
      code: "072+6",
      offset: 7,
      tz: "Asia/Novosibirsk"
    },
    {
      name: "(UTC+06:30)仰光",
      code: "073+6.5",
      offset: 6.5,
      tz: "Asia/Yangon"
    },
    {
      name: "(UTC+07:00)克拉斯诺亚尔斯克",
      code: "074+7",
      offset: 7,
      tz: "Asia/Krasnoyarsk"
    },
    {
      name: "(UTC+07:00)曼谷，河内，雅加达",
      code: "075+7",
      offset: 7,
      tz: "Asia/Bangkok"
    },
    {
      name: "(UTC+08:00)北京，重庆，香港特别行政区，乌鲁木齐",
      code: "076+8",
      offset: 8,
      tz: "Asia/Shanghai"
    },
    {
      name: "(UTC+08:00)吉隆坡，新加坡",
      code: "077+8",
      offset: 8,
      tz: "Asia/Singapore"
    },
    {
      name: "(UTC+08:00)珀斯",
      code: "078+8",
      offset: 8,
      tz: "Australia/Perth"
    },
    {
      name: "(UTC+08:00)台北",
      code: "079+8",
      offset: 8,
      tz: "Asia/Taipei"
    },
    {
      name: "(UTC+08:00)乌兰巴托",
      code: "080+8",
      offset: 8,
      tz: "Asia/Ulaanbaatar"
    },
    {
      name: "(UTC+08:00)伊尔库茨克",
      code: "081+8",
      offset: 8,
      tz: "Asia/Irkutsk"
    },
    {
      name: "(UTC+09:00)大阪，札幌，东京",
      code: "082+9",
      offset: 9,
      tz: "Asia/Tokyo"
    },
    {
      name: "(UTC+09:00)首尔",
      code: "083+9",
      offset: 9,
      tz: "Asia/Seoul"
    },
    {
      name: "(UTC+09:00)雅库茨克",
      code: "084+9",
      offset: 9,
      tz: "Asia/Yakutsk"
    },
    {
      name: "(UTC+09:30)阿德莱德",
      code: "085+9.5",
      offset: 10.5,
      tz: "Australia/Adelaide"
    },
    {
      name: "(UTC+09:30)达尔文",
      code: "086+9.5",
      offset: 9.5,
      tz: "Australia/Darwin"
    },
    {
      name: "(UTC+10:00)布里斯班",
      code: "087+10",
      offset: 10,
      tz: "Australia/Brisbane"
    },
    {
      name: "(UTC+10:00)符拉迪沃斯托克",
      code: "088+10",
      offset: 10,
      tz: "Asia/Vladivostok"
    },
    {
      name: "(UTC+10:00)关岛，莫尔兹比港",
      code: "089+10",
      offset: 10,
      tz: "Pacific/Port_Moresby"
    },
    {
      name: "(UTC+10:00)霍巴特",
      code: "090+10",
      offset: 11,
      tz: "Australia/Hobart"
    },
    {
      name: "(UTC+10:00)堪培拉，墨尔本，悉尼",
      code: "091+10",
      offset: 11,
      tz: "Australia/Sydney"
    },
    {
      name: "(UTC+11:00)马加丹",
      code: "092+11",
      offset: 11,
      tz: "Asia/Magadan"
    },
    {
      name: "(UTC+11:00)所罗门群岛，新喀里多尼亚",
      code: "093+11",
      offset: 11,
      tz: "Pacific/Guadalcanal"
    },
    {
      name: "(UTC+12:00)奥克兰，惠灵顿",
      code: "094+12",
      offset: 13,
      tz: "Pacific/Auckland"
    },
    {
      name: "(UTC+12:00)斐济",
      code: "095+12",
      offset: 13,
      tz: "Pacific/Fiji"
    },
    {
      name: "(UTC+12:00)协调世界时+12",
      code: "096+12",
      offset: 12,
      tz: "Etc/GMT-12"
    },
    {
      name: "(UTC+13:00)努库阿洛法",
      code: "097+13",
      offset: 13,
      tz: "Pacific/Tongatapu"
    }
  ]
};
export {
  timezone_default as default
};
