import { addResizeListener, removeResizeListener } from "../common/deps/resize-event.mjs";
import debounce_default from "../common/deps/debounce.mjs";
import { getHiddenTags, handelItemClick } from "./index.mjs";
const api = ["state", "handelItemClick"];
const renderless = (props, { onMounted, onBeforeUnmount, reactive, watch }, { vm, emit }) => {
  const delay = 100;
  const state = reactive({
    showMore: false,
    hiddenTags: []
  });
  const api2 = {
    state,
    getHiddenTags: getHiddenTags({ props, vm, state }),
    handelItemClick: handelItemClick({ emit })
  };
  onMounted(() => {
    api2.getHiddenTags();
    api2.debouncedGetHiddenTags = debounce_default(delay, api2.getHiddenTags);
    addResizeListener(vm.$refs.tagGroup, debounce_default(delay, api2.debouncedGetHiddenTags));
  });
  watch(
    () => props.data.length,
    () => {
      api2.getHiddenTags();
    }
  );
  onBeforeUnmount(() => {
    removeResizeListener(vm.$refs.tagGroup, api2.debouncedGetHiddenTags);
  });
  return api2;
};
export {
  api,
  renderless
};
