import { keydown, selectItem, mousedown } from "./index.mjs";
import { off, on } from "../common/deps/dom.mjs";
const api = ["state", "mousedown", "selectItem"];
const renderless = (props, { onUnmounted, reactive, watch }, { emit }) => {
  const state = reactive({
    hoverValue: ""
  });
  const api2 = {
    state,
    mousedown,
    selectItem: selectItem({ emit, state }),
    keydown: keydown({ emit, props, state })
  };
  watch(
    () => props.isMemoryStorage,
    (value) => !value && (state.hoverValue = ""),
    { immediate: true }
  );
  onUnmounted(() => {
    state.hoverValue = "";
    off(document, "keydown", api2.keydown);
  });
  on(document, "keydown", api2.keydown);
  return api2;
};
export {
  api,
  renderless
};
