import "../../index.mjs";
import BMapCoordSys from "./BMapCoordSys.mjs";
import "./BMapModel.mjs";
import "./BMapView.mjs";
import { registerCoordinateSystem, registerAction } from "../../lib/core/echarts.mjs";
registerCoordinateSystem("bmap", BMapCoordSys);
registerAction({
  type: "bmapRoam",
  event: "bmapRoam",
  update: "updateLayout"
}, function(payload, ecModel) {
  ecModel.eachComponent("bmap", function(bMapModel) {
    var bmap = bMapModel.getBMap();
    var center = bmap.getCenter();
    bMapModel.setCenterAndZoom([center.lng, center.lat], bmap.getZoom());
  });
});
