import { use } from "./lib/extension.mjs";
import { install } from "./lib/renderer/installCanvasRenderer.mjs";
import { install as install$1 } from "./lib/renderer/installSVGRenderer.mjs";
import { install as install$2 } from "./lib/chart/line/install.mjs";
import { install as install$3 } from "./lib/chart/bar/install.mjs";
import { install as install$4 } from "./lib/chart/pie/install.mjs";
import { install as install$5 } from "./lib/chart/scatter/install.mjs";
import { install as install$6 } from "./lib/chart/radar/install.mjs";
import { install as install$7 } from "./lib/chart/map/install.mjs";
import { install as install$8 } from "./lib/chart/tree/install.mjs";
import { install as install$9 } from "./lib/chart/treemap/install.mjs";
import { install as install$a } from "./lib/chart/graph/install.mjs";
import { install as install$b } from "./lib/chart/gauge/install.mjs";
import { install as install$c } from "./lib/chart/funnel/install.mjs";
import { install as install$d } from "./lib/chart/parallel/install.mjs";
import { install as install$e } from "./lib/chart/sankey/install.mjs";
import { install as install$f } from "./lib/chart/boxplot/install.mjs";
import { install as install$g } from "./lib/chart/candlestick/install.mjs";
import { install as install$h } from "./lib/chart/effectScatter/install.mjs";
import { install as install$i } from "./lib/chart/lines/install.mjs";
import { install as install$j } from "./lib/chart/heatmap/install.mjs";
import { install as install$k } from "./lib/chart/bar/installPictorialBar.mjs";
import { install as install$l } from "./lib/chart/themeRiver/install.mjs";
import { install as install$m } from "./lib/chart/sunburst/install.mjs";
import { install as install$n } from "./lib/chart/custom/install.mjs";
import { install as install$o } from "./lib/component/grid/install.mjs";
import { install as install$p } from "./lib/component/polar/install.mjs";
import { install as install$q } from "./lib/component/geo/install.mjs";
import { install as install$r } from "./lib/component/singleAxis/install.mjs";
import { install as install$s } from "./lib/component/parallel/install.mjs";
import { install as install$t } from "./lib/component/calendar/install.mjs";
import { install as install$u } from "./lib/component/graphic/install.mjs";
import { install as install$v } from "./lib/component/toolbox/install.mjs";
import { install as install$w } from "./lib/component/tooltip/install.mjs";
import { install as install$x } from "./lib/component/axisPointer/install.mjs";
import { install as install$y } from "./lib/component/brush/install.mjs";
import { install as install$z } from "./lib/component/title/install.mjs";
import { install as install$A } from "./lib/component/timeline/install.mjs";
import { install as install$B } from "./lib/component/marker/installMarkPoint.mjs";
import { install as install$C } from "./lib/component/marker/installMarkLine.mjs";
import { install as install$D } from "./lib/component/marker/installMarkArea.mjs";
import { install as install$E } from "./lib/component/legend/install.mjs";
import { install as install$F } from "./lib/component/dataZoom/install.mjs";
import { install as install$G } from "./lib/component/dataZoom/installDataZoomInside.mjs";
import { install as install$H } from "./lib/component/dataZoom/installDataZoomSlider.mjs";
import { install as install$I } from "./lib/component/visualMap/install.mjs";
import { install as install$J } from "./lib/component/visualMap/installVisualMapContinuous.mjs";
import { install as install$K } from "./lib/component/visualMap/installVisualMapPiecewise.mjs";
import { install as install$L } from "./lib/component/aria/install.mjs";
import { install as install$M } from "./lib/component/transform/install.mjs";
import { install as install$N } from "./lib/component/dataset/install.mjs";
import { installUniversalTransition } from "./lib/animation/universalTransition.mjs";
import { installLabelLayout } from "./lib/label/installLabelLayout.mjs";
import { default as default2, default as default3 } from "./lib/coord/geo/parseGeoJson.mjs";
import { default as default4 } from "../../../zrender@5.4.1/node_modules/zrender/lib/core/env.mjs";
import { default as default5 } from "./lib/model/Model.mjs";
import { default as default6 } from "./lib/coord/Axis.mjs";
import { default as default7 } from "./lib/data/SeriesData.mjs";
import { default as default8 } from "./lib/model/Component.mjs";
import { default as default9 } from "./lib/view/Component.mjs";
import { default as default10 } from "./lib/model/Series.mjs";
import { default as default11 } from "./lib/view/Chart.mjs";
import { registerLocale } from "./lib/core/locale.mjs";
import { PRIORITY, connect, dataTool, dependencies, disConnect, disconnect, dispose, getCoordinateSystemDimensions, getInstanceByDom, getInstanceById, getMap, init, registerAction, registerCoordinateSystem, registerLayout, registerLoading, registerMap, registerPostInit, registerPostUpdate, registerPreprocessor, registerProcessor, registerTheme, registerTransform, registerUpdateLifecycle, registerVisual, setCanvasCreator, version } from "./lib/core/echarts.mjs";
import { throttle } from "./lib/util/throttle.mjs";
import { setPlatformAPI } from "../../../zrender@5.4.1/node_modules/zrender/lib/core/platform.mjs";
import { brushSingle } from "../../../zrender@5.4.1/node_modules/zrender/lib/canvas/graphic.mjs";
import * as zrender from "../../../zrender@5.4.1/node_modules/zrender/lib/zrender.mjs";
import * as matrix from "../../../zrender@5.4.1/node_modules/zrender/lib/core/matrix.mjs";
import * as vector from "../../../zrender@5.4.1/node_modules/zrender/lib/core/vector.mjs";
import * as util from "../../../zrender@5.4.1/node_modules/zrender/lib/core/util.mjs";
import * as color from "../../../zrender@5.4.1/node_modules/zrender/lib/tool/color.mjs";
import * as helper from "./lib/export/api/helper.mjs";
import * as number from "./lib/export/api/number.mjs";
import * as time from "./lib/export/api/time.mjs";
import * as graphic from "./lib/export/api/graphic.mjs";
import * as format from "./lib/export/api/format.mjs";
import * as util$1 from "./lib/export/api/util.mjs";
import { extendChartView, extendComponentModel, extendComponentView, extendSeriesModel } from "./lib/export/api.mjs";
use([install]);
use([install$1]);
use([install$2, install$3, install$4, install$5, install$6, install$7, install$8, install$9, install$a, install$b, install$c, install$d, install$e, install$f, install$g, install$h, install$i, install$j, install$k, install$l, install$m, install$n]);
use(install$o);
use(install$p);
use(install$q);
use(install$r);
use(install$s);
use(install$t);
use(install$u);
use(install$v);
use(install$w);
use(install$x);
use(install$y);
use(install$z);
use(install$A);
use(install$B);
use(install$C);
use(install$D);
use(install$E);
use(install$F);
use(install$G);
use(install$H);
use(install$I);
use(install$J);
use(install$K);
use(install$L);
use(install$M);
use(install$N);
use(installUniversalTransition);
use(installLabelLayout);
export {
  default6 as Axis,
  default11 as ChartView,
  default8 as ComponentModel,
  default9 as ComponentView,
  default7 as List,
  default5 as Model,
  PRIORITY,
  default10 as SeriesModel,
  color,
  connect,
  dataTool,
  dependencies,
  disConnect,
  disconnect,
  dispose,
  default4 as env,
  extendChartView,
  extendComponentModel,
  extendComponentView,
  extendSeriesModel,
  format,
  getCoordinateSystemDimensions,
  getInstanceByDom,
  getInstanceById,
  getMap,
  graphic,
  helper,
  init,
  brushSingle as innerDrawElementOnCanvas,
  matrix,
  number,
  default2 as parseGeoJSON,
  default3 as parseGeoJson,
  registerAction,
  registerCoordinateSystem,
  registerLayout,
  registerLoading,
  registerLocale,
  registerMap,
  registerPostInit,
  registerPostUpdate,
  registerPreprocessor,
  registerProcessor,
  registerTheme,
  registerTransform,
  registerUpdateLifecycle,
  registerVisual,
  setCanvasCreator,
  setPlatformAPI,
  throttle,
  time,
  use,
  util$1 as util,
  vector,
  version,
  util as zrUtil,
  zrender
};
