import prepareBoxplotData from "./prepareBoxplotData.mjs";
import { makePrintable, throwError } from "../../util/log.mjs";
import { SOURCE_FORMAT_ARRAY_ROWS } from "../../util/types.mjs";
var boxplotTransform = {
  type: "echarts:boxplot",
  transform: function transform(params) {
    var upstream = params.upstream;
    if (upstream.sourceFormat !== SOURCE_FORMAT_ARRAY_ROWS) {
      var errMsg = "";
      if (process.env.NODE_ENV !== "production") {
        errMsg = makePrintable("source data is not applicable for this boxplot transform. Expect number[][].");
      }
      throwError(errMsg);
    }
    var result = prepareBoxplotData(upstream.getRawData(), params.config);
    return [{
      dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"],
      data: result.boxData
    }, {
      data: result.outliers
    }];
  }
};
export {
  boxplotTransform
};
