import { use } from "../../extension.mjs";
import MapView from "./MapView.mjs";
import MapSeries from "./MapSeries.mjs";
import mapDataStatistic from "./mapDataStatistic.mjs";
import mapSymbolLayout from "./mapSymbolLayout.mjs";
import { createLegacyDataSelectAction } from "../../legacy/dataSelectAction.mjs";
import { install as install$1 } from "../../component/geo/install.mjs";
function install(registers) {
  use(install$1);
  registers.registerChartView(MapView);
  registers.registerSeriesModel(MapSeries);
  registers.registerLayout(mapSymbolLayout);
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, mapDataStatistic);
  createLegacyDataSelectAction("map", registers.registerAction);
}
export {
  install
};
