import { createLegacyDataSelectAction } from "../../legacy/dataSelectAction.mjs";
import pieLayout from "./pieLayout.mjs";
import dataFilter from "../../processor/dataFilter.mjs";
import { curry } from "../../../../../../zrender@5.4.1/node_modules/zrender/lib/core/util.mjs";
import PieView from "./PieView.mjs";
import PieSeriesModel from "./PieSeries.mjs";
import negativeDataFilter from "../../processor/negativeDataFilter.mjs";
function install(registers) {
  registers.registerChartView(PieView);
  registers.registerSeriesModel(PieSeriesModel);
  createLegacyDataSelectAction("pie", registers.registerAction);
  registers.registerLayout(curry(pieLayout, "pie"));
  registers.registerProcessor(dataFilter("pie"));
  registers.registerProcessor(negativeDataFilter("pie"));
}
export {
  install
};
