import SunburstView from "./SunburstView.mjs";
import SunburstSeriesModel from "./SunburstSeries.mjs";
import sunburstLayout from "./sunburstLayout.mjs";
import sunburstVisual from "./sunburstVisual.mjs";
import dataFilter from "../../processor/dataFilter.mjs";
import { curry } from "../../../../../../zrender@5.4.1/node_modules/zrender/lib/core/util.mjs";
import { installSunburstAction } from "./sunburstAction.mjs";
function install(registers) {
  registers.registerChartView(SunburstView);
  registers.registerSeriesModel(SunburstSeriesModel);
  registers.registerLayout(curry(sunburstLayout, "sunburst"));
  registers.registerProcessor(curry(dataFilter, "sunburst"));
  registers.registerVisual(sunburstVisual);
  installSunburstAction(registers);
}
export {
  install
};
