import { use } from "../../extension.mjs";
import { install as install$1 } from "../dataZoom/installDataZoomSelect.mjs";
import ToolboxModel from "./ToolboxModel.mjs";
import ToolboxView from "./ToolboxView.mjs";
import { registerFeature } from "./featureManager.mjs";
import SaveAsImage from "./feature/SaveAsImage.mjs";
import MagicType from "./feature/MagicType.mjs";
import DataView from "./feature/DataView.mjs";
import RestoreOption from "./feature/Restore.mjs";
import DataZoomFeature from "./feature/DataZoom.mjs";
function install(registers) {
  registers.registerComponentModel(ToolboxModel);
  registers.registerComponentView(ToolboxView);
  registerFeature("saveAsImage", SaveAsImage);
  registerFeature("magicType", MagicType);
  registerFeature("dataView", DataView);
  registerFeature("dataZoom", DataZoomFeature);
  registerFeature("restore", RestoreOption);
  use(install$1);
}
export {
  install
};
