import Quill from "./core/quill.mjs";
import Block, { BlockEmbed } from "./blots/block.mjs";
import Break from "./blots/break.mjs";
import Container from "./blots/container.mjs";
import Cursor from "./blots/cursor.mjs";
import Embed from "./blots/embed.mjs";
import Inline from "./blots/inline.mjs";
import Scroll from "./blots/scroll.mjs";
import Text from "./blots/text.mjs";
import Clipboard from "./modules/clipboard.mjs";
import History from "./modules/history.mjs";
import Keyboard from "./modules/keyboard.mjs";
import Uploader from "./modules/uploader.mjs";
import { default as default2 } from "../../../../../_virtual/Delta.mjs";
import Input from "./modules/input.mjs";
import UINode from "./modules/uiNode.mjs";
Quill.register({
  "blots/block": Block,
  "blots/block/embed": BlockEmbed,
  "blots/break": Break,
  "blots/container": Container,
  "blots/cursor": Cursor,
  "blots/embed": Embed,
  "blots/inline": Inline,
  "blots/scroll": Scroll,
  "blots/text": Text,
  "modules/clipboard": Clipboard,
  "modules/history": History,
  "modules/keyboard": Keyboard,
  "modules/uploader": Uploader,
  "modules/input": Input,
  "modules/uiNode": UINode
});
const AttributeMap = DeltaExports.AttributeMap;
const Op = DeltaExports.Op;
export {
  AttributeMap,
  default2 as Delta,
  Op,
  Quill as default
};
