var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
import Block from "../blots/block.mjs";
import Break from "../blots/break.mjs";
import Cursor from "../blots/cursor.mjs";
import Inline from "../blots/inline.mjs";
import Text, { escapeText } from "../blots/text.mjs";
import Container from "../blots/container.mjs";
import Quill from "../core/quill.mjs";
class CodeBlockContainer extends Container {
  static create(value) {
    const domNode = super.create(value);
    domNode.setAttribute("spellcheck", "false");
    return domNode;
  }
  code(index, length) {
    return this.children.map((child) => child.length() <= 1 ? "" : child.domNode.innerText).join("\n").slice(index, index + length);
  }
  html(index, length) {
    return `<pre>
${escapeText(this.code(index, length))}
</pre>`;
  }
}
class CodeBlock extends Block {
  static register() {
    Quill.register(CodeBlockContainer);
  }
}
__publicField(CodeBlock, "TAB", "  ");
class Code extends Inline {
}
Code.blotName = "code";
Code.tagName = "CODE";
CodeBlock.blotName = "code-block";
CodeBlock.className = "ql-code-block";
CodeBlock.tagName = "DIV";
CodeBlockContainer.blotName = "code-block-container";
CodeBlockContainer.className = "ql-code-block-container";
CodeBlockContainer.tagName = "DIV";
CodeBlockContainer.allowedChildren = [CodeBlock];
CodeBlock.allowedChildren = [Text, Break, Cursor];
CodeBlock.requiredContainer = CodeBlockContainer;
export {
  Code,
  CodeBlockContainer,
  CodeBlock as default
};
