import { ClassAttributor as ClassAttributor$1, Scope, StyleAttributor as StyleAttributor$1 } from "../../../../parchment@3.0.0/node_modules/parchment/dist/parchment.mjs";
class ColorAttributor extends StyleAttributor$1 {
  value(domNode) {
    let value = super.value(domNode);
    if (!value.startsWith("rgb(")) return value;
    value = value.replace(/^[^\d]+/, "").replace(/[^\d]+$/, "");
    const hex = value.split(",").map((component) => `00${parseInt(component, 10).toString(16)}`.slice(-2)).join("");
    return `#${hex}`;
  }
}
const ColorClass = new ClassAttributor$1("color", "ql-color", {
  scope: Scope.INLINE
});
const ColorStyle = new ColorAttributor("color", "color", {
  scope: Scope.INLINE
});
export {
  ColorAttributor,
  ColorClass,
  ColorStyle
};
