import * as all from "./src/components/all.mjs";
import * as index$1 from "../mobile/index.mjs";
import { Button } from "./src/components/base/button/index.mjs";
import { ButtonGroup } from "./src/components/base/buttonGroup/index.mjs";
import { Link } from "./src/components/base/link/index.mjs";
import { Divider } from "./src/components/base/divider/index.mjs";
import { VirtualScrollBox } from "./src/components/base/virtualScrollBox/index.mjs";
import { LineChart } from "./src/components/chart/lineChart/index.mjs";
import { HistogramChart } from "./src/components/chart/histogramChart/index.mjs";
import { BarChart } from "./src/components/chart/barChart/index.mjs";
import { PieChart } from "./src/components/chart/pieChart/index.mjs";
import { RingChart } from "./src/components/chart/ringChart/index.mjs";
import { WaterfallChart } from "./src/components/chart/waterfallChart/index.mjs";
import { FunnelChart } from "./src/components/chart/funnelChart/index.mjs";
import { RadarChart } from "./src/components/chart/radarChart/index.mjs";
import { MapChart } from "./src/components/chart/mapChart/index.mjs";
import { SankeyChart } from "./src/components/chart/sankeyChart/index.mjs";
import { HeatmapChart } from "./src/components/chart/heatmapChart/index.mjs";
import { ScatterChart } from "./src/components/chart/scatterChart/index.mjs";
import { CandleChart } from "./src/components/chart/candleChart/index.mjs";
import { GaugeChart } from "./src/components/chart/gaugeChart/index.mjs";
import { TreeChart } from "./src/components/chart/treeChart/index.mjs";
import { LiquidfillChart } from "./src/components/chart/liquidfillChart/index.mjs";
import { WordcloudChart } from "./src/components/chart/wordcloudChart/index.mjs";
import { SunburstChart } from "./src/components/chart/sunburstChart/index.mjs";
import { GraphChart } from "./src/components/chart/graphChart/index.mjs";
import { BoxplotChart } from "./src/components/chart/boxplotChart/index.mjs";
import { ProcessChart } from "./src/components/chart/processChart/index.mjs";
import { Badge } from "./src/components/dataDisplay/badge/index.mjs";
import { Calendar } from "./src/components/dataDisplay/calendar/index.mjs";
import { CalendarView } from "./src/components/dataDisplay/calendarView/index.mjs";
import { Card } from "./src/components/dataDisplay/card/index.mjs";
import { Carousel } from "./src/components/dataDisplay/carousel/index.mjs";
import { CarouselItem } from "./src/components/dataDisplay/carouselItem/index.mjs";
import { Collapse } from "./src/components/dataDisplay/collapse/index.mjs";
import { CollapseItem } from "./src/components/dataDisplay/collapseItem/index.mjs";
import { Guide } from "./src/components/dataDisplay/guide/index.mjs";
import { Image } from "./src/components/dataDisplay/image/index.mjs";
import { Milestone } from "./src/components/dataDisplay/milestone/index.mjs";
import { MindMap } from "./src/components/dataDisplay/mindMap/index.mjs";
import { QrCode } from "./src/components/dataDisplay/qrCode/index.mjs";
import { Statistic } from "./src/components/dataDisplay/statistic/index.mjs";
import { Tag } from "./src/components/dataDisplay/tag/index.mjs";
import { TagGroup } from "./src/components/dataDisplay/tagGroup/index.mjs";
import { Timeline } from "./src/components/dataDisplay/timeline/index.mjs";
import { TimelineItem } from "./src/components/dataDisplay/timelineItem/index.mjs";
import { Tree } from "./src/components/dataDisplay/tree/index.mjs";
import { UserHead } from "./src/components/dataDisplay/userHead/index.mjs";
import { Wizard } from "./src/components/dataDisplay/wizard/index.mjs";
import { Alert } from "./src/components/feedback/alert/index.mjs";
import { DialogBox } from "./src/components/feedback/dialogBox/index.mjs";
import { Drawer } from "./src/components/feedback/drawer/index.mjs";
import { Modal } from "./src/components/feedback/modal/index.mjs";
import { PopConfirm } from "./src/components/feedback/popConfirm/index.mjs";
import { Progress } from "./src/components/feedback/progress/index.mjs";
import { Popover } from "./src/components/feedback/popover/index.mjs";
import { Skeleton } from "./src/components/feedback/skeleton/index.mjs";
import { SkeletonItem } from "./src/components/feedback/skeletonItem/index.mjs";
import { Tooltip } from "./src/components/feedback/tooltip/index.mjs";
import { AutoComplete } from "./src/components/form/autoComplete/index.mjs";
import { Cascader } from "./src/components/form/cascader/index.mjs";
import { CascaderPanel } from "./src/components/form/cascaderPanel/index.mjs";
import { Checkbox } from "./src/components/form/checkbox/index.mjs";
import { CheckboxGroup } from "./src/components/form/checkboxGroup/index.mjs";
import { CheckboxButton } from "./src/components/form/checkboxButton/index.mjs";
import { ColorPicker } from "./src/components/form/colorPicker/index.mjs";
import { ColorSelectPanel } from "./src/components/form/colorSelectPanel/index.mjs";
import { DatePicker } from "./src/components/form/datePicker/index.mjs";
import { DropTimes } from "./src/components/form/dropTimes/index.mjs";
import { FileUpload } from "./src/components/form/fileUpload/index.mjs";
import { FluentEditor } from "./src/components/form/fluentEditor/index.mjs";
import { Form } from "./src/components/form/form/index.mjs";
import { FormItem } from "./src/components/form/formItem/index.mjs";
import { Input } from "./src/components/form/input/index.mjs";
import { IpAddress } from "./src/components/form/ipAddress/index.mjs";
import { Numeric } from "./src/components/form/numeric/index.mjs";
import { PopEditor } from "./src/components/form/popEditor/index.mjs";
import { PopUpload } from "./src/components/form/popUpload/index.mjs";
import { RadioGroup } from "./src/components/form/radioGroup/index.mjs";
import { RadioButton } from "./src/components/form/radioButton/index.mjs";
import { Radio } from "./src/components/form/radio/index.mjs";
import { Rate } from "./src/components/form/rate/index.mjs";
import { Search } from "./src/components/form/search/index.mjs";
import { Select } from "./src/components/form/select/index.mjs";
import { Slider } from "./src/components/form/slider/index.mjs";
import { Switch } from "./src/components/form/switch/index.mjs";
import { TimePicker } from "./src/components/form/timePicker/index.mjs";
import { TimeSelect } from "./src/components/form/timeSelect/index.mjs";
import { Transfer } from "./src/components/form/transfer/index.mjs";
import { Layout } from "./src/components/layout/layout/index.mjs";
import { Row } from "./src/components/layout/row/index.mjs";
import { Col } from "./src/components/layout/col/index.mjs";
import { Container } from "./src/components/layout/container/index.mjs";
import { ActionMenu } from "./src/components/navigation/actionMenu/index.mjs";
import { Anchor } from "./src/components/navigation/anchor/index.mjs";
import { Breadcrumb } from "./src/components/navigation/breadcrumb/index.mjs";
import { BreadcrumbItem } from "./src/components/navigation/breadcrumbItem/index.mjs";
import { Dropdown } from "./src/components/navigation/dropdown/index.mjs";
import { DropdownMenu } from "./src/components/navigation/dropdownMenu/index.mjs";
import { DropdownItem } from "./src/components/navigation/dropdownItem/index.mjs";
import { NavMenu } from "./src/components/navigation/navMenu/index.mjs";
import { Pager } from "./src/components/navigation/pager/index.mjs";
import { Steps } from "./src/components/navigation/steps/index.mjs";
import { Tabs } from "./src/components/navigation/tabs/index.mjs";
import { TabItem } from "./src/components/navigation/tabItem/index.mjs";
import { TreeMenu } from "./src/components/navigation/treeMenu/index.mjs";
import { Table } from "./src/components/table/table/index.mjs";
import { TableColumn } from "./src/components/table/tableColumn/index.mjs";
import { TableToolbar } from "./src/components/table/tableToolbar/index.mjs";
import { MobileButton } from "../mobile/src/components/base/button/index.mjs";
import { MobileCell } from "../mobile/src/components/base/cell/index.mjs";
import { MobileCellGroup } from "../mobile/src/components/base/cellGroup/index.mjs";
import { MobileImage } from "../mobile/src/components/base/image/index.mjs";
import { MobilePopup } from "../mobile/src/components/base/popup/index.mjs";
import { MobileCollapse } from "../mobile/src/components/dataDisplay/collapse/index.mjs";
import { MobileCollapseItem } from "../mobile/src/components/dataDisplay/collapseItem/index.mjs";
import { MobileDivider } from "../mobile/src/components/dataDisplay/divider/index.mjs";
import { MobileEmpty } from "../mobile/src/components/dataDisplay/empty/index.mjs";
import { MobileHighlight } from "../mobile/src/components/dataDisplay/highlight/index.mjs";
import { MobileNoticeBar } from "../mobile/src/components/dataDisplay/noticeBar/index.mjs";
import { MobileSteps } from "../mobile/src/components/dataDisplay/steps/index.mjs";
import { MobileStep } from "../mobile/src/components/dataDisplay/step/index.mjs";
import { MobileSwipe } from "../mobile/src/components/dataDisplay/swipe/index.mjs";
import { MobileSwipeItem } from "../mobile/src/components/dataDisplay/swipeItem/index.mjs";
import { MobileTextEllipsis } from "../mobile/src/components/dataDisplay/textEllipsis/index.mjs";
import { MobileActionSheet } from "../mobile/src/components/feedback/actionSheet/index.mjs";
import { MobileDropdownMenu } from "../mobile/src/components/feedback/dropdownMenu/index.mjs";
import { MobileDropdownItem } from "../mobile/src/components/feedback/dropdownItem/index.mjs";
import { MobileFloatingPanel } from "../mobile/src/components/feedback/floatingPanel/index.mjs";
import { MobileFloatingBubble } from "../mobile/src/components/feedback/floatingBubble/index.mjs";
import { MobileLoading } from "../mobile/src/components/feedback/loading/index.mjs";
import { MobilePullRefresh } from "../mobile/src/components/feedback/pullRefresh/index.mjs";
import { MobileSwipeCell } from "../mobile/src/components/feedback/swipeCell/index.mjs";
import { MobileCalendar } from "../mobile/src/components/form/calendar/index.mjs";
import { MobileCascader } from "../mobile/src/components/form/cascader/index.mjs";
import { MobileCheckbox } from "../mobile/src/components/form/checkbox/index.mjs";
import { MobileCheckboxGroup } from "../mobile/src/components/form/checkboxGroup/index.mjs";
import { MobileDatePicker } from "../mobile/src/components/form/datePicker/index.mjs";
import { MobileField } from "../mobile/src/components/form/field/index.mjs";
import { MobileForm } from "../mobile/src/components/form/form/index.mjs";
import { MobilePicker } from "../mobile/src/components/form/picker/index.mjs";
import { MobilePickerGroup } from "../mobile/src/components/form/pickerGroup/index.mjs";
import { MobileRadio } from "../mobile/src/components/form/radio/index.mjs";
import { MobileRadioGroup } from "../mobile/src/components/form/radioGroup/index.mjs";
import { MobileSearch } from "../mobile/src/components/form/search/index.mjs";
import { MobileTimePicker } from "../mobile/src/components/form/timePicker/index.mjs";
import { MobileUploader } from "../mobile/src/components/form/uploader/index.mjs";
import { MobileActionBar } from "../mobile/src/components/navigation/actionBar/index.mjs";
import { MobileBackTop } from "../mobile/src/components/navigation/backTop/index.mjs";
import { MobileGrid } from "../mobile/src/components/navigation/grid/index.mjs";
import { MobileGridItem } from "../mobile/src/components/navigation/gridItem/index.mjs";
import { MobileIndexBar } from "../mobile/src/components/navigation/indexBar/index.mjs";
import { MobileIndexAnchor } from "../mobile/src/components/navigation/indexAnchor/index.mjs";
import { MobileNavBar } from "../mobile/src/components/navigation/navBar/index.mjs";
import { MobilePagination } from "../mobile/src/components/navigation/pagination/index.mjs";
import { MobileSidebar } from "../mobile/src/components/navigation/sidebar/index.mjs";
import { MobileSidebarItem } from "../mobile/src/components/navigation/sidebarItem/index.mjs";
import { MobileTab } from "../mobile/src/components/navigation/tab/index.mjs";
import { MobileTabs } from "../mobile/src/components/navigation/tabs/index.mjs";
import { MobileTabbar } from "../mobile/src/components/navigation/tabbar/index.mjs";
import { MobileTabbarItem } from "../mobile/src/components/navigation/tabbarItem/index.mjs";
import { MobileTreeSelect } from "../mobile/src/components/navigation/treeSelect/index.mjs";
const index = {
  install: (app) => {
    for (let c in all) {
      app.use(all[c]);
    }
    for (let c in index$1) {
      app.use(index$1[c]);
    }
  }
};
export {
  ActionMenu,
  Alert,
  Anchor,
  AutoComplete,
  Badge,
  BarChart,
  BoxplotChart,
  Breadcrumb,
  BreadcrumbItem,
  Button,
  ButtonGroup,
  Calendar,
  CalendarView,
  CandleChart,
  Card,
  Carousel,
  CarouselItem,
  Cascader,
  CascaderPanel,
  Checkbox,
  CheckboxButton,
  CheckboxGroup,
  Col,
  Collapse,
  CollapseItem,
  ColorPicker,
  ColorSelectPanel,
  Container,
  DatePicker,
  DialogBox,
  Divider,
  Drawer,
  DropTimes,
  Dropdown,
  DropdownItem,
  DropdownMenu,
  FileUpload,
  FluentEditor,
  Form,
  FormItem,
  FunnelChart,
  GaugeChart,
  GraphChart,
  Guide,
  HeatmapChart,
  HistogramChart,
  Image,
  Input,
  IpAddress,
  Layout,
  LineChart,
  Link,
  LiquidfillChart,
  MapChart,
  Milestone,
  MindMap,
  MobileActionBar,
  MobileActionSheet,
  MobileBackTop,
  MobileButton,
  MobileCalendar,
  MobileCascader,
  MobileCell,
  MobileCellGroup,
  MobileCheckbox,
  MobileCheckboxGroup,
  MobileCollapse,
  MobileCollapseItem,
  MobileDatePicker,
  MobileDivider,
  MobileDropdownItem,
  MobileDropdownMenu,
  MobileEmpty,
  MobileField,
  MobileFloatingBubble,
  MobileFloatingPanel,
  MobileForm,
  MobileGrid,
  MobileGridItem,
  MobileHighlight,
  MobileImage,
  MobileIndexAnchor,
  MobileIndexBar,
  MobileLoading,
  MobileNavBar,
  MobileNoticeBar,
  MobilePagination,
  MobilePicker,
  MobilePickerGroup,
  MobilePopup,
  MobilePullRefresh,
  MobileRadio,
  MobileRadioGroup,
  MobileSearch,
  MobileSidebar,
  MobileSidebarItem,
  MobileStep,
  MobileSteps,
  MobileSwipe,
  MobileSwipeCell,
  MobileSwipeItem,
  MobileTab,
  MobileTabbar,
  MobileTabbarItem,
  MobileTabs,
  MobileTextEllipsis,
  MobileTimePicker,
  MobileTreeSelect,
  MobileUploader,
  Modal,
  NavMenu,
  Numeric,
  Pager,
  PieChart,
  PopConfirm,
  PopEditor,
  PopUpload,
  Popover,
  ProcessChart,
  Progress,
  QrCode,
  RadarChart,
  Radio,
  RadioButton,
  RadioGroup,
  Rate,
  RingChart,
  Row,
  SankeyChart,
  ScatterChart,
  Search,
  Select,
  Skeleton,
  SkeletonItem,
  Slider,
  Statistic,
  Steps,
  SunburstChart,
  Switch,
  TabItem,
  Table,
  TableColumn,
  TableToolbar,
  Tabs,
  Tag,
  TagGroup,
  TimePicker,
  TimeSelect,
  Timeline,
  TimelineItem,
  Tooltip,
  Transfer,
  Tree,
  TreeChart,
  TreeMenu,
  UserHead,
  VirtualScrollBox,
  WaterfallChart,
  Wizard,
  WordcloudChart,
  index as default
};
