"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const editor_utils_es = require("./editor.utils.es.js");
function inputFile(type, accept) {
  var _a, _b, _c;
  const defaultMIMETypes = this.quill.uploader.options[type].join(", ");
  const mimeTypes = accept || defaultMIMETypes;
  let fileInput = this.container.querySelector(`input.ql-${type}[type=file]`);
  this.quill.uploader.options.enableMultiUpload = (_a = this.quill.options.uploadOption) == null ? void 0 : _a.multiple;
  if (editor_utils_es.isNullOrUndefined(fileInput)) {
    fileInput = document.createElement("input");
    fileInput.classList.add(`ql-${type}`);
    fileInput.setAttribute("type", "file");
    fileInput.setAttribute("accept", mimeTypes);
    if (this.quill.uploader.options.enableMultiUpload === true || ((_b = this.quill.uploader.options.enableMultiUpload) == null ? void 0 : _b.file) && type === "file" || ((_c = this.quill.uploader.options.enableMultiUpload) == null ? void 0 : _c.image) && type === "image") {
      fileInput.setAttribute("multiple", "");
    }
    fileInput.addEventListener("change", () => {
      const range = this.quill.getSelection(true);
      this.quill.uploader.upload(range, fileInput.files, type === "file");
      fileInput.value = "";
    });
    this.container.appendChild(fileInput);
  }
  fileInput.click();
}
function getListValue(value, preListValue) {
  let curListValue = value;
  if (preListValue && preListValue === value) {
    curListValue = false;
  } else if (value === "check") {
    if (preListValue === "checked" || preListValue === "unchecked") {
      curListValue = false;
    } else {
      curListValue = "unchecked";
    }
  }
  return curListValue;
}
const namespace = "fe";
exports.getEventComposedPath = editor_utils_es.getEventComposedPath;
exports.hadProtocol = editor_utils_es.hadProtocol;
exports.hexToRgbA = editor_utils_es.hexToRgbA;
exports.imageFileToUrl = editor_utils_es.imageFileToUrl;
exports.imageUrlToFile = editor_utils_es.imageUrlToFile;
exports.insideTable = editor_utils_es.insideTable;
exports.isInside = editor_utils_es.isInside;
exports.isNullOrUndefined = editor_utils_es.isNullOrUndefined;
exports.isPureIE = editor_utils_es.isPureIE;
exports.omit = editor_utils_es.omit;
exports.replaceDeltaImage = editor_utils_es.replaceDeltaImage;
exports.sanitize = editor_utils_es.sanitize;
exports.splitWithBreak = editor_utils_es.splitWithBreak;
exports.getListValue = getListValue;
exports.inputFile = inputFile;
exports.namespace = namespace;
