"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const fontSize_es = require("./attributors/font-size.es.js");
const fontStyle_es = require("./attributors/font-style.es.js");
const lineHeight_es = require("./attributors/line-height.es.js");
const textIndent_es = require("./attributors/text-indent.es.js");
const fluentEditor_es = require("./core/fluent-editor.es.js");
const softBreak_es = require("./formats/soft-break.es.js");
const strike_es = require("./formats/strike.es.js");
const video_es = require("./formats/video.es.js");
const counter_es = require("./modules/counter.es.js");
const customClipboard_es = require("./modules/custom-clipboard.es.js");
const BlotFormatter_es = require("./modules/custom-image/BlotFormatter.es.js");
const customUploader_es = require("./modules/custom-uploader.es.js");
const divider_es = require("./modules/divider.es.js");
const index_es$4 = require("./modules/emoji/index.es.js");
const index_es$3 = require("./modules/file/index.es.js");
const i18n_es = require("./modules/i18n.es.js");
const index_es$2 = require("./modules/link/index.es.js");
const index_es$1 = require("./modules/mathlive/index.es.js");
const formats_es = require("./modules/mathlive/formats.es.js");
const Mention_es = require("./modules/mention/Mention.es.js");
const syntax_es = require("./modules/syntax.es.js");
const betterTable_es = require("./modules/table/better-table.es.js");
const index_es = require("./modules/toolbar/index.es.js");
const snow_es = require("./themes/snow.es.js");
const icons_es = require("./ui/icons.es.js");
fluentEditor_es.default.register(
  {
    "formats/emoji": index_es$4.default.EmojiBlot,
    "formats/font": fontStyle_es.FontStyle,
    "formats/line-height": lineHeight_es.LineHeightStyle,
    [`formats/${formats_es.default.blotName}`]: formats_es.default,
    "formats/size": fontSize_es.SizeStyle,
    "formats/softBreak": softBreak_es.default,
    "formats/strike": strike_es.default,
    "formats/text-indent": textIndent_es.TextIndentStyle,
    "formats/video": video_es.default,
    "modules/clipboard": customClipboard_es.default,
    "modules/counter": counter_es.default,
    "modules/divider": divider_es.default,
    "modules/emoji-shortname": index_es$4.default.ShortNameEmoji,
    "modules/emoji-toolbar": index_es$4.default.ToolbarEmoji,
    "modules/file": index_es$3.default,
    // 'modules/global-link': GlobalLink, // TODO
    "modules/i18n": i18n_es.default,
    "modules/image": BlotFormatter_es.default,
    "modules/link": index_es$2.default,
    "modules/mathlive": index_es$1.default,
    "modules/mention": Mention_es.default,
    // 'modules/quickmenu': QuickMenu, // TODO
    "modules/syntax": syntax_es.default,
    "modules/toolbar": index_es.default,
    "modules/uploader": customUploader_es.default,
    // make sure register after `HeaderList`
    "modules/better-table": betterTable_es.default,
    "themes/snow": snow_es.default,
    "ui/icons": icons_es.default
  },
  true
  // 覆盖内部模块
);
exports.default = fluentEditor_es.default;
