"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
require("../../../../../../../../quill@2.0.3/node_modules/quill/quill.js");
const Action_es = require("./Action.es.js");
require("../../../../../../../../quill@2.0.3/node_modules/quill/core.js");
const quill = require("../../../../../../../../quill@2.0.3/node_modules/quill/core/quill.js");
class DeleteAction extends Action_es.default {
  constructor() {
    super(...arguments);
    this.onKeyUp = (event) => {
      if (!this.formatter.currentSpec) {
        return;
      }
      if (event.keyCode === 46 || event.keyCode === 8) {
        const blot = quill.default.find(this.formatter.currentSpec.getTargetElement());
        if (blot) {
          blot.deleteAt(0);
        }
        this.formatter.hide();
      }
    };
  }
  onCreate() {
    document.addEventListener("keyup", this.onKeyUp, true);
    this.formatter.quill.root.addEventListener("input", this.onKeyUp, true);
  }
  onDestroy() {
    document.removeEventListener("keyup", this.onKeyUp);
    this.formatter.quill.root.removeEventListener("input", this.onKeyUp);
  }
}
exports.default = DeleteAction;
