"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
require("../../../../../../../quill@2.0.3/node_modules/quill/quill.js");
const file_es = require("./formats/file.es.js");
const fileBar_es = require("./modules/file-bar.es.js");
require("../../../../../../../quill@2.0.3/node_modules/quill/core.js");
const quill = require("../../../../../../../quill@2.0.3/node_modules/quill/core/quill.js");
const Module = quill.default.imports["core/module"];
class FileModule extends Module {
  static register() {
    quill.default.register("formats/file", file_es.default, true);
  }
  constructor(quill2, options) {
    super(quill2, options);
    this.quill = quill2;
    quill2.root.addEventListener("click", (event) => this.clickEvent(event), false);
  }
  clickEvent(event) {
    event.preventDefault();
    const target = event.target;
    const fileDom = target.closest("a.ql-file-item");
    if (fileDom) {
      if (this.fileBar) {
        this.fileBar.destroy();
      }
      this.fileBar = new fileBar_es.default(this.quill, fileDom);
    } else if (this.fileBar && !target.closest(".ql-file-bar")) {
      this.fileBar.destroy();
      this.fileBar = null;
    }
  }
}
exports.default = FileModule;
