"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
require("../../../../../../../quill@2.0.3/node_modules/quill/quill.js");
const formats_es = require("./formats.es.js");
const tooltip_es = require("./tooltip.es.js");
require("../../../../../../../quill@2.0.3/node_modules/quill/core.js");
const quill = require("../../../../../../../quill@2.0.3/node_modules/quill/core/quill.js");
class MathliveModule {
  constructor(quill$1) {
    this.quill = quill$1;
    this.tooltip = new tooltip_es.default(quill$1);
    this.quill.root.addEventListener(
      "click",
      (e) => {
        if (!this.quill.isEnabled()) return;
        const path = e.composedPath();
        if (!path || path.length <= 0) return;
        const mathliveNode = path.find((node) => node.tagName && node.tagName.toUpperCase() === formats_es.default.tagName.toUpperCase() && node.classList.contains(formats_es.default.className));
        const mathliveBlot = quill.default.find(mathliveNode);
        if (mathliveBlot) {
          const { value, mode } = formats_es.default.value(mathliveBlot.domNode);
          if (mode === "dialog") {
            this.createDialog(value);
          }
        }
      },
      true
    );
  }
  createDialog(value) {
    this.tooltip.edit(value);
  }
}
exports.default = MathliveModule;
