"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
require("../../../../../../../../quill@2.0.3/node_modules/quill/quill.js");
const editor_utils_es = require("../../../config/editor.utils.es.js");
const tableConfig_es = require("../table-config.es.js");
require("../../../../../../../../quill@2.0.3/node_modules/quill/core.js");
const quill = require("../../../../../../../../quill@2.0.3/node_modules/quill/core/quill.js");
const OriginHeader = quill.default.import("formats/header");
class Header extends OriginHeader {
  static create(value) {
    if (typeof value === "string") {
      value = { value };
    }
    const node = super.create(value.value);
    tableConfig_es.CELL_IDENTITY_KEYS.forEach((key) => {
      if (value[key]) {
        node.setAttribute(`data-${key}`, value[key]);
      }
    });
    tableConfig_es.CELL_ATTRIBUTES.forEach((key) => {
      if (value[key]) {
        node.setAttribute(`data-${key}`, value[key]);
      }
    });
    return node;
  }
  static formats(domNode) {
    const formats = {};
    formats.value = this.tagName.indexOf(domNode.tagName) + 1;
    return tableConfig_es.CELL_ATTRIBUTES.concat(tableConfig_es.CELL_IDENTITY_KEYS).reduce((tableFormats, attribute) => {
      if (domNode.hasAttribute(`data-${attribute}`)) {
        tableFormats[attribute] = domNode.getAttribute(`data-${attribute}`) || void 0;
      }
      return tableFormats;
    }, formats);
  }
  format(name, value) {
    if (Object.prototype.toString.call(value) === "[object Object]") {
      value = value.value;
    }
    const headerDom = Header.formats(this.domNode);
    const { row, cell, rowspan, colspan } = headerDom;
    if (name === Header.blotName) {
      if (value) {
        super.format(name, {
          value,
          row,
          cell,
          rowspan,
          colspan
        });
      } else {
        if (row) {
          this.replaceWith("table-cell-line", {
            row,
            cell,
            rowspan,
            colspan
          });
        } else {
          super.format(name, value);
        }
      }
    } else {
      super.format(name, value);
    }
  }
  optimize(_context) {
    const { row, cell, rowspan, colspan } = Header.formats(this.domNode);
    if (row && this.parent.statics.blotName !== "table") {
      this.wrap("table", {
        row,
        cell,
        colspan,
        rowspan
      });
    }
    this.enforceAllowedChildren();
    if (!editor_utils_es.isNullOrUndefined(this.uiNode) && this.uiNode !== this.domNode.firstChild) {
      this.domNode.insertBefore(this.uiNode, this.domNode.firstChild);
    }
    if (this.children.length === 0) {
      if (!editor_utils_es.isNullOrUndefined(this.statics.defaultChild)) {
        const child = this.scroll.create(this.statics.defaultChild.blotName);
        this.appendChild(child);
      } else {
        this.remove();
      }
    }
    this.cache = {};
  }
}
Header.blotName = "header";
Header.tagName = ["H1", "H2", "H3", "H4", "H5", "H6"];
exports.default = Header;
