"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const fluentEditor_es = require("../core/fluent-editor.es.js");
const icons_config_es = require("./icons.config.es.js");
const ICONS_CONFIG = {
  "undo": icons_config_es.UNDO_ICON,
  "redo": icons_config_es.REDO_ICON,
  "clean": icons_config_es.CLEAN_ICON,
  "bold": icons_config_es.BOLD_ICON,
  "italic": icons_config_es.ITALIC_ICON,
  "underline": icons_config_es.UNDERLINE_ICON,
  "strike": icons_config_es.STRIKE_ICON,
  "font": "",
  "size": "",
  "color": `<span class="ql-color-inner">
    ${icons_config_es.COLOR_ICON}
    ${icons_config_es.TRIANGLE_DOWN_ICON}
    <span class="current-color-line"></span>
  </span>`,
  "background": `<span class="ql-color-inner">
    ${icons_config_es.BACKGROUND_COLOR_ICON}
    ${icons_config_es.TRIANGLE_DOWN_ICON}
    <span class="current-color-line color-line-background"></span>
  </span>`,
  "align": {
    "": icons_config_es.ALIGN_LEFT_ICON,
    "center": icons_config_es.ALIGN_CENTER_ICON,
    "right": icons_config_es.ALIGN_RIGHT_ICON,
    "justify": icons_config_es.ALIGN_JUSTIFY_ICON
  },
  "list": {
    bullet: icons_config_es.LIST_UNORDERED_ICON,
    ordered: icons_config_es.LIST_ORDERED_ICON,
    check: icons_config_es.LIST_CHECK_ICON
  },
  "code": icons_config_es.CODE_ICON,
  "code-block": icons_config_es.CODE_BLOCK_ICON,
  "blockquote": icons_config_es.BLOCKQUOTE_ICON,
  "image": icons_config_es.IMAGE_ICON,
  "file": icons_config_es.FILE_ICON,
  "better-table": icons_config_es.TABLE_ICON,
  "link": icons_config_es.LINK_ICON,
  "global-link": icons_config_es.GLOBAL_LINK_ICON,
  "fullscreen": icons_config_es.FULLSCREEN_ICON,
  "fullscreen-exit": icons_config_es.FULLSCREEN_EXIT_ICON,
  "emoji": icons_config_es.EMOJI_ICON,
  "help": icons_config_es.HELP_ICON,
  "screenshot": icons_config_es.SCREENSHOT_ICON,
  "format-painter": icons_config_es.FORMAT_PAINTER_ICON,
  "divider": icons_config_es.DIVIDER_ICON
};
const Icons = fluentEditor_es.default.import("ui/icons");
Object.entries(ICONS_CONFIG).forEach(([key, icon]) => {
  Icons[key] = icon;
});
exports.ICONS_CONFIG = ICONS_CONFIG;
exports.default = Icons;
