"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const cloneDeep = require("../../util/cloneDeep.js");
const BaseOption = require("./BaseOption.js");
const handleOption = require("./handleOption.js");
const handleColor = require("./handleColor.js");
const handleRootData = require("./handleRootData.js");
const handleVirtualLengend = require("./handleVirtualLengend.js");
const handleSeriesData = require("./handleSeriesData.js");
const legendSelectChanged = require("./legendSelectChanged.js");
const index = require("../../option/init/index.js");
const type = require("../../util/type.js");
const constants = require("../../util/constants.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var AssembleBubbleChart = /* @__PURE__ */ function() {
  function AssembleBubbleChart2(iChartOption, chartInstance, plugins) {
    this.baseOption = cloneDeep.default(BaseOption.default);
    this.iChartOption = index.default(iChartOption);
    this.chartInstance = chartInstance;
    this.plugins = plugins;
    this.updateOption(chartInstance);
  }
  var _proto = AssembleBubbleChart2.prototype;
  _proto.updateOption = function updateOption(chartInstance) {
    var _this$baseOption$seri;
    var d3 = this.plugins.d3;
    if (!d3) throw new Error("您必须安装d3才可以使用聚合气泡图");
    if (!type.isArray(this.iChartOption.color)) {
      this.iChartOption.color = [this.iChartOption.color];
    }
    var _this$iChartOption = this.iChartOption, color = _this$iChartOption.color, type$1 = _this$iChartOption.type;
    this.baseOption.color = color;
    this.baseOption.tooltip = handleOption.setTooltip(this.iChartOption);
    this.baseOption.legend = handleOption.setLegend(this.iChartOption);
    var _handleSeriesData = handleSeriesData.handleSeriesData(this.iChartOption, this.baseOption), depthFirst = _handleSeriesData.depthFirst, depthMore = _handleSeriesData.depthMore;
    handleColor.handleColor({
      depthFirst,
      depthMore,
      color,
      type: type$1
    }, this.baseOption);
    (_this$baseOption$seri = this.baseOption.series).unshift.apply(_this$baseOption$seri, handleVirtualLengend.handleVirtualLengend(this.baseOption.legend.data));
    handleRootData.handleRootData({
      d3,
      baseOption: this.baseOption,
      chartInstance,
      iChartOption: this.iChartOption
    });
    var baseOption = this.baseOption;
    chartInstance.on("legendselectchanged", function(params) {
      if (!params.selected[params.name]) {
        legendSelectChanged.legendDisappear({
          seriesData: baseOption.dataset[0].source,
          params,
          type: type$1,
          baseOption,
          chartInstance
        });
      } else {
        handleColor.handleColor({
          depthFirst,
          depthMore,
          color,
          type: type$1
        }, baseOption);
        legendSelectChanged.legendShow({
          seriesData: baseOption.dataset[0].source,
          type: type$1,
          params,
          baseOption,
          chartInstance
        });
      }
    });
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption(option) {
    this.baseOption = option;
  };
  return AssembleBubbleChart2;
}();
_defineProperty(AssembleBubbleChart, "name", constants.CHART_TYPE.ASSEMBLE_BUBBLE);
exports.default = AssembleBubbleChart;
