"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("../../feature/token/index.js");
var themeColor = {
  light: ["#e8e8e8", "#bbbbbb", "#ffffff"],
  dark: ["#2e2e2e", "#4e4e4e", "#272727"],
  "bpit-light": ["#e8e8e8", "#bbbbbb", "#ffffff"],
  "bpit-dark": ["#2e2e2e", "#4e4e4e", "#272727"],
  "cloud-light": ["#f2f2f2", "#bbbbbb", "#ffffff"],
  "cloud-dark": ["#2e2e2e", "#4e4e4e", "#272727"],
  "hdesign-light": ["#e8e8e8", "#bbbbbb", "#ffffff"],
  "hdesign-dark": ["#2e2e2e", "#4e4e4e", "#272727"]
};
function color(items, type) {
  var _themeColor$Theme$the = themeColor[index.default.themeName], subg = _themeColor$Theme$the[0], subfont = _themeColor$Theme$the[1], bg = _themeColor$Theme$the[2];
  items.color = subg;
  items.borderColor = subg;
  items.textColor = subfont;
  if (items.depth >= 1 && type === "nested") {
    items.borderColor = bg;
  }
}
function show(params, items, itemc, type) {
  if (!params.selected[itemc]) {
    if (items.type === itemc) {
      color(items, type);
    }
  }
}
function legendDisappear(paramsd) {
  var seriesData = paramsd.seriesData, params = paramsd.params, type = paramsd.type, baseOption = paramsd.baseOption, chartInstance = paramsd.chartInstance;
  seriesData.forEach(function(items) {
    if (items.type === params.name) {
      color(items, type);
    }
  });
  baseOption.dataset[0].source = seriesData;
  chartInstance.setOption(baseOption);
}
function legendShow(paramss) {
  var seriesData = paramss.seriesData, type = paramss.type, params = paramss.params, baseOption = paramss.baseOption, chartInstance = paramss.chartInstance;
  seriesData.forEach(function(items) {
    if (items.type !== params.name) {
      Object.keys(params.selected).forEach(function(itemc) {
        show(params, items, itemc, type);
      });
    }
  });
  baseOption.dataset[0].source = seriesData;
  chartInstance.setOption(baseOption);
}
exports.legendDisappear = legendDisappear;
exports.legendShow = legendShow;
