"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../BaseChart/index.js");
require("../../../../../../echarts@5.4.1/node_modules/echarts/index.js");
const constants = require("../../util/constants.js");
const echarts = require("../../../../../../echarts@5.4.1/node_modules/echarts/lib/core/echarts.js");
function _inheritsLoose(t, o) {
  t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o);
}
function _setPrototypeOf(t, e) {
  return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(t2, e2) {
    return t2.__proto__ = e2, t2;
  }, _setPrototypeOf(t, e);
}
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var amapPromise = null;
var AutonaviMapChart = /* @__PURE__ */ function(_BaseChart) {
  function AutonaviMapChart2() {
    var _this;
    _this = _BaseChart.call(this) || this;
    _this.echartsIns = null;
    _this.ichartsIns = null;
    _this.eChartOption = null;
    _this.iChartOption = null;
    _this.dom = null;
    _this.option = null;
    return _this;
  }
  _inheritsLoose(AutonaviMapChart2, _BaseChart);
  var _proto = AutonaviMapChart2.prototype;
  _proto.getAmap = function getAmap(option) {
    if (!amapPromise) {
      var key = option.key;
      var url = option.url;
      var version = option.version || option.ver || option.v;
      amapPromise = new Promise(function(resolve) {
        var cbName = "amap" + Date.now();
        var script = document.createElement("script");
        window[cbName] = resolve;
        var src = url + "?v=" + version + "&key=" + key;
        if (option.plugin) {
          src += "&plugin=" + option.plugin;
        }
        script.src = src + "&callback=" + cbName;
        script.onload = function() {
          return resolve();
        };
        document.body.appendChild(script);
      });
    }
    return amapPromise;
  };
  _proto.init = function init(dom) {
    this.uninstall();
    this.dom = dom;
    this.echartsIns = echarts.init(this.dom);
  };
  _proto.setSimpleOption = function setSimpleOption(chartName, option) {
    var _this2 = this;
    this.option = option;
    this.getAmap(this.option).then(function() {
      _this2.echartsIns.setOption(_this2.option);
      _this2.setResizeObserver();
    });
  };
  _proto.render = function render() {
    this.initDom();
    this.renderCallBack && this.renderCallBack(this);
  };
  _proto.onRenderReady = function onRenderReady(callback) {
    this.renderCallBack = callback;
  };
  _proto.initDom = function initDom() {
  };
  _proto.setResizeObserver = function setResizeObserver() {
    var _this3 = this;
    if (this.resizeObserver) {
      this.resizeObserver.disconnect();
      this.resizeObserver = null;
    }
    this.resizeObserver = new ResizeObserver(function(entries) {
      _this3.resizeDom();
    });
    this.resizeObserver.observe(this.dom);
  };
  _proto.resizeDom = function resizeDom() {
    this.echartsIns && this.echartsIns.resize && this.echartsIns.resize();
  };
  _proto.refresh = function refresh(option) {
    this.iChartOption = option;
    this.setSimpleOption("AutonaviMapChart", this.iChartOption);
    this.resizeDom();
  };
  _proto.refreshData = function refreshData(data) {
    this.iChartOption.series[0].data = data;
    this.refresh(this.iChartOption);
  };
  _proto.setResize = function setResize() {
    this.resizeDom();
  };
  _proto.uninstall = function uninstall() {
    if (this.resizeObserver) {
      this.resizeObserver.disconnect();
      this.resizeObserver = null;
    }
    if (this.echartsIns && !this.echartsIns.isDisposed()) {
      this.echartsIns.dispose();
    }
    this.echartsIns = null;
    this.dom = null;
  };
  _proto.getEchartsInstance = function getEchartsInstance() {
    return this.echartsIns;
  };
  _proto.getEchartsOption = function getEchartsOption() {
    return this.echartsIns.getOption();
  };
  _proto.getAmapComponent = function getAmapComponent() {
    return this.echartsIns.getModel().getComponent("amap");
  };
  _proto.getAmapInstance = function getAmapInstance() {
    return this.getAmapComponent().getAMap();
  };
  return AutonaviMapChart2;
}(index.default);
_defineProperty(AutonaviMapChart, "name", constants.CHART_TYPE.AUTONAVI_MAP);
exports.default = AutonaviMapChart;
