"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index$1 = require("../LineChart/index.js");
const miniBarChart = require("../../feature/mini/miniBarChart.js");
const index$3 = require("../../option/init/index.js");
const cloneDeep = require("../../util/cloneDeep.js");
const index$2 = require("../../option/base/index.js");
const barChartOption = require("./barChartOption.js");
const merge = require("../../util/merge.js");
const handleOptipn = require("./handleOptipn.js");
const index = require("../../option/RectSys/index.js");
const handleSeries = require("./handleSeries.js");
const constants = require("../../util/constants.js");
const xkey = require("../../option/config/xAxis/xkey.js");
const xdata = require("../../option/config/xAxis/xdata.js");
const ldata = require("../../option/config/legend/ldata.js");
const ydata = require("../../option/config/yAxis/ydata.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var BarChart = /* @__PURE__ */ function() {
  function BarChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.baseOption = cloneDeep.default(index$2.default);
    this.chartInstance = chartInstance;
    this.iChartOption = index$3.default(iChartOption);
    this.updateOption();
  }
  var _proto = BarChart2.prototype;
  _proto.updateOption = function updateOption() {
    var iChartOption = this.iChartOption;
    index.default(this.baseOption, this.iChartOption, constants.CHART_TYPE.BAR);
    var xAxisKey = xkey.default(iChartOption);
    var xAxisData = xdata.default(iChartOption.data, xAxisKey);
    var legendData = ldata.default(iChartOption.data, xAxisKey);
    var seriesData = ydata.default(iChartOption.data, legendData);
    this.baseOption.legend.data = iChartOption.legend.data || legendData;
    this.baseOption.xAxis.forEach(function(item) {
      item.data = xAxisData;
    });
    this.baseOption.series = handleSeries.setSeries(seriesData, legendData, iChartOption);
    handleOptipn.setStack(this.baseOption, iChartOption, legendData, seriesData);
    handleOptipn.setDoubleSides(this.baseOption, iChartOption);
    handleSeries.setWaterFall(this.baseOption, iChartOption);
    handleSeries.setRange(this.baseOption, iChartOption);
    handleSeries.setMarkLine(this.baseOption, iChartOption);
    handleOptipn.setDirection(this.baseOption, iChartOption.direction);
    handleSeries.setLimitFormatter(this.baseOption, iChartOption, seriesData);
    if (iChartOption.silent) {
      this.baseOption.tooltip = {};
    }
    merge.mergeSeries(iChartOption, this.baseOption);
    merge.mergeVisualMap(iChartOption, this.baseOption);
    miniBarChart.default(iChartOption, this.baseOption);
  };
  _proto.updateOptionAgain = function updateOptionAgain() {
    var baseOption = this.baseOption;
    var iChartOption = this.iChartOption;
    var lineDataName = iChartOption.lineDataName;
    if (lineDataName && lineDataName.length > 0) {
      var lineChartBaseOpt = new index$1.default(iChartOption, {}, this.chartInstance);
      var lineBaseOption = lineChartBaseOpt.getOption();
      var lineSeries = lineBaseOption.series;
      var barSeries = baseOption.series;
      lineDataName.forEach(function(lineName) {
        var bar = null;
        var line = null;
        for (var i = 0; i < lineSeries.length; i++) {
          if (lineSeries[i].name === lineName) {
            line = lineSeries[i];
            break;
          }
        }
        for (var _i = 0; _i < barSeries.length; _i++) {
          if (barSeries[_i].name === lineName) {
            bar = barSeries[_i];
            break;
          }
        }
        for (var key in line) {
          if (Object.hasOwnProperty.call(line, key)) {
            bar[key] = line[key];
          }
        }
      });
    }
    if (constants.ADAPTIVE_THEME.includes(this.iChartOption.theme)) {
      barChartOption.default(baseOption, this.chartInstance, this.iChartOption);
    }
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  _proto.resize = function resize(callback) {
    if (constants.ADAPTIVE_THEME.includes(this.iChartOption.theme)) {
      barChartOption.default(this.baseOption, this.chartInstance, this.iChartOption);
      callback && callback(this.baseOption);
    }
  };
  return BarChart2;
}();
_defineProperty(BarChart, "name", constants.CHART_TYPE.BAR);
exports.default = BarChart;
