"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const insert = require("../../util/init/insert.js");
var BaseChart = /* @__PURE__ */ function() {
  function BaseChart2() {
    this.dom = void 0;
    this.option = void 0;
    if (this.init === void 0) {
      throw new Error('This chart has not overwrite "init" callback!');
    }
    if (this.setSimpleOption === void 0) {
      throw new Error('This chart has not overwrite "setSimpleOption" callback!');
    }
    if (this.render === void 0) {
      throw new Error('This chart has not overwrite "render" callback!');
    }
    if (this.onRenderReady === void 0) {
      throw new Error('This chart has not overwrite "onRenderReady" callback!');
    }
    if (this.refresh === void 0) {
      throw new Error('This chart has not overwrite "refresh" callback!');
    }
    if (this.refreshData === void 0) {
      throw new Error('This chart has not overwrite "refreshData" callback!');
    }
    if (this.setResize === void 0) {
      throw new Error('This chart has not overwrite "setResize" callback!');
    }
    if (this.uninstall === void 0) {
      throw new Error('This chart has not overwrite "uninstall" callback!');
    }
  }
  var _proto = BaseChart2.prototype;
  _proto.showLoading = function showLoading(option) {
    insert.insertStateDom(this.dom, "loading", option);
  };
  _proto.hideLoading = function hideLoading() {
    insert.removeStateDom(this.dom, "loading");
  };
  _proto.closeLoading = function closeLoading() {
    insert.removeStateDom(this.dom, "loading");
  };
  _proto.showError = function showError(option) {
    insert.insertStateDom(this.dom, "error", option);
  };
  _proto.closeError = function closeError() {
    insert.removeStateDom(this.dom, "error");
  };
  _proto.showEmpty = function showEmpty(option) {
    insert.insertStateDom(this.dom, "empty", option);
  };
  _proto.closeEmpty = function closeEmpty() {
    insert.removeStateDom(this.dom, "empty");
  };
  _proto.showStageEmpty = function showStageEmpty(option) {
    insert.insertStateDom(this.dom, "stage_empty", option);
  };
  _proto.closeStageEmpty = function closeStageEmpty() {
    insert.removeStateDom(this.dom, "stage_empty");
  };
  _proto.showState = function showState(option) {
    insert.insertStateDom(this.dom, "custom", option);
  };
  _proto.closeState = function closeState() {
    insert.removeStateDom(this.dom, "custom");
  };
  _proto.showCustomDom = function showCustomDom(callback) {
    if (this.dom.getElementsByClassName("huicharts-custom-dom").length > 0) return;
    if (getComputedStyle(this.dom).position === "static") {
      this.dom.style.position = "relative";
    }
    var customContainer = document.createElement("div");
    customContainer.className = "huicharts-custom-dom";
    customContainer.setAttribute("style", "position:absolute;width:100%;height:100%;top:0px;left:0px;display:flex;justify-content:center;align-items:center");
    this.dom.appendChild(customContainer);
    callback(customContainer);
  };
  _proto.closeCustomDom = function closeCustomDom() {
    var customContainer = this.dom.getElementsByClassName("huicharts-custom-dom");
    this.dom.removeChild(customContainer[0]);
  };
  return BaseChart2;
}();
exports.default = BaseChart;
