"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const color = require("../../util/color.js");
const defendXSS = require("../../util/defendXSS.js");
function tooltipFormatter(params) {
  var seriesName = params.seriesName;
  var color$1 = params.color;
  var data = params.data;
  var x = data[0], y = data[1], radius = data[2], name = data[3];
  var htmlString = '<div style="margin-bottom:4px;">\n                                ' + defendXSS.default(seriesName) + "\n                         </div>";
  htmlString += '<div style="margin-bottom:4px;">\n                            <span style="display:inline-block;width:10px;height:10px;\n                            margin-right:8px;border-radius:5px;border-style: solid;border-width:1px;\n                            border-color:' + defendXSS.default(color.changeRgbaOpacity(color$1, 1)) + ";background-color:" + defendXSS.default(color$1) + ';"></span>\n                            <span>' + defendXSS.default(name) + "</span>\n                       </div>";
  htmlString += '\n            <div>\n                <span style="display:inline-block;margin-right:8px;min-width:60px;">x维度</span> \n                <span>' + defendXSS.default(x) + "</span>\n            </div>\n        ";
  htmlString += '\n            <div>\n                <span style="display:inline-block;margin-right:8px;min-width:60px;">y维度</span> \n                <span>' + defendXSS.default(y) + "</span>\n            </div>\n        ";
  htmlString += '\n            <div>\n                <span style="display:inline-block;margin-right:8px;min-width:60px;">半径维度</span> \n                <span>' + defendXSS.default(radius) + "</span>\n            </div>\n        ";
  return htmlString;
}
function setTooltip(baseOpt, iChartOption) {
  baseOpt.tooltip.trigger = "item";
  if (iChartOption.trigger === "axis") {
    baseOpt.tooltip.trigger = "axis";
    baseOpt.tooltip.axisPointer.type = "shadow";
  }
  if (!baseOpt.tooltip.formatter) {
    baseOpt.tooltip.formatter = tooltipFormatter;
  }
}
exports.setTooltip = setTooltip;
