"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
require("../../../../../../echarts@5.4.1/node_modules/echarts/index.js");
const chartToken = require("./chartToken.js");
const echarts = require("../../../../../../echarts@5.4.1/node_modules/echarts/lib/core/echarts.js");
function handleTrendLine(option, iChartOption, plugins) {
  var ecStat = plugins.ecStat;
  if (iChartOption.trendLineConfig) {
    if (ecStat) {
      echarts.registerTransform(ecStat.transform.regression);
      option.dataset.push({
        transform: {
          type: "ecStat:regression",
          config: iChartOption.trendLineConfig
        }
      });
      option.series.push({
        name: "trendline",
        type: "line",
        smooth: true,
        datasetIndex: 1,
        symbolSize: 0.1,
        symbol: "circle",
        label: {
          show: true,
          fontSize: 14,
          color: chartToken.default.labelColor
        },
        labelLayout: {
          dx: -20
        },
        encode: {
          label: 2,
          tooltip: 1
        },
        silent: true
      });
    } else {
      throw new Error("您必须安装echarts-stat才可以使用趋势线功能");
    }
  }
}
exports.handleTrendLine = handleTrendLine;
