"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const min = require("../../util/sort/min.js");
const max = require("../../util/sort/max.js");
function setVisualMap(baseOption, iChartOption, legendData) {
  var visualMap = [];
  var bubbleSize = iChartOption.bubbleSize || [10, 70];
  var radius = baseOption.dataset[0].source.map(function(item) {
    return item[2];
  });
  var minValue = min.default(radius);
  var maxValue = max.default(radius);
  var seriesIndex = new Array(legendData.length).fill(0).map(function(item, index) {
    return index;
  });
  visualMap.push({
    show: false,
    dimension: 2,
    min: minValue,
    max: maxValue,
    seriesIndex,
    inRange: {
      symbolSize: bubbleSize
    }
  });
  return visualMap;
}
function setDataset(baseOption, iChartOption) {
  var source = [];
  Object.keys(iChartOption.data).forEach(function(key) {
    source = source.concat(iChartOption.data[key]);
  });
  return [{
    source
  }];
}
exports.setDataset = setDataset;
exports.setVisualMap = setVisualMap;
