"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index$2 = require("../../option/init/index.js");
const index$1 = require("../../option/base/index.js");
const cloneDeep = require("../../util/cloneDeep.js");
const handleData = require("./handleData.js");
const handleSeries = require("./handleSeries.js");
const handleOptipn = require("./handleOptipn.js");
const handleTrendLine = require("./handleTrendLine.js");
const handleVisualMap = require("./handleVisualMap.js");
const index = require("../../option/RectSys/index.js");
const merge = require("../../util/merge.js");
const constants = require("../../util/constants.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var BubbleChart = /* @__PURE__ */ function() {
  function BubbleChart2(iChartOption, chartInstance, plugins) {
    this.baseOption = {};
    this.baseOption = cloneDeep.default(index$1.default);
    this.iChartOption = {};
    this.chartInstance = chartInstance;
    this.iChartOption = index$2.default(iChartOption);
    this.updateOption(plugins);
  }
  var _proto = BubbleChart2.prototype;
  _proto.updateOption = function updateOption(plugins) {
    var iChartOption = this.iChartOption;
    index.default(this.baseOption, this.iChartOption, constants.CHART_TYPE.BUBBLE);
    handleOptipn.setTooltip(this.baseOption, iChartOption);
    var legendData = handleData.getLegendData(iChartOption.data);
    var xAxisType = iChartOption.xAxisType;
    if (legendData && legendData[0] && iChartOption.data[legendData[0]] && iChartOption.data[legendData[0]][0] && iChartOption.data[legendData[0]][0][0] && typeof iChartOption.data[legendData[0]][0][0] === "string") {
      this.baseOption.xAxis.forEach(function(item) {
        item.type = xAxisType || "category";
        item.data = handleData.getXAxisData(iChartOption.data);
      });
    } else {
      this.baseOption.xAxis.forEach(function(item) {
        item.type = xAxisType || "value";
      });
    }
    this.baseOption.legend.data = this.baseOption.legend.data || legendData;
    this.baseOption.series = handleSeries.setSeries({
      legendData,
      data: iChartOption.data,
      markLine: iChartOption.markLine,
      color: this.baseOption.color,
      iChartOption
    });
    this.baseOption.dataset = handleVisualMap.setDataset(this.baseOption, iChartOption);
    this.baseOption.visualMap = handleVisualMap.setVisualMap(this.baseOption, iChartOption, legendData);
    handleTrendLine.handleTrendLine(this.baseOption, iChartOption, plugins);
    handleSeries.handleSeriesExtra(this.baseOption, iChartOption);
    merge.mergeSeries(iChartOption, this.baseOption);
    merge.mergeVisualMap(iChartOption, this.baseOption);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  return BubbleChart2;
}();
_defineProperty(BubbleChart, "name", constants.CHART_TYPE.BUBBLE);
exports.default = BubbleChart;
