"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
var BulletChartOption = function BulletChartOption2(width, option, iChartOption) {
  var barWidth;
  var backgroundWidth;
  var rows = option.series[0].data.length;
  var intervalRows = rows;
  var interval = (width - rows * 16) / intervalRows;
  if (interval >= 16) {
    barWidth = 16;
  } else {
    var flag = (width - intervalRows * 16) / rows;
    barWidth = flag > 2 ? flag : 2;
  }
  var intervalBG = (width - rows * 32) / intervalRows;
  if (intervalBG >= 8) {
    backgroundWidth = 32;
  } else {
    var _flag = (width - intervalRows * 8) / rows;
    backgroundWidth = _flag > 9 ? _flag : 9;
  }
  var symbolSize;
  option.series.forEach(function(item) {
    if (item.type === "scatter") {
      symbolSize = item.symbolSize;
    }
  });
  if (iChartOption.direction === "horizontal") {
    symbolSize[1] = backgroundWidth;
  } else {
    symbolSize[0] = backgroundWidth;
  }
  option.series.forEach(function(item) {
    if (item.color) {
      Object.assign(item, {
        barWidth: backgroundWidth
      });
    } else {
      Object.assign(item, {
        barWidth
      });
    }
  });
};
var updateWidth = function updateWidth2(baseOption, chartInstance, iChartOption) {
  var width;
  if (chartInstance.getModel()) {
    if (iChartOption.direction === "horizontal") {
      width = chartInstance.getModel().getComponent("grid").coordinateSystem.getRect().height;
    } else {
      width = chartInstance.getModel().getComponent("grid").coordinateSystem.getRect().width;
    }
    BulletChartOption(width, baseOption, iChartOption);
  }
};
exports.default = updateWidth;
