"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
require("../../feature/token/index.js");
const defendXSS = require("../../util/defendXSS.js");
require("../../util/constants.js");
function toolTipFormatter(params) {
  if (params.seriesIndex > 1) {
    return;
  }
  var htmlString = '<div style="margin-bottom:4px;">' + defendXSS.default(params.name) + "</div>";
  htmlString += '\n		<div>\n			<span style="display:inline-block;width:10px;height:10px;border-radius:5px;background-color:' + defendXSS.default(params.color) + ';">\n			</span>\n			<span style="margin-left:5px;">\n                            <span style="display:inline-block;margin-right:8px;min-width:60px;">' + defendXSS.default(params.seriesName) + '</span>\n			<span style="font-weight:bold">\n				' + defendXSS.default(params.value) + "\n			</span>\n		</div>\n	";
  return htmlString;
}
function handleTooltip(baseOpts, iChartOpt) {
  var _iChartOpt$tooltip;
  if (!iChartOpt.tipHtml && !(iChartOpt != null && (_iChartOpt$tooltip = iChartOpt.tooltip) != null && _iChartOpt$tooltip.formatter)) {
    baseOpts.tooltip.formatter = toolTipFormatter;
  }
}
function setDirection(baseOption, direction) {
  if (direction && direction === "horizontal") {
    var temp = baseOption.xAxis;
    baseOption.xAxis = baseOption.yAxis;
    baseOption.yAxis = temp;
  }
}
exports.handleTooltip = handleTooltip;
exports.setDirection = setDirection;
