"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const handleSeries = require("./handleSeries.js");
const index$1 = require("../../option/init/index.js");
const bulletChartOption = require("./bulletChartOption.js");
const handleOptipn = require("./handleOptipn.js");
const index = require("../../option/RectSys/index.js");
const constants = require("../../util/constants.js");
const xkey = require("../../option/config/xAxis/xkey.js");
const xdata = require("../../option/config/xAxis/xdata.js");
const ldata = require("../../option/config/legend/ldata.js");
const ydata = require("../../option/config/yAxis/ydata.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var BulletChart = /* @__PURE__ */ function() {
  function BulletChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.iChartOption = {};
    this.iChartOption = index$1.default(iChartOption);
    this.chartInstance = chartInstance;
    this.updateOption();
  }
  var _proto = BulletChart2.prototype;
  _proto.updateOption = function updateOption() {
    var iChartOption = this.iChartOption;
    index.default(this.baseOption, iChartOption, constants.CHART_TYPE.BULLET);
    var xAxisKey = xkey.default(iChartOption);
    var xAxisData = xdata.default(iChartOption.data, xAxisKey);
    this.baseOption.xAxis.forEach(function(item) {
      item.data = xAxisData;
    });
    var legendData = ldata.default(iChartOption.data, xAxisKey);
    var seriesData = ydata.default(iChartOption.data, legendData);
    handleOptipn.handleTooltip(this.baseOption, iChartOption);
    handleSeries.handleSeries(this.baseOption, iChartOption, legendData, seriesData);
    handleOptipn.setDirection(this.baseOption, iChartOption.direction);
  };
  _proto.updateOptionAgain = function updateOptionAgain() {
    var baseOption = this.baseOption;
    if (constants.ADAPTIVE_THEME.includes(this.iChartOption.theme)) {
      bulletChartOption.default(baseOption, this.chartInstance, this.iChartOption);
    }
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  _proto.resize = function resize(callback) {
    if (constants.ADAPTIVE_THEME.includes(this.iChartOption.theme)) {
      bulletChartOption.default(this.baseOption, this.chartInstance, this.iChartOption);
      callback && callback(this.baseOption);
    }
  };
  return BulletChart2;
}();
_defineProperty(BulletChart, "name", constants.CHART_TYPE.BULLET);
exports.default = BulletChart;
