"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index$1 = require("../../option/init/index.js");
const index = require("../../option/RectSys/index.js");
const hanleOption = require("./hanleOption.js");
const hanleSeries = require("./hanleSeries.js");
const merge = require("../../util/merge.js");
const constants = require("../../util/constants.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var CandlestickChart = /* @__PURE__ */ function() {
  function CandlestickChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.iChartOption = {};
    this.chartInstance = chartInstance;
    this.iChartOption = index$1.default(iChartOption);
    this.updateOption();
  }
  var _proto = CandlestickChart2.prototype;
  _proto.updateOption = function updateOption() {
    var iChartOption = this.iChartOption;
    var volume = this.iChartOption.volume;
    var data = hanleOption.handleData(iChartOption);
    if (!data) return;
    hanleSeries.handleSeries(this.baseOption, iChartOption, data, this.chartInstance);
    index.default(this.baseOption, iChartOption);
    hanleOption.handleGrid(this.baseOption, iChartOption);
    hanleOption.handleAxis(this.baseOption, data, volume);
    hanleOption.handleTooltip(this.baseOption, iChartOption);
    hanleOption.handleDataZoom(this.baseOption, iChartOption);
    hanleOption.handleLegend(this.baseOption, iChartOption);
    hanleOption.handleAxisPointer(this.baseOption);
    merge.mergeSeries(iChartOption, this.baseOption);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption(option) {
    this.baseOption = option;
  };
  return CandlestickChart2;
}();
_defineProperty(CandlestickChart, "name", constants.CHART_TYPE.CANDLESTICK);
exports.default = CandlestickChart;
