"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const defendXSS = require("../../util/defendXSS.js");
function getSeriesData(data) {
  var seriesData = [];
  data.forEach(function(item, i) {
    seriesData[i] = [];
    seriesData[i][0] = item.value;
  });
  return seriesData;
}
function tooltipFormatter(params) {
  var seriesName = params.seriesName;
  var color = params.color;
  var value = params.value;
  var htmlString = '<div>\n                            <span style="display:inline-block;width:10px;height:10px;\n                            margin-right:8px;border-radius:5px;border-style: solid;border-width:1px;\n                            border-color:' + defendXSS.default(color) + ";background-color:" + defendXSS.default(color) + ';"></span>\n                            <span style="margin-right:16px">' + defendXSS.default(seriesName) + "</span>\n                            <span>" + defendXSS.default(value) + "%</span>\n                       </div>";
  return htmlString;
}
function setTooltip(baseOpt) {
  if (!baseOpt.tooltip.formatter) {
    baseOpt.tooltip.formatter = tooltipFormatter;
  }
}
exports.getSeriesData = getSeriesData;
exports.setTooltip = setTooltip;
