"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const chartToken = require("./chartToken.js");
function getSeriesInit() {
  return {
    type: "bar",
    coordinateSystem: "polar",
    emphasis: {
      focus: "series"
    },
    animation: false,
    stack: "total",
    showBackground: true,
    backgroundStyle: {
      color: ""
    },
    data: []
  };
}
function setSeries(seriesData, iChartOption) {
  var data = iChartOption.data;
  var series = [];
  data.forEach(function(item, i) {
    var seriesUnit = getSeriesInit();
    seriesUnit.name = item.name;
    seriesUnit.data = seriesData[i];
    seriesUnit.backgroundStyle.color = chartToken.default.background;
    series.push(seriesUnit);
  });
  return series;
}
exports.setSeries = setSeries;
