"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
var VDirection = ["TB", "BT", "V"];
var LineRound = /* @__PURE__ */ function() {
  function LineRound2(option) {
    this.radius = 10;
    this.dis = 15;
    this.lineDistance = 0.5;
    this.radius = option.radius === void 0 ? this.radius : option.radius;
    this.lineDistance = option.lineDistance || 0.5;
  }
  var _proto = LineRound2.prototype;
  _proto.setData = function setData(edge, data, direction) {
    if (VDirection.indexOf(direction) !== -1) {
      if (edge.alignType == "target") {
        this.setTargetDataV(edge, data);
      } else if (edge.alignType == "source") {
        this.setSourceDataV(edge, data);
      }
    } else {
      if (edge.alignType == "target") {
        this.setTargetData(edge, data);
      } else if (edge.alignType == "source") {
        this.setSourceData(edge, data);
      }
    }
  };
  _proto.setTargetData = function setTargetData(targetEdge, data) {
    var end = targetEdge.target;
    var start = targetEdge.source;
    var nodesObj = data.nodesObj;
    var startWidth = nodesObj[start].width || 50;
    var startInnerWidth = nodesObj[start].innerWidth || 50;
    var startHeight = nodesObj[start].height || 50;
    var endWidth = nodesObj[end].width || 50;
    var endInnerWidth = nodesObj[end].innerWidth || 50;
    var endHeight = nodesObj[end].height || 50;
    targetEdge.radius = this.radius;
    targetEdge.startPoint = {
      x: nodesObj[start].x + startWidth + (startInnerWidth - startWidth) / 2 - data.minX,
      y: nodesObj[start].y + startHeight / 2 - data.minY
    };
    targetEdge.endPoint = {
      x: nodesObj[end].x - (endInnerWidth - endWidth) / 2 - data.minX,
      y: nodesObj[end].y + endHeight / 2 - data.minY
    };
    var vDis = targetEdge.endPoint.y - targetEdge.startPoint.y;
    var hDis = this.dis;
    if (Math.abs(vDis) <= this.radius * 2) {
      targetEdge.radius = Math.abs(vDis) / 2;
    }
    var revise = targetEdge.radius;
    if (targetEdge.endPoint.y < targetEdge.startPoint.y) {
      revise = -targetEdge.radius;
    }
    targetEdge.firstRoundStartPoint = {
      x: targetEdge.endPoint.x - hDis - targetEdge.radius * 2,
      y: targetEdge.startPoint.y
    };
    targetEdge.firstRoundControlPoint = {
      x: targetEdge.endPoint.x - hDis - targetEdge.radius,
      y: targetEdge.startPoint.y
    };
    targetEdge.firstRoundEndPoint = {
      x: targetEdge.endPoint.x - hDis - targetEdge.radius,
      y: targetEdge.startPoint.y + revise
    };
    targetEdge.secondRoundStartPoint = {
      x: targetEdge.endPoint.x - hDis - targetEdge.radius,
      y: targetEdge.endPoint.y - revise
    };
    targetEdge.secondRoundControlPoint = {
      x: targetEdge.endPoint.x - hDis - targetEdge.radius,
      y: targetEdge.endPoint.y
    };
    targetEdge.secondRoundEndPoint = {
      x: targetEdge.endPoint.x - hDis,
      y: targetEdge.endPoint.y
    };
  };
  _proto.setSourceData = function setSourceData(edge, data) {
    var end = edge.target;
    var start = edge.source;
    var nodesObj = data.nodesObj;
    var startWidth = nodesObj[start].width || 50;
    var startInnerWidth = nodesObj[start].innerWidth || 50;
    var startHeight = nodesObj[start].height || 50;
    var endWidth = nodesObj[end].width || 50;
    var endInnerWidth = nodesObj[end].innerWidth || 50;
    var endHeight = nodesObj[end].height || 50;
    edge.radius = this.radius;
    edge.startPoint = {
      x: nodesObj[start].x + startWidth + (startInnerWidth - startWidth) / 2 - data.minX,
      y: nodesObj[start].y + startHeight / 2 - data.minY
    };
    edge.endPoint = {
      x: nodesObj[end].x - (endInnerWidth - endWidth) / 2 - data.minX,
      y: nodesObj[end].y + endHeight / 2 - data.minY
    };
    var vDis = edge.endPoint.y - edge.startPoint.y;
    var hDis = this.dis;
    if (Math.abs(vDis) <= this.radius * 2) {
      edge.radius = Math.abs(vDis) / 2;
    }
    var revise = edge.radius;
    if (edge.endPoint.y < edge.startPoint.y) {
      revise = -edge.radius;
    }
    edge.firstRoundStartPoint = {
      x: edge.startPoint.x + hDis,
      y: edge.startPoint.y
    };
    edge.firstRoundControlPoint = {
      x: edge.startPoint.x + hDis + edge.radius,
      y: edge.startPoint.y
    };
    edge.firstRoundEndPoint = {
      x: edge.startPoint.x + hDis + edge.radius,
      y: edge.startPoint.y + revise
    };
    edge.secondRoundStartPoint = {
      x: edge.startPoint.x + hDis + edge.radius,
      y: edge.endPoint.y - revise
    };
    edge.secondRoundControlPoint = {
      x: edge.startPoint.x + hDis + edge.radius,
      y: edge.endPoint.y
    };
    edge.secondRoundEndPoint = {
      x: edge.startPoint.x + hDis + edge.radius * 2,
      y: edge.endPoint.y
    };
  };
  _proto.setTargetDataV = function setTargetDataV(targetEdge, data) {
    var end = targetEdge.target;
    var start = targetEdge.source;
    var nodesObj = data.nodesObj;
    var startWidth = nodesObj[start].width || 50;
    var startInnerHeight = nodesObj[start].innerHeight || 50;
    var startHeight = nodesObj[start].height || 50;
    var endWidth = nodesObj[end].width || 50;
    var endInnerHeight = nodesObj[end].innerHeight || 50;
    var endHeight = nodesObj[end].height || 50;
    targetEdge.radius = this.radius;
    targetEdge.startPoint = {
      x: nodesObj[start].x + startWidth / 2 - data.minX,
      y: nodesObj[start].y + startHeight + (startInnerHeight - startHeight) / 2 - data.minY
    };
    targetEdge.endPoint = {
      x: nodesObj[end].x + endWidth / 2 - data.minX,
      y: nodesObj[end].y - (endInnerHeight - endHeight) / 2 - data.minY
    };
    var hDis = targetEdge.endPoint.x - targetEdge.startPoint.x;
    var vDis = this.dis;
    if (Math.abs(hDis) <= this.radius * 2) {
      targetEdge.radius = Math.abs(hDis) / 2;
    }
    var revise = targetEdge.radius;
    if (targetEdge.endPoint.x < targetEdge.startPoint.x) {
      revise = -targetEdge.radius;
    }
    targetEdge.firstRoundStartPoint = {
      x: targetEdge.startPoint.x,
      y: targetEdge.endPoint.y - vDis - targetEdge.radius * 2
    };
    targetEdge.firstRoundControlPoint = {
      x: targetEdge.startPoint.x,
      y: targetEdge.endPoint.y - vDis - targetEdge.radius
    };
    targetEdge.firstRoundEndPoint = {
      x: targetEdge.startPoint.x + revise,
      y: targetEdge.endPoint.y - vDis - targetEdge.radius
    };
    targetEdge.secondRoundStartPoint = {
      x: targetEdge.endPoint.x - revise,
      y: targetEdge.endPoint.y - vDis - targetEdge.radius
    };
    targetEdge.secondRoundControlPoint = {
      x: targetEdge.endPoint.x,
      y: targetEdge.endPoint.y - vDis - targetEdge.radius
    };
    targetEdge.secondRoundEndPoint = {
      x: targetEdge.endPoint.x,
      y: targetEdge.endPoint.y - vDis
    };
  };
  _proto.setSourceDataV = function setSourceDataV(edge, data) {
    var end = edge.target;
    var start = edge.source;
    var nodesObj = data.nodesObj;
    var startWidth = nodesObj[start].width || 50;
    var startInnerHeight = nodesObj[start].innerHeight || 50;
    var startHeight = nodesObj[start].height || 50;
    var endWidth = nodesObj[end].width || 50;
    var endInnerHeight = nodesObj[end].innerHeight || 50;
    var endHeight = nodesObj[end].height || 50;
    edge.radius = this.radius;
    edge.startPoint = {
      x: nodesObj[start].x + startWidth / 2 - data.minX,
      y: nodesObj[start].y + startHeight + (startInnerHeight - startHeight) / 2 - data.minY
    };
    edge.endPoint = {
      x: nodesObj[end].x + endWidth / 2 - data.minX,
      y: nodesObj[end].y - (endInnerHeight - endHeight) / 2 - data.minY
    };
    var hDis = edge.endPoint.x - edge.startPoint.x;
    var vDis = this.dis;
    if (Math.abs(hDis) <= this.radius * 2) {
      edge.radius = Math.abs(hDis) / 2;
    }
    var revise = edge.radius;
    if (edge.endPoint.x < edge.startPoint.x) {
      revise = -edge.radius;
    }
    edge.firstRoundStartPoint = {
      x: edge.startPoint.x,
      y: edge.startPoint.y + vDis
    };
    edge.firstRoundControlPoint = {
      x: edge.startPoint.x,
      y: edge.startPoint.y + vDis + edge.radius
    };
    edge.firstRoundEndPoint = {
      x: edge.startPoint.x + revise,
      y: edge.startPoint.y + vDis + edge.radius
    };
    edge.secondRoundStartPoint = {
      x: edge.endPoint.x - revise,
      y: edge.startPoint.y + vDis + edge.radius
    };
    edge.secondRoundControlPoint = {
      x: edge.endPoint.x,
      y: edge.startPoint.y + vDis + edge.radius
    };
    edge.secondRoundEndPoint = {
      x: edge.endPoint.x,
      y: edge.startPoint.y + vDis + edge.radius * 2
    };
  };
  _proto.setPath = function setPath(edge) {
    var m = "M" + edge.startPoint.x + " " + edge.startPoint.y;
    var l1 = "L" + edge.firstRoundStartPoint.x + " " + edge.firstRoundStartPoint.y;
    var q1 = "Q" + edge.firstRoundControlPoint.x + " " + edge.firstRoundControlPoint.y + " " + edge.firstRoundEndPoint.x + " " + edge.firstRoundEndPoint.y;
    var l2 = "L" + edge.secondRoundStartPoint.x + " " + edge.secondRoundStartPoint.y;
    var q2 = "Q" + edge.secondRoundControlPoint.x + " " + edge.secondRoundControlPoint.y + " " + edge.secondRoundEndPoint.x + " " + edge.secondRoundEndPoint.y;
    var l3 = "L" + edge.endPoint.x + " " + edge.endPoint.y;
    return m + " " + l1 + " " + q1 + " " + l2 + " " + q2 + " " + l3;
  };
  return LineRound2;
}();
exports.default = LineRound;
