"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
function isArray(data) {
  return Object.prototype.toString.call(data) === "[object Array]" ? true : false;
}
function createSvgByTag(tag) {
  return document.createElementNS("http://www.w3.org/2000/svg", tag);
}
function addClass(dom, classes) {
  if (isArray(classes)) {
    classes.forEach(function(cls) {
      dom.classList.add(cls);
    });
  } else {
    classes && dom.classList.add(classes);
  }
}
function attr(dom, key, value) {
  dom.setAttribute(key, value);
}
exports.addClass = addClass;
exports.attr = attr;
exports.createSvgByTag = createSvgByTag;
exports.isArray = isArray;
