"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const cloneDeep = require("../../util/cloneDeep.js");
function sortData(sort, data) {
  var legendName = [];
  if (sort == "ascending") {
    var sortedData = [].concat(data).sort(function(a, b) {
      return a.value - b.value;
    });
    sortedData.forEach(function(item) {
      legendName.push(item.name);
    });
  } else {
    var _sortedData = [].concat(data).sort(function(a, b) {
      return b.value - a.value;
    });
    _sortedData.forEach(function(item) {
      legendName.push(item.name);
    });
  }
  return legendName;
}
function setLegend(baseOption) {
  var dataUnit = cloneDeep.default(baseOption.series[0].data);
  var data = [];
  var sort = [];
  if (dataUnit !== void 0) {
    data = dataUnit;
    sort = baseOption.series[0].sort;
  }
  var legendData = sortData(sort, data);
  return legendData;
}
exports.setLegend = setLegend;
