"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const merge = require("../../util/merge.js");
const chartToken = require("./chartToken.js");
function getSeriesInit() {
  return {
    type: "funnel",
    width: "80%",
    minSize: "0%",
    maxSize: "100%",
    left: "center",
    top: 60,
    bottom: 60,
    funnelAlign: "center",
    orient: "vertical",
    sort: "descending",
    gap: 1,
    itemStyle: {
      borderWidth: chartToken.default.borderWidth,
      borderColor: chartToken.default.borderColor
    },
    label: {
      color: chartToken.default.labelColor,
      position: "inside",
      show: true
    },
    data: void 0
  };
}
function getSeriesUnit(iChartOption) {
  var data = iChartOption.data, sort = iChartOption.sort, size = iChartOption.size, position = iChartOption.position, gap = iChartOption.gap, label = iChartOption.label;
  var seriesUnit = getSeriesInit();
  data && (seriesUnit.data = data);
  sort && (seriesUnit.sort = sort);
  gap && (seriesUnit.gap = gap);
  label && merge.default(seriesUnit.label, label);
  size && merge.default(seriesUnit, size);
  position && merge.default(seriesUnit, position);
  return seriesUnit;
}
function setSeries(iChartOption) {
  var selfSeries = iChartOption.series;
  if (selfSeries && selfSeries.length !== 0) {
    var newSelfSeries = selfSeries.map(function(seriesItem) {
      var seriesUnit2 = getSeriesUnit(iChartOption);
      merge.default(seriesUnit2, seriesItem);
      return seriesUnit2;
    });
    return newSelfSeries;
  }
  var series = [];
  var seriesUnit = getSeriesUnit(iChartOption);
  series.push(seriesUnit);
  return series;
}
exports.setSeries = setSeries;
