"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const util = require("./util.js");
const constant = require("./constant.js");
var CoordinateSystem = /* @__PURE__ */ function() {
  function CoordinateSystem2(wrapper, option, canvasWidth, canvasHeight) {
    var _this = this;
    this.wrapper = null;
    this.option = {};
    this.canvas = null;
    this.isMove = false;
    this.canvasCtx = null;
    this.isShow = false;
    this.lineSpace = 0;
    this.cavasRowCoordinates = [];
    this.mousePosition = {
      x: 0,
      y: 0
    };
    this.tip = void 0;
    this.tipContent = void 0;
    this.currentTotalTime = 0;
    this.timeScope = 0;
    this.canvasMove = function(e) {
      _this.isMove = true;
      _this.mousePosition.x = e.offsetX;
      _this.mousePosition.y = e.offsetY;
      _this.resetCanvas(_this.currentTotalTime, _this.timeScope);
    };
    this.canvasLeave = function() {
      _this.isMove = false;
      util.setStyle(_this.tip, "visibility", "hidden");
      util.setStyle(_this.tip, "opacity", 0);
      util.setStyle(_this.canvas, "cursor", "default");
    };
    this.tipMouseLeave = function() {
      util.setStyle(_this.tip, "visibility", "hidden");
      util.setStyle(_this.tip, "opacity", 0);
      util.setStyle(_this.canvas, "cursor", "default");
    };
    this.wrapper = wrapper;
    this.option = option;
    this.canvasWidth = canvasWidth;
    this.canvasHeight = canvasHeight;
  }
  var _proto = CoordinateSystem2.prototype;
  _proto.createDom = function createDom(className, domName) {
    var node = util.createEl(domName || "div");
    util.addClass(node, className);
    return node;
  };
  _proto.addClassName = function addClassName(node, className) {
    util.addClass(node, className);
  };
  _proto.addDom = function addDom(container, node) {
    util.appendEL(container, node);
  };
  _proto.clearDom = function clearDom(node) {
    util.appendNode(node, "");
  };
  _proto.addText = function addText(node, text) {
    util.appendText(node, text);
  };
  _proto.renderCoordinatesAxis = function renderCoordinatesAxis(body) {
    var _this2 = this;
    var axisWrapper = this.createDom("ev_GanttChart_axisWrapper");
    this.addDom(body, axisWrapper);
    var axis = this.createDom("ev_GanttChart_axis", "ul");
    this.addDom(axisWrapper, axis);
    if (this.option && this.option.data) {
      this.option.data.forEach(function(dataItem) {
        var axisItem = _this2.createDom("ev_GanttChart_axisItem", "li");
        _this2.addText(axisItem, dataItem.name);
        _this2.addDom(axis, axisItem);
      });
    }
  };
  _proto.renderChartItem = function renderChartItem(chartItemWrapper) {
    var _this3 = this;
    this.option.data.forEach(function() {
      var chartItem = _this3.createDom("ev_GanttChart_chartItem");
      var tractionLineWrapper = _this3.createDom("ev_GanttChart_tractionLineWrapper");
      var towingPoint = _this3.createDom("ev_GanttChart_towingPoint");
      var tractionLine = _this3.createDom("ev_GanttChart_tractionLine");
      _this3.addDom(tractionLineWrapper, towingPoint);
      _this3.addDom(tractionLineWrapper, tractionLine);
      var chartPostWrapper = _this3.createDom("ev_GanttChart_chartPostWrapper");
      _this3.addDom(chartItem, chartPostWrapper);
      _this3.addDom(chartItem, tractionLineWrapper);
      _this3.addDom(chartItemWrapper, chartItem);
    });
  };
  _proto.renderBody = function renderBody(chartItemWrapper) {
    if (this.option && this.option.data) {
      this.renderChartItem(chartItemWrapper);
    }
  };
  _proto.getLineSpace = function getLineSpace() {
    var lineSpace;
    if (this.option.data.length < 2) {
      lineSpace = 0;
    } else {
      var isOverHigh = this.canvasHeight - 28 * this.option.data.length <= 0;
      lineSpace = (isOverHigh ? 0 : this.canvasHeight - 28 * this.option.data.length) / (this.option.data.length - 1);
    }
    return lineSpace;
  };
  _proto.drawRoundRect = function drawRoundRect(x, y, width, height, radius) {
    this.canvasCtx.beginPath();
    this.canvasCtx.arc(x + radius, y + radius, radius, Math.PI, Math.PI * 3 / 2);
    this.canvasCtx.lineTo(width - radius + x, y);
    this.canvasCtx.arc(width - radius + x, radius + y, radius, Math.PI * 3 / 2, Math.PI * 2);
    this.canvasCtx.lineTo(width + x, height + y - radius);
    this.canvasCtx.arc(width - radius + x, height - radius + y, radius, 0, Math.PI * 1 / 2);
    this.canvasCtx.lineTo(radius + x, height + y);
    this.canvasCtx.arc(radius + x, height - radius + y, radius, Math.PI * 1 / 2, Math.PI);
  };
  _proto.renderRowItemPoint = function renderRowItemPoint(rowItemWidth, postItem, xCoordinates, yCoordinates) {
    if (rowItemWidth > 8 + 4 + 8) {
      this.canvasCtx.beginPath();
      this.canvasCtx.arc(xCoordinates + 10, yCoordinates + 10, 2, 0, Math.PI * 2);
      var color;
      switch (postItem.status) {
        case "during":
          color = "#DBDFF2";
          break;
        case "success":
          color = "#AFEDCE";
          break;
        case "stop":
          color = "#E4E4E4";
          break;
        case "waiting":
          color = "#FCDBAA";
          break;
        default:
          color = "#F3DADA";
          break;
      }
      this.canvasCtx.fillStyle = color;
      this.canvasCtx.fill();
    }
  };
  _proto.renderRowItemLabel = function renderRowItemLabel(differenceTime, rowItemWidth, xCoordinates, yCoordinates) {
    var label = util.getChartPostLabel(differenceTime);
    var labelWidth = Math.round(this.canvasCtx.measureText(label).width + 8);
    if (rowItemWidth - (8 + 4 + 8) >= labelWidth) {
      this.canvasCtx.fillStyle = "#FFF";
      this.canvasCtx.fillText(label, xCoordinates + (rowItemWidth - labelWidth), yCoordinates + 14);
    }
  };
  _proto.setTipContent = function setTipContent(node, dataIndex, postIndex) {
    if (this.option.tipHtml) {
      util.appendNode(node, this.option.tipHtml(this.option.data, dataIndex, postIndex));
    } else {
      util.appendNode(node, util.innerTooltip(this.option.data, dataIndex, postIndex));
    }
  };
  _proto.renderRowItem = function renderRowItem(yCoordinates, postItem, postIndex, dataIndex, currentTotalTime, timeScope) {
    var startTime = new Date(postItem.startTime).getTime();
    var endTime = new Date(postItem.endTime).getTime();
    var postItemTime = {
      startTime,
      endTime
    };
    var differenceTime = endTime - startTime;
    var currentTime = new Date(this.option.currentTime).getTime();
    var percent = util.handlePercent(postItemTime, currentTime, currentTotalTime, timeScope);
    if (percent === 0) return;
    var chartPostWidth = this.canvasWidth * percent;
    var rowItemWidth = Math.round(chartPostWidth) === 0 ? 1 : Math.round(chartPostWidth);
    var left = util.handleLeft(postItemTime, currentTime, currentTotalTime, timeScope);
    var xCoordinates = Math.round(left * this.canvasWidth);
    var borderRadius = rowItemWidth < 4 ? 0 : constant.BORDER_RADIUS;
    this.drawRoundRect(xCoordinates, yCoordinates, rowItemWidth, constant.BAR_HEIGHT, borderRadius);
    this.canvasCtx.fillStyle = util.handleFillColor(postItem);
    this.canvasCtx.fill();
    if (this.isMove) {
      if (this.canvasCtx.isPointInPath(this.mousePosition.x, this.mousePosition.y)) {
        this.isShow = true;
        if (this.isShow) {
          this.setTipContent(this.tipContent, dataIndex, postIndex);
          util.setStyle(this.tip, "visibility", "visible");
          util.setStyle(this.tip, "opacity", 1);
          util.setStyle(this.canvas, "cursor", "pointer");
          var top = dataIndex * (this.lineSpace + 28) + 16 + 40;
          var transform = "translate3d(" + (this.mousePosition.x + 2) + "px, " + (this.mousePosition.y - top) + "px, 0px)";
          util.setStyle(this.tip, "transform", transform);
        }
      } else {
        if (!this.isShow) {
          util.setStyle(this.tip, "visibility", "hidden");
          util.setStyle(this.tip, "opacity", 0);
          util.setStyle(this.canvas, "cursor", "default");
        }
      }
    }
    this.renderRowItemPoint(rowItemWidth, postItem, xCoordinates, yCoordinates);
    this.renderRowItemLabel(differenceTime, rowItemWidth, xCoordinates, yCoordinates);
  };
  _proto.renderChartRow = function renderChartRow(dataItem, dataIndex, yCoordinates, currentTotalTime, timeScope) {
    var _this4 = this;
    dataItem.data.forEach(function(postItem, postIndex) {
      _this4.renderRowItem(yCoordinates, postItem, postIndex, dataIndex, currentTotalTime, timeScope);
    });
  };
  _proto.resetCanvas = function resetCanvas(currentTotalTime, timeScope) {
    var _this5 = this;
    if (currentTotalTime) {
      this.currentTotalTime = currentTotalTime;
    }
    if (timeScope) {
      this.timeScope = timeScope;
    }
    if (this.option.data && this.option.data.length === 0) return;
    this.canvasCtx.clearRect(0, 0, this.canvasWidth, this.canvasHeight);
    this.option.data.forEach(function(item, index) {
      _this5.renderChartRow(item, index, _this5.cavasRowCoordinates[index].yStart, currentTotalTime, timeScope);
    });
    this.isShow = false;
  };
  _proto.paintCanvas = function paintCanvas() {
    var _this6 = this;
    if (this.option.data) {
      var lineSpace = this.getLineSpace();
      this.lineSpace = lineSpace;
      this.option.data.forEach(function(item, index) {
        var yRow = {
          yStart: constant.SPACE * (2 * index + 1) + index * (constant.BAR_HEIGHT + lineSpace)
        };
        _this6.cavasRowCoordinates.push(yRow);
      });
      this.resetCanvas();
    }
  };
  _proto.init = function init() {
    var body = this.createDom("ev_GanttChart_body");
    this.addDom(this.wrapper, body);
    this.renderCoordinatesAxis(body);
    var chartWrapper = this.createDom("ev_GanttChart_chartWrapper");
    this.addDom(body, chartWrapper);
    var chartItemWrapper = this.createDom("ev_GanttChart_chartItemWrapper");
    this.addDom(chartWrapper, chartItemWrapper);
    this.renderBody(chartItemWrapper);
    var cavas = this.createDom("ev_GanttChart_canvas", "canvas");
    this.canvas = cavas;
    cavas.onmousemove = this.canvasMove;
    cavas.onmouseleave = this.canvasLeave;
    cavas.id = "ev_GanttChart_cavs";
    cavas.width = this.canvasWidth;
    cavas.height = this.canvasHeight;
    this.addDom(chartWrapper, cavas);
    var ctx = cavas.getContext("2d");
    this.canvasCtx = ctx;
    this.paintCanvas();
    var tooltip = this.createDom("ev_GanttChart_tooltipContainer");
    this.addDom(chartWrapper, tooltip);
    this.tip = tooltip;
    var toolTipContent = this.createDom("ev_GanttChart_toolTipContent");
    this.addDom(tooltip, toolTipContent);
    this.tipContent = toolTipContent;
    this.tip.onmouseleave = this.tipMouseLeave;
  };
  return CoordinateSystem2;
}();
exports.default = CoordinateSystem;
