"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const utils = require("./utils.js");
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var handleData = function handleData2(data, baseOption) {
  var nodes = [];
  var links = [];
  var parentNodeName = "";
  var categories = baseOption.series[0].categories;
  parentNodeName = data[0].name;
  var data_ = [{
    name: parentNodeName,
    target: null
  }];
  data.forEach(function(item, index) {
    data_.push({
      name: item.name + "-" + index + "-_clone",
      target: item.name
    });
    if (item.children && item.children.length) {
      utils.cloneNode(item, index, data_);
    }
  });
  data_.forEach(function(item, index) {
    var source = item.name;
    var target = item.target;
    links.push({
      source: target,
      target: source
    });
  });
  var sourceName = [];
  links.forEach(function(item, index) {
    if (item.target && item.source) {
      var childArr = [];
      links.forEach(function(item_, index_) {
        if (item_.source === item.source) {
          var child = [];
          utils.createNodes(links, item_, child);
          childArr.push({
            id: item_.target,
            children: child
          });
        }
      });
      if (!sourceName.includes(item.source)) {
        sourceName.push(item.source);
        if (item.source === parentNodeName) {
          nodes.push({
            id: item.source,
            children: childArr
          });
        }
      }
    }
  });
  nodes.forEach(function(item, index) {
    item.symbolSize = categories[0].symbolSize;
    item.category = 0;
    if (item.children && item.children.length) {
      utils.handleNodes(item.children, categories);
    }
  });
  var rootData = {};
  rootData = _extends({}, nodes[0]);
  baseOption.series[0].links = links;
  return {
    rootData
  };
};
var updateData = function updateData2(rootData, baseOption, positionArr, idArr) {
  var nodes = [_extends({}, rootData)];
  if (rootData.children && rootData.children.length) {
    rootData.children.forEach(function(item, index) {
      utils.expandNodes(nodes, item);
      nodes.push(item);
    });
  }
  nodes.forEach(function(item, index) {
    idArr.forEach(function(item_, index_) {
      if (item.id === item_) {
        item.x = positionArr[index_].x;
        item.y = positionArr[index_].y;
      }
    });
  });
  baseOption.series[0].data = nodes;
};
exports.handleData = handleData;
exports.updateData = updateData;
