"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../../option/init/index.js");
const BaseOption = require("./BaseOption.js");
const cloneDeep = require("../../util/cloneDeep.js");
const handleData = require("./handleData.js");
const handleOption = require("./handleOption.js");
const mixTree = require("./mixTree.js");
const constants = require("../../util/constants.js");
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var GraphTreeChart = /* @__PURE__ */ function() {
  function GraphTreeChart2(iChartOption, chartInstance) {
    this.rootData = {};
    this.baseOption = cloneDeep.default(BaseOption.BaseOption);
    this.iChartOption = index.default(iChartOption);
    this.updateOption(iChartOption, chartInstance);
  }
  var _proto = GraphTreeChart2.prototype;
  _proto.updateOption = function updateOption(iChartOption, chartInstance) {
    var theme = iChartOption.theme || "light";
    handleOption.handleCategories(iChartOption, this.baseOption, theme);
    var _handleData = handleData.handleData(iChartOption.data, this.baseOption), rootData = _handleData.rootData;
    this.rootData = _extends({}, rootData);
    handleOption.handleForce(iChartOption, this.baseOption);
    handleOption.handleArrow(iChartOption, this.baseOption, theme);
    handleOption.handlePosition(iChartOption, this.baseOption);
    handleOption.handleLineStyle(iChartOption, this.baseOption, theme);
    mixTree.mixTree(this, chartInstance, this.baseOption);
  };
  _proto.updateNodesData = function updateNodesData(positionArr, idArr) {
    handleData.updateData(this.rootData, this.baseOption, positionArr, idArr);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  return GraphTreeChart2;
}();
_defineProperty(GraphTreeChart, "name", constants.CHART_TYPE.GRAPH_TREE);
exports.default = GraphTreeChart;
