"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
function handleRectData(data) {
  return data;
}
function handleCategoryName(data) {
  var defaultArr = [];
  data.forEach(function(item) {
    if (defaultArr.indexOf(item) === -1) {
      defaultArr.push(item);
    }
  });
  return defaultArr;
}
function handlecalendarSeriesData(xAxisData, yAxisData, data, keyName) {
  return data.map(function(item) {
    return [xAxisData.indexOf(item[keyName[0]]), yAxisData.indexOf(item[keyName[1]]), item[keyName[2]]];
  });
}
function handleCalendarData(data) {
  var calendarData = [];
  var keyName = Object.keys(data[0]);
  var xCategoryName = data.map(function(item) {
    return item[keyName[0]];
  });
  var yCategoryName = data.map(function(item) {
    return item[keyName[1]];
  });
  var xAxisData = handleCategoryName(xCategoryName);
  var yAxisData = handleCategoryName(yCategoryName);
  var calendarSeriesData = handlecalendarSeriesData(xAxisData, yAxisData, data, keyName);
  calendarData.push(xAxisData);
  calendarData.push(yAxisData);
  calendarData.push(calendarSeriesData);
  return calendarData;
}
function computeCoordinates(arr, number, halfWidth, r) {
  return arr.map(function(item, index) {
    var groupNumber = number * 2 - 1;
    var remainder = index % groupNumber;
    var group = index / groupNumber;
    var lineNumber = Math.floor(group);
    if (remainder < number - 1) {
      return [(remainder + 1) * 2 * halfWidth, (1 + 3 * lineNumber) * r, item.value, r, item];
    } else {
      return [((remainder - number + 1) * 2 + 1) * halfWidth, (1 + 1.5 * (2 * lineNumber + 1)) * r, item.value, r, item];
    }
  });
}
function handleHexagonData(data, iChartOption, chartInstance) {
  var containerWidth = chartInstance.getWidth();
  var containerHeight = chartInstance.getHeight();
  var hexagonData = [];
  var number = iChartOption.quantity || 40;
  var xValue = containerWidth;
  var yValue = containerHeight;
  var initialData = data;
  var x = xValue / (2 * number);
  var r = x / Math.sqrt(0.75);
  var coordinatesArr = computeCoordinates(initialData, number, x, r);
  hexagonData.push(coordinatesArr);
  hexagonData.push(xValue);
  hexagonData.push(yValue);
  hexagonData.push(r);
  return hexagonData;
}
var dataHandler = {
  RectangularHeatMapChart: handleRectData,
  CalendarHeatMapChart: handleCalendarData,
  HexagonHeatMapChart: handleHexagonData
};
function getData(type, iChartOption, chartInstance) {
  if (iChartOption.data && iChartOption.data.length > 0) {
    var chartData = dataHandler[type](iChartOption.data, iChartOption, chartInstance);
    return chartData;
  }
  return null;
}
exports.getData = getData;
