"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const min = require("../../util/sort/min.js");
const max = require("../../util/sort/max.js");
const BaseOption = require("./BaseOption.js");
const merge = require("../../util/merge.js");
const index = require("../../option/config/visualMap/index.js");
function handleCalendar(iChartOption, visualUnit, maxValue, minValue, visualType) {
  visualUnit.show = !!iChartOption.handle;
  if (visualType === "continuous") visualUnit.itemHeight = 400;
  visualUnit.text = [maxValue, minValue];
  visualUnit.right = "4%";
  visualUnit.bottom = "6%";
  if (iChartOption.handle) {
    merge.default(visualUnit, iChartOption.handle);
    if (iChartOption.handle.width) {
      visualUnit.itemWidth = iChartOption.handle.width;
      delete visualUnit.width;
    }
    if (iChartOption.handle.height) {
      visualUnit.itemHeight = iChartOption.handle.height;
      delete visualUnit.height;
    }
    if (iChartOption.handle.position) {
      merge.default(visualUnit, iChartOption.handle.position);
      delete visualUnit.position;
    }
  }
  visualUnit.inRange = !iChartOption.changeProperty || iChartOption.changeProperty === "opcity" ? {
    opacity: [0, 1]
  } : {
    color: iChartOption.color
  };
}
function getVisualType(iChartOption) {
  var _ref, _handle$type;
  var visualMap = iChartOption.visualMap, handle = iChartOption.handle;
  var type = (_ref = (_handle$type = handle == null ? void 0 : handle.type) != null ? _handle$type : visualMap == null ? void 0 : visualMap.type) != null ? _ref : "continuous";
  return type;
}
function setVisualMap(baseOpt, type, data, iChartOption) {
  var baseVisualMap = [];
  var visualType = getVisualType(iChartOption);
  var visualUnit = index.default(visualType);
  var intervalData = {
    RectangularHeatMapChart: data,
    CalendarHeatMapChart: data[2],
    HexagonHeatMapChart: data[0]
  };
  var intervalArr = intervalData[type].map(function(item) {
    return item[2];
  });
  var minValue = min.default(intervalArr);
  var maxValue = max.default(intervalArr);
  visualUnit.min = minValue;
  visualUnit.max = maxValue;
  visualUnit.dimension = 2;
  if (type === BaseOption.CHARTTYPE[0]) {
    visualUnit.inRange = {
      colorAlpha: [0, 1]
    };
  }
  if (type === BaseOption.CHARTTYPE[1]) {
    handleCalendar(iChartOption, visualUnit, maxValue, minValue, visualType);
  }
  if (type === BaseOption.CHARTTYPE[2]) {
    visualUnit.inRange = {
      color: iChartOption.color
    };
  }
  if (iChartOption.visualMap) {
    merge.default(visualUnit, iChartOption.visualMap);
  }
  baseVisualMap.push(visualUnit);
  baseOpt.visualMap = baseVisualMap;
}
exports.setVisualMap = setVisualMap;
