"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const cloneDeep = require("../../util/cloneDeep.js");
const handleData = require("./handleData.js");
const handleSeries = require("./handleSeries.js");
const handleVisualMap = require("./handleVisualMap.js");
const handleOptipn = require("./handleOptipn.js");
const index = require("../../option/init/index.js");
const constants = require("../../util/constants.js");
const merge = require("../../util/merge.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var HeatMapChart = /* @__PURE__ */ function() {
  function HeatMapChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.iChartOption = {};
    this.initIchartOption = cloneDeep.default(iChartOption);
    handleOptipn.setHeatMapDeaultIchartOption(iChartOption);
    this.iChartOption = index.default(iChartOption);
    this.chartInstance = chartInstance;
    this.updateOption();
  }
  var _proto = HeatMapChart2.prototype;
  _proto.updateOption = function updateOption() {
    var iChartOption = this.iChartOption;
    var type = iChartOption.type;
    if (!type) {
      throw new Error("HeatMapChart must have a name");
    }
    var data = handleData.getData(type, iChartOption, this.chartInstance);
    if (!data) return;
    handleOptipn.initRectSys(this.baseOption, iChartOption, type, data);
    handleSeries.handleSeries(this.baseOption, iChartOption, data, type);
    handleVisualMap.setVisualMap(this.baseOption, type, data, iChartOption);
    merge.mergeSeries(iChartOption, this.baseOption);
  };
  _proto.resize = function resize() {
    if (this.iChartOption.type === "HexagonHeatMapChart") {
      var _this$chartInstance;
      this.updateOption(this.iChartOption, this.chartInstance);
      (_this$chartInstance = this.chartInstance) == null ? void 0 : _this$chartInstance.setOption(this.baseOption);
    }
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  return HeatMapChart2;
}();
_defineProperty(HeatMapChart, "name", constants.CHART_TYPE.HEAT_MAP);
exports.default = HeatMapChart;
