"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const baseOption = require("./baseOption.js");
const handleOption = require("./handleOption.js");
const handleSeries = require("./handleSeries.js");
const index$4 = require("../../option/init/index.js");
const index$2 = require("../../option/config/rectTitle/index.js");
const index$3 = require("../../option/config/tooltip/index.js");
const index = require("../../option/config/xAxis/index.js");
const index$1 = require("../../option/config/yAxis/index.js");
const constants = require("../../util/constants.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var HillChart = /* @__PURE__ */ function() {
  function HillChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.iChartOption = {};
    this.baseOption = baseOption.default();
    this.iChartOption = index$4.default(iChartOption);
    this.updateOption(iChartOption, chartInstance);
  }
  var _proto = HillChart2.prototype;
  _proto.updateOption = function updateOption(iChartOption, chartInstance) {
    this.baseOption.xAxis = index.default(iChartOption)[0];
    if (iChartOption.axis && iChartOption.axis.show) {
      this.baseOption.yAxis = index$1.default(this.baseOption, iChartOption, constants.CHART_TYPE.HILL);
    } else {
      this.baseOption.xAxis["axisLine"] = {
        show: false
      };
      this.baseOption.xAxis["axisTick"] = {
        show: false
      };
      this.baseOption.yAxis.show = false;
      this.baseOption.title = index$2.default(iChartOption, constants.CHART_TYPE.HILL, iChartOption.yAxis && iChartOption.yAxis.nameTextStyle);
    }
    handleOption.handleData(iChartOption, this.baseOption);
    handleOption.handleColor(iChartOption, this.baseOption);
    handleOption.handleText(iChartOption, this.baseOption);
    handleOption.handlePadding(iChartOption, this.baseOption);
    handleOption.handleCoincide(iChartOption, this.baseOption);
    this.baseOption.tooltip = index$3.default(iChartOption, constants.CHART_TYPE.HILL);
    this.baseOption.tooltip.trigger = "item";
    handleOption.setGradientColor(this.baseOption, iChartOption.color, iChartOption.gradientColor, iChartOption.opacity, iChartOption);
    handleOption.handleMarkLine(this.baseOption, iChartOption);
    handleSeries.handleEmphasis(this.baseOption, iChartOption);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  return HillChart2;
}();
_defineProperty(HillChart, "name", constants.CHART_TYPE.HILL);
exports.default = HillChart;
