"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
var TipManager = /* @__PURE__ */ function() {
  function TipManager2(theme, tipHtml) {
    this.theme = theme;
    this.isShow = false;
    this.tipHtml = tipHtml;
    this.tooltipDom = null;
    this.setTipTimeOut = null;
  }
  var _proto = TipManager2.prototype;
  _proto.init = function init(tipContainer) {
    var _this = this;
    this.tooltipDom = document.createElement("div");
    this.tooltipDom.classList.add("hc-tooltip");
    if (this.theme === "dark") {
      this.tooltipDom.classList.add("dark");
    }
    this.tooltipDom.addEventListener("mouseenter", function(e) {
      if (_this.setTipTimeOut) {
        clearTimeout(_this.setTipTimeOut);
      }
    });
    this.tooltipDom.addEventListener("mouseleave", function(e) {
      _this.close(e);
    });
    tipContainer.appendChild(this.tooltipDom);
  };
  _proto.show = function show(event, node, tipContainer, chartContainer) {
    if (this.setTipTimeOut) {
      clearTimeout(this.setTipTimeOut);
    }
    this.isShow = true;
    this.tooltipDom.innerHTML = "";
    this.tipHtml(this.tooltipDom, node);
    this.tooltipDom.style.display = "block";
    this.setPosition(event, tipContainer, chartContainer);
  };
  _proto.close = function close(event) {
    var _this2 = this;
    this.setTipTimeOut = setTimeout(function() {
      _this2.isShow = false;
      _this2.tooltipDom.style.display = "none";
    }, 200);
  };
  _proto.setPosition = function setPosition(event, tipContainer, chartContainer) {
    var tipRect = this.tooltipDom.getBoundingClientRect();
    var targetRect = event.target.getBoundingClientRect();
    var tipContainerRect = tipContainer.getBoundingClientRect();
    var chartContainerRect = chartContainer.getBoundingClientRect();
    var tipTop = targetRect.top - tipContainerRect.top - tipRect.height;
    var tipLeft = targetRect.left - tipContainerRect.left + targetRect.width;
    var reviseH = tipContainerRect.left - chartContainerRect.left + tipLeft + tipRect.width - chartContainerRect.width;
    if (reviseH > 0) {
      tipLeft = tipLeft - reviseH - 5;
    }
    var reviseV = tipTop + (tipContainerRect.top - chartContainerRect.top);
    if (reviseV < 0) {
      tipTop = tipTop - reviseV + 5;
    }
    this.tooltipDom.style.top = tipTop + "px";
    this.tooltipDom.style.left = tipLeft + "px";
  };
  return TipManager2;
}();
exports.default = TipManager;
