"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../BaseChart/index.js");
const NodeManager = require("./NodeManager.js");
const constants = require("../../util/constants.js");
function _inheritsLoose(t, o) {
  t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o);
}
function _setPrototypeOf(t, e) {
  return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(t2, e2) {
    return t2.__proto__ = e2, t2;
  }, _setPrototypeOf(t, e);
}
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var HoneycombChart = /* @__PURE__ */ function(_BaseChart) {
  function HoneycombChart2() {
    var _this;
    _this = _BaseChart.call(this) || this;
    _this.dom = null;
    _this.option = null;
    _this.data = null;
    _this.resizeObserver = null;
    _this.nodeManager = null;
    return _this;
  }
  _inheritsLoose(HoneycombChart2, _BaseChart);
  var _proto = HoneycombChart2.prototype;
  _proto.init = function init(dom) {
    this.dom = dom;
  };
  _proto.setSimpleOption = function setSimpleOption(chartName, option) {
    this.option = option;
  };
  _proto.render = function render() {
    this.data = this.option.data || [];
    this.initDom();
    this.setResizeObserver();
    this.renderCallBack && this.renderCallBack(this);
  };
  _proto.onRenderReady = function onRenderReady(callback) {
    this.renderCallBack = callback;
  };
  _proto.initDom = function initDom() {
    this.dom.style.padding = this.option.padding || 0;
    this.dom.insertAdjacentHTML("beforeend", '<div class="hc-container"><div class="hc-rows"></div></div>');
    if (this.data.length > 0) {
      this.nodeManager = new NodeManager.default(this.dom, this.option);
    }
  };
  _proto.resizeDom = function resizeDom() {
    if (this.data.length > 0) {
      Array.prototype.slice.call(this.dom.getElementsByClassName("hc-row")).forEach(function(element) {
        element.remove();
      });
      this.nodeManager.layoutNodes();
    }
  };
  _proto.setResizeObserver = function setResizeObserver() {
    var _this2 = this;
    this.resizeObserver = new ResizeObserver(function(entries) {
      _this2.resizeDom();
    });
    this.resizeObserver.observe(this.dom);
  };
  _proto.refresh = function refresh(option) {
    Array.prototype.slice.call(this.dom.getElementsByClassName("hc-container")).forEach(function(element) {
      element.remove();
    });
    this.option = option;
    this.data = option.data;
    this.initDom();
    this.resizeDom();
  };
  _proto.refreshData = function refreshData(data) {
    Array.prototype.slice.call(this.dom.getElementsByClassName("hc-container")).forEach(function(element) {
      element.remove();
    });
    this.data = data;
    this.option.data = data;
    this.initDom();
    this.resizeDom();
  };
  _proto.setResize = function setResize() {
    this.resizeDom();
  };
  _proto.uninstall = function uninstall() {
    if (this.resizeObserver) {
      this.resizeObserver.disconnect();
      this.resizeObserver = null;
    }
    this.dom.innerHTML = "";
  };
  return HoneycombChart2;
}(index.default);
_defineProperty(HoneycombChart, "name", constants.CHART_TYPE.HONEYCOMB);
exports.default = HoneycombChart;
