"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
require("../../../../../../../echarts@5.4.1/node_modules/echarts/index.js");
const max = require("../../../util/sort/max.js");
const type = require("../../../util/type.js");
const color = require("../../../util/color.js");
const chartToken = require("./chartToken.js");
const index = require("../../../feature/token/index.js");
const LinearGradient = require("../../../../../../../zrender@5.4.1/node_modules/zrender/lib/graphic/LinearGradient.js");
function markLineArea(baseOption, iChartOption, YAxiMin) {
  if (iChartOption.area && iChartOption.markLine && iChartOption.markLine.top && type.isNumber(iChartOption.markLine.top) && iChartOption.markLine.topChangeColor !== false) {
    var colors = baseOption.color;
    var markLine = iChartOption.markLine;
    var topColor = color.codeToRGB(markLine.topColor, 0.15) || color.codeToRGB(index.default.config.colorState.colorError, 0.15);
    baseOption.series.forEach(function(item, index2) {
      var maxValue = max.default(item.data);
      var color$1 = color.getColor(colors, index2);
      var colorTo = color.codeToRGB(color$1, 0);
      var colorFrom = color.codeToRGB(color$1, 0.15);
      var percent = (maxValue - markLine.top) / (maxValue - YAxiMin);
      if (maxValue > markLine.top) {
        item.areaStyle = {
          color: {
            type: "linear",
            x: 0,
            y: 0,
            x2: 0,
            y2: 1,
            colorStops: [{
              offset: 0,
              color: topColor
            }, {
              offset: percent,
              color: topColor
            }, {
              offset: percent + 1e-5,
              color: colorFrom
            }, {
              offset: 1,
              color: colorTo
            }]
          }
        };
      }
    });
  }
}
function defaultArea(baseOption, iChartOption, YAxiMin) {
  if (iChartOption.area) {
    var colors = baseOption.color;
    baseOption.series.forEach(function(item, index2) {
      var color$1 = color.getColor(colors, index2);
      var colorTo = color.codeToRGB(color$1, 0);
      var colorFrom = color.codeToRGB(color$1, 0.15);
      item.areaStyle = {
        opacity: 1,
        color: new LinearGradient.default(0, 0, 0, 1, [{
          offset: 0,
          color: colorFrom
        }, {
          offset: 1,
          color: colorTo
        }])
      };
    });
  }
}
function splitArea(baseOption, iChartOption, YAxiMin) {
  if (iChartOption.area && iChartOption.splitLine) {
    var colors = baseOption.color;
    var splitLine = iChartOption.splitLine;
    baseOption.series.forEach(function(item, index2) {
      var maxValue = max.default(item.data);
      var color$1 = color.getColor(colors, index2);
      var colorTo = color.codeToRGB(color$1, 0.15);
      var colorFrom = color.codeToRGB(color$1, 0.15);
      var percent = (maxValue - splitLine) / (maxValue - YAxiMin);
      item.areaStyle = {
        color: {
          type: "linear",
          x: 0,
          y: 0,
          x2: 0,
          y2: 1,
          colorStops: [{
            offset: 0,
            color: colorFrom
          }, {
            offset: percent,
            color: colorTo
          }, {
            offset: percent + 1e-5,
            color: chartToken.default.colorAreaTP
          }, {
            offset: 1,
            color: chartToken.default.colorAreaTP
          }]
        }
      };
    });
  }
}
function topArea(baseOption, iChartOption, YAxiMin) {
  defaultArea(baseOption, iChartOption);
  markLineArea(baseOption, iChartOption, YAxiMin);
  splitArea(baseOption, iChartOption, YAxiMin);
}
exports.default = topArea;
