"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index$2 = require("../../option/init/index.js");
const miniLineChart = require("../../feature/mini/miniLineChart.js");
const handleSeries = require("./handleSeries.js");
const cloneDeep = require("../../util/cloneDeep.js");
const index$1 = require("../../option/base/index.js");
const handleVisualMap = require("./handleVisualMap.js");
const handlePredict = require("./handlePredict.js");
const topArea = require("./AreaChart/topArea.js");
const bottomArea = require("./AreaChart/bottomArea.js");
const merge = require("../../util/merge.js");
const handleOptipn = require("./handleOptipn.js");
const index = require("../../option/RectSys/index.js");
const lttb = require("../../feature/performance/lttb.js");
const constants = require("../../util/constants.js");
const xkey = require("../../option/config/xAxis/xkey.js");
const xdata = require("../../option/config/xAxis/xdata.js");
const ldata = require("../../option/config/legend/ldata.js");
const ydata = require("../../option/config/yAxis/ydata.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var LineChart = /* @__PURE__ */ function() {
  function LineChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.baseOption = cloneDeep.default(index$1.default);
    this.iChartOption = {};
    this.iChartOption = index$2.default(iChartOption);
    this.updateOption(chartInstance);
  }
  var _proto = LineChart2.prototype;
  _proto.updateOption = function updateOption(chartInstance) {
    var iChartOption = this.iChartOption;
    index.default(this.baseOption, this.iChartOption, constants.CHART_TYPE.LINE);
    var xAxisKey = xkey.default(iChartOption);
    var data = iChartOption.massive ? lttb.lttb(iChartOption.data) : iChartOption.data;
    var xAxisData = xdata.default(data, xAxisKey);
    var legendData = ldata.default(data, xAxisKey);
    var seriesData = ydata.default(data, legendData);
    handleOptipn.handleData(this.baseOption, legendData, xAxisData);
    this.baseOption.series = handleSeries.setSeries({
      seriesData,
      legendData,
      yAxis: iChartOption.yAxis,
      focus: iChartOption.focus,
      stack: iChartOption.stack,
      isStep: iChartOption.step,
      isArea: iChartOption.area,
      colors: this.baseOption.color,
      isSmooth: iChartOption.smooth,
      markLine: iChartOption.markLine,
      markPoint: iChartOption.markPoint,
      splitLine: iChartOption.splitLine,
      labelHtml: iChartOption.labelHtml,
      itemStyle: iChartOption.itemStyle,
      massive: iChartOption.massive
    });
    this.baseOption.visualMap = handleVisualMap.setVisualMap(legendData, seriesData, iChartOption.markLine, iChartOption.color);
    handlePredict.handlePredict(this.baseOption, iChartOption.predict, iChartOption.tipHtml, iChartOption.lineStyle);
    if (iChartOption.silent) {
      this.baseOption.tooltip = {};
    }
    handleOptipn.onlyOnePoint(this.baseOption);
    handleOptipn.discrete(iChartOption, this.baseOption);
    merge.mergeSeries(iChartOption, this.baseOption);
    merge.mergeVisualMap(iChartOption, this.baseOption);
    miniLineChart.default(iChartOption, this.baseOption);
  };
  _proto.updateOptionAgain = function updateOptionAgain(echartsIns) {
    var YAxiMax = this.getYAxisMaxValue(echartsIns, 0);
    var YAxiMin = this.getYAxisMinValue(echartsIns, 0);
    topArea.default(this.baseOption, this.iChartOption, YAxiMin);
    bottomArea.default(this.baseOption, this.iChartOption, YAxiMax);
    merge.mergeSeries(this.iChartOption, this.baseOption);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.getYAxisMaxValue = function getYAxisMaxValue(echartsIns, index2) {
    var _echartsIns$getModel$;
    return (_echartsIns$getModel$ = echartsIns.getModel().getComponent("yAxis", index2)) == null ? void 0 : _echartsIns$getModel$.axis.scale._extent[1];
  };
  _proto.getYAxisMinValue = function getYAxisMinValue(echartsIns, index2) {
    var _echartsIns$getModel$2;
    return (_echartsIns$getModel$2 = echartsIns.getModel().getComponent("yAxis", index2)) == null ? void 0 : _echartsIns$getModel$2.axis.scale._extent[0];
  };
  return LineChart2;
}();
_defineProperty(LineChart, "name", constants.CHART_TYPE.LINE);
exports.default = LineChart;
