"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../BaseChart/index.js");
const RotateManager = require("./RotateManager.js");
const NodeManager = require("./NodeManager.js");
const constants = require("../../util/constants.js");
function _inheritsLoose(t, o) {
  t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o);
}
function _setPrototypeOf(t, e) {
  return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(t2, e2) {
    return t2.__proto__ = e2, t2;
  }, _setPrototypeOf(t, e);
}
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var OrganizationChart = /* @__PURE__ */ function(_BaseChart) {
  function OrganizationChart2() {
    var _this;
    _this = _BaseChart.call(this) || this;
    _this.dom = null;
    _this.option = null;
    _this.data = null;
    _this.resizeObserver = null;
    _this.nodeManager = null;
    _this.selected = null;
    return _this;
  }
  _inheritsLoose(OrganizationChart2, _BaseChart);
  var _proto = OrganizationChart2.prototype;
  _proto.init = function init(dom) {
    this.dom = dom;
  };
  _proto.setSimpleOption = function setSimpleOption(chartName, option) {
    this.option = option;
  };
  _proto.render = function render() {
    this.setResizeObserver();
    this.renderCallBack && this.renderCallBack(this);
  };
  _proto.onRenderReady = function onRenderReady(callback) {
    this.renderCallBack = callback;
  };
  _proto.initDom = function initDom() {
    if (!this.data) return;
    this.container = document.createElement("div");
    this.container.setAttribute("class", "ozc_container");
    if (this.option.theme && this.option.theme.indexOf("dark") !== -1) {
      this.container.classList.add("ozc_container_dark");
    }
    for (var styleKey in this.option.position) {
      if (Object.hasOwnProperty.call(this.option.position, styleKey)) {
        this.container.style[styleKey] = this.option.position[styleKey];
      }
    }
    this.dom.appendChild(this.container);
    this.nodeManager = new NodeManager.default(this.container, this.option, this.selected);
    this.rotateManager = new RotateManager.default(this.container, this.option, this.selected, this.nodeManager);
  };
  _proto.resizeDom = function resizeDom() {
    this.dom.innerHTML = "";
    var domRect = this.dom.getBoundingClientRect();
    var minSize = Math.min(domRect.width, domRect.height);
    this.option.radius = this.option.radius || NodeManager.INIT_RADIUS;
    var radius = this.option.radius;
    if (radius.minRatio !== void 0) {
      radius.min = radius.minRatio * minSize;
    }
    if (radius.gapRatio !== void 0) {
      radius.gap = radius.gapRatio * minSize;
    }
    this.data = this.option.data || [];
    this.selected = this.option.selected || [1, 1];
    this.initDom();
  };
  _proto.setResizeObserver = function setResizeObserver() {
    var _this2 = this;
    this.resizeObserver = new ResizeObserver(function(entries) {
      _this2.resizeDom();
    });
    this.resizeObserver.observe(this.dom);
  };
  _proto.refresh = function refresh(option) {
  };
  _proto.refreshData = function refreshData(data) {
  };
  _proto.uninstall = function uninstall() {
    if (this.resizeObserver) {
      this.resizeObserver.disconnect();
      this.resizeObserver = null;
    }
    this.dom.innerHTML = "";
  };
  _proto.setResize = function setResize() {
    this.resizeDom();
  };
  return OrganizationChart2;
}(index.default);
_defineProperty(OrganizationChart, "name", constants.CHART_TYPE.ORGANIZATION);
exports.default = OrganizationChart;
