"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index$1 = require("../../option/init/index.js");
const handleOption = require("./handleOption.js");
const handleSeries = require("./handleSeries.js");
const index = require("../../option/PolarSys/index.js");
const constants = require("../../util/constants.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var PolarBarChart = /* @__PURE__ */ function() {
  function PolarBarChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.iChartOption = {};
    this.iChartOption = index$1.default(iChartOption);
    this.updateOption(chartInstance);
  }
  var _proto = PolarBarChart2.prototype;
  _proto.updateOption = function updateOption(chartInstance) {
    var _this = this;
    var iChartOption = this.iChartOption;
    var data = iChartOption.data;
    index.default(this.baseOption, iChartOption, constants.CHART_TYPE.POLAR_BAR);
    var type = iChartOption.type || "normal";
    this.baseOption.angleAxis.data = [];
    if (type !== "normal") {
      this.baseOption.angleAxis.axisLabel.show = true;
    }
    if (data) {
      data.forEach(function(item) {
        _this.baseOption.angleAxis.data.push(item.name);
      });
      handleOption.setTooltip(this.baseOption);
      this.baseOption.legend.data = type === "normal" ? data : [];
      var seriesData = handleOption.getSeriesData(data, type);
      var labelData = handleOption.getLabelData(data);
      this.baseOption.series = handleSeries.setSeries(seriesData, labelData, iChartOption, this.baseOption.polar, type);
    }
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  return PolarBarChart2;
}();
_defineProperty(PolarBarChart, "name", constants.CHART_TYPE.POLAR_BAR);
exports.default = PolarBarChart;
