"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index$1 = require("../../option/init/index.js");
const miniProcessChart = require("../../feature/mini/miniProcessChart.js");
const index = require("../../option/RectSys/index.js");
const BaseOption = require("./BaseOption.js");
const handleData = require("./handleData.js");
const handleOption = require("./handleOption.js");
const handleSeries = require("./handleSeries.js");
const cloneDeep = require("../../util/cloneDeep.js");
const constants = require("../../util/constants.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var ProcessChart = /* @__PURE__ */ function() {
  function ProcessChart2(iChartOption, chartInstance) {
    this.initIchartOption = cloneDeep.default(iChartOption);
    this.baseOption = {};
    this.iChartOption = {};
    this.chartInstance = chartInstance;
    this.iChartOption = index$1.default(iChartOption);
    this.updateOption();
  }
  var _proto = ProcessChart2.prototype;
  _proto.updateOption = function updateOption() {
    var iChartOption = this.iChartOption;
    if (!iChartOption.name) {
      throw new Error("ProcessChart must have a name");
    }
    index.default(this.baseOption, iChartOption, iChartOption.name);
    var doubleSide = iChartOption.type && iChartOption.type === BaseOption.PROCESSBARTYPE;
    var dataSet = handleData.default(iChartOption, doubleSide);
    if (!dataSet) return;
    handleOption.handleGrid(this.baseOption, iChartOption, doubleSide, this.chartInstance);
    handleOption.handleYaxis(this.baseOption, iChartOption, dataSet, doubleSide);
    handleOption.handleXaxis(this.baseOption, doubleSide, iChartOption);
    handleOption.handleDataZoom(this.baseOption, this.initIchartOption);
    handleOption.handleLegend(this.baseOption, dataSet, doubleSide, this.initIchartOption);
    handleSeries.default(this.baseOption, iChartOption, dataSet, doubleSide);
    handleOption.handleTooltip(this.baseOption, iChartOption, dataSet, doubleSide);
    miniProcessChart.default(iChartOption, this.baseOption);
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption(option) {
    this.baseOption = option;
  };
  return ProcessChart2;
}();
_defineProperty(ProcessChart, "name", constants.CHART_TYPE.PROCESS);
exports.default = ProcessChart;
