"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index$1 = require("../../option/init/index.js");
const type = require("../../util/type.js");
const handleSeries = require("./handleSeries.js");
const merge = require("../../util/merge.js");
const handleOptipn = require("./handleOptipn.js");
const constants = require("../../util/constants.js");
const index = require("./GradientRadar/index.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var RadarChart = /* @__PURE__ */ function() {
  function RadarChart2(iChartOption, chartInstance) {
    this.gradientRadar = null;
    this.baseOption = {};
    this.iChartOption = {};
    this.chartInstance = chartInstance;
    this.iChartOption = index$1.default(iChartOption);
    this.updateOption(chartInstance);
  }
  var _proto = RadarChart2.prototype;
  _proto.updateOption = function updateOption(chartInstance) {
    var _iChartOption$radar;
    var iChartOption = this.iChartOption;
    var isCustomMaxVal = !!(type.isArray(iChartOption.radarMax) || iChartOption != null && (_iChartOption$radar = iChartOption.radar) != null && _iChartOption$radar.indicator);
    handleOptipn.initRadarSys(this.baseOption, iChartOption);
    var radarKeys = handleOptipn.getRadarKeys(iChartOption.data);
    iChartOption.radarMax = iChartOption.radarMax || handleOptipn.getRadarMax(iChartOption.data, iChartOption, isCustomMaxVal);
    if (iChartOption.gradient) {
      this.gradientRadar = new index.default(chartInstance, {
        iChartOption,
        baseOption: this.baseOption,
        radarKeys
      });
    }
    handleOptipn.setRadar(this.baseOption, iChartOption, radarKeys, isCustomMaxVal);
    handleSeries.setSeries(this.baseOption, iChartOption, radarKeys, iChartOption.data);
    handleOptipn.setMarkLine(this.baseOption, iChartOption, radarKeys);
    handleOptipn.setTooltip(this.baseOption, iChartOption, radarKeys, iChartOption.data);
    handleSeries.setMarkLineSeries(this.baseOption, iChartOption, radarKeys);
    merge.mergeSeries(iChartOption, this.baseOption);
    if (iChartOption.gradient) {
      this.gradientRadar.init();
      this.gradientRadar.setLegend();
      this.gradientRadar.setTooltip();
      this.gradientRadar.setSeries();
    }
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.resize = function resize() {
    if (this.gradientRadar) this.gradientRadar.resize();
  };
  return RadarChart2;
}();
_defineProperty(RadarChart, "name", constants.CHART_TYPE.RADAR);
exports.default = RadarChart;
