"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const baseOption = require("./baseOption.js");
const Manager = require("./Manager.js");
const util = require("./util.js");
const constants = require("../../util/constants.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var RiverChart = /* @__PURE__ */ function() {
  function RiverChart2() {
    this.option = {};
    this.container = null;
    this.wrapper = null;
    this.nodeContainer = null;
    this.svgElement = null;
    this.containerSize = {
      width: 0,
      height: 0
    };
    this.manager = null;
  }
  var _proto = RiverChart2.prototype;
  _proto.init = function init(container) {
    this.container = container;
    this.beforeRender();
    var _this = this;
    util.initWrapper(this.container, _this);
    var size = container.getBoundingClientRect();
    this.containerSize.width = size.width;
    this.containerSize.height = size.height;
  };
  _proto.beforeRender = function beforeRender() {
    if (this.container) this.container.innerHTML = "";
  };
  _proto.setOption = function setOption(option) {
    this.option = Object.assign(baseOption.default(), option);
    util.setChartSize(this.svgElement, this.nodeContainer, this.option);
    if (this.svgElement) this.svgElement.innerHTML = "";
    if (this.nodeContainer) this.nodeContainer.innerHTML = "";
    this.render();
  };
  _proto.render = function render() {
    var _this$option = this.option, data = _this$option.data, width = _this$option.width;
    if (!width) {
      this.option.width = this.containerSize.width;
      this.option.height = this.containerSize.height;
    }
    this.manager = new Manager.default(this.svgElement, this.nodeContainer, this.option, data);
    this.manager.init();
    this.manager.render();
  };
  _proto.destory = function destory() {
    this.container.innerHTML = "";
    this.manager = null;
  };
  return RiverChart2;
}();
_defineProperty(RiverChart, "name", constants.CHART_TYPE.RIVER);
exports.default = RiverChart;
