"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const cloneDeep = require("../../util/cloneDeep.js");
const BaseOption = require("./BaseOption.js");
const index = require("../../option/init/index.js");
const merge = require("../../util/merge.js");
const handleOption = require("./handleOption.js");
const tooltip = require("./tooltip.js");
const constants = require("../../util/constants.js");
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var SankeyChart = /* @__PURE__ */ function() {
  function SankeyChart2(iChartOption, chartInstance) {
    this.baseOption = {};
    this.iChartOption = {};
    this.baseOption = cloneDeep.default(BaseOption.default());
    this.userPadding = iChartOption.padding || iChartOption.chartPadding;
    this.iChartOption = index.default(iChartOption);
    this.updateOption(iChartOption, chartInstance);
  }
  var _proto = SankeyChart2.prototype;
  _proto.updateOption = function updateOption(iChartOption, chartInstance) {
    var _iChartOption$data = iChartOption.data, nodes = _iChartOption$data.nodes, links = _iChartOption$data.links, _iChartOption$draggab = iChartOption.draggable, draggable = _iChartOption$draggab === void 0 ? true : _iChartOption$draggab, tipHtml = iChartOption.tipHtml, _iChartOption$widthSp = iChartOption.widthSpace, widthSpace = _iChartOption$widthSp === void 0 ? [10, 30] : _iChartOption$widthSp, _iChartOption$nodeAli = iChartOption.nodeAlign, nodeAlign = _iChartOption$nodeAli === void 0 ? "justify" : _iChartOption$nodeAli, _iChartOption$label = iChartOption.label, label = _iChartOption$label === void 0 ? {} : _iChartOption$label;
    handleOption.initNodes(nodes, links);
    this.baseOption.series[0].data = nodes;
    this.baseOption.series[0].links = links;
    if (!nodes || !nodes.length || !links || !links.length) {
      return;
    }
    handleOption.isNameRepeat(nodes);
    this.baseOption.series[0].draggable = draggable;
    handleOption.handleItemStyle(iChartOption, this.baseOption);
    tooltip.setTooltip(iChartOption, tipHtml, this.baseOption);
    handleOption.setLabel(iChartOption, this.baseOption);
    handleOption.setEmptyLimit(nodes);
    this.baseOption.series[0].nodeWidth = widthSpace[0];
    this.baseOption.series[0].nodeGap = widthSpace[1];
    this.baseOption.series[0].nodeAlign = nodeAlign;
    handleOption.handleLineStyle(iChartOption);
    handleOption.nodeLabelLayout(label, this.baseOption);
    handleOption.compareNodeText(iChartOption, this.baseOption, this, chartInstance);
  };
  _proto.upDateOption = function upDateOption(centerName, leftNodeArr, rightNodeArr) {
    var _this$iChartOption = this.iChartOption, _this$iChartOption$gr = _this$iChartOption.grid, grid = _this$iChartOption$gr === void 0 ? {} : _this$iChartOption$gr, xAxis = _this$iChartOption.xAxis, _this$iChartOption$yA = _this$iChartOption.yAxis, yAxis = _this$iChartOption$yA === void 0 ? {
      show: false
    } : _this$iChartOption$yA, _this$iChartOption$to = _this$iChartOption.tooltip, tooltip2 = _this$iChartOption$to === void 0 ? {} : _this$iChartOption$to, title = _this$iChartOption.title, padding = _this$iChartOption.padding, chartPadding = _this$iChartOption.chartPadding;
    handleOption.padSize(padding || chartPadding, {
      baseOpt: this.baseOption,
      userPadding: this.userPadding
    }, centerName, leftNodeArr, rightNodeArr);
    handleOption.dataSort(this.iChartOption);
    merge.mergeSeries(this.iChartOption, this.baseOption);
    merge.default(this.baseOption, {
      grid,
      xAxis: xAxis[0].data && xAxis[0].data.length ? xAxis : {
        show: false
      },
      yAxis,
      tooltip: tooltip2,
      title
    });
  };
  _proto.getOption = function getOption() {
    return this.baseOption;
  };
  _proto.setOption = function setOption() {
  };
  return SankeyChart2;
}();
_defineProperty(SankeyChart, "name", constants.CHART_TYPE.SANKEY);
exports.default = SankeyChart;
