"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("../../option/config/tooltip/index.js");
const defendXSS = require("../../util/defendXSS.js");
const constants = require("../../util/constants.js");
function defaultFormatter(params, iChartOption) {
  var _iChartOption$emptySt = iChartOption.emptyStatus, emptyStatus = _iChartOption$emptySt === void 0 ? "node" : _iChartOption$emptySt;
  var htmlString = "";
  if (params.name.includes(">")) {
    params.name = params.name.replace(">", "---");
  }
  var value = params.data.empty ? 0 : params.data.value || params.value;
  if (emptyStatus === "node" && params.dataType === "edge" && value === 0) {
    return;
  }
  htmlString += '<span style="display:inline-block;margin-right:5px;border-radius:50%;height:10px;">' + defendXSS.default(params.name) + '</span><br/><span style="display:inline-block;margin-right:5px;border-radius:50%;height:10px;">value' + ("  :  " + defendXSS.default(value) + "</span>");
  return htmlString;
}
function handleSankeyFormatter(formatter, sankeyTooltip, iChartOption) {
  if (formatter) {
    sankeyTooltip.formatter = formatter;
  } else {
    sankeyTooltip.formatter = function(params) {
      var html = defaultFormatter(params, iChartOption);
      return html;
    };
  }
}
function setTooltip(iChartOption, formatter, baseOpt) {
  var sankeyTooltip = index.default(iChartOption, constants.CHART_TYPE.SANKEY);
  handleSankeyFormatter(formatter, sankeyTooltip, iChartOption);
  sankeyTooltip.trigger = "item";
  baseOpt.tooltip = sankeyTooltip;
}
exports.setTooltip = setTooltip;
