"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("../../option/config/xAxis/index.js");
const index$1 = require("../../option/config/yAxis/index.js");
const index$2 = require("../../option/config/grid/index.js");
const index$3 = require("../../option/config/tooltip/index.js");
const defendXSS = require("../../util/defendXSS.js");
const constants = require("../../util/constants.js");
function toolTipFormatter(params) {
  var data = params.data;
  var x = data[0], y = data[1], name = data[2];
  var htmlStrings = '<div style="margin-bottom:4px;">\n  名称' + (name || "") + "\n                            </div>";
  htmlStrings += '\n                            <div>\n                                <span style="display:inline-block;margin-right:8px;min-width:60px;">x维度</span>\n                                <span>' + defendXSS.default(x) + "</span>\n                            </div>";
  htmlStrings += '\n                            <div>\n                                <span style="display:inline-block;margin-right:8px;min-width:60px;">y维度</span>\n                                <span>' + defendXSS.default(y) + "</span>\n                            </div>";
  return htmlStrings;
}
function handleXaxis(baseOpt, iChartOpt) {
  var basicXaxis = index.default(iChartOpt);
  basicXaxis[0].type = "value";
  baseOpt.xAxis = basicXaxis;
}
function handleYaxis(baseOpt, iChartOpt) {
  var basicYaxis = index$1.default(baseOpt, iChartOpt, constants.CHART_TYPE.SCATTER);
  baseOpt.yAxis = basicYaxis;
}
function handleTooltip(baseOpts, iChartOpt) {
  var _iChartOpt$tooltip;
  var basicTooltip = index$3.default(iChartOpt, constants.CHART_TYPE.SCATTER);
  if (!iChartOpt.tipHtml && !(iChartOpt != null && (_iChartOpt$tooltip = iChartOpt.tooltip) != null && _iChartOpt$tooltip.formatter)) {
    basicTooltip.formatter = toolTipFormatter;
  }
  basicTooltip.trigger = "item";
  baseOpts.tooltip = basicTooltip;
}
function handleGrid(baseOpt, iChartOpt) {
  var basicGrid = index$2.default(iChartOpt);
  baseOpt.grid = basicGrid;
}
exports.handleGrid = handleGrid;
exports.handleTooltip = handleTooltip;
exports.handleXaxis = handleXaxis;
exports.handleYaxis = handleYaxis;
