"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const color = require("../../util/color.js");
const chartToken = require("./chartToken.js");
const handleMarkPoint = require("./handleMarkPoint.js");
const type = require("../../util/type.js");
function handleSeries(baseOpt, iChartOpt) {
  var series = [];
  var errorSeries = handleMarkPoint.default(iChartOpt);
  var data = iChartOpt.data;
  data && type.isObject(data) && Object.keys(data).forEach(function(item) {
    var seriesItem = {
      name: item,
      symbolSize: iChartOpt.symbolSize || 10,
      data: data[item],
      type: "scatter",
      emphasis: {
        itemStyle: {
          color: chartToken.default.color,
          borderWidth: 4
        },
        focus: "series",
        scale: 1.3
      },
      itemStyle: {
        color: function color$1(param) {
          return color.getColor(iChartOpt.color, param.seriesIndex);
        },
        borderColor: function borderColor() {
        },
        borderWidth: 0
      }
    };
    series.push(seriesItem);
  });
  series.push.apply(series, errorSeries);
  baseOpt.series = series;
}
exports.handleSeries = handleSeries;
