"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const CommonConstant = require("../CommonConstant.js");
var Line2G = /* @__PURE__ */ function() {
  function Line2G2(_ref, verCenterPoint, interval, lineStrokeColor, intervalType) {
    var ctx = _ref.ctx, imageList = _ref.imageList, canvasWidth = _ref.canvasWidth, direction = _ref.direction;
    this.ctx = ctx;
    this.imageList = imageList;
    this.verCenterPoint = verCenterPoint;
    this.canvasWidth = canvasWidth;
    this.direction = direction;
    this.interval = interval;
    this.intervalType = intervalType;
  }
  var _proto = Line2G2.prototype;
  _proto.draw = function draw() {
    var _this$imageList = this.imageList, image2R = _this$imageList.image2R, image2L = _this$imageList.image2L, image5R = _this$imageList.image5R, image5L = _this$imageList.image5L, wirelessR = _this$imageList.wirelessR, wirelessL = _this$imageList.wirelessL;
    var left = CommonConstant.direction.left;
    for (var i = 0; i < this.canvasWidth; i++) {
      var image = void 0;
      if (this.direction === left) {
        switch (this.intervalType) {
          case "2.4G":
            image = image2L.image;
            break;
          case "5G":
            image = image5L.image;
            break;
          case "wireless":
            image = wirelessL.image;
            break;
        }
      } else {
        switch (this.intervalType) {
          case "2.4G":
            image = image2R.image;
            break;
          case "5G":
            image = image5R.image;
            break;
          case "wireless":
            image = wirelessR.image;
            break;
        }
      }
      if (i % this.interval === 0) {
        this.ctx.drawImage(image, i, this.verCenterPoint);
      }
    }
  };
  return Line2G2;
}();
exports.default = Line2G;
