"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const cloneDeep = require("../../util/cloneDeep.js");
const chartToken = require("./chartToken.js");
var seriesInit = {
  center: ["50%", "50%"],
  radius: ["12%", "70%"],
  type: "sunburst",
  sort: void 0,
  emphasis: {
    focus: "descendant"
  },
  itemStyle: {
    borderRadius: 4,
    borderWidth: 2,
    borderColor: ""
  },
  data: [],
  label: {
    rotate: 0,
    color: ""
  },
  levels: []
};
function setSeries(iChartOption) {
  var data = iChartOption.data;
  var series = cloneDeep.default(seriesInit);
  series.data = data;
  series.itemStyle.borderColor = chartToken.default.itemBorderColor;
  series.label.color = chartToken.default.labelColor;
  return series;
}
exports.seriesInit = seriesInit;
exports.setSeries = setSeries;
