"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("../../option/config/grid/index.js");
const index$1 = require("../../option/config/tooltip/index.js");
const defendXSS = require("../../util/defendXSS.js");
const constants = require("../../util/constants.js");
function toolTipFormatter(params) {
  var data = params.data;
  var value = data.value, name = data.name;
  var htmlString = '<div style="margin-bottom:4px;">\n  树节点' + (name || "") + "\n                            </div>";
  htmlString += '\n                            <div>\n                                <span style="display:inline-block;margin-right:8px;min-width:60px;">value:</span>\n                                <span>' + defendXSS.default(value) + "</span>\n                            </div>";
  return htmlString;
}
function handleGrid(baseOpt, iChartOpt) {
  var basicGrid = index.default(iChartOpt);
  baseOpt.grid = basicGrid;
}
function handleTitle(baseOpt, iChartOpt) {
  if (iChartOpt.title) {
    baseOpt.title = iChartOpt.title;
  }
}
function handleTooltip(baseOpt, iChartOpt) {
  var _iChartOpt$tooltip;
  var basicTooltip = index$1.default(iChartOpt, constants.CHART_TYPE.TREE_MAP);
  if (!iChartOpt.tipHtml && !(iChartOpt != null && (_iChartOpt$tooltip = iChartOpt.tooltip) != null && _iChartOpt$tooltip.formatter)) {
    basicTooltip.formatter = toolTipFormatter;
  }
  basicTooltip.trigger = "item";
  baseOpt.tooltip = basicTooltip;
}
exports.handleGrid = handleGrid;
exports.handleTitle = handleTitle;
exports.handleTooltip = handleTooltip;
