"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../token/index.js");
const type = require("../../util/type.js");
var distanceX = 16;
var distanceY = 24;
var axisType = ["xAxis", "yAxis"];
function setAxisTriggerEvent(eChartOption, type$1) {
  if (!eChartOption[type$1]) return;
  if (type.isArray(eChartOption[type$1])) {
    eChartOption[type$1].forEach(function(subitem) {
      subitem.triggerEvent = true;
    });
  } else {
    eChartOption[type$1].triggerEvent = true;
  }
}
function setPosition(tipContainer, echartsDom, param) {
  var tipContainerReact = tipContainer.getBoundingClientRect();
  var echartsDomRect = echartsDom.getBoundingClientRect();
  var echartsDomStyle = getComputedStyle(echartsDom);
  var echartsDomBorder = parseFloat(echartsDomStyle.borderRightWidth) + parseFloat(echartsDomStyle.borderLeftWidth);
  var tipContainerW = tipContainerReact.width;
  var tipContainerH = tipContainerReact.height;
  var _param$event = param.event, offsetX = _param$event.offsetX, offsetY = _param$event.offsetY;
  var tipLeft = 0;
  var tipTop = 0;
  if (tipContainerW < echartsDomRect.width - echartsDomBorder) {
    tipTop = offsetY - distanceY;
    var reviseL = echartsDomRect.width - echartsDomBorder - offsetX - tipContainerW - distanceX;
    if (reviseL > 0) {
      tipLeft = offsetX + distanceX;
    } else {
      tipLeft = offsetX - tipContainerW - distanceX;
    }
  } else {
    tipTop = offsetY - tipContainerH - distanceY;
  }
  tipContainer.style.cssText = "\n    position: absolute;\n    display: inline-block;\n    word-break: break-all;\n    opacity: '1';\n    padding: 8px;\n    top:" + tipTop + "px;\n    left:" + tipLeft + "px;\n    color: " + index.default.config.tooltipTextColor + ";\n    font-size: " + index.default.config.tooltipTextFontSize + ";\n    background: " + index.default.config.tooltipBg + ";\n    box-shadow:0 " + index.default.config.tooltipShadowOffsetY + "px\n    " + index.default.config.tooltipShadowBlur + "px 0 " + index.default.config.tooltipShadowColor + ";\n  ";
}
function axistip(echartsDom, echartsIns, eChartOption, axistip2) {
  if (!axistip2) return;
  if (type.isBoolean(axistip2)) {
    axistip2 = {};
    axisType.forEach(function(item) {
      axistip2[item] = true;
    });
  }
  Object.keys(axistip2).forEach(function(item) {
    setAxisTriggerEvent(eChartOption, item);
  });
  var tipContainer = document.createElement("div");
  tipContainer.className = "labeltip";
  tipContainer.style.display = "inline-block";
  tipContainer.style.opacity = "0";
  echartsIns.on("mousemove", function(param) {
    tipContainer.textContent = param.value;
    if (axisType.indexOf(param.componentType) !== -1) {
      setPosition(tipContainer, echartsDom, param);
    }
  });
  echartsIns.on("mouseout", function(param) {
    if (axisType.indexOf(param.componentType) !== -1) {
      tipContainer.textContent = "";
      tipContainer.style.cssText = "\n        opacity:0;\n        padding: 8px;\n        font-size: " + index.default.config.tooltipTextFontSize + ";\n        position: absolute;\n        display: inline-block;\n        word-break: break-all;\n      ";
    }
  });
  var labeltipDom = echartsDom.getElementsByClassName("labeltip")[0];
  if (labeltipDom) {
    echartsDom.removeChild(labeltipDom);
  }
  echartsDom.appendChild(tipContainer);
}
exports.default = axistip;
