"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const Pie = require("./Pie.js");
const Bar = require("./Bar.js");
const Line = require("./Line.js");
const Radar = require("./Radar.js");
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var chartRuleMap = {
  PieChart: Pie.default,
  BarChart: Bar.default,
  LineChart: Line.default,
  RadarChart: Radar.default
};
function getUiRule(chartName, echartsOpt) {
  var moduleFn = chartRuleMap[chartName];
  var seriesUiRule = moduleFn ? moduleFn(echartsOpt) : {};
  return _extends({}, seriesUiRule);
}
exports.default = getUiRule;
