"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../../../token/index.js");
const color = require("../../../../util/color.js");
function getDataZoomToken() {
  var token = index.default.getToken();
  var color$1 = index.default.themeName.includes("dark") ? "#1B3F86" : "#8CA3FA";
  return {
    borderColor: token.dataZoomBackgroundColor,
    backgroundColor: token.dataZoomBackgroundColor,
    fillerColor: color.codeToRGB(token.colorState.colorInfo, 0.1),
    handleStyle: {
      color: token.dataZoomHandleColor,
      shadowColor: token.dataZoomHandleShadowColor,
      borderColor: token.dataZoomHandleBorderColor
    },
    dataBackground: {
      lineStyle: {
        color: token.dataBackgroundLineColor
      },
      areaStyle: {
        color: token.dataBackgroundAreaColor
      }
    },
    selectedDataBackground: {
      lineStyle: {
        color: color$1
      },
      areaStyle: {
        color: color$1
      }
    },
    emphasis: {
      handleStyle: {
        color: token.dataZoomEmphasisHandleColor,
        borderColor: token.dataZoomEmphasisHandleBorderColor
      }
    }
  };
}
exports.default = getDataZoomToken;
