"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const angleAxis = require("./angleAxis.js");
const color = require("./color.js");
const dataZoom = require("./dataZoom.js");
const legend = require("./legend.js");
const radar = require("./radar.js");
const radiusAxis = require("./radiusAxis.js");
const title = require("./title.js");
const tooltip = require("./tooltip.js");
const xAxis = require("./xAxis.js");
const yAxis = require("./yAxis.js");
var moduleMap = {
  angleAxis: angleAxis.default,
  color: color.default,
  dataZoom: dataZoom.default,
  legend: legend.default,
  radar: radar.default,
  radiusAxis: radiusAxis.default,
  title: title.default,
  tooltip: tooltip.default,
  xAxis: xAxis.default,
  yAxis: yAxis.default
};
var moduleSourceCommon = [
  "dataZoom",
  "legend",
  // 暂时屏蔽title的检测
  // 'title',
  "tooltip",
  "xAxis",
  "yAxis"
];
var moduleSourceSpecial = ["angleAxis", "color", "radar", "radiusAxis"];
function getComonRule(moudle, moduleName) {
  if (moudle && (moduleSourceSpecial.includes(moduleName) || moduleSourceCommon.includes(moduleName) && moudle.show !== false)) return moduleMap[moduleName](moudle);
  return null;
}
exports.default = getComonRule;
