"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../../../token/index.js");
const util = require("./util.js");
function getLegendToken(echartsModule) {
  var token = index.default.getToken();
  var uiRule = {
    padding: token.legendPadding,
    inactiveColor: token.legendInactiveColor,
    inactiveBorderColor: token.legendInactiveBorderColor,
    inactiveBorderWidth: token.legendInactiveBorderWidth,
    borderWidth: token.legendBorderWidth,
    textStyle: {
      fontSize: token.legendTextFontSize,
      color: token.legendTextColor,
      padding: token.legendTextPadding
    },
    pageTextStyle: {
      color: token.legendPageTextColor
    },
    pageIconColor: token.legendPageIconColor,
    pageIconInactiveColor: token.legendPageIconInactiveColor,
    itemGap: token.legendItemGap,
    itemStyle: {
      borderWidth: token.legendItemBorderWidth
    }
  };
  var commonProperty = ["padding", "inactiveColor", "inactiveBorderColor", "inactiveBorderWidth", "borderWidth", "textStyle", "itemGap", "itemStyle"];
  var propertyPermissions = [{
    name: "type",
    extraCondition: function extraCondition(val) {
      return val && val === "scroll";
    },
    correlationProperty: ["pageTextStyle", "pageIconColor", "pageIconInactiveColor"]
  }];
  return util.generatedMatchedUiRule(echartsModule, uiRule, propertyPermissions, commonProperty);
}
exports.default = getLegendToken;
