"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../../../token/index.js");
const util = require("./util.js");
function getRadiusAxisToken(echartsModule) {
  var token = index.default.getToken();
  var uiRule = {
    axisLine: {
      lineStyle: {
        color: token.radiusAxisLineColor,
        width: token.radiusAxisLineWidth,
        type: token.radiusAxisLineType
      }
    },
    axisTick: {
      lineStyle: {
        color: token.radiusAxisTickLineColor,
        width: token.radiusAxisTickLineWidth,
        type: token.radiusAxisTickLineType
      }
    },
    axisLabel: {
      color: token.radiusAxisLabelColor,
      fontSize: token.radiusAxisLabelFontSize,
      margin: token.radiusAxisLabelGap * 5
    },
    splitLine: {
      lineStyle: {
        type: token.radiusAxisSplitLineType,
        color: token.radiusAxisSplitLineColor,
        width: token.radiusAxisSplitLineWidth
      }
    }
  };
  return util.generatedMatchedUiRule(echartsModule, uiRule, util.axisCommonPropertyPermissions);
}
exports.default = getRadiusAxisToken;
