"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../../../token/index.js");
const util = require("./util.js");
function getTitleToken(echartsModule) {
  var token = index.default.getToken();
  var uiRule = {
    itemGap: token.titleItemGap,
    textStyle: {
      color: token.titleTextColor,
      fontSize: token.titleTextFontSize
    },
    subtextStyle: {
      color: token.titleSubTextColor,
      fontSize: token.titleSubtextFontSize
    }
  };
  var commonProperty = ["itemGap"];
  var propertyPermissions = [{
    name: "text",
    extraCondition: function extraCondition(val) {
      return val || val === 0;
    },
    correlationProperty: ["textStyle"]
  }, {
    name: "subtext",
    extraCondition: function extraCondition(val) {
      return val || val === 0;
    },
    correlationProperty: ["subtextStyle"]
  }];
  return util.generatedMatchedUiRule(echartsModule, uiRule, propertyPermissions, commonProperty);
}
exports.default = getTitleToken;
