"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const merge = require("../../util/merge.js");
const cloneDeep = require("../../util/cloneDeep.js");
const equal = require("../../util/equal.js");
const index = require("../adaptive/index.js");
var mediaScreen = /* @__PURE__ */ function() {
  function mediaScreen2(dom, option, callback) {
    this.dom = dom;
    this.userOption = option;
    this.callback = callback;
    this.curRange = [];
    this.initOption = {};
  }
  var _proto = mediaScreen2.prototype;
  _proto.observe = function observe() {
    var _this = this;
    if (!this.dom) return;
    var defaultChartOption = index.default[this.chartName] ? index.default[this.chartName] : [];
    this.option = this.userOption || defaultChartOption;
    var domWidth = this.dom.getBoundingClientRect().width;
    var range = this.getRange(domWidth, this.option);
    if (!equal.isArrayEqual(this.curRange, range)) {
      var tempOption = cloneDeep.default(this.initOption);
      this.curRange = range;
      this.curRange.forEach(function(rangeIndex) {
        merge.default(tempOption, _this.option[rangeIndex].option);
      });
      this.callback(tempOption);
    }
  };
  _proto.refresh = function refresh() {
    this.curRange = [];
    this.observe();
  };
  _proto.setInitOption = function setInitOption(option, chartName) {
    this.initOption = cloneDeep.default(option);
    this.chartName = chartName;
  };
  _proto.getRange = function getRange(domWidth, option) {
    var range = [];
    option.forEach(function(item, index2) {
      if (item.maxWidth !== void 0 && item.minWidth !== void 0) {
        if (domWidth <= item.maxWidth && domWidth >= item.minWidth) {
          range.push(index2);
        }
      } else if (item.maxWidth === void 0 && item.minWidth === void 0) {
        range.push(index2);
      } else if (item.maxWidth !== void 0 && item.minWidth === void 0) {
        if (domWidth <= item.maxWidth) {
          range.push(index2);
        }
      } else if (item.maxWidth === void 0 && item.minWidth !== void 0) {
        if (domWidth >= item.minWidth) {
          range.push(index2);
        }
      }
    });
    range = Array.from(new Set(range));
    return range;
  };
  return mediaScreen2;
}();
exports.default = mediaScreen;
