"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
var UNDEFINED = "undefined";
var CtorUint32Array = typeof Uint32Array === UNDEFINED ? Array : Uint32Array;
var CtorUint16Array = typeof Uint16Array === UNDEFINED ? Array : Uint16Array;
function getIndicesCtor(rawCount) {
  return rawCount > 65535 ? CtorUint32Array : CtorUint16Array;
}
function lttb(data) {
  var rate = 1 / Math.round(data.length / 1040);
  var newData = [];
  var len = data.length;
  var sampledIndex = 0;
  var frameSize = Math.floor(1 / rate);
  var currentRawIndex = 0;
  var maxArea;
  var area;
  var nextRawIndex;
  var newIndices = new (getIndicesCtor(len))(Math.ceil(len / frameSize) + 2);
  newIndices[sampledIndex++] = currentRawIndex;
  for (var i = 1; i < len - 1; i += frameSize) {
    var nextFrameStart = Math.min(i + frameSize, len - 1);
    var nextFrameEnd = Math.min(i + frameSize * 2, len);
    var avgX = (nextFrameEnd + nextFrameStart) / 2;
    var avgY = 0;
    for (var idx = nextFrameStart; idx < nextFrameEnd; idx++) {
      var rawIndex = idx;
      var y = data[rawIndex];
      if (isNaN(y)) {
        continue;
      }
      avgY += y;
    }
    avgY /= nextFrameEnd - nextFrameStart;
    var frameStart = i;
    var frameEnd = Math.min(i + frameSize, len);
    var pointAX = i - 1;
    var pointAY = data[currentRawIndex];
    maxArea = -1;
    nextRawIndex = frameStart;
    for (var _idx = frameStart; _idx < frameEnd; _idx++) {
      var _rawIndex = _idx;
      var _y = data[_rawIndex];
      if (isNaN(_y)) {
        continue;
      }
      area = Math.abs((pointAX - avgX) * (_y - pointAY) - (pointAX - _idx) * (avgY - pointAY));
      if (area > maxArea) {
        maxArea = area;
        nextRawIndex = _rawIndex;
      }
    }
    newIndices[sampledIndex++] = nextRawIndex;
    newData.push(data[nextRawIndex]);
    currentRawIndex = nextRawIndex;
  }
  newIndices[sampledIndex++] = len - 1;
  return newData;
}
exports.lttb = lttb;
