"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const board = require("./board.js");
const util = require("../util.js");
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var gray = _extends({}, board.default.gray, board.default.transparent);
var colorState = {
  // 紧急色
  colorError: board.default.red.colorRed60,
  colorAlert: board.default.orange.colorOrange60,
  colorWarning: board.default.yellow.colorYellow60,
  // 成功色
  colorSuccess: board.default.kelly.colorKelly60,
  // 提示色
  colorInfo: board.default.blue.colorBlue60,
  // 失效
  colorNone: board.default.gray.colorGray50
};
var colorChart = {
  colorChart1: board.default.blue.colorBlue60,
  colorChart2: board.default.mint.colorMint70,
  colorChart3: board.default.indigo.colorIndigo50,
  colorChart4: board.default.kelly.colorKelly60,
  colorChart5: board.default.yellow.colorYellow60,
  colorChart6: board.default.sky.colorSky60,
  colorChart7: board.default.purple.colorPurple50,
  colorChart8: board.default.rose.colorRose50
  // (原色 '#EB4696')
};
var colorGroup = util.getColorGroup(colorChart);
var light = util.getThemeColor(gray, colorState, colorGroup, board.default);
exports.default = light;
