"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const getAliasToken = require("./getAliasToken.js");
const getGlobalToken = require("./getGlobalToken.js");
const getModelToken = require("./getModelToken.js");
const index = require("./chartsToken/index.js");
const constants = require("../../../util/constants.js");
const index$1 = require("../color/index.js");
const merge = require("../../../util/merge.js");
const cloneDeep = require("../../../util/cloneDeep.js");
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
function getBasicToken(name, config) {
  return _extends({}, getGlobalToken.default(name), config);
}
function getMapToken(name, config) {
  return _extends({}, getAliasToken.aliasTokenMap[name](config), config);
}
function getConfigModelToken(config) {
  return _extends({}, getModelToken.default(config), config);
}
function mergeSpecialToken(name, chartsConfig, config) {
  constants.TOKENCHARTNAMES.forEach(function(item) {
    if (config[item]) merge.default(chartsConfig, config[item]);
  });
  var colorState = config.colorState;
  if (colorState) {
    var newColorState = merge.default(cloneDeep.default(index$1.default[name].colorSet.colorState), colorState);
    return _extends({}, chartsConfig, {
      colorState: newColorState
    });
  }
  return _extends({}, chartsConfig);
}
function mergeToken(name, config) {
  var basicConfig = getBasicToken(name, config);
  var mapConfig = getMapToken(name, basicConfig);
  var modelConfig = getConfigModelToken(mapConfig);
  var chartsConfig = index.default(mapConfig);
  var specialConfig = mergeSpecialToken(name, chartsConfig, config);
  return _extends({
    colorGroup: basicConfig.colorGroup
  }, modelConfig, specialConfig);
}
exports.default = mergeToken;
