"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("./theme/ict/index.js");
const index$1 = require("./theme/bpit/index.js");
const index$2 = require("./theme/cloud/index.js");
const index$3 = require("./theme/hdesign/index.js");
const merge = require("../../util/merge.js");
const hashMap = require("../../util/hashMap.js");
const cloneDeep = require("../../util/cloneDeep.js");
const tips = require("../../util/tips.js");
const constants = require("../../util/constants.js");
const mergeToken = require("./factory/mergeToken.js");
var _HashMap;
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var themeToken = new hashMap.default((_HashMap = {}, _HashMap[constants.THEMES.LIGHT] = cloneDeep.default(index.ictLight), _HashMap[constants.THEMES.DARK] = cloneDeep.default(index.ictDark), _HashMap[constants.THEMES.BPIT_LIGHT] = cloneDeep.default(index$1.bpitLight), _HashMap[constants.THEMES.BPIT_DARK] = cloneDeep.default(index$1.bpitDark), _HashMap[constants.THEMES.CLOUD_LIGHT] = cloneDeep.default(index$2.cloudLight), _HashMap[constants.THEMES.CLOUD_DARK] = cloneDeep.default(index$2.cloudDark), _HashMap[constants.THEMES.HDESIGN_LIGHT] = cloneDeep.default(index$3.hdesignLight), _HashMap[constants.THEMES.HDESIGN_DARK] = cloneDeep.default(index$3.hdesignDark), _HashMap[constants.CURRENT_THEME] = cloneDeep.default(index.ictLight), _HashMap));
var Theme = /* @__PURE__ */ function() {
  function Theme2() {
  }
  Theme2.set = function set(name, config) {
    var defaultConfig = cloneDeep.default(this.getConfig(constants.DEFAULT_THEME_NAME));
    merge.default(defaultConfig, config);
    themeToken.set(name, defaultConfig);
  };
  Theme2.setConfig = function setConfig(name, config) {
    var themeKeys = this.getThemeKeys();
    var validate = themeKeys.includes(name);
    if (validate) {
      var newConfig = mergeToken.default(name, config);
      var oldConfig = this.getConfig(name);
      merge.default(oldConfig, newConfig);
    } else {
      var _newConfig = mergeToken.default(constants.DEFAULT_THEME_NAME, config);
      themeToken.set(name, _newConfig);
    }
  };
  Theme2.getThemeKeys = function getThemeKeys() {
    return themeToken.keys();
  };
  Theme2.resetThemeCongfig = function resetThemeCongfig() {
    themeToken.set(constants.THEMES.LIGHT, cloneDeep.default(index.ictLight));
    themeToken.set(constants.THEMES.DARK, cloneDeep.default(index.ictDark));
    themeToken.set(constants.THEMES.BPIT_LIGHT, cloneDeep.default(index$1.bpitLight));
    themeToken.set(constants.THEMES.BPIT_DARK, cloneDeep.default(index$1.bpitDark));
    themeToken.set(constants.THEMES.CLOUD_LIGHT, cloneDeep.default(index$2.cloudLight));
    themeToken.set(constants.THEMES.CLOUD_DARK, cloneDeep.default(index$2.cloudDark));
    themeToken.set(constants.THEMES.HDESIGN_LIGHT, cloneDeep.default(index$3.hdesignLight));
    themeToken.set(constants.THEMES.HDESIGN_DARK, cloneDeep.default(index$3.hdesignDark));
    themeToken.set(constants.CURRENT_THEME, cloneDeep.default(index.ictLight));
  };
  Theme2.getConfig = function getConfig(name) {
    return themeToken.get(name);
  };
  Theme2.setDefaultTheme = function setDefaultTheme(name) {
    var tempTheme = this.validate(name);
    if (this.themeName !== tempTheme) {
      this.themeName = tempTheme;
      themeToken.set(constants.CURRENT_THEME, themeToken.get(tempTheme));
      this.config = this.getConfig(constants.CURRENT_THEME);
    }
  };
  Theme2.validate = function validate(name) {
    var tempTheme = name || this.themeName || constants.DEFAULT_THEME_NAME;
    if (tempTheme.toLowerCase().includes("cloud-light")) {
      tempTheme = constants.THEMES.CLOUD_LIGHT;
    }
    if (tempTheme.toLowerCase().includes("cloud-dark")) {
      tempTheme = constants.THEMES.CLOUD_DARK;
    }
    var themeKeys = themeToken.keys();
    var validate2 = themeKeys.includes(tempTheme);
    if (!validate2) {
      tips.default.error(constants.THEME_ERROR_TIP_MESSAGE);
      tempTheme = constants.THEMES.LIGHT;
    }
    return tempTheme;
  };
  Theme2.getTokenByName = function getTokenByName(chartName) {
    var _this = this;
    var handler = function handler2(_, prop) {
      var token = _extends({}, _this.config[chartName]);
      return token[prop];
    };
    return new Proxy({}, {
      get: handler
    });
  };
  Theme2.getChartTokenByName = function getChartTokenByName(chartName) {
    return this.config[chartName];
  };
  Theme2.getToken = function getToken() {
    return this.config;
  };
  return Theme2;
}();
Theme.themeName = void 0;
Theme.config = cloneDeep.default(index.ictLight);
exports.THEMES = constants.THEMES;
exports.default = Theme;
