"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("../../../feature/token/index.js");
const merge = require("../../../util/merge.js");
function getThresholdLabelBgColor() {
  var redGroup = index.default.config.colorBoard.red;
  return Object.values(redGroup)[0];
}
function getThresholdMarkLineLabel() {
  var colorError = index.default.config.colorState.colorError;
  var bg = getThresholdLabelBgColor();
  return {
    label: {
      color: colorError,
      backgroundColor: bg,
      fontSize: index.default.config.markLineLabelFontSize,
      borderColor: colorError,
      borderWidth: index.default.config.markLineLabelBorderWidth,
      borderRadius: index.default.config.markLineLabelBorderRadius,
      padding: index.default.config.markLineLabelPadding,
      position: "insideEnd"
    },
    lineStyle: {
      color: colorError
    }
  };
}
function setThresholdMarkLineLabel(markLine) {
  var thresholdLabel = getThresholdMarkLineLabel();
  merge.default(markLine, thresholdLabel);
}
function getMarkLineDefault(isThreshold) {
  if (isThreshold === void 0) {
    isThreshold = false;
  }
  var lineStyle = {
    width: index.default.config.markLineWidth
  };
  if (isThreshold) lineStyle.color = index.default.config.colorState.colorError;
  return {
    symbol: "none",
    silent: true,
    label: {
      show: false
    },
    lineStyle,
    emphasis: {
      label: {
        show: false
      },
      lineStyle: {
        width: index.default.config.markLineEmphasisWidth
      }
    },
    data: []
  };
}
function getMarkPointDefault() {
  return {
    symbol: "path://M50 0 L0 50 L100 50 Z",
    symbolSize: [10, 6],
    label: {
      color: index.default.config.markPointLabelColor
    },
    data: []
  };
}
exports.getMarkLineDefault = getMarkLineDefault;
exports.getMarkPointDefault = getMarkPointDefault;
exports.setThresholdMarkLineLabel = setThresholdMarkLineLabel;
