"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const base = require("./base.js");
const textStyle = require("./textStyle.js");
const merge = require("../../../util/merge.js");
const subtextStyle = require("./subtextStyle.js");
function title(iChartOption) {
  var text = iChartOption.text, title2 = iChartOption.title;
  if (!title2 && !text) return;
  var titleOption = base.default();
  if (title2) {
    merge.default(titleOption, title2);
    return titleOption;
  }
  var pieMain = text.main, pieSub = text.sub, textPosition = text.position, itemGap = text.itemGap;
  titleOption.textAlign = "center";
  titleOption.left = "49.5%";
  titleOption.text = (pieMain == null ? void 0 : pieMain.text) || (text == null ? void 0 : text.text) || "";
  titleOption.subtext = (pieSub == null ? void 0 : pieSub.text) || (text == null ? void 0 : text.subtext) || "";
  if (itemGap) {
    titleOption.itemGap = itemGap;
  }
  textStyle.default(titleOption, pieMain);
  subtextStyle.default(titleOption, pieSub);
  merge.default(titleOption, text);
  if (textPosition) {
    merge.default(titleOption, textPosition);
  }
  return titleOption;
}
exports.default = title;
