"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../../../feature/token/index.js");
var chartType = ["CircleProcessChart", "GaugeChart", "RadarChart", "FunnelChart", "JadeJueChart", "LiquidfillChart", "PieChart", "PolarBarChart", "SunburstChart", "BulletChart", "HeatMapChart", "WordCloudChart"];
function base(chartName) {
  var trigger = chartName && chartType.includes(chartName) ? "item" : "axis";
  return {
    trigger,
    confine: true,
    borderRadius: index.default.config.tooltipBorderRaduis,
    axisPointer: {
      z: 0,
      type: "line",
      lineStyle: {
        type: index.default.config.tooltipAxisPointerLineType,
        width: index.default.config.tooltipAxisPointerLineWidth,
        color: index.default.config.tooltipAxisPointerLineColor
      },
      shadowStyle: {
        color: index.default.config.tooltipAxisPointerShadowColor
      }
    },
    textStyle: {
      color: index.default.config.tooltipTextColor,
      fontSize: index.default.config.tooltipTextFontSize
    },
    borderWidth: index.default.config.tooltipBorderWidth,
    padding: index.default.config.tooltipPadding,
    backgroundColor: index.default.config.tooltipBg,
    formatter: void 0,
    extraCssText: "box-shadow:0 " + index.default.config.tooltipShadowOffsetY + "px " + index.default.config.tooltipShadowBlur + "px 0 " + index.default.config.tooltipShadowColor + ";"
  };
}
exports.default = base;
