"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const base = require("./base.js");
const axisPointer = require("./axisPointer.js");
const merge = require("../../../util/merge.js");
function tooltip(iChartOption, chartName, callBack) {
  var formatter = iChartOption.tipHtml;
  var formatterStyle = iChartOption.tipHtmlStyle;
  var tooltip2 = base.default(chartName);
  var extraCssText = tooltip2.extraCssText;
  if (formatter) {
    tooltip2.formatter = formatter;
  }
  if (formatterStyle) {
    tooltip2.padding = formatterStyle.padding || tooltip2.padding;
    tooltip2.backgroundColor = formatterStyle.backgroundColor || tooltip2.backgroundColor;
  }
  axisPointer.default(tooltip2, chartName);
  callBack && callBack(tooltip2);
  merge.default(tooltip2, iChartOption.tooltip);
  if (tooltip2.extraCssText) {
    tooltip2.extraCssText = tooltip2.extraCssText + extraCssText;
  }
  return tooltip2;
}
exports.default = tooltip;
