"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const base = require("./base.js");
const name = require("./name.js");
const axisLine = require("./axisLine.js");
const axisLabel = require("./axisLabel.js");
const axisMargin = require("./axisMargin.js");
const boundaryGap = require("./boundaryGap.js");
const merge = require("../../../util/merge.js");
const type = require("../../../util/type.js");
function xAxis(iChartOpt, callBack) {
  var xAxisResult = iChartOpt.xAxis || {};
  xAxisResult = type.toArray(xAxisResult).map(function(xAxisItem, xAxisItemIndex) {
    var xAxisUnit = base.default();
    name.default(xAxisUnit, xAxisItem, iChartOpt);
    boundaryGap.default(xAxisUnit, xAxisItem, iChartOpt);
    axisLabel.default(xAxisUnit, xAxisItem, iChartOpt);
    axisLine.default(xAxisUnit, xAxisItem, iChartOpt);
    axisMargin.default(xAxisUnit, xAxisItem);
    callBack && callBack(xAxisUnit, xAxisItemIndex);
    merge.default(xAxisUnit, xAxisItem);
    return xAxisUnit;
  });
  return xAxisResult;
}
exports.default = xAxis;
