"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../../../feature/fluctuation/index.js");
const type = require("../../../util/type.js");
function defaultFormatter(val) {
  if (!type.isNumber(val)) return val;
  var actualVal = Number.parseFloat(val.toFixed(2));
  return actualVal;
}
function axisOptimization(yAxis, baseYaxis, data) {
  if (yAxis && yAxis.fluctuation) {
    var _yAxis$fluctuation = yAxis.fluctuation, equalSplit = _yAxis$fluctuation.equalSplit, splitNumber = _yAxis$fluctuation.splitNumber, active = _yAxis$fluctuation.active, labelFormatter = _yAxis$fluctuation.labelFormatter;
    if (!active) return;
    var newdata = index.transformData(data);
    var value = index.default(newdata);
    baseYaxis.min = value[0];
    baseYaxis.max = value[1];
    if (equalSplit) {
      var interval = (value[1] - value[0]) / (splitNumber != null ? splitNumber : 5);
      baseYaxis.interval = interval;
      baseYaxis.axisLabel.formatter = labelFormatter || defaultFormatter;
    }
  }
  if (yAxis && yAxis.allowRange) {
    var _newdata = index.transformData(data);
    var _value = index.default(_newdata, yAxis.allowRange);
    baseYaxis.min = _value[0];
    baseYaxis.max = _value[1];
  }
}
exports.default = axisOptimization;
