"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const base = require("./base.js");
const index = require("../rectTitle/index.js");
const type = require("../../../util/type.js");
const merge = require("../../../util/merge.js");
const axisOptimization = require("./axisOptimization.js");
function isNeedTitle(yAxisOpt, yAxisName) {
  if (yAxisName) {
    return true;
  }
  if (yAxisOpt.length === 1 && yAxisOpt[0] && yAxisOpt[0].position !== "right") {
    return true;
  }
  return false;
}
function yAxis(baseOpt, iChartOpt, chartName, callback) {
  var yAxisOpt = iChartOpt.yAxis;
  var yAxisName = iChartOpt.yAxisName;
  var data = iChartOpt.data;
  if (!type.isArray(yAxisOpt)) {
    yAxisOpt = [yAxisOpt];
  }
  if (isNeedTitle(yAxisOpt, yAxisName)) {
    var _yAxisOpt$;
    baseOpt.title = index.default(iChartOpt, chartName, (_yAxisOpt$ = yAxisOpt[0]) == null ? void 0 : _yAxisOpt$.nameTextStyle);
  }
  var yAxis2 = [];
  yAxisOpt.forEach(function(item, index2) {
    var temp = base.default();
    if (item && item.unit) {
      temp.axisLabel.formatter = "{value} " + item.unit;
    }
    if (item && item.formatter) {
      temp.axisLabel.formatter = item.formatter;
    }
    if (item && item.name) {
      item.nameTextStyle = Object.assign(temp.nameTextStyle, item.nameTextStyle);
    }
    if (item && item.labelTextStyle) {
      item.labelTextStyle = Object.assign(temp.axisLabel, item.labelTextStyle);
    }
    if (item && item.splitLine) {
      item.splitLine = Object.assign(temp.splitLine, item.splitLine);
    }
    axisOptimization.default(item, temp, data);
    callback && callback(temp, index2);
    temp = merge.default(temp, item);
    if (index2 === 0 && yAxisOpt.length === 1 && temp.position !== "right") {
      delete temp.name;
    }
    yAxis2.push(temp);
  });
  return yAxis2;
}
exports.default = yAxis;
