"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("./components/LineChart/index.js");
const index$1 = require("./components/BarChart/index.js");
const index$2 = require("./components/PieChart/index.js");
const index$5 = require("./components/RadarChart/index.js");
const index$3 = require("./components/GaugeChart/index.js");
const index$4 = require("./components/BubbleChart/index.js");
const index$6 = require("./components/WordCloudChart/index.js");
const index$9 = require("./components/SankeyChart/index.js");
const index$7 = require("./components/HeatMapChart/index.js");
const index$8 = require("./components/ScatterChart/index.js");
const index$a = require("./components/JadeJueChart/index.js");
const index$b = require("./components/TreeChart/index.js");
const index$c = require("./components/TreeMapChart/index.js");
const index$d = require("./components/HillChart/index.js");
const index$e = require("./components/GraphTreeChart/index.js");
const index$f = require("./components/ProcessChart/index.js");
const index$g = require("./components/PolarBarChart/index.js");
const index$h = require("./components/CircleProcessChart/index.js");
const index$i = require("./components/SunburstChart/index.js");
const index$j = require("./components/FunnelChart/index.js");
const index$k = require("./components/LiquidfillChart/index.js");
const index$l = require("./components/BoxplotChart/index.js");
const index$m = require("./components/RegionChart/index.js");
const index$n = require("./components/CandlestickChart/index.js");
const index$o = require("./components/GraphChart/index.js");
const index$p = require("./components/AssembleBubbleChart/index.js");
const index$q = require("./components/BulletChart/index.js");
function Register() {
  this.registeredComp = {};
}
function registerComp(options) {
  this.registeredComp[options.name] = options.component;
}
function getRegisteredComp(name) {
  if (name in this.registeredComp) {
    return this.registeredComp[name];
  }
  return null;
}
Register.prototype.registerComp = registerComp;
Register.prototype.getRegisteredComp = getRegisteredComp;
var register = new Register();
var components = [{
  name: "AreaChart",
  component: index.default
}, {
  name: "LineChart",
  component: index.default
}, {
  name: "BarChart",
  component: index$1.default
}, {
  name: "PieChart",
  component: index$2.default
}, {
  name: "GaugeChart",
  component: index$3.default
}, {
  name: "BubbleChart",
  component: index$4.default
}, {
  name: "RadarChart",
  component: index$5.default
}, {
  name: "WordCloudChart",
  component: index$6.default
}, {
  name: "HeatMapChart",
  component: index$7.default
}, {
  name: "ScatterChart",
  component: index$8.default
}, {
  name: "SankeyChart",
  component: index$9.default
}, {
  name: "JadeJueChart",
  component: index$a.default
}, {
  name: "TreeChart",
  component: index$b.default
}, {
  name: "TreeMapChart",
  component: index$c.default
}, {
  name: "HillChart",
  component: index$d.default
}, {
  name: "GraphTreeChart",
  component: index$e.default
}, {
  name: "ProcessChart",
  component: index$f.default
}, {
  name: "PolarBarChart",
  component: index$g.default
}, {
  name: "CircleProcessChart",
  component: index$h.default
}, {
  name: "SunburstChart",
  component: index$i.default
}, {
  name: "FunnelChart",
  component: index$j.default
}, {
  name: "LiquidfillChart",
  component: index$k.default
}, {
  name: "BoxplotChart",
  component: index$l.default
}, {
  name: "RegionChart",
  component: index$m.default
}, {
  name: "CandlestickChart",
  component: index$n.default
}, {
  name: "GraphChart",
  component: index$o.default
}, {
  name: "AssembleBubbleChart",
  component: index$p.default
}, {
  name: "BulletChart",
  component: index$q.default
}];
components.forEach(function(comp) {
  register.registerComp(comp);
});
exports.default = register;
