"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
var THEMES = {
  DARK: "dark",
  LIGHT: "light",
  BPIT_LIGHT: "bpit-light",
  BPIT_DARK: "bpit-dark",
  CLOUD_DARK: "cloud-dark",
  CLOUD_LIGHT: "cloud-light",
  HDESIGN_LIGHT: "hdesign-light",
  HDESIGN_DARK: "hdesign-dark"
};
var CURRENT_THEME = Symbol("current_theme");
var TOKENCHARTNAMES = ["AssembleBubbleChart", "BarChart", "BoxplotChart", "BubbleChart", "CandlestickChart", "CircleProcessChart", "FunnelChart", "GaugeChart", "HeatMapChart", "HillChart", "JadeJueChart", "LineChart", "AreaChart", "LiquidfillChart", "PieChart", "PolarBarChart", "ProcessChart", "RadarChart", "RegionChart", "SankeyChart", "SunburstChart", "TreeChart", "WaveChart", "WordCloudChart", "TimelineChart", "ChartCard", "BulletChart"];
var DEFAULT_THEME_NAME = THEMES.LIGHT;
var THEME_ERROR_TIP_MESSAGE = "Theme must be one of " + Object.values(THEMES).join(",") + " or the theme name registered for calling HuiCharts.registerTheme()";
var CHART_TYPE = {
  ASSEMBLE_BUBBLE: "AssembleBubbleChart",
  AUTONAVI_MAP: "AutonaviMapChart",
  BAIDU_MAP: "BaiduMapChart",
  BAR: "BarChart",
  BOXPLOT: "BoxplotChart",
  BUBBLE: "BubbleChart",
  BULLET: "BulletChart",
  CANDLESTICK: "CandlestickChart",
  CIRCLE_PROCESS: "CircleProcessChart",
  FLOW: "FlowChart",
  FUNNEL: "FunnelChart",
  GANTT: "GanttChart",
  GAUGE: "GaugeChart",
  GRAPH_TREE: "GraphTreeChart",
  HEAT_MAP: "HeatMapChart",
  HILL: "HillChart",
  HONEYCOMB: "HoneycombChart",
  JADGEJUE: "JadeJueChart",
  LINE: "LineChart",
  AREA: "AreaChart",
  LIQUID_FILL: "LiquidfillChart",
  MILESTONE: "MilestoneChart",
  ORGANIZATION: "OrganizationChart",
  PIE: "PieChart",
  POLAR_BAR: "PolarBarChart",
  PROCESS: "ProcessChart",
  RADAR: "RadarChart",
  REGION: "RegionChart",
  RIVER: "RiverChart",
  SANKEY: "SankeyChart",
  SCATTER: "ScatterChart",
  SNOWFLAKE: "SnowFlakeChart",
  SUNBURST: "SunburstChart",
  TERRACE: "TerraceChart",
  TIME_LINE: "TimelineChart",
  TREE: "TreeChart",
  TREE_MAP: "TreeMapChart",
  WAVE: "WaveChart",
  WORD_CLOUD: "WordCloudChart",
  CHART_CARD: "ChartCard"
};
var ADAPTIVE_THEME = ["hdesign-light", "hdesign-dark", "bpit-light", "bpit-dark"];
exports.ADAPTIVE_THEME = ADAPTIVE_THEME;
exports.CHART_TYPE = CHART_TYPE;
exports.CURRENT_THEME = CURRENT_THEME;
exports.DEFAULT_THEME_NAME = DEFAULT_THEME_NAME;
exports.THEMES = THEMES;
exports.THEME_ERROR_TIP_MESSAGE = THEME_ERROR_TIP_MESSAGE;
exports.TOKENCHARTNAMES = TOKENCHARTNAMES;
