"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
var appendHTML = function appendHTML2(dom, child) {
  dom.insertAdjacentHTML("beforeend", child);
};
var appendDom = function appendDom2(dom, child) {
  dom.insertAdjacentElement("beforeend", child);
};
var createDom = function createDom2(name) {
  return document.createElementNS("http://www.w3.org/2000/svg", name);
};
var setStyle = function setStyle2(dom, option) {
  for (var i in option) {
    if (Object.hasOwnProperty.call(option, i)) {
      dom.setAttribute(i, option[i]);
    }
  }
};
var _isParent = function isParent(targetElement, parentClass) {
  if (targetElement === document.body) {
    return false;
  } else if (targetElement.parentNode.classList.contains(parentClass)) {
    return targetElement.parentNode;
  } else {
    return _isParent(targetElement.parentNode, parentClass);
  }
};
var getTextWidth = function getTextWidth2(text, fontSize) {
  if (fontSize === void 0) {
    fontSize = 12;
  }
  var result = 0;
  var ele = document.createElement("span");
  ele.innerText = text;
  ele.setAttribute("style", "font-size: " + fontSize + "px");
  document.documentElement.append(ele);
  result = ele.offsetWidth;
  document.documentElement.removeChild(ele);
  return result;
};
exports.appendDom = appendDom;
exports.appendHTML = appendHTML;
exports.createDom = createDom;
exports.getTextWidth = getTextWidth;
exports.isParent = _isParent;
exports.setStyle = setStyle;
