"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const hooks = require("vue");
const index = require("../../../../../@opentiny_vue-common@3.21.0/node_modules/@opentiny/vue-common/lib/index.js");
const vue = require("../../../../../@opentiny_vue-renderless@3.21.1/node_modules/@opentiny/vue-renderless/avatar/vue.js");
;/* empty css                                                                                                         */
var $constants = {
  COMPONENT_PREFIX: "tiny-mobile-avatar",
  ICON: "icon"
};
var _sfc_main = /* @__PURE__ */ index.defineComponent({
  name: index.$prefix + "Avatar",
  props: {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    alt: String,
    error: Function,
    fit: {
      type: String,
      default: "cover"
    },
    icon: Object,
    shape: {
      type: String,
      default: "circle",
      validator: function validator(val) {
        return ~["circle", "square"].indexOf(val);
      }
    },
    size: {
      type: [Number, String],
      validator: function validator2(val) {
        return typeof val === "string" ? ~["large", "medium", "small"].indexOf(val) : typeof val === "number";
      }
    },
    src: String,
    srcSet: String
  },
  setup: function setup(props, context) {
    return index.setup({
      props,
      context,
      renderless: vue.renderless,
      api: vue.api,
      mono: true
    });
  },
  render: function render() {
    var _this = this;
    var alt = this.alt, fit = this.fit, Icon = this.icon, size = this.size, src = this.src, srcSet = this.srcSet, _this$state = this.state, isImageExist = _this$state.isImageExist, avatarClass = _this$state.avatarClass;
    var hasImageSrc = isImageExist && src;
    var sizeStyle = {};
    if (typeof size === "number") {
      sizeStyle = {
        height: size + "px",
        width: size + "px",
        lineHeight: size + "px"
      };
    }
    var renderAvatar = function renderAvatar2() {
      if (hasImageSrc) {
        return hooks.createVNode("img", {
          "src": src,
          "alt": alt,
          "srcSet": srcSet,
          "style": {
            "object-fit": fit
          },
          "onError": _this.handleError
        }, null);
      }
      if (Icon) {
        return hooks.createVNode(Icon, null, null);
      }
      return _this.$slots.default && _this.$slots.default();
    };
    return hooks.createVNode("span", {
      "class": avatarClass,
      "style": sizeStyle
    }, [renderAvatar()]);
  }
});
var version = "3.21.0";
_sfc_main.install = function(Vue) {
  Vue.component(_sfc_main.name, _sfc_main);
};
_sfc_main.version = version;
exports.default = _sfc_main;
