"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const vue = require("../../../../../@opentiny_vue-renderless@3.21.1/node_modules/@opentiny/vue-renderless/card/vue.js");
const index = require("../../../../../@opentiny_vue-common@3.21.0/node_modules/@opentiny/vue-common/lib/index.js");
const index$5 = require("../../../../../@opentiny_vue-dropdown@3.21.1/node_modules/@opentiny/vue-dropdown/lib/index.js");
const index$4 = require("../../../../../@opentiny_vue-dropdown-menu@3.21.0/node_modules/@opentiny/vue-dropdown-menu/lib/index.js");
const index$3 = require("../../../../../@opentiny_vue-dropdown-item@3.21.0/node_modules/@opentiny/vue-dropdown-item/lib/index.js");
const index$2 = require("../../../../../@opentiny_vue-checkbox@3.21.0/node_modules/@opentiny/vue-checkbox/lib/index.js");
const index$1 = require("../../../../../@opentiny_vue-radio@3.21.0/node_modules/@opentiny/vue-radio/lib/index.js");
const ellipsis = require("../../../../../@opentiny_vue-icon@3.21.0/node_modules/@opentiny/vue-icon/lib/ellipsis.js");
const hooks = require("vue");
var classes = {
  "card": "overflow-hidden bg-color-bg-1 border hover:shadow",
  "size-large": "rounded-lg min-w-[theme(spacing.112)]",
  "size-medium": "rounded-lg min-w-[theme(spacing.72)]",
  "size-small": "rounded-lg min-w-[theme(spacing.54)]",
  "size-mini": "rounded min-w-[theme(spacing.32)]",
  "size-large-padding": "p-4",
  "size-medium-padding": "p-3",
  "size-small-padding": "p-3",
  "size-mini-padding": "p-2",
  "size-large-width": "w-144",
  "size-medium-width": "w-96",
  "size-small-width": "w-72",
  "size-mini-width": "w-44",
  "status-success": "border-color-success",
  "status-warning": "border-color-warning",
  "status-alerting": "border-color-alert",
  "status-danger": "border-color-error",
  "status-default": "border-color-border-separator",
  "title": "text-base sm:text-sm mb-3 leading-5.5 text-color-text-primary mr-2",
  "checkbox": "relative left-1 pt-3 sm:pt-3.5 pl-2 [&_[data-tag=tiny-checkbox]]:p-0 [&_[data-tag=tiny-checkbox]>span>span]:p-0 [&_[data-tag=tiny-checkbox]>span:nth-child(2)]:hidden",
  "radio": "relative left-0 sm:left-3 pt-0 sm:pt-3 [&_[role=radio]_span_span]:pr-0",
  "logo": "flex mb-3 py-2 w-full justify-center items-center aspect-[5_/_2] overflow-hidden",
  "main": "text-sm sm:text-xs text-color-text-secondary overflow-y-auto",
  "footer": "p-3 border-t border-t-color-border-separator",
  "options": "w-full px-3 h-11 flex items-center justify-around text-color-text-primary border-t border-t-color-border-separator"
};
function _createForOfIteratorHelperLoose(r, e) {
  var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (t) return (t = t.call(r)).next.bind(t);
  if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e) {
    t && (r = t);
    var o = 0;
    return function() {
      return o >= r.length ? { done: true } : { done: false, value: r[o++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0;
  }
}
function _arrayLikeToArray(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};
var _sfc_main = index.defineComponent({
  name: index.$prefix + "Card",
  emits: ["icon-click", "update:modelValue", "change", "click"],
  components: {
    TinyDropdown: index$5.default,
    TinyDropdownMenu: index$4.default,
    TinyDropdownItem: index$3.default,
    TinyCheckbox: index$2.default,
    TinyRadio: index$1.default,
    IconEllipsis: ellipsis.default()
  },
  props: [].concat(index.props, ["_constants", "modelValue", "src", "title", "customClass", "height", "label", "autoWidth", "options", "iconMore", "size", "status", "checkType", "type", "disabled"]),
  setup: function setup$1(props2, context) {
    return index.setup({
      props: props2,
      context,
      renderless: vue.renderless,
      api: vue.api,
      classes
    });
  }
});
var _hoisted_1 = /* @__PURE__ */ hooks.createElementVNode(
  "span",
  null,
  null,
  -1
  /* HOISTED */
);
var _hoisted_2 = {
  key: 2,
  "data-tag": "tiny-card-image"
};
var _hoisted_3 = ["src"];
var _hoisted_4 = {
  key: 3,
  "data-tag": "tiny-card-vadio"
};
var _hoisted_5 = ["src"];
var _hoisted_6 = ["src"];
var _hoisted_7 = {
  key: 0,
  "data-tag": "tiny-card-footer",
  class: "w-full"
};
var _hoisted_8 = ["onClick"];
var _hoisted_9 = {
  key: 0,
  class: "ml-1 align-middle"
};
var _hoisted_10 = {
  key: 0,
  class: "ml-1 align-middle"
};
var _hoisted_11 = {
  key: 0,
  class: "ml-1 text-color-text-primary"
};
var _hoisted_12 = ["onClick"];
var _hoisted_13 = {
  key: 0
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_tiny_checkbox = hooks.resolveComponent("tiny-checkbox");
  var _component_tiny_radio = hooks.resolveComponent("tiny-radio");
  var _component_tiny_dropdown_item = hooks.resolveComponent("tiny-dropdown-item");
  var _component_tiny_dropdown_menu = hooks.resolveComponent("tiny-dropdown-menu");
  var _component_tiny_dropdown = hooks.resolveComponent("tiny-dropdown");
  return hooks.openBlock(), hooks.createElementBlock(
    "div",
    {
      "data-tag": "tiny-card",
      class: hooks.normalizeClass(_ctx.m(_ctx.gcls("card"), _ctx.gcls("size-" + _ctx.state.size), _ctx.gcls("status-" + _ctx.state.status), _ctx.gcls(!_ctx.state.autoWidth && "size-" + _ctx.state.size + "-width"), _ctx.state.itemChecked ? "border-color-brand" : "", _ctx.state.disabled ? "bg-color-bg-2" : "", _ctx.state.customClass)),
      onClick: _cache[3] || (_cache[3] = function($event) {
        return _ctx.$emit("click", $event);
      })
    },
    [hooks.createElementVNode(
      "div",
      {
        "data-tag": "tiny-card-body",
        class: hooks.normalizeClass([_ctx.state.type === "text" ? "flex" : "block"])
      },
      [_ctx.state.checkType === "checkbox" && _ctx.state.type === "text" ? (hooks.openBlock(), hooks.createElementBlock(
        "div",
        {
          key: 0,
          "data-tag": "tiny-card-checkbox",
          class: hooks.normalizeClass(_ctx.gcls("checkbox"))
        },
        [hooks.createVNode(_component_tiny_checkbox, {
          modelValue: _ctx.state.model,
          "onUpdate:modelValue": _cache[0] || (_cache[0] = function($event) {
            return _ctx.state.model = $event;
          }),
          label: _ctx.label,
          disabled: _ctx.state.disabled,
          onChange: _ctx.handleChange
        }, null, 8, ["modelValue", "label", "disabled", "onChange"])],
        2
        /* CLASS */
      )) : hooks.createCommentVNode("v-if", true), _ctx.state.checkType === "radio" && _ctx.state.type === "text" ? (hooks.openBlock(), hooks.createElementBlock(
        "div",
        {
          key: 1,
          "data-tag": "tiny-card-radio",
          class: hooks.normalizeClass(_ctx.gcls("radio"))
        },
        [hooks.createVNode(_component_tiny_radio, {
          modelValue: _ctx.state.model,
          "onUpdate:modelValue": _cache[1] || (_cache[1] = function($event) {
            return _ctx.state.model = $event;
          }),
          label: _ctx.label,
          disabled: _ctx.state.disabled,
          onChange: _ctx.handleChange
        }, {
          default: hooks.withCtx(function() {
            return [_hoisted_1];
          }),
          _: 1
          /* STABLE */
        }, 8, ["modelValue", "label", "disabled", "onChange"])],
        2
        /* CLASS */
      )) : hooks.createCommentVNode("v-if", true), _ctx.state.type === "image" ? (hooks.openBlock(), hooks.createElementBlock("div", _hoisted_2, [hooks.createElementVNode("img", {
        src: _ctx.src,
        class: "w-full aspect-video bg-cover"
      }, null, 8, _hoisted_3)])) : hooks.createCommentVNode("v-if", true), _ctx.state.type === "video" ? (hooks.openBlock(), hooks.createElementBlock("div", _hoisted_4, [hooks.createElementVNode("video", {
        class: "w-full aspect-video",
        src: _ctx.src,
        controls: ""
      }, null, 8, _hoisted_5)])) : hooks.createCommentVNode("v-if", true), hooks.createElementVNode(
        "div",
        {
          "data-tag": "tiny-card-logo",
          class: hooks.normalizeClass(["flex-1", _ctx.gcls("size-" + _ctx.state.size + "-padding")])
        },
        [_ctx.state.type === "logo" ? (hooks.openBlock(), hooks.createElementBlock(
          "div",
          {
            key: 0,
            class: hooks.normalizeClass(_ctx.gcls("logo"))
          },
          [hooks.createElementVNode("img", {
            src: _ctx.src,
            class: "bg-contain"
          }, null, 8, _hoisted_6)],
          2
          /* CLASS */
        )) : hooks.createCommentVNode("v-if", true), _ctx.title || _ctx.slots.title ? (hooks.openBlock(), hooks.createElementBlock(
          "div",
          {
            key: 1,
            "data-tag": "tiny-card-title",
            class: hooks.normalizeClass(["flex items-start", [_ctx.state.type === "logo" && "text-center justify-center mb-1"]])
          },
          [hooks.renderSlot(_ctx.$slots, "title-left"), hooks.renderSlot(_ctx.$slots, "title", {}, function() {
            return [hooks.createElementVNode(
              "p",
              {
                class: hooks.normalizeClass(_ctx.gcls("title"))
              },
              hooks.toDisplayString(_ctx.title),
              3
              /* TEXT, CLASS */
            )];
          }), hooks.renderSlot(_ctx.$slots, "title-right")],
          2
          /* CLASS */
        )) : hooks.createCommentVNode("v-if", true), hooks.createElementVNode(
          "div",
          {
            "data-tag": "tiny-card-main",
            class: hooks.normalizeClass(_ctx.m(_ctx.gcls("main"), _ctx.state.type === "logo" ? "text-center pb-2" : "")),
            style: hooks.normalizeStyle({
              height: _ctx.state.height
            })
          },
          [hooks.renderSlot(_ctx.$slots, "default")],
          6
          /* CLASS, STYLE */
        )],
        2
        /* CLASS */
      )],
      2
      /* CLASS */
    ), _ctx.state.effectOptions.length || _ctx.slots.footer ? (hooks.openBlock(), hooks.createElementBlock("div", _hoisted_7, [_ctx.slots.footer ? (hooks.openBlock(), hooks.createElementBlock(
      "div",
      {
        key: 0,
        class: hooks.normalizeClass(_ctx.gcls("footer"))
      },
      [hooks.renderSlot(_ctx.$slots, "footer")],
      2
      /* CLASS */
    )) : hooks.createCommentVNode("v-if", true), _ctx.state.effectOptions.length ? (hooks.openBlock(), hooks.createElementBlock(
      "div",
      {
        key: 1,
        class: hooks.normalizeClass(_ctx.gcls("options"))
      },
      [(hooks.openBlock(true), hooks.createElementBlock(
        hooks.Fragment,
        null,
        hooks.renderList(_ctx.state.effectOptions.slice(0, _ctx.state.sliceNum), function(item, index2) {
          return hooks.openBlock(), hooks.createElementBlock("div", {
            class: hooks.normalizeClass(["cursor-pointer", [item.disabled ? "text-color-text-disabled cursor-not-allowed" : ""]]),
            key: item.text + index2,
            onClick: hooks.withModifiers(function($event) {
              return _ctx.handelIconClick(item, index2, $event);
            }, ["stop"])
          }, [(hooks.openBlock(), hooks.createBlock(hooks.resolveDynamicComponent(item.icon), {
            class: hooks.normalizeClass(["w-4 h-4", [item.disabled ? "fill-color-icon-disabled" : ""]])
          }, null, 8, ["class"])), item.text ? (hooks.openBlock(), hooks.createElementBlock(
            "span",
            _hoisted_9,
            hooks.toDisplayString(item.text),
            1
            /* TEXT */
          )) : hooks.createCommentVNode("v-if", true)], 10, _hoisted_8);
        }),
        128
        /* KEYED_FRAGMENT */
      )), _ctx.state.effectOptions.length === _ctx.state.iconNum ? (hooks.openBlock(), hooks.createElementBlock(
        "div",
        {
          key: 0,
          class: hooks.normalizeClass(["cursor-pointer", [_ctx.state.effectOptions[_ctx.state.sliceNum].disabled ? "text-color-text-disabled cursor-not-allowed" : ""]]),
          onClick: _cache[2] || (_cache[2] = hooks.withModifiers(function($event) {
            return _ctx.handelIconClick(_ctx.state.effectOptions[_ctx.state.sliceNum], _ctx.state.sliceNum, $event);
          }, ["stop"]))
        },
        [(hooks.openBlock(), hooks.createBlock(hooks.resolveDynamicComponent(_ctx.state.effectOptions[_ctx.state.sliceNum].icon), {
          class: hooks.normalizeClass(["w-4 h-4", [_ctx.state.effectOptions[_ctx.state.sliceNum].disabled ? "fill-color-icon-disabled" : ""]])
        }, null, 8, ["class"])), _ctx.state.effectOptions[_ctx.state.sliceNum].text ? (hooks.openBlock(), hooks.createElementBlock(
          "span",
          _hoisted_10,
          hooks.toDisplayString(_ctx.state.effectOptions[_ctx.state.sliceNum].text),
          1
          /* TEXT */
        )) : hooks.createCommentVNode("v-if", true)],
        2
        /* CLASS */
      )) : hooks.createCommentVNode("v-if", true), _ctx.state.effectOptions.length > _ctx.state.iconNum ? (hooks.openBlock(), hooks.createBlock(_component_tiny_dropdown, {
        key: 1,
        "show-self-icon": ""
      }, {
        dropdown: hooks.withCtx(function() {
          return [hooks.createVNode(_component_tiny_dropdown_menu, {
            placement: "bottom"
          }, {
            default: hooks.withCtx(function() {
              return [(hooks.openBlock(true), hooks.createElementBlock(
                hooks.Fragment,
                null,
                hooks.renderList(_ctx.state.effectOptions.slice(_ctx.state.sliceNum), function(item, index2) {
                  return hooks.openBlock(), hooks.createBlock(
                    _component_tiny_dropdown_item,
                    {
                      key: item.text + index2
                    },
                    {
                      default: hooks.withCtx(function() {
                        return [hooks.createElementVNode("div", {
                          onClick: hooks.withModifiers(function($event) {
                            return _ctx.handelIconClick(item, index2 + _ctx.state.sliceNum, $event);
                          }, ["stop"]),
                          class: hooks.normalizeClass(["px-2", item.disabled ? "text-color-text-disabled cursor-not-allowed" : ""])
                        }, [(hooks.openBlock(), hooks.createBlock(hooks.resolveDynamicComponent(item.icon), {
                          class: hooks.normalizeClass(["w-4 h-4", [item.disabled ? "fill-color-icon-disabled" : ""]])
                        }, null, 8, ["class"])), item.text ? (hooks.openBlock(), hooks.createElementBlock(
                          "span",
                          _hoisted_13,
                          hooks.toDisplayString(item.text),
                          1
                          /* TEXT */
                        )) : hooks.createCommentVNode("v-if", true)], 10, _hoisted_12)];
                      }),
                      _: 2
                      /* DYNAMIC */
                    },
                    1024
                    /* DYNAMIC_SLOTS */
                  );
                }),
                128
                /* KEYED_FRAGMENT */
              ))];
            }),
            _: 1
            /* STABLE */
          })];
        }),
        default: hooks.withCtx(function() {
          return [(hooks.openBlock(), hooks.createBlock(hooks.resolveDynamicComponent(_ctx.iconMore), {
            class: "w-4 h-4"
          })), _ctx.state.effectOptions[0].text ? (hooks.openBlock(), hooks.createElementBlock(
            "span",
            _hoisted_11,
            hooks.toDisplayString(_ctx.t("ui.base.more")),
            1
            /* TEXT */
          )) : hooks.createCommentVNode("v-if", true)];
        }),
        _: 1
        /* STABLE */
      })) : hooks.createCommentVNode("v-if", true)],
      2
      /* CLASS */
    )) : hooks.createCommentVNode("v-if", true)])) : hooks.createCommentVNode("v-if", true)],
    2
    /* CLASS */
  );
}
var mobileFirst = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
exports.default = mobileFirst;
