"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const hooks = require("vue");
const vue = require("../../../../../@opentiny_vue-renderless@3.21.1/node_modules/@opentiny/vue-renderless/cascader-menu/vue.js");
const index = require("../../../../../@opentiny_vue-common@3.21.0/node_modules/@opentiny/vue-common/lib/index.js");
const index$3 = require("../../../../../@opentiny_vue-locale@3.21.0/node_modules/@opentiny/vue-locale/lib/index.js");
const index$2 = require("../../../../../@opentiny_vue-scrollbar@3.21.0/node_modules/@opentiny/vue-scrollbar/lib/index.js");
const index$1 = require("../../../../../@opentiny_vue-cascader-node@3.21.0/node_modules/@opentiny/vue-cascader-node/lib/index.js");
;/* empty css                                                                                                  */
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t2 = arguments[e];
      for (var r in t2) ({}).hasOwnProperty.call(t2, r) && (n[r] = t2[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var renderNodeListFunc = function renderNodeListFunc2(_vm) {
  return function() {
    var events = {
      on: {}
    };
    var menuId = _vm.state.menuId;
    var isHoverMenu = _vm.panel.state.isHoverMenu;
    if (isHoverMenu) {
      events.on.expand = _vm.handleExpand;
    }
    var mapHandler = function mapHandler2(node, index2) {
      var uid = node.uid;
      var hasChildren = node.hasChildren;
      return hooks.createVNode(hooks.resolveComponent("cascader-node"), hooks.mergeProps({
        "key": uid,
        "node": node,
        "node-id": menuId + "-" + index2,
        "data-haspopup": hasChildren,
        "data-owns": hasChildren ? menuId : null
      }, events), null);
    };
    var nodes = _vm.nodes.map(mapHandler);
    return [].concat(nodes, [isHoverMenu ? hooks.createVNode("svg", {
      "ref": "hoverZone",
      "class": "tiny-cascader-menu__hover-zone"
    }, null) : null]);
  };
};
var CascaderMenu = /* @__PURE__ */ index.defineComponent({
  name: index.$prefix + "CascaderMenu",
  components: {
    TinyScrollbar: index$2.default,
    CascaderNode: index$1.default
  },
  props: _extends({}, index.$props, {
    nodes: {
      type: Array,
      required: true
    },
    index: Number,
    onlyUsePanel: Boolean
  }),
  inject: {
    panel: {
      value: "panel",
      default: null
    },
    cascaderRoot: {
      value: "cascaderRoot",
      default: null
    }
  },
  setup: function setup(props, context) {
    return index.setup({
      props,
      context,
      renderless: vue.renderless,
      api: vue.api,
      mono: true
    });
  },
  render: function render() {
    var parentVm = this.cascaderRoot || this.panel || this;
    var noDataSlot = parentVm.slots["no-data"] && parentVm.slots["no-data"]();
    var renderEmptyText = function renderEmptyText2() {
      return noDataSlot ? hooks.createVNode("div", {
        "class": "tiny-cascader-menu__no-data"
      }, [noDataSlot]) : hooks.createVNode("div", {
        "class": "tiny-cascader-menu__empty-text"
      }, [index$3.t("ui.cascader.noData")]);
    };
    var renderNodeList = renderNodeListFunc(this);
    var state = this.state;
    var events = {
      nativeOn: {}
    };
    if (this.panel.state.isHoverMenu) {
      events.nativeOn.mousemove = this.handleMouseMove;
    }
    return index.h("tiny-scrollbar", _extends({
      attrs: {
        role: "menu",
        id: state.menuId
      },
      ref: "cascaderMenu",
      class: "tiny-cascader-menu",
      props: {
        tag: "ul",
        "wrap-class": "tiny-cascader-menu__wrap " + (this.onlyUsePanel ? "tiny-cascader-menu__wrap-expand" : ""),
        "view-class": {
          "tiny-cascader-menu__list": true,
          "is-empty": state.isEmpty
        }
      }
    }, events), [state.isEmpty ? renderEmptyText() : renderNodeList()]);
  }
});
exports.default = CascaderMenu;
