"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const hooks = require("vue");
const vue = require("../../../../../@opentiny_vue-renderless@3.21.1/node_modules/@opentiny/vue-renderless/cascader-node/vue.js");
const index = require("../../../../../@opentiny_vue-common@3.21.0/node_modules/@opentiny/vue-common/lib/index.js");
const index$2 = require("../../../../../@opentiny_vue-checkbox@3.21.0/node_modules/@opentiny/vue-checkbox/lib/index.js");
const index$1 = require("../../../../../@opentiny_vue-radio@3.21.0/node_modules/@opentiny/vue-radio/lib/index.js");
const object = require("../../../../../@opentiny_vue-renderless@3.21.1/node_modules/@opentiny/vue-renderless/common/object.js");
const chevronRight = require("../../../../../@opentiny_vue-icon@3.21.0/node_modules/@opentiny/vue-icon/lib/chevron-right.js");
const loadingShadow = require("../../../../../@opentiny_vue-icon@3.21.0/node_modules/@opentiny/vue-icon/lib/loading-shadow.js");
const yes = require("../../../../../@opentiny_vue-icon@3.21.0/node_modules/@opentiny/vue-icon/lib/yes.js");
;/* empty css                                                                                                  */
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var _sfc_main = /* @__PURE__ */ index.defineComponent({
  name: index.$prefix + "CascaderNode",
  components: {
    TinyCheckbox: index$2.default,
    TinyRadio: index$1.default,
    IconYes: yes.default(),
    IconLoading: loadingShadow.default(),
    IconChevronRight: chevronRight.default()
  },
  inheritAttrs: false,
  emits: ["expand", "update:modelValue", "expand-change", "active-item-change", "change"],
  inject: ["panel"],
  props: _extends({}, index.$props, {
    node: {
      type: Object,
      required: true
    },
    nodeId: String
  }),
  setup: function setup(props, context) {
    return index.setup({
      props,
      context,
      renderless: vue.renderless,
      api: vue.api
    });
  },
  render: function render() {
    var _this = this;
    var renderPrefix = function renderPrefix2() {
      var _this$state = _this.state, isLeaf = _this$state.isLeaf, isChecked = _this$state.isChecked, config = _this$state.config;
      var checkStrictly2 = config.checkStrictly, multiple2 = config.multiple;
      if (multiple2) {
        return renderCheckbox();
      } else if (checkStrictly2) {
        return renderRadio();
      } else if (isLeaf && isChecked) {
        return renderCheckIcon();
      }
      return null;
    };
    var renderPostfix = function renderPostfix2() {
      var node = _this.node, state2 = _this.state;
      if (node.loading) {
        return renderLoadingIcon();
      } else if (!state2.isLeaf) {
        return renderExpandIcon();
      }
      return null;
    };
    var stopPropagation = function stopPropagation2(e) {
      return e.stopPropagation();
    };
    var renderCheckbox = function renderCheckbox2() {
      var state2 = _this.state, node = _this.node;
      return hooks.createVNode(hooks.resolveComponent("tiny-checkbox"), {
        "modelValue": node.checked,
        "indeterminate": !node.checked && node.indeterminate,
        "disabled": state2.isDisabled,
        "onChange": _this.handleMultiCheckChange,
        "onClick": stopPropagation
      }, null);
    };
    var renderRadio = function renderRadio2() {
      var _this$state2 = _this.state, checkedValue = _this$state2.checkedValue, value = _this$state2.value, isDisabled = _this$state2.isDisabled;
      if (object.isEqual(value, checkedValue)) {
        value = checkedValue;
      }
      return hooks.createVNode(hooks.resolveComponent("tiny-radio"), {
        "modelValue": checkedValue,
        "onUpdate:modelValue": function onUpdateModelValue($event) {
          return checkedValue = $event;
        },
        "disabled": isDisabled,
        "label": value,
        "onClick": stopPropagation,
        "onChange": _this.handleCheckChange
      }, {
        default: function _default() {
          return [hooks.createVNode("span", null, null)];
        }
      });
    };
    var renderCheckIcon = function renderCheckIcon2() {
      return hooks.createVNode(hooks.resolveComponent("icon-yes"), {
        "class": "tiny-cascader-node__prefix"
      }, null);
    };
    var renderLoadingIcon = function renderLoadingIcon2() {
      return hooks.createVNode(hooks.resolveComponent("icon-loading"), {
        "class": "tiny-cascader-node__postfix"
      }, null);
    };
    var renderExpandIcon = function renderExpandIcon2() {
      return hooks.createVNode(hooks.resolveComponent("icon-chevron-right"), {
        "class": "tiny-cascader-node__postfix"
      }, null);
    };
    var renderContent = function renderContent2() {
      var panel = _this.panel, node = _this.node;
      var render2 = panel.state.renderLabelFn;
      var vnode = render2 ? render2({
        node,
        data: node.data
      }) : null;
      return hooks.createVNode("span", {
        "class": "tiny-cascader-node__label"
      }, [vnode || node.label]);
    };
    var state = this.state;
    var _state$config = state.config, checkStrictly = _state$config.checkStrictly, expandTrigger = _state$config.expandTrigger, multiple = _state$config.multiple;
    var disabled = !checkStrictly && state.isDisabled;
    var events = {};
    events.on = {};
    if (expandTrigger === "click") {
      events.on.click = this.handleExpand;
    } else {
      var handler = function handler2(e) {
        _this.handleExpand();
        _this.$emit("expand", e);
      };
      events.on.mouseenter = handler;
      events.on.focus = handler;
    }
    if (state.isLeaf && !(state.isDisabled || checkStrictly || multiple)) {
      events.on.click = this.handleCheckChange;
    }
    return index.h("li", _extends({
      attrs: {
        role: "menuitem",
        id: this.nodeId,
        tabindex: disabled ? null : -1,
        "aria-expanded": state.inActivePath
      },
      class: {
        "tiny-cascader-node": true,
        "is-selectable": checkStrictly,
        "in-active-path": state.inActivePath,
        "in-checked-path": state.inCheckedPath,
        "is-active": state.isChecked,
        "is-disabled": disabled
      }
    }, events), [renderPrefix(), renderContent(), renderPostfix()]);
  }
});
exports.default = _sfc_main;
