"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleMoreClick", "handleItemClick", "visibleChange"];
const renderless = (props, { computed, reactive }, { emit, t, designConfig }) => {
  const api2 = {};
  const state = reactive({
    visibleOptions: computed(() => props.options.slice(0, state.maxShowNum)),
    isCardMode: computed(() => props.mode === "card"),
    moreOptions: computed(() => props.options.slice(state.maxShowNum)),
    spacing: computed(() => api2.computedSpacing()),
    maxShowNum: computed(() => api2.computedMaxShowNum()),
    moreText: computed(() => api2.computedMoreText()),
    suffixIcon: computed(() => api2.computedSuffixIcon())
  });
  Object.assign(api2, {
    state,
    handleMoreClick: index.handleMoreClick(emit),
    handleItemClick: index.handleItemClick(emit),
    visibleChange: index.visibleChange(emit),
    computedMaxShowNum: index.computedMaxShowNum({ props, state }),
    computedSpacing: index.computedSpacing({ props, state, designConfig }),
    computedMoreText: index.computedMoreText({ props, state, t }),
    computedSuffixIcon: index.computedSuffixIcon({ props, state })
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
