"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "setSheetStyle",
  "initScrollMenu",
  "visibleHandle",
  "watchVisible",
  "menuHandle",
  "close",
  "selectOption",
  "confirm",
  "actionSelectOption",
  "hide"
];
const renderless = (props, { reactive, watch }, { emit, nextTick, refs, vm }, { BScroll }) => {
  const state = reactive({
    toggle: false,
    sheetMaskStyle: {},
    sheetContentStyle: {},
    scroll: null
  });
  const api2 = {};
  Object.assign(api2, {
    state,
    setSheetStyle: index.setSheetStyle({ state, props }),
    initScrollMenu: index.initScrollMenu({ state, nextTick, refs, BScroll }),
    visibleHandle: index.visibleHandle({ emit, state }),
    watchVisible: index.watchVisible({ emit, state }),
    menuHandle: index.menuHandle({ state, emit }),
    confirm: index.confirm({ state, api: api2 }),
    selectOption: index.selectOption({ emit, props }),
    actionSelectOption: index.actionSelectOption({ emit }),
    hide: index.hide({ api: api2 }),
    close: index.close({ api: api2 }),
    handleClose: index.handleClose({ vm, emit, props })
  });
  watch(
    () => props.visible,
    (value) => {
      if (value) {
        api2.setSheetStyle({ state, props });
        api2.initScrollMenu({ state, nextTick, refs, BScroll });
      }
      api2.watchVisible(value);
    }
  );
  watch(() => props.visible, api2.watchVisible, { immediate: true });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
