"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "getContainer",
  "linkClick",
  "onItersectionObserver",
  "setScrollContainer",
  "getCurrentAnchor"
];
const renderless = (props, { onMounted, onUnmounted, onUpdated, reactive, watch }, { vm, emit, nextTick }) => {
  const api2 = {};
  const state = reactive({
    currentLink: "",
    observerLinks: {},
    expandLink: {},
    intersectionObserver: null,
    scrollContainer: null,
    currentHash: "",
    isScroll: false,
    scrollTimer: 0,
    childOffsetTop: 0
  });
  Object.assign(api2, {
    state,
    mounted: index.mounted({ state, api: api2, props, nextTick }),
    updated: index.updated({ api: api2 }),
    unmounted: index.unmounted({ state, api: api2 }),
    getContainer: index.getContainer({ props }),
    linkClick: index.linkClick({ state, vm, emit, props, api: api2 }),
    onItersectionObserver: index.onItersectionObserver({ state, props, api: api2, vm, emit }),
    setScrollContainer: index.setScrollContainer({ state, api: api2 }),
    getCurrentAnchor: index.getCurrentAnchor({ vm, state, emit }),
    setFixAnchor: index.setFixAnchor({ vm, props }),
    handleScroll: index.handleScroll(state)
  });
  onMounted(api2.mounted);
  onUpdated(api2.updated);
  onUnmounted(api2.unmounted);
  watch(
    () => props.links,
    () => {
      api2.mounted();
    }
  );
  watch(
    () => props.isAffix,
    () => {
      api2.setFixAnchor();
    }
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
