"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleClickNode", "handleClickLink", "handleClickBlank", "handleClickGroup", "refresh"];
const renderless = (props, { reactive, onMounted, onBeforeUnmount, markRaw }, { nextTick, vm, emit }, { Loading }) => {
  const state = reactive({
    loading: true,
    data: null,
    config: null
  });
  state.temporary = {};
  const api2 = {
    state,
    observeContainerSize: index.observeContainerSize({ nextTick, vm, state }),
    unobserveContainerSize: index.unobserveContainerSize(state),
    handleClickNode: index.handleClickNode(emit),
    handleClickLink: index.handleClickLink(emit),
    handleClickBlank: index.handleClickBlank(emit),
    handleClickGroup: index.handleClickGroup(emit)
  };
  Object.assign(api2, {
    fetchData: index.fetchData({ Loading, props, state, vm, markRaw, api: api2, nextTick }),
    refresh: index.refresh(api2)
  });
  onMounted(api2.fetchData);
  onBeforeUnmount(() => api2.unobserveContainerSize());
  return api2;
};
exports.api = api;
exports.renderless = renderless;
