"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "getRoute", "handleBulletinBoardClick"];
const renderless = (props, { reactive, computed, watch }, { emit }) => {
  const api2 = {};
  const state = reactive({
    actName: props.activeName,
    dataList: computed(() => api2.computedDataList()),
    moreLink: computed(() => api2.computedMoreLink())
  });
  watch(
    () => props.activeName,
    (value) => {
      state.actName = value;
    },
    { immediate: true }
  );
  Object.assign(api2, {
    state,
    getRoute: index.getRoute,
    computedDataList: index.computedDataList({ props, state }),
    computedMoreLink: index.computedMoreLink({ props }),
    handleBulletinBoardClick: index.handleBulletinBoardClick({ emit })
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
