"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const popupManager = require("../common/deps/popup-manager.js");
const toolClick = (showMoreTools) => (cb) => {
  typeof cb === "function" && cb();
  showMoreTools.value = false;
};
const computedMoreTools = ({ props }) => () => Array.isArray(props.tools) && props.tools.length > 3 ? props.tools.slice(2) : [];
const computedTools = ({ props, state, constants, refs, t }) => () => {
  let result = [];
  const tools = props.tools;
  if (Array.isArray(tools) && tools.length) {
    if (tools.length <= 3) {
      result = tools;
    } else {
      result = [].concat(tools[0], tools[1], {
        icon: constants.MOREICON,
        title: t("ui.base.more"),
        click() {
          state.showMoreTools = !state.showMoreTools;
          refs.selector.style.zIndex = popupManager.default.nextZIndex();
        }
      });
    }
  }
  return result;
};
exports.computedMoreTools = computedMoreTools;
exports.computedTools = computedTools;
exports.toolClick = toolClick;
