"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handelIconClick", "handleChange", "cardClick"];
const renderless = (props, { reactive, watch, computed }, { vm, parent, emit, constants, nextTick, dispatch }) => {
  const api2 = {};
  const state = reactive({
    cardGroup: {},
    selfModel: false,
    itemChecked: computed(() => api2.getItemChecked()),
    sliceNum: computed(() => api2.getSliceNum()),
    iconNum: computed(() => api2.getIconNum()),
    effectOptions: computed(() => props.options.filter((item) => !item.hidden)),
    store: computed(() => api2.computedStore()),
    customClass: computed(() => props.customClass || state.cardGroup.customClass || ""),
    autoWidth: computed(() => props.autoWidth || state.cardGroup.autoWidth),
    height: computed(() => props.height || state.cardGroup.height),
    status: computed(() => props.status || state.cardGroup.status || "default"),
    checkType: computed(() => props.checkType || state.cardGroup.checkType),
    type: computed(() => props.type || state.cardGroup.type || "text"),
    isCheckbox: computed(() => state.checkType === "checkbox"),
    isGroup: computed(() => api2.isGroup()),
    size: computed(() => api2.getSize()),
    disabled: computed(() => api2.isDisabled()),
    model: computed({
      get: () => api2.getModel(),
      set: (val) => api2.setModel(val)
    }),
    checkMode: computed(() => props.checkMode)
  });
  Object.assign(api2, {
    state,
    getSize: index.getSize({ props, state }),
    getModel: index.getModel({ props, state }),
    isGroup: index.isGroup({ constants, parent, state }),
    isDisabled: index.isDisabled({ props, state }),
    setModel: index.setModel({ constants, dispatch, emit, state }),
    handleChange: index.handleChange({ constants, dispatch, emit, state, nextTick }),
    cardClick: index.cardClick({ emit, state, props }),
    getSliceNum: index.getSliceNum({ state }),
    getIconNum: index.getIconNum({ state }),
    computedStore: index.computedStore({ state, props }),
    handelIconClick: index.handelIconClick({ emit }),
    getItemChecked: index.getItemChecked({ state, props })
  });
  watch(
    () => state.disabled,
    () => {
      state.effectOptions.forEach((item) => {
        item.disabled = item.disabled || state.disabled;
      });
    },
    { immediate: true }
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
