"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "close",
  "selectOption",
  "confirm",
  "searchMethod",
  "searchSelectHandler",
  "searchBoxToggle",
  "setLevel",
  "loadData",
  "renderSearchOption",
  "disabledNavOption",
  "isSelected"
];
const renderless = (props, { computed, reactive, watch }, { emit, constants }) => {
  const api2 = {};
  const state = reactive({
    toggle: false,
    loading: false,
    root: null,
    store: null,
    navList: [],
    rootData: [],
    level: 0,
    isLeaf: false,
    search: {
      show: false,
      input: "",
      options: [],
      filterOptions: []
    },
    options: computed(() => {
      let arr;
      let list = [state.rootData];
      state.navList.forEach((option) => {
        arr = option.childNodes;
        arr && arr.length && list.push(arr);
      });
      return list;
    }),
    checkIds: computed(() => state.navList.map((option) => option.data[props.valueField])),
    checkLabels: computed(() => state.navList.map((option) => option.data[props.textField])),
    waitLoadList: computed(
      () => state.navList.filter((option) => option.selfWaitLoad).map((option) => option.data[props.valueField])
    ),
    computedNavList: computed(() => api2.computedNavListHandler()),
    showButton: computed(() => {
      const len = state.navList.length;
      if (!props.nodeConfig.checkStrictly) {
        if (state.level < len - 1) {
          return false;
        }
      }
      return len && (props.nodeConfig.checkStrictly || state.navList[len - 1].isLeaf);
    })
  });
  Object.assign(api2, {
    state,
    confirm: index.confirm({ state, emit, api: api2 }),
    selectOption: index.selectOption({ state, emit, props, api: api2 }),
    close: index.close({ state, emit }),
    watchVisible: index.watchVisible({ emit, state, props, api: api2 }),
    watchModelValue: index.watchModelValue({ props, state, emit }),
    searchMethod: index.searchMethod({ state, props, api: api2 }),
    searchSelectHandler: index.searchSelectHandler({ emit, api: api2, props }),
    searchBoxToggle: index.searchBoxToggle({ state, props, api: api2 }),
    syncCheckStatus: index.syncCheckStatus({ state, props, api: api2 }),
    setLevel: index.setLevel({ state, api: api2 }),
    created: index.created({ api: api2 }),
    loadData: index.loadData({ state, props }),
    getNodeConfig: index.getNodeConfig({ constants, props }),
    initTreeStore: index.initTreeStore({ props, state, api: api2 }),
    renderSearchOption: index.renderSearchOption({ state }),
    computedNavListHandler: index.computedNavListHandler({ props, state }),
    disabledNavOption: index.disabledNavOption({ state }),
    isSelected: index.isSelected({ state })
  });
  api2.created();
  api2.syncCheckStatus();
  watch(() => props.visible, api2.watchVisible);
  watch(() => props.modelValue, api2.watchModelValue, { immediate: true, deep: true });
  watch(() => props.data, api2.loadData, { deep: true });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
