"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleMultiCheckChange", "handleCheckChange", "handleExpand", "handleNodeClick"];
const renderless = (props, { computed, reactive, inject }, { dispatch }) => {
  const parent = inject("panel");
  const api2 = {};
  const state = reactive({
    config: computed(() => parent.state.config),
    isLeaf: computed(() => props.node.isLeaf),
    isDisabled: computed(() => props.node.isDisabled),
    checkedValue: computed(() => parent.state.checkedValue),
    isChecked: computed(() => props.node.isSameNode(state.checkedValue)),
    inActivePath: computed(() => api2.isInPath(parent.state.activePath)),
    inCheckedPath: computed(() => api2.comptCheckPath()),
    value: computed(() => props.node.getValueByOption()),
    nodeLabel: computed(() => {
      return parent.state.renderLabelFn ? parent.state.renderLabelFn({ node: props.node, data: props.node.data }) : props.node.label;
    })
  });
  Object.assign(api2, {
    state,
    isInPath: index.isInPath(props),
    handleExpand: index.handleExpand({ api: api2, props, parent, state }),
    comptCheckPath: index.comptCheckPath({ api: api2, parent, state }),
    handleCheckChange: index.handleCheckChange({ api: api2, parent, dispatch, state }),
    handleMultiCheckChange: index.handleMultiCheckChange({ parent, props }),
    handleNodeClick: index.handleNodeClick({ state, api: api2 })
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
