"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const chunkG2ADBYYC = require("../chunk-G2ADBYYC.js");
const index$1 = require("./index.js");
const object = require("../common/object.js");
const index = require("../cascader/index.js");
const store = require("./store.js");
const api = [
  "state",
  "handleKeyDown",
  "getCheckedNodes",
  "clearCheckedNodes",
  "scrollIntoView",
  "handleExpand",
  "handleCheckChange",
  "getNodeByValue",
  "calculateMultiCheckedValue",
  "lazyLoad",
  "getFlattedNodes"
];
const initDefaultProps = () => ({
  expandTrigger: "click",
  multiple: false,
  checkStrictly: false,
  emitPath: true,
  lazy: false,
  lazyLoad: () => void 0,
  value: "value",
  label: "label",
  children: "children",
  leaf: "leaf",
  disabled: "disabled",
  hoverThreshold: 500
});
const initState = ({ reactive, props, computed, parent, slots }) => {
  const DefaultProps = initDefaultProps();
  const state = reactive({
    checkedValue: null,
    checkedNodePaths: [],
    store: [],
    menus: [],
    activePath: [],
    loadCount: 0,
    config: computed(() => object.merge(chunkG2ADBYYC.__spreadValues({}, DefaultProps), props.props || {})),
    multiple: computed(() => state.config.multiple),
    checkStrictly: computed(() => state.config.checkStrictly),
    leafOnly: computed(() => !state.checkStrictly),
    isHoverMenu: computed(() => state.config.expandTrigger === "hover"),
    renderLabelFn: computed(
      () => {
        var _a;
        return props.renderLabel || slots.default || ((_a = parent.$parent) == null ? void 0 : _a.$options.componentName) === "TinyCascader" && parent.$parent.$scopedSlots.default;
      }
    )
  });
  return state;
};
const initApi = ({
  api: api2,
  state,
  menus,
  props,
  nextTick,
  parent,
  emit
}) => {
  Object.assign(api2, {
    state,
    isLeaf: index$1.isLeaf(),
    getMenuIndex: index$1.getMenuIndex(),
    getNodeByValue: index$1.getNodeByValue(state),
    getFlattedNodes: index$1.getFlattedNodes(state),
    handleCheckChange: index$1.handleCheckChange(state),
    scrollIntoView: index$1.scrollIntoView({ menus }),
    syncActivePath: index$1.syncActivePath({ api: api2, state }),
    initStore: index$1.initStore({ api: api2, props, state, Store: store.default }),
    syncMenuState: index$1.syncMenuState({ api: api2, nextTick, state }),
    syncMultiCheckState: index$1.syncMultiCheckState({ api: api2, state }),
    calculateCheckedNodePaths: index$1.calculateCheckedNodePaths({ api: api2, state }),
    lazyLoad: index$1.lazyLoad({ api: api2, $parent: parent, state, Store: store.default, emit }),
    syncCheckedValue: index$1.syncCheckedValue({ api: api2, props, state }),
    focusNode: index$1.focusNode(api2),
    checkNode: index$1.checkNode(api2),
    expandNodes: index$1.expandNodes(api2),
    handleExpand: index$1.handleExpand({ emit, state }),
    getCheckedNodes: index$1.getCheckedNodes({ api: api2, state }),
    clearCheckedNodes: index$1.clearCheckedNodes({ api: api2, state }),
    calculateMultiCheckedValue: index$1.calculateMultiCheckedValue({ api: api2, state }),
    watchCheckedValue: index$1.watchCheckedValue({ api: api2, emit, props, state }),
    handleKeyDown: index$1.handleKeyDown({ api: api2, emit, menus })
  });
};
const initWatch = ({
  watch,
  state,
  props,
  api: api2
}) => {
  watch(
    () => props.options,
    () => api2.initStore(),
    { deep: true, immediate: true }
  );
  watch(
    () => props.modelValue,
    () => {
      api2.syncCheckedValue();
      state.checkStrictly && api2.calculateCheckedNodePaths();
    }
  );
  watch(
    () => state.checkedValue,
    (value) => {
      api2.watchCheckedValue(value);
    },
    { deep: true }
  );
};
const renderless = (props, { computed, onMounted, reactive, watch }, { nextTick, emit, parent, childrenHandler, slots }) => {
  const api2 = {};
  const menus = [];
  const state = initState({ reactive, props, computed, parent, slots });
  childrenHandler(({ vm }) => {
    menus.push(vm);
  });
  initApi({ api: api2, state, menus, props, nextTick, parent, emit });
  initWatch({ watch, state, props, api: api2 });
  onMounted(() => !index.isEmpty(props.modelValue) && api2.syncCheckedValue());
  return api2;
};
exports.api = api;
exports.renderless = renderless;
