"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const usePicker = require("./usePicker.js");
const api = [
  "state",
  "close",
  "confirm",
  "clear",
  "columnsType",
  "columnsList",
  "columnFieldNames",
  "changeHandler",
  "defaultValues",
  "isDisabled",
  "selectedOptions",
  "columnStyle"
];
const renderless = (props, { reactive, computed, watch, ref, toRefs }, { emit, vm }) => {
  const state = reactive({
    actionSheetVisible: false,
    visibleOptionNum: 5
  });
  const {
    changeHandler,
    defaultValues,
    columnsList,
    columnsType,
    columnFieldNames,
    selectedOptions,
    setValue,
    isDisabled
  } = usePicker.usePicker({ ref, reactive, watch, computed, toRefs, props });
  const api2 = {
    state
  };
  Object.assign(api2, {
    close: index.close(state),
    clear: index.clear({ api: api2, emit }),
    confirm: index.confirm({ api: api2, emit, defaultValues, selectedOptions, isDisabled, vm }),
    watchActionSheetVisible: index.watchActionSheetVisible({ emit, api: api2, props }),
    columnsType,
    columnsList,
    columnFieldNames,
    changeHandler,
    defaultValues,
    selectedOptions,
    setValue,
    isDisabled,
    columnStyle: index.columnStyle({ props, computed })
  });
  watch(
    () => props.visible,
    (value) => state.actionSheetVisible = value
  );
  watch(
    () => state.actionSheetVisible,
    (value) => api2.watchActionSheetVisible(value)
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
