"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "close",
  "clean",
  "confirm",
  "setLevel",
  "loadData",
  "nodeExpand",
  "selectOption",
  "searchMethod",
  "searchBoxToggle",
  "searchSelectHandler",
  "renderSearchOption",
  "disabledNavOption",
  "toggleCheckList",
  "inputKeyword",
  "removeOption",
  "getCheckedNodes",
  "isSelected"
];
const renderless = (props, { computed, reactive, watch }, { t, emit, constants }) => {
  const api2 = {};
  const state = reactive({
    toggle: false,
    loading: false,
    root: null,
    store: null,
    checkList: [],
    level: 0,
    rootData: [],
    navList: [],
    waitLoadCheckList: [],
    search: {
      loaded: false,
      show: false,
      input: "",
      filterOptions: [],
      options: []
    },
    selected: {
      removeList: [],
      options: [],
      show: false,
      waitLoadList: []
    },
    options: computed(() => {
      let data;
      let list = [state.rootData];
      state.navList.map((option) => {
        data = option.childNodes;
        data && data.length && list.push(data);
      });
      return list;
    }),
    computedNavList: computed(() => api2.computedNavListHandler()),
    computedCheckList: computed(() => [...state.waitLoadCheckList, ...state.checkList]),
    computedSelectedList: computed(() => api2.computedSelectedListHandler()),
    checkIds: computed(() => state.computedSelectedList.map((option) => option.data[props.valueField])),
    checkLabels: computed(() => state.computedSelectedList.map((option) => option.data[props.textField]))
  });
  Object.assign(api2, {
    state,
    created: index.created({ api: api2 }),
    close: index.close({ state, emit }),
    clean: index.clean({ state }),
    setLevel: index.setLevel({ state, api: api2 }),
    loadData: index.loadData({ state, props }),
    confirm: index.confirm({ state, emit, props }),
    selectOption: index.selectOption({ emit, state, api: api2 }),
    searchMethod: index.searchMethod({ state, props, api: api2 }),
    initTreeStore: index.initTreeStore({ props, state, api: api2 }),
    searchBoxToggle: index.searchBoxToggle({ state, props, api: api2 }),
    syncCheckStatus: index.syncCheckStatus({ state, api: api2 }),
    getNodeConfig: index.getNodeConfig({ constants, props }),
    watchVisible: index.watchVisible({ emit, state, props, api: api2 }),
    watchModelValue: index.watchModelValue({ props, state, emit }),
    loopSearchOption: index.loopSearchOption({ state, api: api2, props }),
    filterOptionsHandler: index.filterOptionsHandler({ state, props }),
    searchSelectHandler: index.searchSelectHandler({ emit, api: api2 }),
    renderSearchOption: index.renderSearchOption({ state }),
    computedNavListHandler: index.computedNavListHandler({ props, state, t }),
    computedSelectedListHandler: index.computedSelectedListHandler({ state }),
    disabledNavOption: index.disabledNavOption({ state }),
    inputKeyword: index.inputKeyword({ state, api: api2 }),
    removeOption: index.removeOption({ state }),
    isSelected: index.isSelected({ state }),
    nodeExpand: index.nodeExpand({ emit, state, props, api: api2 }),
    toggleCheckList: index.toggleCheckList({ state, props, api: api2 }),
    getCheckedNodes: index.getCheckedNodes({ state })
  });
  api2.created();
  watch(() => props.data, api2.loadData, { deep: true });
  watch(() => props.modelValue, api2.watchModelValue, { immediate: true, deep: true });
  watch(() => props.visible, api2.watchVisible);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
