"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const index$1 = require("../checkbox/index.js");
const api = ["state", "handleChange"];
const initState = ({ reactive, computed, api: api2 }) => {
  const state = reactive({
    focus: false,
    selfModel: false,
    isLimitExceeded: false,
    model: computed({
      get: () => api2.computedGetModelGet(),
      set: (value) => api2.computedGetModelSet(value)
    }),
    size: computed(() => api2.computedSize()),
    store: computed(() => api2.computedStore()),
    isChecked: computed(() => api2.computedIsChecked()),
    isDisabled: computed(() => api2.computedIsDisabled()),
    activeStyle: computed(() => api2.computedActiveStyle()),
    checkboxGroup: computed(() => api2.computedCheckboxGroup()),
    isLimitDisabled: computed(() => api2.computedIsLimitDisabled()),
    showText: computed(() => api2.computedShowText()),
    isShowText: computed(() => api2.computedIsShowText())
  });
  return state;
};
const initApi = ({ api: api2, state, props, formItemSize, parent, constants, emit, nextTick, dispatch }) => {
  Object.assign(api2, {
    state,
    addToStore: index$1.addToStore({ state, props }),
    computedStore: index$1.computedStore({ state, props }),
    computedActiveStyle: index.computedActiveStyle(state),
    computedFormItemSize: index.computedFormItemSize(props),
    computedSize: index.computedSize({ state, formItemSize }),
    computedIsChecked: index$1.computedIsChecked({ state, props }),
    computedIsLimitDisabled: index$1.computedIsLimitDisabled(state),
    computedIsDisabled: index.computedIsDisabled({ state, props }),
    computedGetModelGet: index.computedGetModelGet({ state, props }),
    computedCheckboxGroup: index.computedCheckboxGroup({ parent, constants }),
    handleChange: index.handleChange({ state, props, emit, nextTick, dispatch, constants }),
    computedGetModelSet: index.computedGetModelSet({ state, props, emit, dispatch, constants }),
    computedIsShowText: index$1.computedIsShowText({ props }),
    computedShowText: index$1.computedShowText({ props })
  });
};
const renderless = (props, { computed, onMounted, onBeforeUnmount, reactive }, { parent, emit, dispatch, constants, nextTick }) => {
  const api2 = {};
  const formItemSize = computed(() => api2.computedFormItemSize());
  const state = initState({ reactive, computed, api: api2 });
  initApi({ api: api2, state, props, formItemSize, parent, constants, emit, nextTick, dispatch });
  onBeforeUnmount(() => {
    index.toggleEvent({ parent, props, type: "remove" });
  });
  onMounted(() => {
    index.toggleEvent({ parent, props, type: "add" });
    props.checked && api2.addToStore();
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
