"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state"];
const renderless = (props, { computed, reactive, watch, provide }, { dispatch, constants }) => {
  const api2 = {
    computedFormItemSize: index.computedFormItemSize(props)
  };
  const formItemSize = computed(() => api2.computedFormItemSize());
  const state = reactive({
    checkboxGroupSize: computed(() => api2.computedCheckboxGroupSize())
  });
  Object.assign(api2, {
    state,
    computedCheckboxGroupSize: index.computedCheckboxGroupSize({ props, formItemSize })
  });
  watch(
    () => props.modelValue,
    (value) => dispatch(constants.FORM_ITEM, constants.FORM_CHANGE, [value])
  );
  provide("size", props.size);
  provide("vertical", props.vertical);
  provide("iconPosition", props.iconPosition);
  provide("shape", props.shape);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
