"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state"];
const renderless = (props, { computed, reactive, inject }, { parent }) => {
  const api2 = {};
  const state = reactive({
    row: computed(() => api2.row()),
    style: computed(() => api2.getStyle()),
    className: computed(() => api2.getClassName()),
    layout: inject("layout", {})
  });
  Object.assign(api2, {
    state,
    row: index.row(parent),
    setGlobalAttrValue: index.setGlobalAttrValue,
    setSubitemAttrValue: index.setSubitemAttrValue,
    getStyle: index.getStyle({ props, state }),
    getClassName: index.getClassName({ api: api2, props, state })
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
