"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state"];
const renderless = (props, { reactive, watch }, { parent, emit, constants }) => {
  const eventName = constants.EVENT_NAME.CollapseItemClick;
  const state = reactive({
    activeNames: []
  });
  const api2 = {
    state,
    setActiveNames: index.setActiveNames({ emit, props, state })
  };
  api2.handleItemClick = index.handleItemClick({ api: api2, props, state });
  watch(
    () => props.modelValue,
    (value) => {
      state.activeNames = value || value === 0 ? [].concat(value) : [];
    },
    { immediate: true, deep: true }
  );
  parent.$on(eventName, api2.handleItemClick);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
