"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const color = require("./utils/color.js");
const api = ["state", "changeVisible", "onConfirm", "onCancel", "onHueUpdate", "onSVUpdate", "onColorUpdate"];
const renderless = (props, ctx, { emit }) => {
  var _a, _b, _c;
  const { modelValue, visible, predefine, size, history } = ctx.toRefs(props);
  const isShow = ctx.ref(visible.value);
  const hex = ctx.ref((_a = modelValue.value) != null ? _a : "transparent");
  const stack = ctx.ref([...(_b = history == null ? void 0 : history.value) != null ? _b : []]);
  const predefineStack = ctx.ref([...(_c = predefine == null ? void 0 : predefine.value) != null ? _c : []]);
  ctx.watch(
    predefine,
    (newPredefine) => {
      predefineStack.value = [...newPredefine];
    },
    { deep: true }
  );
  ctx.watch(
    history,
    (newHistory) => {
      stack.value = [...newHistory];
    },
    { deep: true }
  );
  const state = ctx.reactive({
    isShow,
    hex,
    triggerBg: ctx.ref(modelValue.value),
    size,
    stack,
    predefineStack,
    enablePredefineColor: ctx.computed(() => props.enablePredefineColor),
    enableHistory: ctx.computed(() => props.enableHistory)
  });
  const color$1 = new color.Color({
    value: props.modelValue,
    format: props.format,
    enableAlpha: props.alpha
  });
  ctx.watch(
    () => [props.alpha, props.format],
    () => {
      color$1.enableAlpha = props.alpha;
      color$1.format = props.format || color$1.format;
      color$1.onChange();
      index.updateModelValue(color$1.value, emit);
    }
  );
  ctx.watch(
    () => props.modelValue,
    () => {
      color$1.fromString(props.modelValue);
      const { r, g, b, a } = color$1.toRgba();
      state.hex = `rgba(${r}, ${g}, ${b}, ${a})`;
    }
  );
  const changeVisible = index.toggleVisible(isShow);
  const { onConfirm, onCancel } = index.useEvent(state, emit, changeVisible, color$1);
  const api2 = {
    state,
    changeVisible,
    onConfirm,
    onCancel
  };
  return api2;
};
exports.api = api;
exports.renderless = renderless;
