"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const useDrag = require("../utils/use-drag.js");
const index = require("./index.js");
const api = ["state", "color", "slider", "alphaWrapper", "alphaThumb", "onClick"];
const renderless = (props, hooks, utils) => {
  const { onMounted, ref } = hooks;
  const { emit } = utils;
  const slider = ref();
  const alphaWrapper = ref();
  const alphaThumb = ref();
  const state = index.initState(hooks);
  const { update, onClick, onDrag } = index.useEvent(state, slider, alphaWrapper, alphaThumb, props);
  onMounted(() => {
    if (!slider.value || !alphaThumb.value) {
      return;
    }
    const dragConfig = {
      drag: (event) => {
        onDrag(event);
      },
      end: (event) => {
        onDrag(event);
      }
    };
    useDrag.draggable(slider.value, dragConfig);
    useDrag.draggable(alphaThumb.value, dragConfig);
    update();
    emit("ready", update);
  });
  index.initWatch(props, update, hooks);
  const api2 = {
    state,
    slider,
    alphaWrapper,
    alphaThumb,
    onClick
  };
  return api2;
};
exports.api = api;
exports.renderless = renderless;
