"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const useDrag = require("../utils/use-drag.js");
const index = require("./index.js");
const api = ["state", "onSvReady", "bar", "thumb", "wrapper"];
const renderless = (props, hooks, utils) => {
  const { onMounted } = hooks;
  const { emit } = utils;
  const { thumb, bar, wrapper } = index.initDom(hooks);
  const state = index.initState(props, hooks);
  const { onSvReady, onDrag, update } = index.useEvent({ thumb, bar }, state, props, utils);
  const api2 = {
    state,
    onSvReady,
    bar,
    thumb,
    wrapper
  };
  onMounted(() => {
    if (!bar.value || !thumb.value) {
      return;
    }
    const dragConfig = {
      drag: (event) => {
        onDrag(event);
      },
      end: (event) => {
        onDrag(event);
      }
    };
    useDrag.draggable(bar.value, dragConfig);
    useDrag.draggable(thumb.value, dragConfig);
    emit("hueReady", update);
    update();
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
