"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const useDrag = require("../utils/use-drag.js");
const index = require("./index.js");
const api = ["state", "wrapper", "cursor"];
const renderless = (props, hooks, utils) => {
  const state = index.initState(props, hooks);
  const { ref, onMounted } = hooks;
  const { emit } = utils;
  const wrapper = ref();
  const update = index.useUpdate(state, props, wrapper);
  const onDrag = index.useDrag(state, wrapper, props, utils);
  index.initWatch(state, update, hooks);
  onMounted(() => {
    const drag = {
      drag: (event) => {
        onDrag(event);
      },
      end: (event) => {
        onDrag(event);
      }
    };
    useDrag.draggable(wrapper.value, drag);
    update();
    emit("ready", update);
  });
  const api2 = { state, wrapper };
  return api2;
};
exports.api = api;
exports.renderless = renderless;
