"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handelIconClick", "handleChange"];
const renderless = (props, { reactive, computed }, { vm, parent, emit, nextTick, dispatch, constants }) => {
  const api2 = {};
  const state = reactive({
    columnGroup: {},
    type: computed(() => api2.getType()),
    size: computed(() => api2.getSize()),
    disabled: computed(() => api2.isDisabled()),
    itemChecked: computed(() => api2.getItemChecked()),
    sliceNum: computed(() => props.size === "small" ? 1 : 2),
    iconNum: computed(() => props.size === "small" ? 2 : 3),
    showCheckbox: computed(() => props.showCheckbox || state.columnGroup.showCheckbox),
    showRadio: computed(() => props.showRadio || state.columnGroup.showRadio),
    store: computed(() => api2.computedStore()),
    effectOptions: computed(() => api2.computedOptions()),
    isGroup: computed(() => api2.getIsGroup()),
    model: computed({
      get: () => api2.getModel(),
      set: (val) => api2.setModel(val)
    })
  });
  Object.assign(api2, {
    state,
    getIsGroup: index.getIsGroup({ constants, parent, state }),
    isDisabled: index.isDisabled({ props, state }),
    setModel: index.setModel({ constants, dispatch, emit, state }),
    getSize: index.getSize({ props, state }),
    getModel: index.getModel({ props, state }),
    handleChange: index.handleChange({ constants, dispatch, emit, state, nextTick }),
    computedStore: index.computedStore({ state, props }),
    handelIconClick: index.handelIconClick({ emit }),
    getItemChecked: index.getItemChecked({ state, props }),
    computedOptions: index.computedOptions({ props }),
    getType: index.getType({ props, state })
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
