"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const opentinyUtils_es = require("../../../../../@opentiny_utils@1.0.0/node_modules/@opentiny/utils/dist/opentiny-utils.es.js");
const KEY_CODE = {
  Backspace: 8,
  Tab: 9,
  Enter: 13,
  Escape: 27,
  Space: 32,
  PageUp: 33,
  PageDown: 34,
  End: 35,
  Home: 36,
  "ArrowLeft": 37,
  "ArrowUp": 38,
  "ArrowRight": 39,
  "ArrowDown": 40,
  Delete: 46,
  AtMark: 64,
  KeyA: 65,
  "KeyF": 70,
  KeyV: 86,
  "NumpadEnter": 13,
  NumpadDecimal: 110,
  NumpadComma: 190
};
const POSITION = { Left: "left", Right: "right", Top: "top", Bottom: "bottom" };
const REFRESH_INTERVAL = 100;
const IPTHRESHOLD = { Min: 0, Max: 255, NonNumeric: 25 };
const DATE = {
  Datetime: "yyyy-MM-dd hh:mm",
  Date: "yyyy-MM-dd"
};
const TriggerTypes = "date,datetime,time,time-select,week,month,year,years,yearrange,daterange,monthrange,timerange,datetimerange,dates,quarter";
const DATEPICKER = {
  Day: "day",
  Date: "date",
  Dates: "dates",
  Year: "year",
  Years: "years",
  YearRange: "yearrange",
  PanelYearNum: 12,
  Month: "month",
  Week: "week",
  Normal: "normal",
  Today: "today",
  PreMonth: "pre-month",
  NextMonth: "next-month",
  YearI18n: "ui.datepicker.year",
  List: [38, 40, 37, 39],
  YearObj: { 38: -4, 40: 4, 37: -1, 39: 1 },
  WeekObj: { 38: -1, 40: 1, 37: -1, 39: 1 },
  DayObj: { 38: -7, 40: 7, 37: -1, 39: 1 },
  Aviailable: "available",
  Default: "default",
  Current: "current",
  InRange: "in-range",
  StartDate: "start-date",
  EndDate: "end-date",
  Selected: "selected",
  Disabled: "disabled",
  Range: "range",
  fullMonths: "January,February,March,April,May,June,July,August,September,October,November,December".split(","),
  fullWeeks: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
  MonhtList: ["jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sep", "oct", "nov", "dec"],
  Weeks: ["sun", "mon", "tue", "wed", "thu", "fri", "sat"],
  PlacementMap: {
    left: "bottom-start",
    center: "bottom",
    right: "bottom-end"
  },
  QuarterMap: {
    0: 0,
    1: 3,
    2: 6,
    3: 9
  },
  MonthQuarterMap: {
    0: 1,
    3: 2,
    6: 3,
    9: 4
  },
  TriggerTypes: TriggerTypes.split(","),
  DateFormats: {
    year: "yyyy",
    years: "yyyy",
    yearrange: "yyyy",
    month: "yyyy-MM",
    time: "HH:mm:ss",
    week: "yyyywWW",
    date: "yyyy-MM-dd",
    timerange: "HH:mm:ss",
    monthrange: "yyyy-MM",
    daterange: "yyyy-MM-dd",
    datetime: "yyyy-MM-dd HH:mm:ss",
    datetimerange: "yyyy-MM-dd HH:mm:ss"
  },
  Time: "time",
  TimeRange: "timerange",
  Quarter: "quarter",
  IconTime: "icon-time",
  IconDate: "icon-Calendar",
  DateRange: "daterange",
  DateTimeRange: "datetimerange",
  MonthRange: "monthrange",
  TimeSelect: "time-select",
  TimesTamp: "timestamp",
  DateTime: "datetime",
  SelectbaleRange: "selectableRange",
  Start: "09:00",
  End: "18:00",
  Step: "00:30",
  CompareOne: "-1:-1",
  CompareHundred: "100:100",
  selClass: ".selected",
  queryClass: ".tiny-picker-panel__content",
  disableClass: ".time-select-item:not(.disabled)",
  defaultClass: ".default",
  Qurtyli: '[data-tag="li"]',
  MappingKeyCode: { 40: 1, 38: -1 },
  DatePicker: "DatePicker",
  TimePicker: "TimePicker"
};
const BROWSER_NAME = {
  IE: "ie",
  Edge: "edge"
};
const MOUSEDELTA = 120;
const VALIDATE_STATE = {
  Validating: "validating",
  Success: "success",
  Error: "error"
};
const CASCADER = {
  SvgStr: '<path style="pointer-events: auto;" fill="transparent" d="M',
  CascaderNodeExpand: '.tiny-cascader-node[aria-expanded="true"]',
  CascaderNodeTab: '.tiny-cascader-node[tabindex="-1"]',
  ScrollWrap: ".tiny-scrollbar__wrap",
  CascaderActice: ".tiny-cascader-node.is-active",
  ActivePath: ".tiny-cascader-node.in-active-path",
  SugItem: ".tiny-cascader__suggestion-item",
  CascaderMenu: ".tiny-cascader-menu",
  InputClass: ".tiny-input__inner",
  TagClass: ".tiny-cascader__tags",
  ListClass: ".tiny-cascader__suggestion-list",
  PropsExpandTri: "expandTrigger",
  PropsCheckStric: "checkStrictly",
  PropsHover: "hoverThreshold",
  MenuConnector: "cascader-menu-"
};
const log = (data, type = "log") => {
  opentinyUtils_es.log.logger[type](data);
};
exports.xss = opentinyUtils_es.xss;
exports.BROWSER_NAME = BROWSER_NAME;
exports.CASCADER = CASCADER;
exports.DATE = DATE;
exports.DATEPICKER = DATEPICKER;
exports.IPTHRESHOLD = IPTHRESHOLD;
exports.KEY_CODE = KEY_CODE;
exports.MOUSEDELTA = MOUSEDELTA;
exports.POSITION = POSITION;
exports.REFRESH_INTERVAL = REFRESH_INTERVAL;
exports.VALIDATE_STATE = VALIDATE_STATE;
exports.log = log;
