"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const util = require("../util.js");
const type = require("../../type.js");
const string = require("../../string.js");
function getErro({ min, max, val, key, rule, errors, util: util2, options }) {
  if (min && !max && val < rule.min) {
    errors.push(util2.format(options.messages[key].min, "", rule.min));
  } else if (max && !min && val > rule.max) {
    errors.push(util2.format(options.messages[key].max, "", rule.max));
  } else if (min && max && (val < rule.min || val > rule.max)) {
    errors.push(util2.format(options.messages[key].range, "", rule.min, rule.max));
  }
}
function range_default(rule, checkValue, source, errors, options) {
  const len = type.isNumber(rule.len);
  const min = type.isNumber(rule.min);
  const max = type.isNumber(rule.max);
  let val = checkValue;
  let key = null;
  const num = type.isNumber(Number(checkValue));
  const str = typeof checkValue === "string";
  const arr = Array.isArray(checkValue);
  if (num) {
    key = "number";
  } else if (str) {
    key = "string";
  } else if (arr) {
    key = "array";
  }
  if (!key) {
    return false;
  }
  if (arr) {
    val = checkValue.length;
  }
  if (str) {
    val = string.getLength(checkValue, "string");
  }
  if (rule.type === "number") {
    val = checkValue;
  }
  if (len) {
    if (val !== rule.len) {
      errors.push(util.format(options.messages[key].len, "", rule.len));
    }
  } else {
    getErro({ min, max, val, key, rule, errors, util, options });
  }
}
exports.default = range_default;
