"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../rules/index.js");
const util = require("../util.js");
const type = require("../../type.js");
function date_default(rule, checkValue, callback, source, options) {
  const errors = [];
  const validate = rule.required || !rule.required && type.hasOwn.call(source, rule.field);
  const isValidDateStr = (value) => value && typeof value === "string" && new Date(value).toString() !== "Invalid Date";
  if (validate) {
    if (util.isEmptyValue(checkValue) && !rule.required) {
      return callback();
    }
    index.default.required({ rule, checkValue, source, errors, options });
    if (!util.isEmptyValue(checkValue)) {
      let dateObject;
      if (typeof checkValue === "number" || isValidDateStr(checkValue)) {
        dateObject = new Date(checkValue);
      } else {
        dateObject = checkValue;
      }
      index.default.type(rule, dateObject, source, errors, options);
      if (dateObject && typeof dateObject.getTime === "function") {
        index.default.range(rule, dateObject.getTime(), source, errors, options);
      }
    }
  }
  callback(errors);
}
exports.default = date_default;
