"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const index = require("../rules/index.js");
const util = require("../util.js");
const type = require("../../type.js");
function type_default(rule, checkValue, callback, source, options) {
  const ruleType = rule.type;
  const errors = [];
  const validate = rule.required || !rule.required && type.hasOwn.call(source, rule.field);
  if (validate) {
    if (util.isEmptyValue(checkValue, ruleType) && !rule.required) {
      return callback();
    }
    index.default.required({
      rule,
      checkValue,
      source,
      errors,
      options,
      type: ruleType
    });
    if (!util.isEmptyValue(checkValue, ruleType)) {
      index.default.type(rule, checkValue, source, errors, options);
    }
  }
  callback(errors);
}
exports.default = type_default;
