"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const type = require("../common/type.js");
const computedShowHeader = ({ constants, props }) => () => props.pattern !== constants.SIMPLE;
const computedShowFooter = ({ constants, props }) => () => props.pattern === constants.LEGEND || props.pattern === constants.CLASSIC;
const computedShowAside = ({ constants, props }) => () => props.pattern !== constants.CLASSIC;
const transferWidthOrHeight = (value) => type.isNumber(value) ? value + "px" : value;
const computedHeaderStyle = ({ constants, props }) => () => {
  if (props.pattern === constants.FASHION) {
    return {
      height: transferWidthOrHeight(props.headerHeight),
      left: transferWidthOrHeight(props.asideWidth)
    };
  }
  return {
    height: transferWidthOrHeight(props.headerHeight)
  };
};
const computedAsideStyle = ({ constants, props }) => () => {
  if (props.pattern === constants.SIMPLE || props.pattern === constants.FASHION) {
    return {
      top: transferWidthOrHeight(0),
      width: transferWidthOrHeight(props.asideWidth)
    };
  }
  return {
    width: transferWidthOrHeight(props.asideWidth),
    top: transferWidthOrHeight(props.headerHeight)
  };
};
const computedMainStyle = ({ constants, props }) => () => {
  if (props.pattern === constants.DEFAULT || props.pattern === constants.FASHION) {
    return {
      top: transferWidthOrHeight(props.headerHeight),
      left: transferWidthOrHeight(props.asideWidth),
      bottom: transferWidthOrHeight(0)
    };
  }
  if (props.pattern === constants.LEGEND) {
    return {
      top: transferWidthOrHeight(props.headerHeight),
      left: transferWidthOrHeight(props.asideWidth),
      bottom: transferWidthOrHeight(props.footerHeight)
    };
  }
  if (props.pattern === constants.SIMPLE) {
    return {
      top: transferWidthOrHeight(0),
      left: transferWidthOrHeight(props.asideWidth),
      bottom: transferWidthOrHeight(0)
    };
  }
  if (props.pattern === constants.CLASSIC) {
    return {
      top: transferWidthOrHeight(props.headerHeight),
      left: transferWidthOrHeight(0),
      bottom: transferWidthOrHeight(props.footerHeight)
    };
  }
};
const computedFooterStyle = ({ constants, props }) => () => {
  if (props.pattern === constants.CLASSIC) {
    return {
      height: transferWidthOrHeight(props.footerHeight),
      left: transferWidthOrHeight(0)
    };
  } else if (props.pattern === constants.LEGEND) {
    return {
      height: transferWidthOrHeight(props.footerHeight),
      left: transferWidthOrHeight(props.asideWidth)
    };
  }
  return {
    height: transferWidthOrHeight(props.footerHeight)
  };
};
const computedLeftStyle = ({ constants, props }) => () => {
  return {
    width: transferWidthOrHeight(props.leftWidth)
  };
};
const computedShowRight = ({ constants, props }) => () => {
  return props.pattern === constants.DEFAULT ? false : true;
};
const computedRightStyle = ({ constants, props }) => () => {
  return {
    width: transferWidthOrHeight(props.rightWidth)
  };
};
exports.computedAsideStyle = computedAsideStyle;
exports.computedFooterStyle = computedFooterStyle;
exports.computedHeaderStyle = computedHeaderStyle;
exports.computedLeftStyle = computedLeftStyle;
exports.computedMainStyle = computedMainStyle;
exports.computedRightStyle = computedRightStyle;
exports.computedShowAside = computedShowAside;
exports.computedShowFooter = computedShowFooter;
exports.computedShowHeader = computedShowHeader;
exports.computedShowRight = computedShowRight;
