"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "change", "emit"];
const renderless = (props, { watch, reactive }, { service, emit }) => {
  const $service = index.initService({ props, service });
  const state = reactive({
    source: null,
    options: [],
    selectedValue: props.modelValue
  });
  const api2 = {
    state,
    emit,
    change: index.change(emit),
    init: index.init({ state, service: $service })
  };
  watch(
    () => props.modelValue,
    (newValue) => {
      state.selectedValue = newValue;
    },
    { immediate: true }
  );
  api2.init();
  return api2;
};
exports.api = api;
exports.renderless = renderless;
