"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "change", "toogleDefaultCurrency", "visibleChange"];
const renderless = (props, { watch, reactive, computed }, { service, emit }) => {
  const api2 = {};
  const $service = index.initService({ props, service });
  const state = reactive({
    options: [],
    selectedValue: props.modelValue,
    defaultCurrency: "",
    searchConfig: computed(() => api2.computedSearchConfig())
  });
  Object.assign(api2, {
    state,
    change: index.change(emit),
    visibleChange: index.visibleChange(emit),
    fixServiceData: index.fixServiceData({ props, service: $service }),
    init: index.init({ state, service: $service, api: api2 }),
    fetchDefaultCurrency: index.fetchDefaultCurrency({ state, props, emit, service: $service }),
    toogleDefaultCurrency: index.toogleDefaultCurrency({ state, service: $service }),
    computedSearchConfig: index.computedSearchConfig({ props, service: $service })
  });
  watch(
    () => props.modelValue,
    (param) => {
      state.selectedValue = param;
    },
    { immediate: true }
  );
  api2.init();
  api2.fetchDefaultCurrency();
  return api2;
};
exports.api = api;
exports.renderless = renderless;
