"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const index$1 = require("../common/index.js");
const api = [
  "state",
  "clearDisplayValue",
  "showPickerAndLockScroll",
  "hookMounted",
  "onConfirm",
  "onCancel",
  "onChange"
];
const setWatchFn = ({ api: api2, watch, props, state, emit }) => {
  watch(
    () => props.minDate,
    () => api2.updateInnerValue(),
    {
      lazy: true
    }
  );
  watch(
    () => props.visible,
    (value) => state.visible = value,
    { lazy: true }
  );
  watch(
    () => props.maxDate,
    () => api2.updateInnerValue(),
    {
      lazy: true
    }
  );
  watch(
    () => props.modelValue,
    (value) => {
      if (value) {
        const val = api2.formatValue(new Date(value));
        if (val.valueOf() !== state.innerValue.valueOf()) {
          state.innerValue = val;
        }
        state.displayValue = api2.getDisplayValue();
      }
    },
    {
      immediate: true
    }
  );
  watch(
    () => state.columns,
    () => api2.updateColumnValue(),
    {
      lazy: true
    }
  );
  watch(
    () => state.innerValue,
    (value) => emit("input", value),
    {
      lazy: true
    }
  );
};
const renderless = (props, { computed, onMounted, reactive, watch }, { constants, emit, nextTick, refs, parent }) => {
  const api2 = {
    formatValue: index.formatValue(props),
    getMonthEndDay: index.getMonthEndDay(constants),
    hookMounted: index.hookMounted({ constants, parent, refs, nextTick })
  };
  const state = reactive({
    visible: false,
    innerValue: index.formatValue(props)(props.modelValue),
    ranges: computed(() => api2.getRanges()),
    originColumns: computed(() => api2.getOriginColumns()),
    columns: computed(() => api2.getColumns()),
    displayValue: "",
    isReadonly: false,
    clearable: props.clearable
  });
  Object.assign(api2, {
    state,
    getOriginColumns: index.getOriginColumns(state),
    onCancel: index.onCancel({ emit, state }),
    getColumns: index.getColumns({ props, state }),
    clearDisplayValue: index.clearDisplayValue(state),
    getDisplayValue: index.getDisplayValue({ constants, DATE: index$1.DATE, props, state }),
    showPickerAndLockScroll: index.showPickerAndLockScroll({ constants, state }),
    updateColumnValue: index.updateColumnValue({ constants, nextTick, props, refs, state })
  });
  api2.getBoundary = index.getBoundary({ api: api2, constants, props });
  api2.updateInnerValue = index.updateInnerValue({ api: api2, constants, props, refs, state });
  api2.getRanges = index.getRanges({ api: api2, constants, props, state });
  setWatchFn({ api: api2, watch, props, state, emit });
  onMounted(() => {
    api2.updateColumnValue();
    nextTick(() => {
      api2.updateInnerValue();
    });
  });
  return Object.assign(api2, {
    onConfirm: index.onConfirm({ api: api2, emit, state }),
    onChange: index.onChange({ api: api2, emit, refs, nextTick })
  });
};
exports.api = api;
exports.renderless = renderless;
