"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const chunkG2ADBYYC = require("../chunk-G2ADBYYC.js");
const index = require("./index.js");
const vuePopup = require("../common/deps/vue-popup.js");
const api = [
  "afterEnter",
  "afterLeave",
  "handleClose",
  "handleWrapperClick",
  "useMouseEventDown",
  "useMouseEventUp",
  "handleCancel",
  "handleConfirm",
  "handleDrag",
  "toggleFullScreen",
  "state"
];
const initState = ({
  reactive,
  computed,
  api: api2,
  emitter,
  props,
  useBreakpoint
}) => {
  const { current } = useBreakpoint();
  const state = reactive({
    emitter: emitter(),
    key: 0,
    x: null,
    y: null,
    top: null,
    left: null,
    max: null,
    move: false,
    closed: false,
    dragable: false,
    isFull: props.fullscreen,
    style: computed(() => api2.computedStyle()),
    animationName: computed(() => api2.computedAnimationName()),
    current,
    dragStyle: null
  });
  return state;
};
const mergeState = ({ reactive, state, toRefs, usePopups }) => {
  const { opened, rendered } = usePopups;
  const merge = reactive(chunkG2ADBYYC.__spreadValues({
    opened,
    rendered
  }, toRefs(state)));
  return merge;
};
const initApi = ({
  emit,
  api: api2,
  state,
  parent,
  props,
  lockScrollClass,
  constants,
  usePopups,
  nextTick,
  broadcast,
  designConfig,
  vm
}) => {
  const { open, close } = usePopups;
  Object.assign(api2, {
    state,
    open,
    close,
    broadcast,
    handleCancel: index.handleCancel({ api: api2, emit }),
    handleConfirm: index.handleConfirm({ api: api2, emit }),
    updatePopper: index.updatePopper({ api: api2, constants }),
    handleWrapperClick: index.handleWrapperClick({ api: api2, props, state }),
    useMouseEventDown: index.useMouseEventDown({ state }),
    useMouseEventUp: index.useMouseEventUp({ state }),
    hide: index.hide({ api: api2, emit, state, props }),
    handleClose: index.handleClose({ api: api2, constants, emit, parent, props }),
    watchVisible: index.watchVisible({
      api: api2,
      constants,
      emit,
      nextTick,
      parent,
      props,
      vm,
      state
    }),
    computedStyle: index.computedStyle({ state, props, designConfig }),
    mounted: index.mounted({ api: api2, parent, props }),
    unMounted: index.unMounted({ api: api2, parent, props }),
    computedAnimationName: index.computedAnimationName({ constants, props }),
    afterEnter: index.afterEnter(emit),
    afterLeave: index.afterLeave(emit),
    hideScrollbar: index.hideScrollbar(lockScrollClass),
    showScrollbar: index.showScrollbar(lockScrollClass),
    handleDrag: index.handleDrag({ parent, props, state, emit, vm }),
    // tiny 新增
    toggleFullScreen: index.toggleFullScreen({ state, emit, nextTick, vm })
  });
};
const initWatch = ({ watch, state, api: api2, props }) => {
  watch(() => props.visible, api2.watchVisible);
  watch(
    () => props.fullscreen,
    (value) => {
      state.isFull = value;
    }
  );
};
const renderless = (props, { computed, onBeforeUnmount, onMounted, toRefs, reactive, watch }, {
  vm,
  emitter,
  parent,
  emit,
  constants,
  nextTick,
  mode,
  broadcast,
  designConfig,
  useBreakpoint
}) => {
  const api2 = {};
  const lockScrollClass = constants.SCROLL_LOCK_CLASS(mode);
  let state = initState({ reactive, computed, api: api2, emitter, props, useBreakpoint });
  const usePopups = vuePopup.default({
    api: api2,
    nextTick,
    onBeforeUnmount,
    onMounted,
    props,
    reactive,
    toRefs,
    vm,
    watch
  });
  initApi({
    api: api2,
    state,
    parent,
    props,
    emit,
    constants,
    usePopups,
    lockScrollClass,
    nextTick,
    vm,
    broadcast,
    designConfig
  });
  state = mergeState({ reactive, state, toRefs, usePopups });
  initWatch({ watch, state, api: api2, props });
  onMounted(api2.mounted);
  onBeforeUnmount(api2.unMounted);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
