"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "queryGridData",
  "multiGridSelectAll",
  "multiGridSelectChange",
  "selectedBoxClear",
  "selectedBoxDelete",
  "selectedBoxDrag",
  "doMultiTreeFilter",
  "multiTreeAfterLoad",
  "multiTreeFilterNode",
  "multiTreeFilterPlain",
  "multiTreeLeavePlain",
  "multiTreeCheck",
  "emitChange",
  "onFooterCancel",
  "onFooterConfirm",
  "multiTreeRadio",
  "multiGridRadioChange",
  "clearStatus",
  "setSelection",
  "getSelection"
];
const renderless = (props, { reactive, computed, watch }, { vm, nextTick, emit, constants, designConfig }) => {
  const state = reactive({
    splitValue: 0,
    gridColumns: computed(() => api2.computedGridColumns()),
    selectedChanged: false,
    selectedDatas: [],
    selectedValues: [],
    multiGridStore: {
      selectConfig: computed(() => api2.computedConfig("select")),
      radioConfig: computed(() => api2.computedConfig("radio")),
      inited: false,
      loading: false
    },
    multiTreeStore: {
      viewType: "tree",
      expandedKeys: [],
      checkedKeys: [],
      highlight: null,
      filterText: "",
      inited: false
    },
    lookupStore: {
      datas: []
    },
    theme: vm.theme,
    isBorder: computed(() => {
      if (typeof props.gridOp.border === "boolean") {
        return props.gridOp.border;
      } else {
        return vm.theme !== "saas";
      }
    }),
    constants: (designConfig == null ? void 0 : designConfig.constants) || constants
  });
  state.temporary = {};
  const api2 = {
    state,
    computedGridColumns: index.computedGridColumns(props),
    selectedBoxInit: index.selectedBoxInit({ props, vm, nextTick }),
    selectedBoxClear: index.selectedBoxClear({ props, state, vm }),
    selectedBoxDelete: index.selectedBoxDelete({ props, state, vm }),
    selectedBoxDrag: index.selectedBoxDrag({ props, state }),
    doMultiTreeFilter: index.doMultiTreeFilter({ props, state, nextTick, vm }),
    multiTreeFilterNode: index.multiTreeFilterNode(props),
    multiTreeLeavePlain: index.multiTreeLeavePlain({ props, state }),
    emitChange: index.emitChange({ props, state, emit }),
    emitClose: index.emitClose(emit),
    computedConfig: index.computedConfig({ props, state }),
    doAutoLookup: index.doAutoLookup({ props, state, emit }),
    multiGridRadioChange: index.multiGridRadioChange({ props, state })
  };
  Object.assign(api2, {
    multiGridSelectAll: index.multiGridSelectAll({ api: api2, props, state }),
    multiGridSelectChange: index.multiGridSelectChange({ api: api2, props, state, vm }),
    multiTreeAfterLoad: index.multiTreeAfterLoad({ api: api2, props, state, vm }),
    multiTreeCheck: index.multiTreeCheck({ api: api2, props, state, vm, nextTick }),
    multiTreeFilterPlain: index.multiTreeFilterPlain({ api: api2, props, state }),
    onFooterCancel: index.onFooterCancel({ api: api2, props }),
    onFooterConfirm: index.onFooterConfirm({ api: api2, props }),
    queryGridData: index.queryGridData({ api: api2, props, state }),
    setChecked: index.setChecked({ api: api2, props, state }),
    multiTreeRadio: index.multiTreeRadio({ api: api2, props }),
    watchMulti: index.watchMulti({ api: api2, state, props }),
    clearStatus: index.clearStatus(api2),
    setSelection: index.setSelection({ api: api2, props }),
    getSelection: index.getSelection({ state }),
    setTreeSelection: index.setTreeSelection({ api: api2, state, vm, props }),
    setGridSelection: index.setGridSelection({ api: api2, state, vm })
  });
  watch(
    () => props.visible,
    (value) => {
      if (value && !state.multiGridStore.inited) {
        api2.queryGridData();
      }
    }
  );
  watch(
    () => props.multi,
    () => api2.watchMulti(),
    { immediate: true }
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
