"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state"];
const renderless = (props, { reactive, onMounted, computed }, { vm, nextTick }) => {
  const defaultMargin = "16px 0";
  const verticalMargin = "0 8px";
  const api2 = {};
  const state = reactive({
    height: "auto",
    margin: props.direction === "vertical" ? verticalMargin : defaultMargin,
    lineStyle: computed(() => api2.computedLineStyle()),
    textStyle: computed(() => api2.computedTextStyle()),
    rootStyle: computed(() => api2.computedRootStyle())
  });
  Object.assign(api2, {
    state,
    computedLineStyle: index.computedLineStyle({ props }),
    computedTextStyle: index.computedTextStyle({ props }),
    computedRootStyle: index.computedRootStyle({ props, state }),
    setDividerHeight: index.setDividerHeight({ props, state, vm, nextTick })
  });
  onMounted(() => {
    api2.setDividerHeight();
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
