"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "close", "confirm", "handleClose", "open"];
const renderless = (props, { reactive, watch, onMounted, onBeforeUnmount, computed }, { emit, vm, mode, constants, designConfig }) => {
  const lockScrollClass = constants.SCROLL_LOCK_CLASS(mode);
  const api2 = {};
  const state = reactive({
    visible: false,
    width: 0,
    height: 0,
    dragEvent: { x: 0, y: 0, isDrag: false, offsetWidth: 0, offsetHeight: 0 },
    computedWidth: computed(() => api2.computedWidth()),
    computedHeight: computed(() => api2.computedHeight())
  });
  Object.assign(api2, {
    state,
    open: index.open({ state, emit, vm }),
    confirm: index.confirm({ api: api2 }),
    close: index.close({ api: api2 }),
    handleClose: index.handleClose({ emit, props, state }),
    mousedown: index.mousedown({ state, vm }),
    mousemove: index.mousemove({ state, props, emit }),
    mouseup: index.mouseup({ state }),
    addDragEvent: index.addDragEvent({ api: api2, vm }),
    removeDragEvent: index.removeDragEvent({ api: api2, vm }),
    watchVisible: index.watchVisible({ state, api: api2 }),
    showScrollbar: index.showScrollbar(lockScrollClass),
    hideScrollbar: index.hideScrollbar(lockScrollClass),
    computedWidth: index.computedWidth({ state, designConfig, props, constants }),
    computedHeight: index.computedHeight({ state, designConfig, props, constants })
  });
  onMounted(() => {
    props.dragable && api2.addDragEvent();
    if (props.lockScroll && props.visible) {
      api2.showScrollbar();
    }
  });
  onBeforeUnmount(() => {
    props.dragable && api2.removeDragEvent();
    props.lockScroll && api2.hideScrollbar();
  });
  watch(() => props.visible, api2.watchVisible, { immediate: true });
  watch(
    () => props.width,
    () => state.width = 0
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
