"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "change"];
const renderless = (props, { onMounted, reactive, watch }, { parent, emit, service }) => {
  const $service = index.initService({ props, service });
  const state = reactive({
    options: [],
    source: null,
    selectedValue: props.modelValue,
    attrs: parent.$attr
  });
  watch(
    () => props.modelValue,
    (value) => {
      state.selectedValue = value;
    },
    { immediate: true }
  );
  const api2 = {
    state,
    change: index.change(emit),
    init: index.init({ state, service: $service, emit })
  };
  onMounted(api2.init);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
