"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "toggleItem",
  "updateOffset",
  "clickOutside",
  "doDestroy",
  "handleMouseenter",
  "handleMouseleave"
];
const renderless = (props, hooks, instance) => {
  const api2 = {};
  const { reactive, provide, onMounted, inject } = hooks;
  const { nextTick, mode, vm, parent, dispatch, emit, designConfig } = instance;
  provide("dropdownMenuVm", vm);
  provide("multiStage", props.multiStage);
  const dropdownVm = inject("dropdownVm");
  const state = reactive({
    offset: 0,
    scroller: null,
    children: [],
    size: "",
    showPopper: false,
    initShowPopper: !dropdownVm.lazyShowPopper,
    // 辅助变量,
    label: "",
    showContent: false,
    selected: false,
    selectedIndex: -1,
    canvasHeight: inject("change-size", null)
  });
  if (mode === "mobile") {
    nextTick(() => {
      state.scroller = index.getScroller(vm.$refs.menu);
    });
  } else {
    index.useVuePopper({ api: api2, hooks, props, instance, state, dropdownVm, designConfig });
  }
  Object.assign(api2, {
    state,
    toggleItem: index.toggleItem(state),
    clickOutside: index.clickOutside({ props, state }),
    updateOffset: index.updateOffset({ props, state, vm }),
    mounted: index.mounted({ api: api2, parent, state }),
    handleMouseenter: index.handleMouseenter(emit),
    handleMouseleave: index.handleMouseleave(emit),
    handleMenuItemClick: index.handleMenuItemClick({ dispatch, state })
  });
  onMounted(api2.mounted);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
