"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const string = require("../common/string.js");
const index = require("./index.js");
const api = ["state", "handleMainButtonClick", "hide", "show", "initDomOperation", "handleClick", "clickOutside"];
const renderless = (props, { reactive, watch, provide, onMounted, computed, onBeforeUnmount }, { emit, parent, broadcast, vm, nextTick, mode, designConfig }) => {
  const api2 = {};
  const state = reactive({
    visible: false,
    timeout: null,
    focusing: false,
    menuItems: [],
    menuItemsArray: [],
    triggerElm: null,
    dropdownElm: null,
    listId: `dropdown-menu-${string.guid()}`,
    showIcon: props.showIcon,
    showSelfIcon: props.showSelfIcon,
    designConfig,
    trigger: computed(() => {
      var _a;
      return props.trigger || ((_a = designConfig == null ? void 0 : designConfig.props) == null ? void 0 : _a.trigger) || "hover";
    }),
    visibleIsBoolean: computed(() => typeof props.visible === "boolean")
  });
  provide("dropdownVm", vm);
  Object.assign(api2, {
    state,
    watchVisible: index.watchVisible({ broadcast, emit, nextTick }),
    watchFocusing: index.watchFocusing(parent),
    show: index.show({ props, state, emit }),
    hide: index.hide({ api: api2, props, state, emit }),
    mounted: index.mounted({ api: api2, vm, state, broadcast }),
    handleClick: index.handleClick({ api: api2, props, state, emit }),
    handleTriggerKeyDown: index.handleTriggerKeyDown({ api: api2, state }),
    handleItemKeyDown: index.handleItemKeyDown({ api: api2, props, state, emit }),
    resetTabindex: index.resetTabindex(api2),
    removeTabindex: index.removeTabindex(state),
    initAria: index.initAria({ state, props }),
    initEvent: index.initEvent({ api: api2, props, state, vm, mode }),
    handleMenuItemClick: index.handleMenuItemClick({ props, state, emit }),
    handleMainButtonClick: index.handleMainButtonClick({ api: api2, emit }),
    triggerElmFocus: index.triggerElmFocus(state),
    initDomOperation: index.initDomOperation({ api: api2, state, vm }),
    beforeDistory: index.beforeDistory({ vm, api: api2, state }),
    clickOutside: index.clickOutside({ props, api: api2 }),
    toggleFocusOnTrue: index.toggleFocus({ state, value: true }),
    toggleFocusOnFalse: index.toggleFocus({ state, value: false })
  });
  if (typeof props.visible === "boolean") {
    watch(() => props.visible, api2.watchVisible);
  } else {
    watch(() => state.visible, api2.watchVisible);
  }
  watch(() => state.focusing, api2.watchFocusing);
  onMounted(api2.mounted);
  onBeforeUnmount(api2.beforeDistory);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
