"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const chunkG2ADBYYC = require("../chunk-G2ADBYYC.js");
const index = require("./index.js");
const api = ["state"];
const addWatchers = ({ watch, props, api: api2, state }) => {
  watch(
    () => props.watchData,
    () => api2.updateWatchData()
  );
  watch(
    () => state.id,
    (value, oldValue) => api2.watchId(value, oldValue)
  );
  watch(
    () => state.finalActive,
    (value) => api2.watchFinalActive(value)
  );
};
const renderless = (props, { reactive, computed, onMounted, onBeforeUnmount, watch, inject, markRaw }, { vm, nextTick, emit }) => {
  const vscrollData = inject("vscrollData");
  const vscrollParent = inject("vscrollParent");
  const vscrollResizeObserver = markRaw(inject("vscrollResizeObserver"));
  const state = reactive({
    id: computed(() => api2.computedId()),
    size: computed(() => api2.computedSize()),
    finalActive: computed(() => api2.computedFinalActive()),
    vscrollData,
    vscrollParent: { props: chunkG2ADBYYC.__spreadValues({}, vscrollParent.props), state: chunkG2ADBYYC.__spreadValues({}, vscrollParent.state) },
    vscrollResizeObserver
  });
  const api2 = {
    state,
    computedId: index.computedId({ props, state }),
    computedSize: index.computedSize(state),
    computedFinalActive: index.computedFinalActive({ props, state }),
    applySize: index.applySize({ emit, props, state, vm }),
    unobserveSize: index.unobserveSize({ state, vm })
  };
  Object.assign(api2, {
    updateWatchData: index.updateWatchData({ api: api2, props, state, watch }),
    watchId: index.watchId({ api: api2, state, vm }),
    onDataUpdate: index.onDataUpdate(api2),
    updateSize: index.updateSize({ api: api2, state }),
    computeSize: index.computeSize({ api: api2, nextTick, state, vm }),
    applyWidthHeight: index.applyWidthHeight({ api: api2, state }),
    watchFinalActive: index.watchFinalActive({ api: api2, state }),
    observeSize: index.observeSize({ api: api2, state, vm }),
    onResize: index.onResize({ api: api2, state }),
    onVscrollUpdate: index.onVscrollUpdate({ api: api2, state })
  });
  state.temporary = {
    forceNextVScrollUpdate: null
  };
  api2.updateWatchData();
  for (const k in props.sizeDependencies) {
    watch(() => props.sizeDependencies[k], api2.onDataUpdate);
  }
  state.vscrollParent.state.temporary.events.on("vscroll:update", api2.onVscrollUpdate);
  onMounted(() => {
    if (state.finalActive) {
      api2.updateSize();
      api2.observeSize();
    }
  });
  onBeforeUnmount(() => {
    state.vscrollParent.state.temporary.events.off("vscroll:update", api2.onVscrollUpdate);
    api2.unobserveSize();
  });
  addWatchers({ watch, props, api: api2, state });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
