"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "fall",
  "arrowClick",
  "mouseover",
  "mouseout",
  "clickActive",
  "overContent",
  "reRender",
  "left"
];
const initState = ({
  reactive,
  computed,
  api: api2,
  props
}) => {
  const state = reactive({
    pager: 1,
    level2data: [],
    activeNode: null,
    isActive: props.value,
    pagerData: { data: [], offset: [], index: [] },
    left: computed(() => api2.computeLeft()),
    data: computed(() => api2.computeData()),
    active: 0
  });
  return state;
};
const initApi = ({
  api: api2,
  state,
  fall,
  props,
  refs
}) => {
  Object.assign(api2, {
    fall,
    state,
    computePx: index.computePx({ props, refs, state }),
    mounted: index.mounted({ api: api2 }),
    computeLeft: index.computeLeft({ state }),
    beforeDestroy: index.beforeDestroy(api2),
    computeData: index.computeData({ props }),
    arrowClick: index.arrowClick(state),
    overContent: index.overContent(state),
    mouseout: index.mouseout(state),
    mouseover: index.mouseover({ props, fall, state }),
    clickActive: index.clickActive(state),
    reRender: index.reRender({ api: api2, state })
  });
};
const renderless = (props, { computed, reactive, onMounted, onBeforeUnmount, ref }, { refs }) => {
  const api2 = {};
  const fall = ref(null);
  const state = initState({ reactive, computed, api: api2, props });
  initApi({ api: api2, state, fall, props, refs });
  onMounted(api2.mounted);
  onBeforeUnmount(api2.beforeDestroy);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
