"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const dom = require("../common/deps/dom.js");
const api = ["state", "doDestroy", "show", "hide", "popoverShow", "popoverHide", "handleClear", "togglePanel"];
const renderless = (props, { reactive, onMounted, onBeforeUnmount }, { vm, emit }) => {
  const state = reactive({
    visible: false
  });
  const api2 = {};
  Object.assign(api2, {
    state,
    show: index.show({ state }),
    hide: index.hide({ state }),
    togglePanel: index.togglePanel({ props, state }),
    popoverShow: index.popoverShow({ state, emit }),
    popoverHide: index.popoverHide({ state, emit }),
    handleClear: index.handleClear({ emit }),
    doDestroy: index.doDestroy({ vm }),
    handleDocumentClick: index.handleDocumentClick({ vm, state })
  });
  onMounted(() => {
    dom.on(document, "click", api2.handleDocumentClick);
  });
  onBeforeUnmount(() => {
    dom.off(document, "click", api2.handleDocumentClick);
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
