"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const dom = require("../common/deps/dom.js");
const index = require("./index.js");
const api = [
  "state",
  "panelToggle",
  "filterSelectOption",
  "filterConfirm",
  "selectOption",
  "confirm",
  "cancel",
  "reset",
  "selectOptionAll"
];
const renderless = (props, { reactive, computed, onMounted, onBeforeUnmount }, { emit, vm }) => {
  const api2 = {};
  const state = reactive({
    showPanelIndex: -1,
    filterPanel: {
      show: false,
      selected: []
    },
    selectPanel: {
      selected: [],
      config: computed(() => state.showPanelIndex !== -1 ? props.data[state.showPanelIndex] : { options: [] })
    },
    tagWidth: computed(() => (100 / props.columnNum).toFixed(1) + "%"),
    labelList: computed(() => api2.labelListComputed()),
    showPanel: computed(() => state.showPanelIndex !== -1 || state.filterPanel.show),
    hasFilterValue: computed(
      () => props.filterValue.find((item) => Array.isArray(item) ? item.length > 0 : ![void 0, null, ""].includes(item))
    )
  });
  Object.assign(api2, {
    state,
    panelToggle: index.panelToggle({ state, props, api: api2, emit }),
    filterSelectOption: index.filterSelectOption({ state, props }),
    filterConfirm: index.filterConfirm({ state, emit }),
    selectOption: index.selectOption({ state, api: api2 }),
    confirm: index.confirm({ state, props, emit, api: api2 }),
    cancel: index.cancel({ state, emit }),
    resize: index.resize({ state, vm, props }),
    reset: index.reset({ state, props }),
    selectOptionAll: index.selectOptionAll({ state }),
    labelListComputed: index.labelListComputed({ props })
  });
  onMounted(() => {
    dom.on(window, "scroll", api2.resize);
    dom.on(window, "resize", api2.resize);
  });
  onBeforeUnmount(() => {
    dom.off(window, "scroll", api2.resize);
    dom.off(window, "resize", api2.resize);
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
