"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleClick"];
const renderless = (props, { computed, reactive, onMounted, onBeforeUnmount, watch }, { vm, emit, nextTick }) => {
  const state = reactive({
    centerSpace: 0,
    disabled: false,
    initTimer: null,
    scrolling: false,
    commHiddenSpace: "",
    specialHiddenSpace: "",
    stayTime: null,
    lastScrollTop: 0,
    style: computed(() => api2.computedStyle()),
    expandList: null,
    itemTitle: "",
    isExpand: false,
    scrollElement: "",
    elementHeight: 0,
    screenHeight: 0
  });
  const api2 = {};
  Object.assign(api2, {
    state,
    getClientWidth: index.getClientWidth({ state, vm }),
    handleClick: index.handleClick({ props, state, emit }),
    clearTimer: index.clearTimer({ state, api: api2 }),
    useTouchEvent: index.useTouchEvent({ state, props, nextTick, api: api2 }),
    onScroll: index.onScroll({ state, api: api2 }),
    computedStyle: index.computedStyle({ props, state }),
    getExpandList: index.getExpandList({ state, props }),
    mounted: index.mounted(api2),
    getScrollListener: index.getScrollListener({ vm, props, state })
  });
  onMounted(api2.mounted);
  onBeforeUnmount(api2.clearTimer);
  watch(() => props.expandList, api2.getExpandList);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
