"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const throttle = require("../common/deps/throttle.js");
const api = [
  "state",
  "clearHoverAfterLink",
  "clickNode",
  "getVars",
  "omitText",
  "refresh",
  "clearDropdown",
  "clickGroup"
];
const renderless = (props, { reactive, markRaw, onMounted, onBeforeUnmount, provide }, { vm, nextTick, emit, mode }, { emitter }) => {
  const state = reactive({
    afterData: null,
    refreshKey: 0,
    wrapperStyle: "",
    dropdowns: {}
  });
  state.temporary = {
    graphWidth: 0,
    adjustX: 0,
    emitter: emitter(),
    customLinks: [],
    lastRowAfterNodes: [],
    adjustY: 0
  };
  const api2 = {
    state,
    omitText: index.omitText,
    getVars: index.getVars(),
    initDropdowns: index.initDropdowns(),
    buildAfterNode: index.buildAfterNode(props),
    buildAfterLink: index.buildAfterLink(),
    isLinkHover: index.isLinkHover(state),
    clearDropdown: index.clearDropdown(state),
    getAllItem: index.getAllItem(props),
    buildHoverState: index.buildHoverState(props),
    removeListeners: index.removeListeners({ state, vm }),
    isMf: index.isMf(mode),
    antialiasing: index.antialiasing(vm),
    getNodeDef: index.getNodeDef(props),
    clickGroup: index.clickGroup(emit)
  };
  Object.assign(api2, {
    compute: index.compute({ api: api2, markRaw, props, state }),
    computeMf: index.computeMf({ api: api2, markRaw, props, state }),
    drawAfterLink: index.drawAfterLink({ api: api2, props, state, vm }),
    refresh: index.refresh({ api: api2, nextTick, state }),
    addListeners: index.addListeners({ api: api2, state, vm }),
    setListeners: index.setListeners({ api: api2, emit, props, state, vm }),
    hitTest: index.hitTest({ api: api2, state, vm }),
    clearHoverAfterLink: throttle.default(10, index.clearHoverAfterLink({ api: api2, state, vm })),
    clickNode: index.clickNode({ api: api2, emit }),
    getNode: index.getNode(api2),
    setAdjustY: index.setAdjustY({ api: api2, state }),
    runAdjustYTask: index.runAdjustYTask({ api: api2, state })
  });
  provide("graphEmitter", state.temporary.emitter);
  provide("graphInstance", { setAdjustY: api2.setAdjustY });
  if (api2.isMf()) {
    api2.computeMf();
  } else {
    api2.compute();
  }
  onMounted(() => {
    nextTick(() => {
      api2.antialiasing();
      api2.drawAfterLink();
      api2.addListeners();
    });
  });
  onBeforeUnmount(() => {
    api2.removeListeners();
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
