"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const screenfull = require("../common/deps/fullscreen/screenfull.js");
const index = require("./index.js");
const api = [
  "state",
  "exit",
  "enter",
  "toggle",
  "request",
  "getState",
  "shadeClick",
  "keypressCallback",
  "fullScreenCallback",
  "onChangeFullScreen"
];
const renderless = (props, { reactive, computed, watch }, { vm, emit }) => {
  const api2 = {};
  const state = reactive({
    isFullscreen: false,
    isEnabled: false,
    support: computed(() => state.isEnabled),
    // 如果不支持浏览器全屏，改用网页全屏
    isPageOnly: computed(() => props.pageOnly || !screenfull.default.isEnabled),
    wrapperStyle: computed(() => api2.computeWrapperStyle())
  });
  Object.assign(api2, {
    state,
    getState: index.getState(state),
    enter: index.enter(api2),
    exit: index.exit({ state, api: api2, sf: screenfull.default, props }),
    toggle: index.toggle({ state, api: api2 }),
    keypressCallback: index.keypressCallback(api2),
    shadeClick: index.shadeClick({ props, vm, api: api2 }),
    request: index.request({ props, state, vm, sf: screenfull.default, api: api2 }),
    fullScreenCallback: index.fullScreenCallback({ state, sf: screenfull.default, api: api2 }),
    computeWrapperStyle: index.computeWrapperStyle({ props, state }),
    onChangeFullScreen: index.onChangeFullScreen({ props, state, vm, emit })
  });
  watch(
    () => props.fullscreen,
    (value) => {
      if (value !== state.isFullscreen) {
        value ? api2.request() : api2.exit();
      }
    },
    { lazy: true }
  );
  state.isEnabled = screenfull.default.isEnabled;
  return api2;
};
exports.api = api;
exports.renderless = renderless;
