"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "buildRadioConfig", "buildSelectConfig", "filter", "radioChange", "selectChange"];
const renderless = (props, { reactive, watch }, { vm, emit }) => {
  const api2 = {};
  const state = reactive({
    value: props.modelValue,
    gridData: props.gridOp.data,
    remoteData: [],
    selected: props.multiple ? [] : {}
  });
  Object.assign(api2, {
    state,
    buildRadioConfig: index.buildRadioConfig({ props, state }),
    buildSelectConfig: index.buildSelectConfig({ props, state }),
    filter: index.filter({ props, state, vm }),
    radioChange: index.radioChange({ props, vm, emit }),
    selectChange: index.selectChange({ props, vm, emit })
  });
  watch(
    () => props.gridOp.data,
    (data) => data && (state.gridData = data),
    { immediate: true, deep: true }
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
