"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const each = require("../base/each.js");
const isFunction = require("../base/isFunction.js");
const property = require("../function/property.js");
const map = function(obj, iterate, context) {
  let result = [];
  if (obj && arguments.length > 1) {
    if (!isFunction.default(iterate)) {
      iterate = property.default(iterate);
    }
    if (obj.map) {
      return obj.map(iterate, context);
    } else {
      each.default(obj, (...args) => {
        result.push(iterate.apply(context, args));
      });
    }
  }
  return result;
};
var map_default = map;
exports.default = map_default;
