"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const helperCreateTreeFunc = require("./helperCreateTreeFunc.js");
const map = require("./map.js");
const mapTreeItem = ({ parent, obj, iterate, context, path, node, parseChildren, opts }) => {
  let mapChildren = opts.mapChildren || parseChildren;
  return map.default(obj, (item, index) => {
    const paths = path.concat([`${index}`]);
    const nodes = node.concat([item]);
    const rest = iterate.call(context, item, index, obj, paths, parent, nodes);
    if (rest && item && parseChildren && item[parseChildren]) {
      rest[mapChildren] = mapTreeItem({
        obj: item[parseChildren],
        iterate,
        context,
        path: paths,
        node: nodes,
        parseChildren,
        opts
      });
    }
    return rest;
  });
};
const mapTree = helperCreateTreeFunc.default(mapTreeItem);
var mapTree_default = mapTree;
exports.default = mapTree_default;
