"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const arrayEach = require("./arrayEach.js");
const toArray = require("./toArray.js");
const map = require("./map.js");
const isFunction = require("../base/isFunction.js");
const isUndefined = require("../base/isUndefined.js");
const isNull = require("../base/isNull.js");
const get = require("../base/get.js");
const property = require("../function/property.js");
const sortByDef = (v1, v2) => {
  if (isUndefined.default(v1) || isUndefined.default(v2)) {
    return isUndefined.default(v2) ? 1 : -1;
  }
  if (isNull.default(v1) || isNull.default(v2)) {
    return isNull.default(v2) ? 1 : -1;
  }
  return v1 && v1.localeCompare ? v1.localeCompare(v2) : v1 > v2 ? 1 : -1;
};
const sortMultis = (name, compares) => (item1, item2) => {
  let v1 = item1[name];
  let v2 = item2[name];
  if (v1 === v2) {
    return compares ? compares(item1, item2) : 0;
  }
  return sortByDef(v1, v2);
};
const getSortPros = (arr, list, iterate, context) => {
  iterate = Array.isArray(iterate) ? iterate : [iterate];
  arrayEach.default(iterate, (prop, index) => {
    let eachCallback;
    if (isFunction.default(prop)) {
      eachCallback = (val, key) => {
        val[index] = prop.call(context, val.data, key, arr);
      };
    } else {
      eachCallback = (val) => {
        val[index] = get.default(val.data, prop);
      };
    }
    arrayEach.default(list, eachCallback);
  });
  return iterate;
};
const sortBy = (arr, iterate, context, STR_UNDEFINED) => {
  if (arr) {
    if (iterate === STR_UNDEFINED) {
      return toArray.default(arr).sort(sortByDef);
    }
    let compares;
    let list = map.default(arr, (item) => ({ data: item }));
    let sortPros = getSortPros(arr, list, iterate, context);
    let len = sortPros.length;
    if (len) {
      while (len >= 0) {
        compares = sortMultis(len, compares);
        len--;
      }
      list = list.sort(compares);
    }
    return map.default(list, property.default("data"));
  }
  return [];
};
var sortBy_default = sortBy;
exports.default = sortBy_default;
