"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const each = require("../base/each.js");
const isFunction = require("../base/isFunction.js");
const toNumber = require("../number/toNumber.js");
const sum = (array, iterate, context) => {
  let result = 0;
  let eachCallback;
  if (iterate) {
    if (isFunction.default(iterate)) {
      eachCallback = (...args) => {
        result += toNumber.default(iterate.apply(context, args));
      };
    } else {
      eachCallback = (val) => {
        result += toNumber.default(val[iterate]);
      };
    }
  } else {
    eachCallback = (val) => {
      result += toNumber.default(val);
    };
  }
  each.default(array, eachCallback);
  return result;
};
var sum_default = sum;
exports.default = sum_default;
