"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const isNull = require("./isNull.js");
const isObject = require("./isObject.js");
const assign = require("../object/assign.js");
const isPlainObject = require("./isPlainObject.js");
const objectEach = require("../object/objectEach.js");
const helperDeleteProperty = require("./helperDeleteProperty.js");
const clear = function(obj, defs, assigns) {
  if (!obj) {
    return obj;
  }
  let isDefs = arguments.length > 1 && (isNull.default(defs) || !isObject.default(defs));
  let extds = isDefs ? assigns : defs;
  if (isPlainObject.default(obj)) {
    let eachCallback;
    if (isDefs) {
      eachCallback = (val, key) => {
        obj[key] = defs;
      };
    } else {
      eachCallback = (val, key) => {
        helperDeleteProperty.default(obj, key);
      };
    }
    objectEach.default(obj, eachCallback);
    if (extds) {
      assign.default(obj, extds);
    }
  } else if (Array.isArray(obj)) {
    if (isDefs) {
      let len = obj.length;
      while (len > 0) {
        len--;
        obj[len] = defs;
      }
    } else {
      obj.length = 0;
    }
    if (extds) {
      obj.push.apply(obj, extds);
    }
  }
  return obj;
};
var clear_default = clear;
exports.default = clear_default;
