"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const eqNull = require("./eqNull.js");
const hasOwnProp = require("./hasOwnProp.js");
const isUndefined = require("./isUndefined.js");
const helperGetHGSKeys = require("./helperGetHGSKeys.js");
const staticHGKeyRE = require("../static/staticHGKeyRE.js");
const valGet = (obj, key) => {
  const matchs = key ? key.match(staticHGKeyRE.default) : "";
  return matchs ? matchs[1] ? obj[matchs[1]] ? obj[matchs[1]][matchs[2]] : void 0 : obj[matchs[2]] : obj[key];
};
const pathGet = (obj, property) => {
  if (!obj) {
    return;
  }
  let rest;
  let index = 0;
  const getRest = (len, props) => {
    for (rest = obj; index < len; index++) {
      rest = valGet(rest, props[index]);
      if (eqNull.default(rest)) {
        return;
      }
    }
  };
  if (obj[property] || hasOwnProp.default(obj, property)) {
    return obj[property];
  } else {
    const props = helperGetHGSKeys.default(property);
    const len = props.length;
    if (len) {
      getRest(len, props);
    }
    return rest;
  }
};
const get = (obj, property, defaultValue) => {
  if (eqNull.default(obj)) {
    return defaultValue;
  }
  const result = pathGet(obj, property);
  return isUndefined.default(result) ? defaultValue : result;
};
var get_default = get;
exports.default = get_default;
