"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const isFunction = require("./isFunction.js");
const isString = require("./isString.js");
const hasOwnProp = require("./hasOwnProp.js");
const helperCreateiterateIndexOf = (callback) => (obj, iterate, context) => {
  if (!obj || !isFunction.default(iterate)) {
    return -1;
  }
  if (Array.isArray(obj) || isString.default(obj)) {
    return callback(obj, iterate, context);
  }
  for (let key of Object.keys(obj)) {
    if (hasOwnProp.default(obj, key) && iterate.call(context, obj[key], key, obj)) {
      return key;
    }
  }
  return -1;
};
var helperCreateiterateIndexOf_default = helperCreateiterateIndexOf;
exports.default = helperCreateiterateIndexOf_default;
