"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const type = require("../../../common/type.js");
const isNumber = require("./isNumber.js");
const isString = require("./isString.js");
const isBoolean = require("./isBoolean.js");
const isUndefined = require("./isUndefined.js");
const keys = require("./keys.js");
const every = require("../array/every.js");
let equalVal;
const helperEqualCompare = ({ val1, val2, compare, func, key, obj1, obj2 }) => {
  if (val1 === val2) {
    return true;
  }
  if (val1 && val2 && !isNumber.default(val1) && !isNumber.default(val2) && !isString.default(val1) && !isString.default(val2)) {
    if (type.isRegExp(val1)) {
      return compare(String(val1), String(val2), key, obj1, obj2);
    }
    if (type.isDate(val1) || isBoolean.default(val1)) {
      return compare(Number(val1), Number(val2), key, obj1, obj2);
    }
    return equalVal(val1, val2, func, key, compare);
  }
  return compare(val1, val2, key, obj1, obj2);
};
equalVal = (val1, val2, func, key, compare) => {
  let result, val1Keys, val2Keys;
  let isObj1Arr = Array.isArray(val1);
  let isObj2Arr = Array.isArray(val2);
  if (isObj1Arr || isObj2Arr ? isObj1Arr && isObj2Arr : val1.constructor === val2.constructor) {
    val1Keys = keys.default(val1);
    val2Keys = keys.default(val2);
    if (func) {
      result = func(val1, val2, key);
    }
    if (val1Keys.length === val2Keys.length) {
      if (isUndefined.default(result)) {
        return every.default(
          val1Keys,
          (key2, index) => key2 === val2Keys[index] && helperEqualCompare({
            val1: val1[key2],
            val2: val2[val2Keys[index]],
            compare,
            func,
            key: isObj1Arr || isObj2Arr ? index : key2,
            obj1: val1,
            obj2: val2
          })
        );
      }
      return !!result;
    }
    return false;
  }
};
var helperEqualCompare_default = helperEqualCompare;
exports.default = helperEqualCompare_default;
