"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const helperDeleteProperty = require("./helperDeleteProperty.js");
const isFunction = require("./isFunction.js");
const each = require("./each.js");
const arrayEach = require("../array/arrayEach.js");
const lastEach = require("./lastEach.js");
const clear = require("./clear.js");
const eqNull = require("./eqNull.js");
const pluckProperty = (name) => (obj, key) => key === name;
const remove = (obj, iterate, context) => {
  if (obj) {
    if (!eqNull.default(iterate)) {
      let removeIndexs = [];
      let rest = [];
      if (!isFunction.default(iterate)) {
        iterate = pluckProperty(iterate);
      }
      each.default(obj, (item, index, rest2) => {
        if (iterate.call(context, item, index, rest2)) {
          removeIndexs.push(index);
        }
      });
      if (Array.isArray(obj)) {
        lastEach.default(removeIndexs, (item) => {
          rest.push(obj[item]);
          obj.splice(item, 1);
        });
      } else {
        rest = {};
        arrayEach.default(removeIndexs, (key) => {
          rest[key] = obj[key];
          helperDeleteProperty.default(obj, key);
        });
      }
      return rest;
    }
    return clear.default(obj);
  }
  return obj;
};
var remove_default = remove;
exports.default = remove_default;
