"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const each = require("../base/each.js");
const isFunction = require("../base/isFunction.js");
const property = require("../function/property.js");
const objectMap = (obj, iterate, context) => {
  let result = {};
  if (obj) {
    if (iterate) {
      if (!isFunction.default(iterate)) {
        iterate = property.default(iterate);
      }
      each.default(obj, (val, index) => {
        result[index] = iterate.call(context, val, index, obj);
      });
    } else {
      return obj;
    }
  }
  return result;
};
var objectMap_default = objectMap;
exports.default = objectMap_default;
