"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "hrChange", "selectedDept", "resetPerson", "getDisplay", "cancel"];
const initState = ({ reactive, props }) => {
  const state = reactive({
    hrList: [],
    lastHrList: [],
    dept: props.modelValue,
    current: "",
    approvalPerson: props.approvalPerson,
    overdueData: "",
    loading: false
  });
  return state;
};
const initApi = ({ api: api2, state, emit, props, $service }) => {
  Object.assign(api2, {
    state,
    hrChange: index.hrChange({ emit, state }),
    resetPerson: index.resetPerson({ props, state }),
    fetchHrapprover: $service.fetchHrapprover,
    cancel: index.cancel({ state }),
    getHrList: index.getHrList({ api: api2, props, state }),
    selectedDept: index.selectedDept({ api: api2, state }),
    getDisplay: index.getDisplay({ api: api2, state })
  });
};
const initWatch = ({ watch, state, api: api2, props }) => {
  watch(
    () => props.modelValue,
    (value) => {
      state.dept = value;
      api2.getDisplay(value);
    },
    { immediate: true }
  );
  watch(
    () => props.approvalPerson,
    (value) => {
      state.overdueData = value;
      state.approvalPerson = value;
    },
    { immediate: true }
  );
};
const renderless = (props, { reactive, watch }, { service, emit }) => {
  const api2 = {};
  const $service = index.initService({ props, service });
  const state = initState({ reactive, props });
  initApi({ api: api2, state, emit, props, $service });
  initWatch({ watch, state, api: api2, props });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
