"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "handleIndexClick",
  "handleScroll",
  "updateAnchorChildren",
  "handleTouchDown",
  "handleTouchMove",
  "handleTouchUp",
  "handleIndexClick"
];
const renderless = (props, { computed, reactive, onMounted, onUnmounted, onUpdated, watch }, { emit, parent, refs }) => {
  const state = reactive({
    index: 0,
    childrenAnchor: [],
    isFistUpdate: true
  });
  const api2 = {
    state,
    isMouseDown: false,
    handleScroll: index.handleScroll({ state }),
    updateAnchorChildren: index.updateAnchorChildren({ refs, state }),
    handleTouchDown: index.handleTouchDown({ state }),
    handleTouchMove: index.handleTouchMove({ emit, state }),
    handleTouchUp: index.handleTouchUp({ state }),
    handleIndexClick: index.handleIndexClick({ emit, state })
  };
  Object.assign(api2, {
    state
  });
  onMounted((e) => {
    window.addEventListener("scroll", api2.handleScroll);
  });
  onUnmounted(() => {
    window.removeEventListener("scroll", api2.handleScroll);
  });
  watch(
    () => state.index,
    (value, oldValue) => {
      const isChange = value !== oldValue && value >= 0 && value < parent.indexList.length;
      if (isChange) {
        emit("change", value);
      }
    },
    { immediate: false }
  );
  watch(
    () => props.indexList,
    () => {
      api2.updateAnchorChildren({ refs, state });
    },
    { immediate: false, deep: true }
  );
  onUpdated(() => {
    if (state.isFistUpdate) {
      state.isFistUpdate = false;
      api2.updateAnchorChildren({ refs, state });
    }
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
