"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const chunkG2ADBYYC = require("../chunk-G2ADBYYC.js");
const index = require("./index.js");
const index$1 = require("../common/index.js");
const api = ["state", "focus", "inputEvent", "blur", "keyup", "keydown", "change", "select"];
const initState = ({
  reactive,
  computed,
  handleValue,
  parent,
  props
}) => {
  const state = reactive(chunkG2ADBYYC.__spreadProps(chunkG2ADBYYC.__spreadValues({}, handleValue.state), {
    active: false,
    isSelected: false,
    filterKeyCodes: [
      index$1.KEY_CODE.AtMark,
      index$1.KEY_CODE.Backspace,
      index$1.KEY_CODE.ArrowLeft,
      index$1.KEY_CODE.ArrowRight,
      index$1.KEY_CODE.Tab,
      index$1.KEY_CODE.Delete
    ],
    formDisabled: computed(() => (parent.tinyForm || {}).disabled),
    disabled: computed(() => props.disabled || state.formDisabled),
    size: computed(() => props.size)
  }));
  return state;
};
const initApi = ({
  state,
  api: api2,
  dispatch,
  handleValue,
  emit,
  broadcast,
  parent,
  componentName,
  props,
  eventName
}) => {
  Object.assign(api2, chunkG2ADBYYC.__spreadProps(chunkG2ADBYYC.__spreadValues({}, handleValue.api), {
    state,
    dispatch,
    broadcast,
    getCursorPosition: index.getCursorPosition,
    focus: index.focus({ emit, parent, state }),
    select: index.select({ emit, parent, state }),
    blur: index.blur({
      api: api2,
      componentName,
      emit,
      eventName: eventName.blur,
      props,
      state
    }),
    keyup: index.keyup({ api: api2, props }),
    change: index.change({ api: api2, emit }),
    keydown: index.keydown({ api: api2, props, state }),
    inputEvent: index.inputEvent({ api: api2, emit, props, componentName, eventName: eventName.change })
  }));
};
const useHandleValue = ({ componentName, dispatch, eventName, props, reactive, toRefs, watch }) => {
  const state = reactive({
    address: [],
    isDel: false
  });
  const api2 = {
    isIP6: index.isIP6,
    isIP4: index.isIP4
  };
  api2.getValue = index.getValue({ api: api2, props, state });
  api2.setValue = index.setValue({ api: api2, props, state });
  api2.ipValidator = index.ipValidator({ api: api2, props });
  watch(
    () => props.modelValue,
    (value) => {
      var _a;
      if (!state.isDel) {
        (_a = api2 == null ? void 0 : api2.setValue) == null ? void 0 : _a.call(api2, value);
        dispatch(componentName, eventName, [value]);
      }
    },
    { immediate: true }
  );
  return {
    state: toRefs(state),
    api: api2
  };
};
const renderless = (props, { reactive, toRefs, watch, inject, computed }, { emit, parent, broadcast, dispatch }) => {
  const api2 = {};
  const componentName = "FormItem";
  const eventName = {
    change: "form.change",
    blur: "form.blur"
  };
  parent.tinyForm = parent.tinyForm || inject("form", null);
  const handleValue = useHandleValue({
    componentName,
    dispatch,
    eventName: eventName.change,
    props,
    reactive,
    toRefs,
    watch
  });
  const state = initState({ reactive, computed, handleValue, parent, props });
  initApi({
    api: api2,
    state,
    handleValue,
    dispatch,
    broadcast,
    emit,
    props,
    parent,
    componentName,
    eventName
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
exports.useHandleValue = useHandleValue;
