"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleClick", "computeLabel", "computeLabelStyle", "computeLabelClass"];
const renderless = (props, { computed, onBeforeUnmount, reactive, watch, inject }, { emit, parent }) => {
  parent.tinyForm = parent.tinyForm || inject("form", null);
  const state = reactive({
    label: computed(() => api2.computeLabel()),
    type: props.type,
    color: props.color,
    size: props.size,
    labelClass: computed(() => api2.computeLabelClass()),
    isRequired: props.isRequired
  });
  const api2 = {
    state,
    handleClick: index.handleClick({ emit, state }),
    computeLabel: index.computeLabel(props),
    // computeLabelStyle: computeLabelStyle(props, state),
    computeLabelClass: index.computeLabelClass(props)
  };
  return api2;
};
exports.api = api;
exports.renderless = renderless;
