"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const object = require("../common/object.js");
const index$1 = require("../tree-menu/index.js");
const api = [
  "state",
  "initData",
  "filterNode",
  "getValue",
  "hideDialog",
  "setMenuKey",
  "showDialog",
  "sureNodevalue"
];
const initState = ({ reactive, computed, api: api2 }) => {
  const state = reactive({
    filterText: "",
    datas: [],
    disabled: false,
    alertShow: false,
    boxVisibility: false,
    listItem: [],
    getNodeValue: [],
    currentCheckNode: [],
    titles: computed(() => api2.dialogTitle())
  });
  return state;
};
const initWatch = ({ watch, state, props, nextTick, vm }) => {
  watch(
    () => state.filterText,
    (value) => nextTick(() => vm.$refs.tree.filter(value))
  );
  watch(
    () => props.data,
    (value) => {
      if (value) {
        const changeData = object.copyArray(value);
        changeData.forEach((item) => {
          if (!item.children) {
            item.disabled = false;
          } else {
            item.children.forEach((item2) => {
              item2.disabled = false;
            });
          }
        });
        state.datas = changeData;
      }
    },
    { immediate: true }
  );
};
const initApi = ({ api: api2, state, constants, props, t, service, vm }) => {
  Object.assign(api2, {
    state,
    filterNode: index.filterNode(),
    showDialog: index.showDialog(state),
    sureNodevalue: index.sureNodevalue(state),
    disabledTreeNode: index.disabledTreeNode(state),
    disabledParentNode: index.disabledParentNode(state),
    dialogTitle: index.dialogTitle({ constants, props, t }),
    setMenuKey: index$1.setMenuKey(api2),
    getValue: index.getValue({ api: api2, state, props }),
    initData: index.initData({ state, props, service, api: api2 }),
    hideDialog: index.hideDialog({ api: api2, state, vm, props })
  });
};
const renderless = (props, { computed, onMounted, reactive, watch }, { t, vm, service, constants, nextTick }) => {
  service = index.initService({ props, service });
  const api2 = {};
  const state = initState({ reactive, computed, api: api2 });
  initWatch({ watch, state, props, nextTick, vm });
  onMounted(() => {
    api2.initData();
    api2.disabledParentNode(state);
  });
  initApi({ api: api2, state, constants, props, t, service, vm });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
