"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const dom = require("../common/deps/dom.js");
const clickList = ({ emit, props }) => () => {
  const list = {
    id: props.id,
    content: props.content,
    subtext: props.subText,
    contentdes: props.contentDes
  };
  emit("click", list);
};
const check = ({ api, emit, props, state, vm }) => () => {
  if (state.loading || props.finished || props.disabled || props.error || // skip check when inside an inactive tab
  state.tabStatus === false) {
    return;
  }
  const offset = +props.offset;
  const scrollParentRect = api.useRect(state.scroller);
  if (!scrollParentRect.height || dom.isDisplayNone(vm.$el)) {
    return;
  }
  let isReachEdge = false;
  const placeholderRect = api.useRect(vm.$refs.placeholder);
  if (props.direction === "up") {
    isReachEdge = scrollParentRect.top - placeholderRect.top <= offset;
  } else {
    isReachEdge = placeholderRect.bottom - scrollParentRect.bottom <= offset;
  }
  if (isReachEdge) {
    state.loading = true;
    emit("update:loading", true);
    emit("load");
  }
};
const clickErrorText = ({ api, emit }) => () => {
  emit("update:error", false);
  api.check();
};
exports.check = check;
exports.clickErrorText = clickErrorText;
exports.clickList = clickList;
