"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const afterLeave = require("../common/deps/after-leave.js");
const dom = require("../common/deps/dom.js");
const handleAfterLeave = (emit) => () => {
  emit("after-leave");
};
const setText = (state) => (text) => {
  state.text = text;
};
const close = ({ state, constants, vm }) => () => {
  afterLeave.default(
    vm,
    () => {
      const target = state.fullscreen || state.body ? document.body : state.target;
      if (vm.$el && vm.$el.parentNode) {
        dom.removeClass(target, constants.PARENT_RELATIVE_CLS);
        dom.removeClass(target, constants.PARENT_HIDDEN_CLS);
        vm.$el.parentNode.removeChild(vm.$el);
      }
      state.closed = true;
    },
    300
  );
  state.visible = false;
};
exports.close = close;
exports.handleAfterLeave = handleAfterLeave;
exports.setText = setText;
