"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "showTip",
  "handleClick",
  "handleFlagClick",
  "flagOperate",
  "getMileIcon",
  "getMileContent",
  "getMileFlagStyle",
  "getLineColor",
  "getStatus",
  "hexToRgb",
  "getFlagStyle"
];
const renderless = (props, { reactive }, { emit, refs, constants }) => {
  const state = reactive({
    tipContent: ""
  });
  const api2 = {
    state,
    getLineColor: index.getLineColor(props),
    getMileContent: index.getMileContent(props),
    handleFlagClick: index.handleFlagClick(emit),
    handleClick: index.handleClick({ emit }),
    getMileIcon: index.getMileIcon({ constants, props }),
    flagOperate: index.flagOperate({ constants, refs, state }),
    hexToRgb: index.hexToRgb,
    getFlagStyle: index.getFlagStyle(props)
  };
  return api2;
};
exports.api = api;
exports.renderless = renderless;
