"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "dragEvent",
  "mousedownEvent",
  "toggleZoomEvent",
  "revert",
  "maximize",
  "getBox",
  "close",
  "updateStyle",
  "selfClickEvent",
  "mouseEnterEvent",
  "mouseLeaveEvent",
  "updateZindex",
  "closeEvent",
  "confirmEvent",
  "cancelEvent",
  "open",
  "beforeUnmouted",
  "resetDragStyle",
  "resetModalViewPosition"
];
const renderless = (props, { computed, onMounted, onBeforeUnmount, reactive, watch }, { vm, emit, emitter, nextTick, broadcast, vm: parent, constants, mode }, { isMobileFirstMode }) => {
  const api2 = {};
  const lockScrollClass = constants.SCROLL_LOCK_CLASS(mode);
  const state = reactive({
    emitter: emitter(),
    visible: false,
    contentVisible: false,
    cumsumZindex: 0,
    modalTop: 0,
    modalZindex: 0,
    zoomLocat: null,
    isMsg: computed(() => api2.computedIsMsg(props)),
    prevEvent: null,
    options: [],
    theme: props.tiny_theme,
    boxStyle: computed(() => api2.computedBoxStyle()),
    timer: 0
  });
  Object.assign(api2, {
    state,
    broadcast,
    computedIsMsg: index.computedIsMsg(),
    updateStyle: index.updateStyle({ nextTick, props }),
    getBox: index.getBox({ vm }),
    watchValue: index.watchValue(api2),
    created: index.created({ api: api2, props, state }),
    mounted: index.mounted({ api: api2, parent, props, isMobileFirstMode, state }),
    beforeUnmouted: index.beforeUnmouted({ api: api2, parent, isMobileFirstMode }),
    selfClickEvent: index.selfClickEvent({ api: api2, parent, props }),
    mouseEnterEvent: index.mouseEnterEvent(state),
    mouseLeaveEvent: index.mouseLeaveEvent({ api: api2, props, state }),
    updateZindex: index.updateZindex({ state, props }),
    handleEvent: index.handleEvent({ api: api2, emit, parent, props, isMobileFirstMode }),
    closeEvent: index.closeEvent(api2),
    confirmEvent: index.confirmEvent({ api: api2, state }),
    cancelEvent: index.cancelEvent(api2),
    open: index.open({ api: api2, emit, nextTick, parent, props, state, isMobileFirstMode }),
    addMsgQueue: index.addMsgQueue({ api: api2, parent }),
    removeMsgQueue: index.removeMsgQueue({ api: api2, parent }),
    close: index.close({ emit, parent, props, state }),
    handleGlobalKeydownEvent: index.handleGlobalKeydownEvent(api2),
    handleHashChange: index.handleHashChange(api2),
    maximize: index.maximize({ api: api2, nextTick, props, state, isMobileFirstMode }),
    revert: index.revert({ api: api2, nextTick, state, isMobileFirstMode }),
    toggleZoomEvent: index.toggleZoomEvent({ api: api2, emit, parent, state, isMobileFirstMode }),
    mousedownEvent: index.mousedownEvent({ api: api2, nextTick, props, state, emit, isMobileFirstMode }),
    dragEvent: index.dragEvent({ api: api2, emit, parent, props, state }),
    resetDragStyle: index.resetDragStyle(api2),
    resetModalViewPosition: index.resetModalViewPosition(api2),
    computedBoxStyle: index.computedBoxStyle({ props, isMobileFirstMode }),
    watchVisible: index.watchVisible({ api: api2, props }),
    hideScrollbar: index.hideScrollbar(lockScrollClass),
    showScrollbar: index.showScrollbar(lockScrollClass)
  });
  watch(() => props.modelValue, api2.watchValue);
  watch(() => state.visible, api2.watchVisible);
  api2.created();
  onMounted(api2.mounted);
  onBeforeUnmount(api2.beforeUnmouted);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
