"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const dateUtil = require("../common/deps/date-util.js");
const api = [
  "state",
  "rightNextYear",
  "rightPrevYear",
  "handleRangePick",
  "handleShortcutClick",
  "handleChangeRange",
  "leftPrevYear",
  "leftNextYear",
  "isValidValue"
];
const initState = ({ reactive, computed, api: api2, t }) => {
  const state = reactive({
    popperClass: "",
    value: [],
    defaultValue: null,
    defaultTime: null,
    minDate: "",
    maxDate: "",
    leftDate: /* @__PURE__ */ new Date(),
    rightDate: dateUtil.nextYear(/* @__PURE__ */ new Date()),
    rangeState: { endDate: null, selecting: false, row: null, column: null },
    shortcuts: "",
    visible: "",
    disabledDate: "",
    format: "",
    arrowControl: false,
    unlinkPanels: false,
    btnDisabled: computed(
      () => !(state.minDate && state.maxDate && !state.selecting && api2.isValidValue([state.minDate, state.maxDate]))
    ),
    leftLabel: computed(() => state.leftDate.getFullYear() + " " + t("ui.datepicker.year")),
    rightLabel: computed(() => state.rightDate.getFullYear() + " " + t("ui.datepicker.year")),
    leftYear: computed(() => state.leftDate.getFullYear()),
    rightYear: computed(
      () => state.rightDate.getFullYear() === state.leftDate.getFullYear() ? state.leftDate.getFullYear() + 1 : state.rightDate.getFullYear()
    ),
    enableYearArrow: computed(() => state.unlinkPanels && state.rightYear > state.leftYear + 1)
  });
  return state;
};
const renderless = (props, { computed, reactive, watch }, { t, emit: $emit }) => {
  const api2 = {};
  const emit = props.emitter ? props.emitter.emit : $emit;
  const state = initState({ reactive, computed, api: api2, t });
  Object.assign(api2, {
    state,
    resetView: index.resetView(state),
    handleChangeRange: index.handleChangeRange(state),
    isValidValue: index.isValidValue(state),
    leftNextYear: index.leftNextYear(state),
    leftPrevYear: index.leftPrevYear(state),
    doPick: index.doPick(emit),
    rightNextYear: index.rightNextYear(state),
    rightPrevYear: index.rightPrevYear(state),
    watchValue: index.watchValue({ state }),
    handleClear: index.handleClear({ emit, state }),
    watchDefaultValue: index.watchDefaultValue({ state }),
    handleConfirm: index.handleConfirm({ api: api2, emit, state }),
    handleRangePick: index.handleRangePick({ api: api2, state, t }),
    handleShortcutClick: index.handleShortcutClick(api2)
  });
  watch(() => state.value, api2.watchValue);
  watch(() => state.defaultValue, api2.watchDefaultValue);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
