"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index$1 = require("./index.js");
const index = require("../common/index.js");
const api = ["state", "handleMonthTableClick", "handleMouseMove", "getCellStyle"];
const renderless = (props, { computed, reactive, watch }, { t, vm, emit }) => {
  const api2 = {};
  const { MonhtList } = index.DATEPICKER;
  const state = reactive({
    months: MonhtList,
    tableRows: [[], [], []],
    lastRow: null,
    lastColumn: null,
    rows: computed(() => api2.getRows())
  });
  Object.assign(api2, {
    t,
    state,
    getMonthOfCell: index$1.getMonthOfCell(props),
    cellMatchesDate: index$1.cellMatchesDate(props),
    markRange: index$1.markRange({ props, state }),
    watchDate: index$1.watchDate({ api: api2, props }),
    getMonthTimestamp: index$1.getMonthTimestamp(api2),
    handleMouseMove: index$1.handleMouseMove({ api: api2, emit, props, state }),
    handleMonthTableClick: index$1.handleMonthTableClick({ api: api2, emit, props }),
    getCellStyle: index$1.getCellStyle({ api: api2, props }),
    getRows: index$1.getRows({ props, state, vm })
  });
  watch(
    () => props.rangeState,
    (value) => api2.markRange(props.minDate, value.endDate),
    { deep: true }
  );
  watch(() => props.minDate, api2.watchDate);
  watch(() => props.maxDate, api2.watchDate);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
