"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "created",
  "handleClick",
  "confirm",
  "reset",
  "wheelChange",
  "clickWheelItem",
  "loadDefault",
  "handleSearchBtnClick",
  "handleClose",
  "handleSearchInput"
];
const initState = ({ emitter, reactive, computed, api: api2, props }) => {
  const state = reactive({
    dataSource: [],
    wheelData: [],
    isSearching: false,
    headerIndex: -1,
    showOptions: false,
    labelLevelsInfo: [],
    labelsStyle: [],
    wheelIndex: [],
    wheelText: "",
    headerInfo: [],
    defaultSelectedIndexs: [],
    defaultSelectedArray: [],
    multiSelectEmitter: emitter(),
    searchValue: "",
    optionMap: [],
    currentOptions: computed(() => api2.computedCurrentOptions()),
    showMask: computed(() => props.mask && state.showOptions)
  });
  return state;
};
const initApi = ({ api: api2, props, state, emit, nextTick, refs, vm }) => {
  Object.assign(api2, {
    state,
    created: index.created({ api: api2, emit, props, state, refs, nextTick }),
    initValue: index.initValue({ props, emit }),
    handleClick: index.handleClick({ api: api2, props, state }),
    confirm: index.confirm({ state, emit }),
    reset: index.reset({ api: api2, props, state, emit }),
    wheelChange: index.wheelChange(state),
    clickWheelItem: index.clickWheelItem({ state, emit }),
    loadDefault: index.loadDefault({ props, state }),
    handleSearchBtnClick: index.handleSearchBtnClick({ props, state, nextTick, vm }),
    handleOptionSelect: index.handleOptionSelect({ api: api2, state, emit }),
    handleClose: index.handleClose(state),
    toggleItemExpand: index.toggleItemExpand({ state }),
    computedCurrentOptions: index.computedCurrentOptions({ state, props }),
    updateValue: index.updateValue({ state, props, emit }),
    updateTitle: index.updateTitle({ props, state }),
    handleSearchInput: index.handleSearchInput({ state, emit })
  });
};
const initWatch = ({ api: api2, watch, props, state, refs, nextTick }) => {
  watch(
    () => props.dataSource,
    () => {
      api2.created({ props, state, refs, nextTick });
    }
  );
  watch(
    () => props.defaultSelectedArray,
    () => {
      api2.created({ props, state, refs, nextTick });
    }
  );
  watch(
    () => props.modelValue,
    () => {
      api2.updateTitle();
    },
    { deep: true }
  );
};
const renderless = (props, { onMounted, reactive, watch, provide, computed }, { emit, nextTick, refs, vm, emitter }) => {
  const api2 = {};
  const state = initState({ emitter, reactive, computed, api: api2, props });
  provide("multiSelect", vm);
  initApi({ api: api2, props, state, emit, nextTick, refs, vm });
  initWatch({ api: api2, watch, props, state, refs, nextTick });
  onMounted(() => {
    api2.created({ props, state, refs, nextTick });
  });
  state.multiSelectEmitter.on("multiSelectItemClick", api2.handleOptionSelect);
  state.multiSelectEmitter.on("toggleItemExpand", api2.toggleItemExpand);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
