"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "getSelectedIndex",
  "showSetting",
  "willHideSetting",
  "showSubMenu",
  "hideSubMenu",
  "willHideSubMenu",
  "stopHideSubMenu",
  "setSubMenu",
  "leaveMoreMune",
  "isHide",
  "hidePopmenu",
  "clickMenu",
  "skip",
  "getPoint",
  "classify",
  "calcWidth",
  "getTag",
  "getUrl",
  "getRoute",
  "setActiveMenu",
  "handleTitleMouseenter",
  "getMoreSelected",
  "getLeftSelected",
  "getLastChildSelected",
  "getTabSelected",
  "handleTitleMouseleave"
];
const initState = ({ reactive, api: api2, computed, vm }) => reactive({
  data: [],
  more: [],
  width: -1,
  enterMenu: false,
  popMenuTop: 0,
  defaultActiveId: null,
  subMenu: [],
  showMore: false,
  showPopmenu: false,
  enterMoreMenu: false,
  timer: null,
  activeIndex: -1,
  subActiveIndex: -1,
  selectedIndex: -1,
  subItemSelectedIndex: -1,
  moreItemSelectedIndex: -1,
  subIndex: -1,
  isShowSetting: false,
  tooltipVisible: false,
  tooltipContent: "",
  isSaaSTheme: vm.theme === "saas",
  menuClass: "",
  isShowMore: computed(() => api2.computedIsShowMore()),
  popClass: computed(() => api2.computedPopClass()),
  subMenus: computed(() => api2.computedSubMenus()),
  menuStyle: computed(() => api2.computedMenuStyle()),
  popStyle: computed(() => api2.computedPopStyle())
});
const initApi = ({ api: api2, state, props, parent, fetchMenuData, fields, router, route, nextTick, vm }) => {
  Object.assign(api2, {
    state,
    getUrl: index.getUrl(),
    getTag: index.getTag(props),
    getRoute: index.getRoute(props),
    setSubMenu: index.setSubMenu(state),
    leaveMoreMune: index.leaveMoreMune(state),
    isHide: index.isHide({ parent, state }),
    setActiveMenu: index.setActiveMenu(state),
    willHideSetting: index.willHideSetting(state),
    stopHideSubMenu: index.stopHideSubMenu(state),
    calcWidth: index.calcWidth({ parent, props, state }),
    getSelectedIndex: index.getSelectedIndex(state),
    showSetting: index.showSetting({ parent, state }),
    initData: index.initData({ fetchMenuData, fields, props, state }),
    computedIsShowMore: index.computedIsShowMore({ props, state }),
    computedPopClass: index.computedPopClass(state),
    computedSubMenus: index.computedSubMenus(state),
    computedMenuStyle: index.computedMenuStyle({ props, state }),
    computedPopStyle: index.computedPopStyle(state),
    skip: index.skip({ api: api2, router, fields }),
    hidePopmenu: index.hidePopmenu(api2),
    getPoint: index.getPoint({ api: api2, parent }),
    clickMenu: index.clickMenu({ api: api2, props, state }),
    unMounted: index.unMounted({ api: api2, state, router }),
    mounted: index.mounted({ api: api2, props, router, route, state }),
    classify: index.classify({ api: api2, props, state }),
    watchWidth: index.watchWidth({ api: api2, nextTick }),
    willHideSubMenu: index.willHideSubMenu({ api: api2, state }),
    hideSubMenu: index.hideSubMenu({ api: api2, parent, state }),
    showSubMenu: index.showSubMenu({ api: api2, nextTick, parent, state, vm }),
    handleTitleMouseenter: index.handleTitleMouseenter({ state, vm }),
    getMoreSelected: index.getMoreSelected({ state }),
    getLeftSelected: index.getLeftSelected({ state }),
    getLastChildSelected: index.getLastChildSelected({ state }),
    getTabSelected: index.getTabSelected({ state }),
    handleTitleMouseleave: index.handleTitleMouseleave({ state })
  });
};
const renderless = (props, { computed, onMounted, onUnmounted, reactive, watch }, { parent, nextTick, service, router, route, vm }) => {
  const api2 = {};
  const { fetchMenuData, fields } = index.initService({ props, service });
  const state = initState({ reactive, api: api2, computed, vm });
  initApi({ api: api2, state, props, parent, fetchMenuData, fields, router, route, nextTick, vm });
  api2.initData();
  watch(() => state.width, api2.watchWidth, { deep: true, immediate: true });
  watch(() => state.data, api2.watchWidth);
  onMounted(api2.mounted);
  onUnmounted(api2.unMounted);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
