"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "onPagerClick", "onMouseenter"];
const renderless = (props, { computed, reactive, watch }, { emit, vm }) => {
  const api2 = {
    onPagerClick: index.onPagerClick({ emit, props, vm })
  };
  const state = reactive({
    current: null,
    showPrevMore: false,
    showNextMore: false,
    quicknextIconClass: props.popupIcon,
    quickprevIconClass: props.popupIcon,
    pagers: computed(() => api2.getPages())
  });
  Object.assign(api2, {
    state,
    getPages: index.getPages({ props, state }),
    onMouseenter: index.onMouseenter({ props, state })
  });
  watch(
    () => state.showPrevMore,
    (value) => {
      if (!value) {
        state.quickprevIconClass = props.popupIcon;
      }
    },
    { immediate: true }
  );
  watch(
    () => state.showNextMore,
    (value) => {
      if (!value) {
        state.quicknextIconClass = props.popupIcon;
      }
    },
    { immediate: true }
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
