"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "handleJumperFocus",
  "handleSizeChange",
  "handleJumperInput",
  "handleJumperChange",
  "handleJumperClick",
  "isValueNumber",
  "parseValueNumber",
  "handleSizeShowPopover",
  "handleSizeHidePopover",
  "canJumperGo",
  "beforeSizeChangeHandler",
  "beforePagerChangeHandler",
  "beforeJumperChangeHandler",
  "beforeChangeHandler",
  "handleCurrentChange",
  "prev",
  "next",
  "buildBeforePageChangeParam",
  "getValidCurrentPage",
  "emitChange",
  "setTotal",
  "clickSizes"
];
const renderless = (props, { reactive, computed, watch }, { emit, vm, nextTick, t, designConfig }) => {
  var _a, _b, _c, _d;
  const api2 = {};
  const state = reactive({
    showSizes: false,
    internalCurrentPage: 1,
    internalPageSize: props.pageSize,
    lastEmittedPage: -1,
    userChangePageSize: false,
    internalTotal: props.total,
    jumperValue: "1",
    jumperBackup: "1",
    simplestPagerOption: computed(() => api2.computedSimplestPagerOption()),
    simplestPagerWidth: computed(() => api2.computedSimplestPagerWidth()),
    showPager: computed(() => api2.computedShowPager()),
    internalLayout: computed(() => api2.computedInternalLayout()),
    totalText: computed(() => api2.computedTotalText()),
    internalPageCount: computed(() => api2.computedInternalPageCount()),
    showJumperSuffix: (_b = (_a = designConfig == null ? void 0 : designConfig.state) == null ? void 0 : _a.showJumperSuffix) != null ? _b : true,
    align: props.align || ((_c = designConfig == null ? void 0 : designConfig.state) == null ? void 0 : _c.align) || "right",
    totalI18n: ((_d = designConfig == null ? void 0 : designConfig.state) == null ? void 0 : _d.totalI18n) || "totals",
    totalFixedLeft: computed(
      () => {
        var _a2, _b2, _c2, _d2;
        return (_d2 = (_c2 = (_b2 = props.totalFixedLeft) != null ? _b2 : (_a2 = designConfig == null ? void 0 : designConfig.state) == null ? void 0 : _a2.totalFixedLeft) != null ? _c2 : props.mode !== "simplest") != null ? _d2 : true;
      }
    ),
    pageSizeText: computed(() => api2.computedPageSizeText())
  });
  Object.assign(api2, {
    state,
    computedShowPager: index.computedShowPager({ props, state }),
    computedInternalLayout: index.computedInternalLayout({ props }),
    computedTotalText: index.computedTotalText({ props, t }),
    computedInternalPageCount: index.computedInternalPageCount({ props, state }),
    computedSimplestPagerOption: index.computedSimplestPagerOption({ props, state }),
    computedSimplestPagerWidth: index.computedSimplestPagerWidth({ state }),
    computedPageSizeText: index.computedPageSizeText({ props, designConfig }),
    getValidCurrentPage: index.getValidCurrentPage({ state }),
    handleJumperFocus: index.handleJumperFocus({ state }),
    handleSizeChange: index.handleSizeChange({ props, state, api: api2, emit, vm }),
    handleJumperInput: index.handleJumperInput({ state }),
    handleJumperChange: index.handleJumperChange({ props, state, api: api2 }),
    handleJumperClick: index.handleJumperClick({ props, state, api: api2 }),
    isValueNumber: index.isValueNumber({ state }),
    parseValueNumber: index.parseValueNumber({ state }),
    handleSizeShowPopover: index.handleSizeShowPopover({ state, props }),
    handleSizeHidePopover: index.handleSizeHidePopover({ state }),
    canJumperGo: index.canJumperGo({ props, state, vm }),
    beforeSizeChangeHandler: index.beforeSizeChangeHandler({ state, emit }),
    beforePagerChangeHandler: index.beforePagerChangeHandler({ state, emit }),
    copyEmit: index.copyEmit({ emit }),
    beforeChangeHandler: index.beforeChangeHandler({ state, api: api2 }),
    handleCurrentChange: index.handleCurrentChange({ state, api: api2 }),
    prev: index.prev({ state, props, api: api2, emit }),
    next: index.next({ props, state, api: api2, emit }),
    buildBeforePageChangeParam: index.buildBeforePageChangeParam({ state }),
    emitChange: index.emitChange({ state, nextTick, emit }),
    setTotal: index.setTotal({ state }),
    clickSizes: index.clickSizes(),
    // watch
    watchInternalCurrentPage: index.watchInternalCurrentPage({ state, emit }),
    watchPageSizes: index.watchPageSizes({ state, props }),
    watchCurrentPage: index.watchCurrentPage({ state, api: api2 }),
    watchInternalPageCount: index.watchInternalPageCount({ state, api: api2 }),
    watchPageSize: index.watchPageSize({ state }),
    watchTotal: index.watchTotal({ state }),
    watchShowSizes: index.watchShowSizes({ nextTick, vm })
  });
  state.internalCurrentPage = api2.getValidCurrentPage(props.currentPage);
  watch(() => state.internalCurrentPage, api2.watchInternalCurrentPage);
  watch(() => props.pageSizes, api2.watchPageSizes, { immediate: true });
  watch(() => props.currentPage, api2.watchCurrentPage);
  watch(() => state.internalPageCount, api2.watchInternalPageCount);
  watch(() => props.pageSize, api2.watchPageSize, { immediate: true });
  watch(() => props.total, api2.watchTotal);
  watch(() => state.showSizes, api2.watchShowSizes);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
