"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const dom = require("../common/deps/dom.js");
const index = require("./index.js");
const api = ["state", "show", "hide", "confirm", "handleEmit"];
const renderless = (props, { computed, reactive, onMounted, onBeforeUnmount }, { emit, constants, designConfig, vm }) => {
  var _a;
  const api2 = {};
  const designIcon = (_a = designConfig == null ? void 0 : designConfig.icons) == null ? void 0 : _a[props.type];
  const state = reactive({
    isLock: false,
    showPopover: false,
    getIcon: computed(
      () => typeof props.type === "object" ? props.type : designIcon || constants.ICON_MAP[props.type]
    )
  });
  Object.assign(api2, {
    state,
    show: index.show({ state, emit, props }),
    hide: index.hide({ state, emit }),
    confirm: index.confirm({ state, api: api2 }),
    handleEmit: index.handleEmit({ state, emit, vm }),
    handleDocumentClick: index.handleDocumentClick({ api: api2, vm })
  });
  onMounted(() => {
    props.closeOnClickOutside && dom.on(document, "click", api2.handleDocumentClick);
  });
  onBeforeUnmount(() => {
    props.closeOnClickOutside && dom.off(document, "click", api2.handleDocumentClick);
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
