"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state"];
const renderless = (props, { watch, onMounted, reactive, onBeforeUnmount }, { t, refs, emit, nextTick }) => {
  const api2 = {};
  const state = reactive({
    pullDownReplaces: "",
    refreshStyle: {},
    translate3d: 0,
    draggposition: 0,
    pullUpLoading: false,
    pullDownLoading: false,
    loosingText: "",
    successText: "",
    failedText: "",
    noMoreText: t("ui.pullRefresh.noMore"),
    pullUpLoadingText: props.pullUpLoadingText,
    pullDownLoadingText: props.pullDownLoadingText,
    pullUp: null,
    pullDown: null,
    hasMore: true,
    successDuration: props.successDuration,
    animationDuration: props.animationDuration,
    disabledPullDown: props.disabledPullDown,
    disabledPullUp: props.disabledPullUp,
    pullUpDistance: typeof props.pullUpDistance === "string" ? Number(props.pullUpDistance) : props.pullUpDistance,
    timer: null
  });
  Object.assign(api2, {
    state,
    onTouchstart: index.onTouchstart(state),
    onTouchmove: index.onTouchmove({ state, refs }),
    onTouchend: index.onTouchend({ api: api2, props, state, emit, refs }),
    onScroll: index.onScroll({ state, emit, refs }),
    mountedHandler: index.mountedHandler({ api: api2, refs }),
    beforeUnmountHandler: index.beforeUnmountHandler({ api: api2, refs }),
    handlerModelValue: index.handlerModelValue({ api: api2, state }),
    initPullRefresh: index.initPullRefresh({ t, props, state }),
    clearPullRefresh: index.clearPullRefresh(state)
  });
  watch(
    () => props.hasMore,
    (value) => {
      state.hasMore = value;
    },
    { immediate: true }
  );
  watch(
    () => props.modelValue,
    (value) => {
      if (!value) {
        api2.clearPullRefresh();
      }
    }
  );
  onMounted(() => {
    api2.mountedHandler({ api: api2, refs, state });
    api2.initPullRefresh({ t, props, state });
  });
  onBeforeUnmount(api2.beforeUnmountHandler);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
