"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("../common/index.js");
const index$1 = require("./index.js");
const api = [
  "state",
  "handleQuarterTableClick",
  "showYearPicker",
  "handleYearPick",
  "cusPrevYear",
  "cusNextYear",
  "getCellStyle"
];
const renderless = (props, { reactive, computed }, { emit, t }) => {
  const api2 = {};
  const state = reactive({
    date: /* @__PURE__ */ new Date(),
    visible: false,
    currentView: index.DATEPICKER.Quarter,
    yearLabel: computed(() => api2.getYearLabel()),
    startYear: Math.floor((/* @__PURE__ */ new Date()).getFullYear() / 10) * 10,
    rows: [{ text: "Q1" }, { text: "Q2" }, { text: "Q3" }, { text: "Q4" }]
  });
  Object.assign(api2, {
    state,
    handleQuarterTableClick: index$1.handleQuarterTableClick({ state, emit }),
    showYearPicker: index$1.showYearPicker({ state }),
    handleYearPick: index$1.handleYearPick({ state }),
    cusPrevYear: index$1.cusPrevYear({ state }),
    cusNextYear: index$1.cusNextYear({ state }),
    getYearLabel: index$1.getYearLabel({ state, t }),
    getCellStyle: index$1.getCellStyle({ api: api2, props, state })
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
