"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleKeydown"];
const renderless = (props, { computed, onMounted, reactive, watch, provide }, { parent, dispatch }) => {
  const state = reactive({
    radioGroupSize: computed(() => props.size),
    tag: "div",
    activeStyle: props.fill
  });
  parent.$on("handleChange", (value) => {
    parent.$emit("change", value);
  });
  const api2 = {
    state,
    dispatch,
    onMounted: index.mounted(parent),
    handleKeydown: index.handleKeydown(parent)
  };
  watch(
    () => props.modelValue,
    (value) => {
      api2.dispatch("FormItem", "form.change", [value]);
    }
  );
  onMounted(api2.onMounted);
  provide("radioVertical", props.vertical);
  provide("showTips", props.showTips);
  provide("size", props.size);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
