"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleChange"];
const renderless = (props, { onMounted, onBeforeUnmount, computed, reactive, inject }, { vm, parent, emit, constants, nextTick, dispatch }) => {
  parent.tinyForm = parent.tinyForm || inject("form", null);
  const api2 = {};
  const state = reactive({
    vertical: inject("radioVertical", false),
    size: computed(() => props.size || inject("size", null) || (parent.tinyForm || {}).size),
    focus: false,
    radioGroup: null,
    isGroup: computed(() => api2.isGroup()),
    radioSize: computed(() => api2.radioSize()),
    isDisabled: computed(() => api2.isDisabled()),
    isDisplayOnly: computed(() => api2.isDisplayOnly() || (parent.tinyForm || {}).displayOnly),
    tabIndex: computed(() => api2.tabIndex()),
    formDisabled: computed(() => (parent.tinyForm || {}).disabled),
    model: computed({
      get: () => api2.getModel(),
      set: (val) => api2.setModel(val)
    })
  });
  Object.assign(api2, {
    state,
    radioSize: index.radioSize({ props, state }),
    getModel: index.getModel({ props, state }),
    isGroup: index.isGroup({ constants, parent, state }),
    tabIndex: index.tabIndex({ props, state }),
    isDisabled: index.isDisabled({ props, state }),
    isDisplayOnly: index.isDisplayOnly({ props }),
    setModel: index.setModel({ constants, dispatch, emit, props, vm, state }),
    handleChange: index.handleChange({ constants, dispatch, emit, state, nextTick })
  });
  onMounted(() => {
    dispatch("Tooltip", "tooltip-update");
    index.toggleEvent({ props, vm, type: "add" });
  });
  onBeforeUnmount(() => {
    index.toggleEvent({ props, vm, type: "remove" });
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
