"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const resizeEvent = require("../common/deps/resize-event.js");
const api = ["state", "lightUp", "style"];
const renderless = (props, { computed, onMounted, onBeforeUnmount, reactive }, { vm, emit, parent }, { echarts }) => {
  const state = reactive({
    myChart: null,
    markLineShow: false,
    lighting: [],
    nameInfo: null,
    styling: [],
    option: null,
    canvasStyle: computed(() => api2.computeCanvasStyle()),
    canvasWidth: null,
    canvasTransformOrigin: "left top",
    canvasTransform: null
  });
  const api2 = {
    state,
    getRenderLege: index.getRenderLege(),
    getTooltip: index.getTooltip(),
    getMarkLine: index.getMarkLine(),
    setChartOption: index.setChartOption(state),
    setRiverRgbaOpacity: index.setRiverRgbaOpacity({ props, state }),
    setRiverIconStyle: index.setRiverIconStyle(state),
    computeCanvasStyle: index.computeCanvasStyle({ props, state }),
    getContainerWidth: index.getContainerWidth(state),
    resizeListener: index.resizeListener({ props, state })
  };
  Object.assign(api2, {
    buildOption: index.buildOption({ api: api2, emit, props, state, vm }),
    getRenderNode: index.getRenderNode({ api: api2, echarts }),
    getRenderLink: index.getRenderLink({ api: api2, echarts }),
    getRenderIcon: index.getRenderIcon({ api: api2 }),
    setListeners: index.setListeners({ api: api2, emit, state }),
    lightUp: index.lightUp({ api: api2, state }),
    style: index.style({ api: api2, state })
  });
  onMounted(() => {
    state.myChart = echarts.init(vm.$el);
    state.containerEl = parent.$parent.$el;
    const option = state.option = api2.buildOption();
    api2.setChartOption(option);
    api2.setListeners(option);
    state.containerEl && resizeEvent.addResizeListener(state.containerEl, api2.resizeListener);
  });
  onBeforeUnmount(() => {
    state.myChart.off("mousemove");
    state.myChart.getZr().off("mousemove");
    state.myChart.off("click");
    state.myChart = null;
    state.containerEl && resizeEvent.removeResizeListener(state.containerEl, api2.resizeListener);
    state.containerEl = null;
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
