"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const dom = require("../common/deps/dom.js");
const api = [
  "state",
  "startDrag",
  "renderThumbStyle",
  "clickTrackHandler",
  "clickThumbHandler",
  "mouseUpDocumentHandler",
  "mouseMoveDocumentHandler"
];
const renderless = (props, { computed, onUnmounted, reactive }, { vm, parent }) => {
  const state = reactive({
    bar: computed(() => index.BAR_MAP[props.vertical ? "vertical" : "horizontal"]),
    wrap: computed(() => parent.$refs.wrap)
  });
  const api2 = {
    state,
    renderThumbStyle: index.renderThumbStyle,
    clickTrackHandler: index.clickTrackHandler({ vm, state }),
    mouseMoveDocumentHandler: index.mouseMoveDocumentHandler({ vm, state })
  };
  onUnmounted(() => dom.off(document, "mouseup", api2.mouseUpDocumentHandler));
  return Object.assign(api2, {
    startDrag: index.startDrag({ api: api2, on: dom.on, state }),
    clickThumbHandler: index.clickThumbHandler({ api: api2, state }),
    mouseUpDocumentHandler: index.mouseUpDocumentHandler({ api: api2, off: dom.off, state })
  });
};
exports.api = api;
exports.renderless = renderless;
