"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const resizeEvent = require("../common/deps/resize-event.js");
const api = ["state", "update", "handleScroll"];
const renderless = (props, { onBeforeUnmount, onMounted, reactive }, { vm, nextTick, emit }) => {
  const state = reactive({
    sizeWidth: "0",
    sizeHeight: "0",
    moveX: 0,
    moveY: 0
  });
  const api2 = {
    state,
    update: index.update({ vm, state }),
    handleScroll: index.handleScroll({ vm, state, emit })
  };
  onMounted(() => {
    if (props.native) {
      return;
    }
    nextTick(api2.update);
    !props.noresize && resizeEvent.addResizeListener(vm.$refs.resize, api2.update);
  });
  onBeforeUnmount(() => {
    if (props.native) {
      return;
    }
    !props.noresize && resizeEvent.removeResizeListener(vm.$refs.resize, api2.update);
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
