"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const chunkG2ADBYYC = require("../chunk-G2ADBYYC.js");
const index = require("./index.js");
const api = [
  "state",
  "handleChange",
  "handleInput",
  "showSelector",
  "changeKey",
  "searchClick",
  "searchEnterKey",
  "inputStyle",
  "formatSearchTypes",
  "setDefaultType",
  "clear"
];
const useFormatSearchTypes = ({ computed, props, reactive, toRefs, watch }) => {
  const api2 = {
    setDefaultType: index.setDefaultType,
    formatSearchTypes: index.formatSearchTypes
  };
  const state = reactive({
    searchValue: props.typeValue,
    types: computed(() => api2.formatSearchTypes(props.searchTypes))
  });
  watch(
    () => props.typeValue,
    () => {
      state.searchValue = api2.setDefaultType(props.searchTypes, props.typeValue);
    },
    { immediate: true }
  );
  return {
    api: api2,
    state: toRefs(state)
  };
};
const renderless = (props, { computed, onBeforeUnmount, onMounted, reactive, toRefs, watch }, { vm, parent, emit, nextTick }) => {
  const formatSearchTypes2 = useFormatSearchTypes({
    computed,
    props,
    reactive,
    toRefs,
    watch
  });
  const state = reactive(chunkG2ADBYYC.__spreadProps(chunkG2ADBYYC.__spreadValues({
    show: false,
    focus: false,
    hovering: false,
    collapse: props.mini,
    currentValue: props.modelValue
  }, formatSearchTypes2.state), {
    showClear: computed(() => props.clearable && (state.focus || state.hovering) && state.currentValue),
    formItemSize: computed(() => (parent.formItem || {}).formItemSize),
    searchSize: computed(() => props.size || state.formItemSize)
  }));
  const api2 = chunkG2ADBYYC.__spreadValues({
    state,
    changeKey: index.changeKey({ state, emit }),
    handleChange: index.handleChange({ emit, state }),
    showSelector: index.showSelector({ vm, state }),
    searchClick: index.searchClick({ emit, props, state }),
    clickOutside: index.clickOutside({ parent, props, state }),
    emitInput: index.emitInput({ emit })
  }, formatSearchTypes2.api);
  Object.assign(api2, {
    clear: index.clear({ api: api2, emit, vm, state }),
    handleInput: index.handleInput({ api: api2, props, state }),
    searchEnterKey: index.searchEnterKey({ api: api2, props, vm, nextTick })
  });
  onMounted(index.mounted({ api: api2 }));
  onBeforeUnmount(index.beforeDestroy({ api: api2 }));
  watch(
    () => props.modelValue,
    (value) => state.currentValue = value
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
exports.useFormatSearchTypes = useFormatSearchTypes;
