"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "hide",
  "selectOption",
  "confirm",
  "searchMethod",
  "searchSelectHandler",
  "searchBoxToggle",
  "includeOptionIndex",
  "isSelected",
  "allCheckHandler"
];
const renderless = (props, { computed, reactive, watch }, { emit }) => {
  const api2 = {};
  const state = reactive({
    toggle: false,
    checkList: [],
    search: {
      show: false,
      input: "",
      options: [],
      filterOptions: []
    },
    checkIds: computed(() => state.checkList.map((option) => option[props.valueField])),
    selectedLabel: ""
  });
  Object.assign(api2, {
    state,
    confirm: index.confirm({ state, emit, props, api: api2 }),
    selectOption: index.selectOption({ state, emit, props, api: api2 }),
    hide: index.hide({ state, emit }),
    watchVisible: index.watchVisible({ emit, state, props, api: api2 }),
    watchModelValue: index.watchModelValue({ api: api2 }),
    searchMethod: index.searchMethod({ state, props }),
    searchSelectHandler: index.searchSelectHandler({ state, emit, api: api2, props }),
    searchBoxToggle: index.searchBoxToggle({ state, props, api: api2 }),
    allCheckHandler: index.allCheckHandler({ state, props }),
    includeOptionIndex: index.includeOptionIndex(props),
    isSelected: index.isSelected({ state, api: api2, props }),
    watchPropsOption: index.watchPropsOption({ api: api2 }),
    setSelected: index.setSelected({ props, state, emit })
  });
  watch(() => props.visible, api2.watchVisible);
  watch(() => props.modelValue, api2.watchModelValue);
  watch(() => props.menus, api2.watchPropsOption, { immediate: true, deep: true });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
