"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "allCheckHandler",
  "close",
  "confirm",
  "searchMethod",
  "searchSelectHandler",
  "searchBoxToggle",
  "includeOptionIndex",
  "clean",
  "load",
  "selectedOptionHandler",
  "toggleCheckList"
];
const renderless = (props, { computed, reactive, watch }, { emit, vm }) => {
  const api2 = {};
  const state = reactive({
    toggle: false,
    checkList: [],
    selected: {
      show: false,
      options: []
    },
    search: {
      filterOptions: [],
      input: "",
      options: props.menus || [],
      loading: false
    },
    checkIds: computed(() => state.checkList.map((option) => option[props.valueField])),
    lazy: computed(() => !props.infiniteScroll.disabled && typeof props.infiniteScroll.load === "function")
  });
  Object.assign(api2, {
    state,
    confirm: index.confirm({ state, emit, props, api: api2 }),
    close: index.close({ state, emit, vm }),
    watchVisible: index.watchVisible({ emit, state, props, api: api2 }),
    watchModelValue: index.watchModelValue({ props, state, emit }),
    searchMethod: index.searchMethod({ state, props }),
    searchSelectHandler: index.searchSelectHandler({ state, emit, api: api2, props }),
    searchBoxToggle: index.searchBoxToggle({ state, props, api: api2 }),
    allCheckHandler: index.allCheckHandler({ state, props }),
    toggleCheckList: index.toggleCheckList({ state }),
    clean: index.clean({ state, props }),
    load: index.load({ state, props, api: api2 }),
    selectedOptionHandler: index.selectedOptionHandler({ state, api: api2 }),
    includeOptionIndex: index.includeOptionIndex(props)
  });
  watch(() => props.visible, api2.watchVisible, { immediate: true });
  watch(() => props.modelValue, api2.watchModelValue, { immediate: true });
  watch(
    () => props.menus,
    (value) => {
      state.search.options = value;
      api2.searchMethod();
    }
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
