"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "init",
  "submitSelection",
  "getSelection",
  "i18nSelected",
  "textPrimary",
  "textAuxi",
  "handleMouseenter",
  "handleMouseleave",
  "handleClear",
  "handleDelete",
  "keyOption",
  "keyType",
  "batchSubmit",
  "coverSubmit"
];
const renderless = (props, { reactive, computed, onBeforeMount, onMounted, onBeforeUnmount, watch, markRaw }, { emit, t, vm }) => {
  const state = reactive({
    inverse: false,
    total: 0,
    select: [],
    refresh: 0,
    optionSelector: '[data-tag="tiny-selected-box-item"]',
    dragAnimation: 100,
    showAuxi: computed(() => api2.computedShowAuxi()),
    popoverVisible: false,
    popoverContent: "",
    dragInstance: null,
    slotParams: computed(() => ({ inverse: state.inverse, total: state.total, select: state.select })),
    showClear: computed(() => api2.computedShowClear()),
    theme: vm.theme
  });
  const api2 = {
    state,
    init: index.init({ props, state }),
    i18nSelected: index.i18nSelected({ state, t }),
    computedShowAuxi: index.computedShowAuxi(props),
    textPrimary: index.textPrimary(props),
    textAuxi: index.textAuxi(props),
    handleMouseenter: index.handleMouseenter({ state, vm }),
    handleMouseleave: index.handleMouseleave(state),
    keyType: index.keyType(props),
    unmount: index.unmount(state),
    getParams: index.getParams(state),
    computedShowClear: index.computedShowClear(state)
  };
  Object.assign(api2, {
    submitSelection: index.submitSelection({ api: api2, state }),
    handleClear: index.handleClear({ api: api2, emit, props, state }),
    handleDelete: index.handleDelete({ api: api2, emit, state }),
    emitChange: index.emitChange({ api: api2, emit }),
    initDrag: index.initDrag({ api: api2, emit, markRaw, props, state, vm }),
    arrayMinus: index.arrayMinus(api2),
    batchSubmit: index.batchSubmit({ api: api2, state }),
    getSelection: index.getSelection({ api: api2, state }),
    coverSubmit: index.coverSubmit({ api: api2, props, state }),
    keyOption: index.keyOption({ api: api2, props })
  });
  onBeforeMount(() => {
    api2.init();
  });
  onMounted(() => {
    api2.initDrag();
  });
  onBeforeUnmount(() => {
    api2.unmount();
  });
  watch(
    () => props.inverse,
    () => api2.init()
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
