"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const touchEmulator = require("../common/deps/touch-emulator.js");
const useRect = require("../common/deps/useRect.js");
const index = require("./index.js");
touchEmulator.default();
const api = [
  "state",
  "touchStart",
  "touchMove",
  "touchEnd",
  "rewrite",
  "submit",
  "toggleFullscreen",
  "initCanvas",
  "cancel",
  "tranformImage",
  "redraw",
  "getSignatureImage"
];
const renderless = (props, { unref, reactive, onMounted, onBeforeUnmount, watch, markRaw }, { emit, vm, nextTick, t, useBreakpoint }, { Modal }) => {
  const { current } = useBreakpoint();
  const state = reactive({
    width: 0,
    height: 0,
    ctx: null,
    isBeginWrite: false,
    isFullscreen: false,
    current,
    canvasRect: null,
    isDrawing: false,
    paths: markRaw([]),
    resizeObserver: null,
    value: props.value,
    lastRedrawDate: 0
  });
  watch(
    () => props.value,
    (newValue) => {
      if (newValue) {
        state.value = newValue;
      }
    }
  );
  const useRect$1 = useRect.useRect(unref);
  const api2 = {
    state,
    touchMove: index.touchMove({ emit, state }),
    touchEnd: index.touchEnd({ emit, state }),
    setCanvasBgColor: index.setCanvasBgColor({ props, state }),
    setPlaceholder: index.setPlaceholder({ props, state }),
    getSignatureImage: index.getSignatureImage({ props, vm, Modal, t })
  };
  Object.assign(api2, {
    touchStart: index.touchStart({ emit, props, state, vm, api: api2, useRect: useRect$1 }),
    rewrite: index.rewrite({ api: api2, emit, state }),
    mounted: index.mounted({ state, api: api2, vm, nextTick, markRaw }),
    onBeforeUnmount: index.beforeUnmount({ state, vm }),
    initCanvas: index.initCanvas({ props, state, vm }),
    toggleFullscreen: index.toggleFullscreen({ api: api2, nextTick, state }),
    cancel: index.cancel({ api: api2, emit }),
    redraw: index.redraw({ props, state, nextTick }),
    tranformImage: index.tranformImage({ api: api2, vm, props, nextTick }),
    submit: index.submit({ emit, api: api2 })
  });
  onMounted(() => api2.mounted());
  onBeforeUnmount(() => api2.onBeforeUnmount());
  return api2;
};
exports.api = api;
exports.renderless = renderless;
