"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleChange"];
const renderless = (props, { computed, reactive, onMounted, inject, onBeforeUnmount, watch }, { emit, parent, dispatch, constants, nextTick, vm }) => {
  const state = reactive({
    disabled: inject("disabled", null) || props.disabled,
    type: inject("sliderType", null),
    value: computed({
      get: () => api2.getValue(),
      set: (val) => api2.setValue(val)
    }),
    label: computed(() => props.label || props.text),
    sliderButtonGroup: computed(() => api2.getGroup()),
    size: inject("sliderSize", null),
    tabIndex: computed(() => state.sliderButtonGroup && state.value !== (props.label || props.text) ? -1 : 0)
  });
  const api2 = {};
  Object.assign(api2, {
    state,
    mounted: index.mounted({ vm, props, dispatch, constants }),
    unMounted: index.unMounted({ props, dispatch, constants }),
    getValue: index.getValue(state),
    setValue: index.setValue({ state }),
    getGroup: index.getGroup({ constants, parent }),
    handleChange: index.handleChange({ constants, dispatch, nextTick, state })
  });
  onMounted(() => {
    api2.mounted();
    index.customEvents({ props, vm, type: "add" });
  });
  onBeforeUnmount(() => {
    api2.unMounted();
    index.customEvents({ props, vm, type: "remove" });
  });
  watch(() => state.label, api2.mounted);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
