"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const chunkG2ADBYYC = require("../chunk-G2ADBYYC.js");
const index = require("./index.js");
const dom = require("../common/deps/dom.js");
const api = ["state", "handleMousedown", "buttonMousedown", "buttonLeftTopClick", "buttonRightBottomClick"];
const renderless = (props, hooks, { vm, nextTick, emit, constants, designConfig }) => {
  var _a;
  const api2 = {};
  const { computed, reactive } = hooks;
  const getUseOffset = useOffset({ nextTick, props, vm, constants, hooks });
  const state = reactive(chunkG2ADBYYC.__spreadValues({
    lastClickOffset: 50,
    lastmodelValue: 0.5,
    oldOffset: 0,
    initOffset: 0,
    isMoving: false,
    prefix: constants.PREFIX,
    computedleftTopMin: computed(() => api2.getComputedThresholdValue("leftTopMin")),
    computedrightBottomMin: computed(() => api2.getComputedThresholdValue("rightBottomMin")),
    wrapperClasses: computed(() => [
      `${state.prefix}-wrapper`,
      state.isMoving ? "no-select" : "",
      props.border ? "" : "no-border"
    ]),
    paneClasses: computed(() => [
      `${state.prefix}-pane ${props.scrollable ? "tiny-split-scroll" : ""}`,
      { [`${state.prefix}-pane-moving`]: state.isMoving }
    ]),
    triggerBarConWithLine: (_a = designConfig == null ? void 0 : designConfig.triggerBarConWithLine) != null ? _a : true
  }, getUseOffset.state));
  Object.assign(api2, chunkG2ADBYYC.__spreadProps(chunkG2ADBYYC.__spreadValues({
    state,
    getleftTopMin: index.getleftTopMin(state),
    getrightBottomMin: index.getrightBottomMin(state)
  }, getUseOffset.api), {
    handleUp: index.handleUp({ api: api2, emit, off: dom.off, state }),
    getAnotherOffset: index.getAnotherOffset({ vm, state }),
    handleMove: index.handleMove({ api: api2, emit, props, vm, state }),
    handleMousedown: index.handleMousedown({ api: api2, emit, on: dom.on, props, state, vm }),
    buttonMousedown: index.buttonMousedown(),
    buttonLeftTopClick: index.buttonLeftTopClick({ emit, props, state }),
    buttonRightBottomClick: index.buttonRightBottomClick({ emit, props, state }),
    getComputedThresholdValue: index.getComputedThresholdValue({ api: api2, props, vm, state })
  }));
  return api2;
};
const useOffset = ({ nextTick, props, vm, constants, hooks }) => {
  const api2 = {};
  const { computed, onMounted, onUnmounted, reactive, toRefs, watch } = hooks;
  const state = reactive({
    offset: 0,
    anotherOffset: computed(() => 100 - state.offset),
    valueIsPx: computed(() => typeof props.modelValue === "string"),
    isHorizontal: computed(() => props.mode === constants.HORIZONTAL),
    offsetSize: computed(() => state.isHorizontal ? "offsetWidth" : "offsetHeight"),
    leftTopPane: 0,
    totalPane: 0
  });
  Object.assign(api2, {
    px2percent: index.px2percent,
    computeOffset: index.computeOffset({ api: api2, nextTick, props, vm, state }),
    getAnotherOffset: index.getAnotherOffset({ vm, state })
  });
  watch(() => props.modelValue, api2.computeOffset, { immediate: true });
  onMounted(() => {
    dom.on(window, "resize", api2.computeOffset);
  });
  onUnmounted(() => {
    dom.off(window, "resize", api2.computeOffset);
  });
  return {
    api: api2,
    state: toRefs(state)
  };
};
exports.api = api;
exports.renderless = renderless;
exports.useOffset = useOffset;
