"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "isVisibleHandler", "handleMouseenter", "handleMouseleave"];
const renderless = (props, { reactive, watch, computed }, { vm }) => {
  const state = reactive({
    startIndex: 0,
    popoverVisible: false,
    popoverContent: "",
    popoverPlacement: "top",
    endIndex: computed(() => state.startIndex + props.visibleNum),
    rightNodePositions: computed(() => api2.computedRightNodePos()),
    computedSpace: computed(() => index.computedSpace({ props }))
  });
  const api2 = {
    state,
    updateStartIndex: index.updateStartIndex({ state, props }),
    isVisibleHandler: index.isVisibleHandler({ state, props }),
    handleMouseenter: index.handleMouseenter({ state, vm }),
    handleMouseleave: index.handleMouseleave(state),
    computedRightNodePos: index.computedRightNodePos({ state, props })
  };
  watch(() => props.active, api2.updateStartIndex, { immediate: true });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
