"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state"];
const renderless = (props, { computed, inject, reactive, watch }, { parent, nextTick }) => {
  const rootTabs = inject("rootTabs");
  const api2 = {
    watchTitle: index.watchTitle(parent),
    computedIsClosable: index.computedIsClosable({ rootTabs, props })
  };
  const state = reactive({
    index: null,
    loaded: false,
    animateShow: true,
    rootTabs,
    active: computed(() => api2.computedActive()),
    paneName: computed(() => api2.computedPaneName()),
    isClosable: computed(() => api2.computedIsClosable())
  });
  Object.assign(api2, {
    state,
    computedActive: index.computedActive({ nextTick, props, state }),
    computedPaneName: index.computedPaneName({ props, state })
  });
  watch(() => props.title, api2.watchTitle);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
