"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "setFocus",
  "removeFocus",
  "scrollPrev",
  "scrollNext",
  "changeTab",
  "scrollToActiveTab",
  "scrollIntoView",
  "moreTabShow",
  "expandTabShow",
  "expandTabHide",
  "computedHeaderStyle",
  "swiperHandle",
  "updated",
  "handleTitleMouseenter",
  "handleTitleMouseleave"
];
const renderless = (props, { computed, inject, onBeforeUnmount, onMounted, onUpdated, reactive, markRaw }, { parent, vm, nextTick, mode: tinyMode, emit }) => {
  const api2 = { mounted: index.mounted, beforeUnmount: index.beforeUnmount, computedNavStyle: index.computedNavStyle, computedSizeName: index.computedSizeName };
  const state = reactive({
    dragging: false,
    navOffset: 0,
    lineStyle: {
      width: 20,
      offset: 0
    },
    scrollable: false,
    isFocus: false,
    focusable: false,
    showMoreItem: false,
    isActive: false,
    tooltipVisible: false,
    tooltipContent: "",
    showMoreTabs: props.showMoreTabs,
    showExpandItem: false,
    showExpandTabs: props.showExpandTabs,
    expandHeaderStyle: {},
    mode: props._mode || parent.$mode || tinyMode || "pc",
    rootTabs: inject("rootTabs"),
    sizeName: computed(() => api2.computedSizeName(state)),
    navStyle: computed(() => api2.computedNavStyle(state)),
    navSortableObj: {},
    separator: inject("separator", null)
  });
  Object.assign(api2, {
    state,
    setFocus: index.setFocus(state),
    removeFocus: index.removeFocus(state),
    moreTabShow: index.moreTabShow(state),
    expandTabShow: index.expandTabShow({ api: api2, state }),
    expandTabHide: index.expandTabHide(state),
    scrollPrev: index.scrollPrev({ vm, state }),
    scrollNext: index.scrollNext({ vm, state }),
    windowBlurHandler: index.windowBlurHandler(state),
    windowFocusHandler: index.windowFocusHandler(state),
    visibilityChangeHandler: index.visibilityChangeHandler(state),
    scrollToActiveTab: index.scrollToActiveTab({ parent, vm, state }),
    scrollIntoView: index.scrollIntoView({ parent, vm, state }),
    computedHeaderStyle: index.computedHeaderStyle({ vm, state }),
    watchCurrentName: index.watchCurrentName({ nextTick, vm, state }),
    handleTabDragStart: index.handleTabDragStart({ state, vm, emit }),
    handleTabDragEnd: index.handleTabDragEnd({ state, vm, nextTick }),
    sortableEvent: index.sortableEvent({ api: api2, props, state, vm, emit, markRaw }),
    handleTitleMouseenter: index.handleTitleMouseenter({ state, vm, props }),
    handleTitleMouseleave: index.handleTitleMouseleave({ state })
  });
  Object.assign(api2, { updated: index.updated({ api: api2, vm, state }), changeTab: index.changeTab(api2) });
  onUpdated(() => api2.updated());
  onMounted(() => api2.mounted({ api: api2, parent }));
  onBeforeUnmount(() => api2.beforeUnmount({ api: api2, parent }));
  return api2;
};
exports.api = api;
exports.renderless = renderless;
