"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "selectRow", "togeSelected", "togeSelectAll"];
const renderless = (props, { computed, reactive, watch }, { t, emit }) => {
  const api2 = {};
  const state = reactive({
    selectedRow: null,
    checkChangeByUser: false,
    selected: [],
    checkableData: computed(() => api2.computedCheckableData()),
    selectedKeys: computed(() => api2.computedSelectedKeys()),
    selectCls: computed(() => api2.computedSelectCls())
  });
  Object.assign(api2, {
    t,
    state,
    computedSelectCls: index.computedSelectCls({ state }),
    computedSelectedKeys: index.computedSelectedKeys({ props, state }),
    computedCheckableData: index.computedCheckableData({ props }),
    selectRow: index.selectRow({ emit, state }),
    togeSelected: index.togeSelected({ state }),
    togeSelectAll: index.togeSelectAll({ emit, props, state }),
    watchSelected: index.watchSelected({ emit, props, state }),
    watchDefaultChecked: index.watchDefaultChecked({ props, state })
  });
  watch(() => props.defaultChecked, api2.watchDefaultChecked);
  watch(() => state.selected, api2.watchSelected);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
