"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleNavItemClick", "getBoundRect", "handleNavItemClose"];
const renderless = (props, { inject, markRaw, reactive, computed }, { vm }) => {
  const tabs = inject("tabs", null);
  tabs.addNav(markRaw(vm));
  const state = reactive({
    tabSize: computed(() => tabs.size),
    withClose: computed(() => tabs.withClose),
    separator: inject("separator", null)
  });
  const api2 = {
    state,
    handleNavItemClick: index.handleNavItemClick({ tabs, props, vm }),
    getBoundRect: index.getBoundRectNV({ vm, props }),
    handleNavItemClose: index.handleNavItemClose({ tabs, props })
  };
  return api2;
};
exports.api = api;
exports.renderless = renderless;
