"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const resizeEvent = require("../common/deps/resize-event.js");
const debounce = require("../common/deps/debounce.js");
const index = require("./index.js");
const api = ["state", "handelItemClick"];
const renderless = (props, { onMounted, onBeforeUnmount, reactive, watch }, { vm, emit }) => {
  const delay = 100;
  const state = reactive({
    showMore: false,
    hiddenTags: []
  });
  const api2 = {
    state,
    getHiddenTags: index.getHiddenTags({ props, vm, state }),
    handelItemClick: index.handelItemClick({ emit })
  };
  onMounted(() => {
    api2.getHiddenTags();
    api2.debouncedGetHiddenTags = debounce.default(delay, api2.getHiddenTags);
    resizeEvent.addResizeListener(vm.$refs.tagGroup, debounce.default(delay, api2.debouncedGetHiddenTags));
  });
  watch(
    () => props.data.length,
    () => {
      api2.getHiddenTags();
    }
  );
  onBeforeUnmount(() => {
    resizeEvent.removeResizeListener(vm.$refs.tagGroup, api2.debouncedGetHiddenTags);
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
