"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const dom = require("../common/deps/dom.js");
const api = ["state", "mousedown", "selectItem"];
const renderless = (props, { onUnmounted, reactive, watch }, { emit }) => {
  const state = reactive({
    hoverValue: ""
  });
  const api2 = {
    state,
    mousedown: index.mousedown,
    selectItem: index.selectItem({ emit, state }),
    keydown: index.keydown({ emit, props, state })
  };
  watch(
    () => props.isMemoryStorage,
    (value) => !value && (state.hoverValue = ""),
    { immediate: true }
  );
  onUnmounted(() => {
    state.hoverValue = "";
    dom.off(document, "keydown", api2.keydown);
  });
  dom.on(document, "keydown", api2.keydown);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
