"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "onFocus", "onBlur", "onInput"];
const renderless = (props, { computed, onMounted, reactive, watch, inject }, { emit, nextTick, refs }) => {
  const api2 = {};
  const state = reactive({
    showAutoWidth: inject("showAutoWidth", null),
    type: "input",
    textAreaValue: "",
    text: null,
    popup: null,
    width: computed(() => api2.computedWidth())
  });
  Object.assign(api2, {
    state,
    jointText: index.jointText,
    separteText: index.separteText,
    computedWidth: index.computedWidth({ props }),
    mounted: index.mounted({ props, refs, state }),
    onInput: index.onInput({ api: api2, emit, props }),
    watchValue: index.watchValue({ api: api2, props, state }),
    onBlur: index.onBlur({ api: api2, emit, props, state }),
    onFocus: index.onFocus({ api: api2, emit, props, nextTick, state })
  });
  watch(() => props.modelValue, api2.watchValue, { immediate: true });
  onMounted(api2.mounted);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
