"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleClick", "getStatusCls", "getStatus", "getDate", "changeStatus"];
const renderless = (props, { computed, reactive }, { t, emit, constants }) => {
  const api2 = {};
  const state = reactive({
    nodes: computed(() => api2.computedData()),
    stackNodes: computed(() => state.showAll ? state.nodes : api2.computedStackNodes()),
    current: computed(() => api2.computedCurrent()),
    isReverse: computed(() => api2.computedIsReverse()),
    showData: false,
    showAll: false
  });
  Object.assign(api2, {
    state,
    getDate: index.getDate,
    computedData: index.computedData({ props, state }),
    computedCurrent: index.computedCurrent({ props, state }),
    computedIsReverse: index.computedIsReverse(props),
    getStatus: index.getStatus({ state, t }),
    handleClick: index.handleClick({ emit, state }),
    getStatusCls: index.getStatusCls({ constants, state }),
    computedStackNodes: index.computedStackNodes({ state, props }),
    changeStatus: index.changeStatus({ state })
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
