"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleClick", "getStatusCls", "getStatus", "getDate", "changeStatus", "toggleFold"];
const renderless = (props, { computed, reactive, provide, watch }, { t, emit, constants }) => {
  const api2 = {};
  const state = reactive({
    // 当标签式使用时，记录有多少个 item 的标签
    itemsArray: [],
    nodes: computed(() => api2.computedData()),
    current: computed(() => api2.computedCurrent()),
    isReverse: computed(() => api2.computedIsReverse()),
    stackNodes: computed(() => state.showAll ? state.nodes : api2.computedStackNodes()),
    computedSpace: computed(() => api2.computedSpace()),
    showData: false,
    showAll: false,
    computedWrapperClass: computed(() => api2.computedWrapperClass())
  });
  Object.assign(api2, {
    state,
    getDate: index.getDate,
    computedData: index.computedData({ props, state }),
    computedCurrent: index.computedCurrent({ props, state }),
    computedIsReverse: index.computedIsReverse(props),
    computedSpace: index.computedSpace({ props }),
    getStatus: index.getStatus({ state, t }),
    handleClick: index.handleClick({ emit, state }),
    getStatusCls: index.getStatusCls({ constants, state }),
    computedStackNodes: index.computedStackNodes({ state, props }),
    changeStatus: index.changeStatus({ state }),
    computedWrapperClass: index.computedWrapperClass({ props }),
    toggleFold: index.toggleFold({ props })
  });
  provide("nodesInject", { state, props });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
