"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const index$1 = require("../common/index.js");
const api = ["state", "handleMenuEnter", "handleClick", "handleClear", "emitDestroy"];
const initState = ({ reactive, computed, api: api2 }) => {
  const { Start, End, Step } = index$1.DATEPICKER;
  const state = reactive({
    popperClass: "",
    start: Start,
    end: End,
    step: Step,
    realValue: "",
    defaultValue: "",
    defaultTime: "",
    visible: false,
    minTime: "",
    maxTime: "",
    width: 0,
    lastEmitValue: "",
    isFilter: false,
    filterVal: "",
    items: computed(() => api2.computItems()),
    default: computed(() => state.defaultValue || state.defaultTime || ""),
    value: computed({
      get: () => state.realValue || state.default,
      set: (value) => {
        const valid = state.items.some((item) => item.value === value);
        state.realValue = state.lastEmitValue = valid ? value : "";
      }
    })
  });
  return state;
};
const renderless = (props, { computed, reactive, watch, nextTick }, { vm, emit: $emit }) => {
  const api2 = {};
  const emit = props.emitter ? props.emitter.emit : $emit;
  const state = initState({ reactive, computed, api: api2 });
  Object.assign(api2, {
    state,
    parseTime: index.parseTime(),
    formatTime: index.formatTime(),
    isValidValue: index.isValidValue(state),
    scrollToOption: index.scrollToOption({ vm }),
    emitPick: index.emitPick({ emit, state }),
    emitDestroy: index.emitDestroy(emit),
    nextTime: index.nextTime(api2),
    compareTime: index.compareTime(api2),
    handleClick: index.handleClick(api2),
    scrollDown: index.scrollDown({ api: api2, state }),
    handleClear: index.handleClear({ api: api2, state }),
    watchValue: index.watchValue({ api: api2, nextTick }),
    handleKeydown: index.handleKeydown({ api: api2 }),
    computItems: index.computItems({ api: api2, state }),
    handleMenuEnter: index.handleMenuEnter({ api: api2, nextTick, state })
  });
  watch(() => state.value, api2.watchValue);
  watch(
    () => state.visible,
    () => setTimeout(() => state.fnUpdatePopper && state.fnUpdatePopper())
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
