"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "confirm", "updateVisible", "clear"];
const renderless = (props, { reactive, watch, computed }, { emit, vm, dispatch }) => {
  const api2 = {};
  const state = reactive({
    visible: false,
    dateArr: [],
    seconds: null,
    options: computed(() => api2.computedOptions()),
    value: computed(
      () => !props.showSeconds && state.seconds !== null ? [...state.dateArr, state.seconds] : state.dateArr
    )
  });
  Object.assign(api2, {
    state,
    watchModelValue: index.watchModelValue({ props, state }),
    watchVisible: index.watchVisible({ api: api2, state }),
    confirm: index.confirm({ emit, state }),
    clear: index.clear({ state, emit, api: api2, vm, dispatch }),
    updateVisible: index.updateVisible({ emit, state }),
    getTimePeriod: index.getTimePeriod({ state, props }),
    computedOptions: index.computedOptions({ state, api: api2, props }),
    optionMethod: index.optionMethod
  });
  watch(() => props.visible, api2.watchVisible);
  watch(() => props.modelValue, api2.watchModelValue, { immediate: true });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
