"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const dateUtil = require("../common/deps/date-util.js");
const api = [
  "state",
  "handleMinChange",
  "handleConfirm",
  "setMinSelectionRange",
  "handleCancel",
  "setMaxSelectionRange",
  "handleMaxChange"
];
const initState = ({ reactive, computed, vm, api: api2 }) => {
  const state = reactive({
    popperClass: "",
    defaultValue: null,
    format: "HH:mm:ss",
    visible: false,
    value: [],
    oldValue: [/* @__PURE__ */ new Date(), /* @__PURE__ */ new Date()],
    selectionRange: [0, 2],
    arrowControl: false,
    maxDate: /* @__PURE__ */ new Date(),
    minDate: /* @__PURE__ */ new Date(),
    showTimePickerRangeButton: false,
    showSeconds: computed(() => (state.format || "").includes("ss")),
    offset: computed(() => state.showSeconds ? 11 : 8),
    spinner: computed(() => state.selectionRange[0] < state.offset ? vm.$refs.minSpinner : vm.$refs.maxSpinner),
    btnDisabled: computed(() => state.minDate.getTime() > state.maxDate.getTime()),
    amPmMode: computed(() => api2.compuAmPmMode())
  });
  return state;
};
const renderless = (props, { computed, reactive, watch, nextTick }, { t, vm, emit: $emit, designConfig }) => {
  var _a;
  const api2 = {};
  const emit = props.emitter ? props.emitter.emit : $emit;
  const MIN_TIME = dateUtil.parseDate("00:00:00", "HH:mm:ss", t);
  const MAX_TIME = dateUtil.parseDate("23:59:59", "HH:mm:ss", t);
  const state = initState({ reactive, computed, vm, api: api2 });
  state.showTimePickerRangeButton = (_a = designConfig == null ? void 0 : designConfig.showTimePickerRangeButton) != null ? _a : true;
  Object.assign(api2, {
    t,
    state,
    handleClear: index.handleClear(emit),
    compuAmPmMode: index.compuAmPmMode(state),
    maxTimeOfDay: index.maxTimeOfDay({ MAX_TIME }),
    minTimeOfDay: index.minTimeOfDay({ MIN_TIME }),
    changeSelectionRange: index.changeSelectionRange({ vm, state }),
    setMaxSelectionRange: index.setMaxSelectionRange({ emit, state }),
    setMinSelectionRange: index.setMinSelectionRange({ emit, state }),
    isValidValue: index.isValidValue({ vm, state }),
    handleConfirm: index.handleConfirm({ emit, vm, state }),
    handleCancel: index.handleCancel({ emit, api: api2, state }),
    watchVisible: index.watchVisible({ nextTick, api: api2, state }),
    advanceTime: index.advanceTime(api2),
    watchValue: index.watchValue({ api: api2, state }),
    handleKeydown: index.handleKeydown({ api: api2, state }),
    handleChange: index.handleChange({ api: api2, emit, vm, state }),
    handleMinChange: index.handleMinChange({ api: api2, state }),
    handleMaxChange: index.handleMaxChange({ api: api2, state }),
    adjustSpinners: index.adjustSpinners({ vm })
  });
  watch(() => state.value, api2.watchValue);
  watch(() => state.visible, api2.watchVisible);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
