"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const index$1 = require("../time-range/index.js");
const dateUtil = require("../common/deps/date-util.js");
const api = ["state", "handleChange", "setSelectionRange", "handleCancel", "handleConfirm", "adjustSpinners"];
const initState = ({ reactive, props, computed, api: api2 }) => {
  const state = reactive({
    popperClass: "",
    format: "HH:mm:ss",
    value: "",
    defaultValue: null,
    date: props.value || /* @__PURE__ */ new Date(),
    oldValue: /* @__PURE__ */ new Date(),
    selectableRange: [],
    selectionRange: [0, 2],
    disabled: false,
    arrowControl: false,
    visible: false,
    showTimePickerButton: false,
    needInitAdjust: true,
    displayValue: computed(() => api2.displayValue()),
    showSeconds: computed(() => (state.format || "").includes("ss")),
    useArrow: computed(() => state.arrowControl || props.timeArrowControl || false),
    amPmMode: computed(() => api2.compuAmPmMode())
  });
  return state;
};
const renderless = (props, { computed, onMounted, reactive, watch, nextTick }, { t, emit: $emit, vm, designConfig }) => {
  var _a;
  const api2 = {};
  const emit = props.emitter ? props.emitter.emit : $emit;
  const state = initState({ reactive, props, computed, api: api2 });
  state.showTimePickerButton = (_a = designConfig == null ? void 0 : designConfig.showTimePickerButton) != null ? _a : true;
  Object.assign(api2, {
    t,
    state,
    compuAmPmMode: index$1.compuAmPmMode(state),
    adjustSpinners: index.adjustSpinners(vm),
    handleCancel: index.handleCancel({ state, emit }),
    setSelectionRange: index.setSelectionRange({ state, emit }),
    watchVisible: index.watchVisible({ nextTick, vm, state, api: api2 }),
    isValidValue: index.isValidValue({ state }),
    changeSelectionRange: index.changeSelectionRange({ vm, state }),
    handleConfirm: index.handleConfirm({ state, emit }),
    handleKeydown: index.handleKeydown({ api: api2, vm }),
    handleChange: index.handleChange({ api: api2, emit, state }),
    displayValue: index.displayValue({ state, t }),
    watchValue: index.watchValue({ api: api2, nextTick, state })
  });
  watch(() => state.value, api2.watchValue);
  watch(
    () => props.show,
    (value) => {
      state.visible = value;
    },
    { immediate: true }
  );
  watch(
    () => state.selectableRange,
    (value) => vm.$refs.spinner.state.selectableRange = value
  );
  watch(
    () => state.defaultValue,
    (value) => !dateUtil.isDate(state.value) && (state.date = value ? new Date(value) : /* @__PURE__ */ new Date())
  );
  onMounted(() => {
    api2.handleConfirm(true, true);
  });
  watch(() => state.visible, api2.watchVisible);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
