"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleClick", "getStatusCls", "getStatus", "getDate", "rootProps"];
const renderless = (props, { computed, reactive, inject, onUnmounted }, { t, emit, constants }) => {
  const api2 = {};
  const { state: rootState, props: rootProps } = inject("nodesInject");
  if (!rootState.itemsArray.includes(props.node)) {
    rootState.itemsArray.push(props.node);
  }
  onUnmounted(() => {
    if (rootState.itemsArray.includes(props.node)) {
      rootState.itemsArray.splice(rootState.itemsArray.indexOf(props.node), 1);
    }
  });
  const state = reactive({
    nodesLength: computed(() => rootState.nodes.length),
    current: computed(() => api2.computedCurrent()),
    isReverse: computed(() => api2.computedIsReverse()),
    computedSpace: computed(() => api2.computedWidth(props.space || api2.rootProps.space)),
    computedItemCls: computed(() => api2.computedItemCls()),
    computedItemStyle: computed(() => api2.computedItemStyle()),
    computedLineWidth: computed(() => api2.computedWidth(props.lineWidth || api2.rootProps.lineWidth)),
    iconClass: computed(() => api2.computedIconClass())
  });
  Object.assign(api2, {
    state,
    rootProps,
    getDate: index.getDate,
    computedCurrent: index.computedCurrent({ state, api: api2 }),
    computedIsReverse: index.computedIsReverse(api2),
    computedItemCls: index.computedItemCls({ props, api: api2, state }),
    computedItemStyle: index.computedItemStyle({ props, state, api: api2 }),
    computedWidth: index.computedWidth(),
    getStatus: index.getStatus({ state, t }),
    handleClick: index.handleClick({ emit, state, props }),
    getStatusCls: index.getStatusCls({ constants, state, props }),
    computedIconClass: index.computedIconClass({ props, api: api2 })
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
