"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const index$1 = require("../tree-menu/index.js");
const api = [
  "state",
  "setMenuKey",
  "initData",
  "hideNodeText",
  "filterNode",
  "searchNodeText",
  "nodeClick",
  "nodeExpand",
  "nodeCollapse",
  "nodeDragEnd",
  "nodeDragEnter",
  "nodeDragLeave",
  "nodeDragOver",
  "nodeDragStart",
  "nodeDrop",
  "clickA"
];
const renderless = (props, { reactive, watch, computed, onMounted }, { t, service, nextTick, constants, emit, refs }) => {
  const api2 = {};
  const state = reactive({
    datas: [],
    toggleIcon: true,
    showNode: true,
    filterText: "",
    placeholder: computed(() => api2.computedPlaceholder())
  });
  service = service || { base: {} };
  service = {
    getMenuDataSync: props.getMenuDataSync || service.base.getMenuDataSync,
    // deprecated v3.4.0废弃, v3.16.0移除；移除原因：如果是同步数据则和:data功能重复
    getMenuDataAsync: props.getMenuDataAsync
  };
  Object.assign(api2, {
    state,
    clickA: index.clickA,
    nodeDrop: index.nodeDrop(emit),
    filterNode: index.filterNode(props),
    nodeClick: index.nodeClick(emit),
    nodeExpand: index.nodeExpand(emit),
    nodeDragEnd: index.nodeDragEnd(emit),
    hideNodeText: index.hideNodeText(state),
    nodeDragOver: index.nodeDragOver(emit),
    nodeCollapse: index.nodeCollapse(emit),
    nodeDragStart: index.nodeDragStart(emit),
    nodeDragLeave: index.nodeDragLeave(emit),
    nodeDragEnter: index.nodeDragEnter(emit),
    searchNodeText: index.searchNodeText({ state, refs, nextTick }),
    computedPlaceholder: index.computedPlaceholder({ constants, props, t }),
    setMenuKey: index$1.setMenuKey(api2),
    initData: index.initData({ state, props, service, api: api2 })
  });
  watch(
    () => state.filterText,
    (value) => {
      if (props.automaticFiltering) {
        nextTick(() => refs.tree.filter(value));
      }
    }
  );
  onMounted(api2.initData);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
