"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleAfterLeave", "clearTimer", "startTimer", "close", "getZindex"];
const renderless = (props, { computed, onBeforeUnmount, onMounted, reactive, watch }, { vm, parent, constants }) => {
  const api2 = {};
  const state = reactive({
    timer: null,
    message: "",
    type: "info",
    iconClass: "",
    onClose: null,
    closed: false,
    center: false,
    buttons: null,
    duration: 3e3,
    visible: false,
    customClass: "",
    showClose: false,
    verticalOffset: 20,
    dangerouslyUseHTMLString: false,
    typeClass: computed(() => api2.getTypeClass()),
    positionStyle: computed(() => api2.getOffsetStyle())
  });
  Object.assign(api2, {
    state,
    getZindex: index.getZindex,
    close: index.close(state),
    destroy: index.destroy(parent),
    clearTimer: index.clearTimer(state),
    getOffsetStyle: index.getOffsetStyle({ state }),
    getTypeClass: index.getTypeClass({ constants, state }),
    bindEvent: index.bindEvent({ api: api2 }),
    startTimer: index.startTimer({ api: api2, state }),
    unBindEvent: index.unBindEvent({ api: api2 }),
    handleAfterLeave: index.handleAfterLeave(api2),
    watchClosed: index.watchClosed({ state })
  });
  watch(() => state.closed, api2.watchClosed, { immediate: true });
  onMounted(() => {
    props.emitter.emit("TopBoxMounted", vm);
    api2.bindEvent();
  });
  onBeforeUnmount(api2.unBindEvent);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
