"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "onSourceCheckedChange", "onTargetCheckedChange", "addToLeft", "addToRight", "clearQuery"];
const initState = ({ reactive, computed, api: api2, props, h, slots }) => reactive({
  leftChecked: [],
  rightChecked: [],
  rightData: computed(() => api2.getRightCheckedData()),
  leftData: computed(() => api2.getLeftCheckedData()),
  dataObj: computed(() => api2.getObj()),
  sourceData: computed(() => api2.getSourceData()),
  targetData: computed(() => api2.getTargetData()),
  hasButtonTexts: computed(() => props.buttonTexts.length === 2),
  isToLeft: false,
  optionRender: computed(() => (option) => {
    if (props.renderContent) {
      return props.renderContent(h, option);
    }
    if (slots.default) {
      return slots.default({ option });
    }
    return h("span", option[props.props.label] || option[props.props.key]);
  })
});
const renderless = (props, { computed, onMounted, reactive, h }, { $prefix, emit, refs, parent, slots, vm }) => {
  const api2 = {};
  const Tree = $prefix + "Tree";
  const Table = $prefix + "Table";
  const state = initState({ reactive, computed, api: api2, props, h, slots });
  const { DROPPANEL, TRANSFERPANEL } = parent.$constants;
  Object.assign(api2, {
    state,
    getObj: index.getObj(props),
    clearQuery: index.clearQuery(refs),
    getSourceData: index.getSourceData({ props, Tree }),
    addToLeft: index.addToLeft({ emit, props, state }),
    getLeftCheckedData: index.getLeftCheckedData({ props, state }),
    getRightCheckedData: index.getRightCheckedData({ props, state }),
    addToRight: index.addToRight({ emit, refs, props, state, Tree }),
    onTargetCheckedChange: index.onTargetCheckedChange({ emit, state }),
    onSourceCheckedChange: index.onSourceCheckedChange({ emit, state }),
    logicFun: index.logicFun({ props, emit, state, vm }),
    getTargetData: index.getTargetData({ props, state, Tree, Table }),
    sortableEvent: index.sortableEvent({ api: api2, droppanel: DROPPANEL, props, queryDom: TRANSFERPANEL, refs })
  });
  onMounted(api2.sortableEvent);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
