"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "t",
  "initData",
  "setMenuKey",
  "filterNode",
  "nodeDragStart",
  "nodeDragEnter",
  "nodeDragOver",
  "nodeDragEnd",
  "nodeDrop",
  "nodeExpand",
  "nodeCollapse",
  "nodeClick",
  "checkChange",
  "check",
  "currentChange",
  "getTitle",
  "collapseChange",
  "collapseMenu",
  "expandMenu",
  "setCurrentKey",
  "getCurrentKey",
  "setCurrentNode",
  "getCurrentNode",
  "handleToggleMenu",
  "getTree"
];
const renderless = (props, { computed, watch, reactive, onMounted }, { t, service, emit, vm }) => {
  service = service || { base: {} };
  service = { getMenuDataSync: props.getMenuDataSync || service.base.getMenuDataSync };
  const api2 = {};
  const state = reactive({
    data: [],
    filterText: "",
    isExpand: false,
    isCollapsed: false,
    nodeKey: null,
    currentKey: [],
    treeStyle: computed(() => api2.computedTreeStyle()),
    defaultExpandedKeys: computed(
      () => props.defaultExpandedKeys && props.defaultExpandedKeys.length ? props.defaultExpandedKeys : state.currentKey
    ),
    clearable: computed(() => props.clearable)
  });
  Object.assign(api2, {
    t,
    state,
    check: index.check(emit),
    filterNode: index.filterNode(props),
    nodeDrop: index.nodeDrop(emit),
    nodeClick: index.nodeClick({ emit, props, state }),
    nodeExpand: index.nodeExpand(emit),
    nodeDragEnd: index.nodeDragEnd(emit),
    checkChange: index.checkChange(emit),
    nodeCollapse: index.nodeCollapse(emit),
    nodeDragOver: index.nodeDragOver(emit),
    nodeDragStart: index.nodeDragStart(emit),
    nodeDragEnter: index.nodeDragEnter(emit),
    currentChange: index.currentChange(emit),
    watchFilterText: index.watchFilterText({ vm }),
    getTitle: index.getTitle(props),
    setMenuKey: index.setMenuKey(api2),
    initData: index.initData({ state, props, service, api: api2 }),
    collapseChange: index.collapseChange({ state, props, emit }),
    collapseMenu: index.collapseMenu({ state, props, api: api2 }),
    expandMenu: index.expandMenu({ state, props, api: api2 }),
    setCurrentKey: index.setCurrentKey({ vm }),
    getCurrentKey: index.getCurrentKey({ vm }),
    setCurrentNode: index.setCurrentNode({ vm }),
    getCurrentNode: index.getCurrentNode({ vm }),
    getTree: index.getTree({ vm }),
    handleToggleMenu: index.handleToggleMenu({ state, vm }),
    computedTreeStyle: index.computedTreeStyle({ props })
  });
  watch(
    () => props.data,
    (value) => state.data = value,
    { immediate: true }
  );
  watch(() => state.filterText, api2.watchFilterText, { deep: true });
  onMounted(api2.initData);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
