"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "check", "filter", "nodeClick"];
const renderless = (props, { reactive, computed, watch, onMounted }, { vm, emit }) => {
  const api2 = {};
  const state = reactive({
    childrenName: computed(() => props.treeOp.props && props.treeOp.props.children || "children"),
    currentKey: props.modelValue,
    defaultCheckedKeys: [],
    remoteData: [],
    treeData: props.treeOp.data,
    value: computed(() => props.modelValue)
  });
  Object.assign(api2, {
    state,
    check: index.check({ props, vm, emit }),
    filter: index.filter({ vm }),
    getCheckedData: index.getCheckedData({ props, state }),
    getPluginOption: index.getPluginOption({ api: api2, props, state }),
    getTreeData: index.getTreeData({ props, state }),
    mounted: index.mounted({ api: api2, state, props, vm }),
    nodeClick: index.nodeClick({ props, vm, emit })
  });
  watch(
    () => props.treeOp.data,
    (data) => data && (state.treeData = data),
    { immediate: true, deep: true }
  );
  onMounted(api2.mounted);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
