"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "onDragOver", "onDrop"];
const renderless = (props, { inject, reactive, ref, watch }, { emit }) => {
  const state = reactive({
    dragover: false,
    uploadFiles: [],
    uploader: inject("uploader") || ref({ default: "" })
  });
  const constants = state.uploader.$constants || {};
  const api2 = {
    state,
    onDragOver: index.onDragOver({ props, state }),
    onDrop: index.onDrop({ emit, props, state }),
    watchDragover: index.watchDragover({ state, constants })
  };
  watch(
    () => state.dragover,
    () => api2.watchDragover()
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
