"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index$1 = require("./index.js");
const index = require("../file-upload/index.js");
const string = require("../common/string.js");
const vue = require("../file-upload/vue.js");
const browser = require("../common/browser.js");
const api = [
  "t",
  "state",
  "parsePercentage",
  "handleClick",
  "handlePreview",
  "picturefilePreview",
  "getDeleteData",
  "downloadFile",
  "play",
  "pause",
  "handleLoadedmetadata",
  "handleTimeupdate",
  "showOperatePanel",
  "getFileType",
  "getFileIcon",
  "reUpload",
  "remove",
  "handleTriggerClick",
  "chooseFile",
  "formatFileSize"
];
const renderless = (props, { reactive, onMounted, onUnmounted, watch, inject, computed }, { t, parent, mode, emit, service, vm, nextTick, designConfig, useBreakpoint }, { Modal }) => {
  var _a, _b, _c, _d, _e;
  const api2 = { getApi: vue.getApi };
  parent = inject("uploader").$children[0];
  const constants = browser.isBrowser ? parent.$constants : null;
  const $service = index.initService({ props, service });
  const { current } = useBreakpoint();
  const state = reactive({
    focusing: false,
    shows: false,
    currentBreakpoint: current,
    progressType: ((_a = designConfig == null ? void 0 : designConfig.state) == null ? void 0 : _a.progressType) || "line",
    progressWidth: (designConfig == null ? void 0 : designConfig.state) && Object.hasOwnProperty.call(designConfig.state, "progressWidth") ? designConfig.state.progressWidth : "68",
    progressStrokeWidth: ((_b = designConfig == null ? void 0 : designConfig.state) == null ? void 0 : _b.progressStrokeWidth) || 4,
    tooltipDisabled: (_d = (_c = designConfig == null ? void 0 : designConfig.state) == null ? void 0 : _c.tooltipDisabled) != null ? _d : false,
    closeComponent: ((_e = designConfig == null ? void 0 : designConfig.icons) == null ? void 0 : _e.closeComponent) || "icon-del",
    preViewComponent: (designConfig == null ? void 0 : designConfig.icons) && Object.hasOwnProperty.call(designConfig.icons, "preViewComponent") ? designConfig.icons.preViewComponent : "icon-fullscreen-left",
    failUploadFileCount: computed(
      () => props.files.reduce((total, item) => total += item.status === "fail" ? 1 : 0, 0)
    ),
    startPostion: 0,
    screenType: mode === "mobile",
    showPanel: false,
    showTriggerPanel: false,
    triggerClickType: "",
    showAudioPanel: false,
    files: computed(() => api2.getNotSuccessFiles()),
    currentFile: null
  });
  parent.getToken = index.getToken({ constants, props: parent, state: parent.state, t, Modal });
  Object.assign(api2, {
    state,
    getDeleteData: index$1.getDeleteData(emit),
    parsePercentage: index$1.parsePercentage(),
    downloadFile: index$1.downloadFile($service),
    picturefilePreview: index$1.picturefilePreview(state),
    handleClick: index$1.handleClick({ props, api: api2, parent }),
    play: index$1.play({ vm, api: api2, props }),
    pause: index$1.pause({ vm, props }),
    handleLoadedmetadata: index$1.handleLoadedmetadata({ vm }),
    handleTimeupdate: index$1.handleTimeupdate(),
    destroyed: index$1.destroyed({ props, vm }),
    showOperatePanel: index$1.showOperatePanel({ state }),
    getFileType: index$1.getFileType(),
    getFileIcon: index$1.getFileIcon({ constants }),
    mounted: index$1.mounted({ api: api2, vm }),
    calcUploadListLiWidth: index$1.calcUploadListLiWidth({ vm, nextTick, props, constants }),
    reUpload: index$1.reUpload({ emit, props, parent }),
    remove: index$1.remove({ emit }),
    handleTriggerClick: index$1.handleTriggerClick({ state, props }),
    chooseFile: index$1.chooseFile({ state, constants }),
    calcVisible: index$1.calcVisible({ props, constants, emit }),
    getNotSuccessFiles: index$1.getNotSuccessFiles({ props, constants }),
    formatFileSize: string.formatFileSize
  });
  props.listType === constants.LIST_TYPE.DRAG_SINGLE && watch(
    () => props.files && props.files[0],
    (file) => {
      if (file && file.status === constants.FILE_STATUS.FAIL) {
        setTimeout(() => {
          api2.remove({ file });
        }, 2e3);
      }
    },
    { immediate: true, deep: true }
  );
  watch(() => props.files, api2.calcUploadListLiWidth);
  if (props.mode === constants.MODE.BUBBLE && props.listType === constants.LIST_TYPE.TEXT) {
    constants && watch(() => props.files, api2.calcVisible, { immediate: true, deep: true });
  }
  onMounted(api2.mounted);
  onUnmounted(api2.destroyed);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
