"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "isImage",
  "handleChange",
  "handlePaste",
  "uploadFiles",
  "upload",
  "abort",
  "post",
  "handleClick",
  "handleKeydown",
  "handleUpdate"
];
const renderless = (props, { computed, inject, reactive, onMounted, onBeforeUnmount }, { refs, service, t, useBreakpoint }, { Modal }) => {
  const api2 = {};
  const uploader = inject("uploader");
  const constants = uploader.$constants;
  const { current } = useBreakpoint();
  const state = reactive({
    currentBreakpoint: current,
    mouseover: false,
    reqs: {},
    uploader,
    accecpt: "",
    uploadInner: computed(() => state.uploader.$refs[constants.FILE_UPLOAD_INNER_TEMPLATE]),
    isEdm: computed(() => state.uploadInner.state.isEdm),
    openEdmDownload: computed(() => state.uploadInner.edm.download),
    headers: computed(() => {
      if (state.isEdm) {
        return {
          [constants.EDM.EDMTOKEN]: props.edmToken.edmToken || "",
          [constants.EDM.TRACEID]: props.edmToken.traceId || ""
        };
      }
    }),
    formData: {},
    cancelToken: {},
    updateId: "",
    updateInput: null,
    isStopPropagation: false
  });
  Object.assign(api2, {
    state,
    isImage: index.isImage,
    abort: index.abort({ state, props, constants }),
    getFormData: index.getFormData({ state, constants, props }),
    handleClick: index.handleClick({ props, refs, state }),
    onBeforeDestroy: index.onBeforeDestroy(state),
    handleUpdate: index.handleUpdate({ state, props }),
    uploadFiles: index.uploadFiles({ constants, Modal, props, state, t }),
    post: index.post({ api: api2, constants, props, state, service }),
    handleChange: index.handleChange(api2),
    handlePaste: index.handlePaste({ api: api2, props }),
    handleKeydown: index.handleKeydown(api2),
    upload: index.upload({ api: api2, props, refs }),
    mounted: index.mounted({ state, props, api: api2 })
  });
  onMounted(api2.mounted);
  onBeforeUnmount(api2.onBeforeDestroy);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
