"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const eSpaceCtrl = require("../common/deps/eSpaceCtrl.js");
const index = require("./index.js");
const index$1 = require("../espace/index.js");
const api = ["show", "getUserHref", "doUserAction", "initEspaceLink", "openEspace", "testUID"];
const renderless = (props, { reactive, ref }, { service }) => {
  const api2 = {};
  const { setting = {} } = service || {};
  const { widgets = {} } = setting;
  const eSpaceCtrlDisabled = widgets.ESpaceCtrl && !widgets.ESpaceCtrl.autoLink;
  const eSpaceCtrl$1 = eSpaceCtrlDisabled ? {} : eSpaceCtrl.init();
  const state = reactive({
    initialized: false
  });
  Object.assign(api2, {
    state,
    testUID: index$1.testUID,
    show: ref(false),
    getUserHref: index.getUserHref({ api: api2, props }),
    initEspaceLink: index.initEspaceLink({ api: api2, props, state, eSpaceCtrl: eSpaceCtrl$1, eSpaceCtrlDisabled }),
    doUserAction: index.doUserAction({ api: api2, props, state, eSpaceCtrl: eSpaceCtrl$1 }),
    openEspace: index.openEspace({ api: api2, props, eSpaceCtrl: eSpaceCtrl$1 })
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
