"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleClick", "mouseEnter"];
const renderless = (props, { reactive, provide, computed }, { emit }) => {
  const state = reactive({
    groupSize: props.groupSize,
    list: props.list,
    width: computed(() => api2.getWidth()),
    minHeight: computed(() => api2.getMinHeight()),
    horizontalWidth: computed(() => api2.getHorizontalWidth()),
    horizontalLeft: computed(() => api2.getHorizontalLeft())
  });
  const api2 = {
    state,
    getWidth: index.getWidth(props),
    getMinHeight: index.getMinHeight(props),
    getHorizontalWidth: index.getHorizontalWidth(props),
    getHorizontalLeft: index.getHorizontalLeft(props),
    handleClick: index.handleClick(emit),
    mouseEnter: index.mouseEnter(emit)
  };
  provide("groupSize", state.groupSize);
  provide("color", props.color);
  provide("backgroundColor", props.backgroundColor);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
