"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleClick", "mouseEnter"];
const renderless = (props, { reactive, computed, inject }, { mode, emit }) => {
  const groupSize = inject("groupSize", null);
  const state = reactive({
    internalValue: computed(() => api2.getInternalValue()),
    label: computed(() => api2.computedLabel()),
    style: computed(() => api2.computedStyle()),
    message: computed(() => api2.computedMessage()),
    fontSize: computed(() => api2.computedFontSize()),
    size: groupSize || props.size,
    color: inject("color", null) || props.color,
    backgroundColor: inject("backgroundColor", null) || props.backgroundColor
  });
  const api2 = {
    state,
    computedLabel: index.computedLabel({ state, props }),
    computedStyle: index.computedStyle({ state, props }),
    computedMessage: index.computedMessage({ props }),
    computedFontSize: index.computedFontSize({ props, state, mode }),
    getInternalValue: index.getInternalValue({ props }),
    handleClick: index.handleClick(emit),
    mouseEnter: index.mouseEnter(emit)
  };
  return api2;
};
exports.api = api;
exports.renderless = renderless;
