"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("../user/index.js");
const index$1 = require("./index.js");
const api = ["state", "showCard", "showDetail"];
const renderless = (props, { reactive, watch, computed }, { service }) => {
  service = index.initService({ props, service });
  const api2 = {};
  const state = reactive({
    options: [],
    user: [],
    selected: [],
    type: props.valueField,
    expand: false,
    data: {},
    spinner: true,
    imgUrl: "",
    batch: props.batch === false ? false : props.batch || service.batch,
    textField: computed(() => api2.computedTextField()),
    valueField: computed(() => api2.computedValueField())
  });
  Object.assign(api2, {
    state,
    showDetail: index$1.showDetail(state),
    saveCache: index.saveCache({ props }),
    syncCacheIds: index.syncCacheIds({ props, state }),
    cacheUser: index.cacheUser({ api: api2, props, service, state }),
    initUser: index$1.initUser({ api: api2, props, state }),
    getUsers: index.getUsers({ api: api2, props, state }),
    showCard: index$1.showCard({ api: api2, service, state }),
    getUserImageUrl: service.getUserImageUrl,
    fetchW3Accounts: service.fetchW3Accounts,
    fetchUserByUserId: service.fetchUserByUserId,
    computedTextField: index$1.computedTextField({ service, props }),
    computedValueField: index$1.computedValueField({ service, props })
  });
  watch(() => props.modelValue, api2.initUser, { immediate: true });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
