"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleBlur", "searchMethod", "userChange", "visibleChange", "useSortable", "filter"];
const renderless = (props, { reactive, watch, computed, provide }, { emit, nextTick, vm, service, constants, dispatch }) => {
  const api2 = {};
  const $service = index.initService({ props, service });
  const state = reactive({
    loading: false,
    options: [],
    hisOptions: [],
    user: props.multiple ? [] : "",
    selected: [],
    visible: false,
    lastValue: null,
    type: props.valueField,
    sortable: null,
    overflow: false,
    addevnet: false,
    batch: props.batch === false ? false : props.batch || $service.batch,
    textField: computed(() => api2.computedTextField()),
    valueField: computed(() => api2.computedValueField())
  });
  Object.assign(api2, {
    state,
    fetchW3Accounts: $service.fetchW3Accounts,
    fetchSuggestUser: $service.fetchSuggestUser,
    fetchUserByUserId: $service.fetchUserByUserId,
    visibleChange: index.visibleChange({ state, emit }),
    saveCache: index.saveCache({ props }),
    updateCache: index.updateCache({ props, state }),
    autoSelect: index.autoSelect({ props, state, nextTick }),
    updateOptions: index.updateOptions({ props, state, nextTick }),
    handleBlur: index.handleBlur({ constants, dispatch, state, emit }),
    filter: index.filter({ props, state }),
    suggestUser: index.suggestUser(api2),
    cacheUser: index.cacheUser({ api: api2, props, service: $service, state }),
    initUser: index.initUser({ api: api2, props, state }),
    getUsers: index.getUsers({ api: api2, props, state }),
    setSelected: index.setSelected({ api: api2, props, state }),
    searchMethod: index.searchMethod({ api: api2, props, state, emit }),
    userChange: index.userChange({ api: api2, emit, props, state, dispatch, constants }),
    useSortable: index.useSortable({ api: api2, props, state, vm }),
    computedTextField: index.computedTextField({ service: $service, props }),
    computedValueField: index.computedValueField({ service: $service, props }),
    syncCacheIds: index.syncCacheIds({ props, state })
  });
  props.cache && api2.updateCache();
  watch(() => props.modelValue, api2.initUser, { immediate: true });
  provide("showContent", props.showTips);
  provide("tips-max-width", props.maxWidth);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
