"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "onVsBoxChange",
  "onTreeChange",
  "getTreeInstance",
  "keepExpandStatus",
  "keepScrollTop",
  "refresh"
];
const renderless = (props, { reactive, watch, provide }, { nextTick, vm }) => {
  const api2 = {};
  const state = reactive({
    expandeds: [],
    treeOptions: {},
    treeEvents: {},
    vsBoxOptions: {},
    renderRows: [],
    treeStyle: {}
  });
  Object.assign(api2, {
    state,
    computeState: index.computeState({ props, state }),
    shouldRender: index.shouldRender(state),
    onVsBoxChange: index.onVsBoxChange({ props, state }),
    onTreeChange: index.onTreeChange({ nextTick, props, state, vm }),
    getTreeInstance: index.getTreeInstance(vm),
    keepExpandStatus: index.keepExpandStatus(state),
    keepScrollTop: index.keepScrollTop(state),
    refresh: index.refresh({ api: api2, state, vm })
  });
  provide("TreeAdapter", { shouldRender: api2.shouldRender });
  watch(
    () => props.treeOp.data,
    () => api2.refresh(),
    { immediate: true }
  );
  return api2;
};
exports.api = api;
exports.renderless = renderless;
