"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "created",
  "loadPickerData",
  "wheelChanged",
  "changeWheelItemStyle",
  "loadWheels",
  "createWheelHasFooter",
  "createWheelNoFooter",
  "wheelsTo",
  "refreshWheel",
  "dealWheels",
  "clickWheelItem"
];
const initState = (reactive) => {
  const state = reactive({
    dataSource: [],
    defaultSelectedIndexs: [],
    pickerData: [],
    wheels: [],
    prevSelectedIndexs: []
  });
  return state;
};
const initApi = ({ api: api2, props, state, emit, nextTick, refs, BScroll }) => {
  Object.assign(api2, {
    state,
    created: index.created(api2),
    loadPickerData: index.loadPickerData({ props, state }),
    wheelChanged: index.wheelChanged({ api: api2, state }),
    changeWheelItemStyle: index.changeWheelItemStyle(state),
    loadWheels: index.loadWheels({ api: api2, props, state, nextTick, refs }),
    createWheelHasFooter: index.createWheelHasFooter({ api: api2, state, emit, BScroll }),
    createWheelNoFooter: index.createWheelNoFooter({ api: api2, state, BScroll }),
    wheelsTo: index.wheelsTo({ api: api2, state, nextTick }),
    refreshWheel: index.refreshWheel(nextTick),
    dealWheels: index.dealWheels(state),
    clickWheelItem: index.clickWheelItem({ api: api2, state, emit })
  });
};
const initWatch = ({ watch, api: api2, props, state, nextTick }) => {
  watch(
    () => props.defaultSelectedIndexs,
    () => {
      api2.dealWheels(state);
      nextTick(() => {
        api2.created(api2);
      });
    }
  );
};
const renderless = (props, { onMounted, reactive, watch }, { emit, nextTick, refs }, { BScroll }) => {
  const api2 = {};
  const state = initState(reactive);
  initApi({ api: api2, props, state, emit, nextTick, refs, BScroll });
  initWatch({ watch, api: api2, props, state, nextTick });
  onMounted(() => {
    api2.created(api2);
  });
  return api2;
};
exports.api = api;
exports.renderless = renderless;
