"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = [
  "state",
  "btnSaveHandle",
  "nodeClick",
  "submitHandle",
  "lastStepHandle",
  "nextStepHandle",
  "showNode"
];
const renderless = (props, { onMounted, reactive }, { emit, constants, designConfig }) => {
  var _a;
  const state = reactive({
    datas: props.data,
    submitShow: false,
    doing: constants.DOING_STATUS,
    ready: constants.READY_STATUS,
    wait: constants.WAIT_STATUS,
    iconYes: ((_a = designConfig == null ? void 0 : designConfig.icons) == null ? void 0 : _a.IconYes) || "tiny-icon-successful"
  });
  const api2 = {
    state,
    nodeClick: index.nodeClick(emit),
    showNode: index.showNode(emit),
    nextStepHandle: index.nextStepHandle({ state, emit }),
    lastStepHandle: index.lastStepHandle({ state, emit }),
    submitHandle: index.submitHandle({ state, emit }),
    btnSaveHandle: index.btnSaveHandle({ state, emit }),
    setTimelineflowNodeStatus: index.setTimelineflowNodeStatus(state)
  };
  api2.timelineflowData = index.timelineflowData({ state, props, api: api2 });
  onMounted(api2.timelineflowData);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
