"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const index$1 = require("../common/index.js");
const dateUtil = require("../common/deps/date-util.js");
const api = [
  "state",
  "rightNextYear",
  "handleRangePick",
  "handleShortcutClick",
  "handleChangeRange",
  "leftPrevYear"
];
const initState = ({ reactive, computed, api: api2, t }) => {
  const state = reactive({
    selectionMode: index$1.DATEPICKER.YearRange,
    popperClass: "",
    value: [],
    defaultValue: null,
    defaultTime: null,
    minDate: "",
    maxDate: "",
    leftDate: /* @__PURE__ */ new Date(),
    rightDate: dateUtil.nextYear(/* @__PURE__ */ new Date()),
    rangeState: { startDate: null, endDate: null, selecting: false, row: null, column: null },
    shortcuts: "",
    visible: "",
    disabledDate: "",
    format: "",
    arrowControl: false,
    unlinkPanels: false,
    leftStartYear: Math.floor((/* @__PURE__ */ new Date()).getFullYear() / 10) * 10,
    rightStartYear: computed(() => state.leftStartYear + index$1.DATEPICKER.PanelYearNum),
    btnDisabled: computed(
      () => !(state.minDate && state.maxDate && !state.selecting && api2.isValidValue([state.minDate, state.maxDate]))
    ),
    leftLabel: computed(
      () => `${state.leftStartYear} ${t("ui.datepicker.year")} - ${state.leftStartYear + index$1.DATEPICKER.PanelYearNum - 1} ${t(
        "ui.datepicker.year"
      )}`
    ),
    rightLabel: computed(
      () => `${state.rightStartYear} ${t("ui.datepicker.year")} - ${state.rightStartYear + index$1.DATEPICKER.PanelYearNum - 1} ${t(
        "ui.datepicker.year"
      )}`
    )
  });
  return state;
};
const renderless = (props, { computed, reactive, watch }, { t, emit: $emit }) => {
  const emit = props.emitter ? props.emitter.emit : $emit;
  const api2 = {};
  const state = initState({ reactive, computed, api: api2, t });
  Object.assign(api2, {
    state,
    doPick: index.doPick(emit),
    resetView: index.resetView(state),
    watchValue: index.watchValue({ state }),
    isValidValue: index.isValidValue(state),
    leftPrevYear: index.leftPrevYear(state),
    rightNextYear: index.rightNextYear(state),
    handleClear: index.handleClear({ emit, state }),
    handleChangeRange: index.handleChangeRange(state),
    handleShortcutClick: index.handleShortcutClick(api2),
    watchDefaultValue: index.watchDefaultValue({ state }),
    handleConfirm: index.handleConfirm({ api: api2, emit, state }),
    handleRangePick: index.handleRangePick({ api: api2, state })
  });
  watch(() => state.value, api2.watchValue);
  watch(() => state.defaultValue, api2.watchDefaultValue);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
