"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("./index.js");
const api = ["state", "handleYearTableClick", "handleMouseMove", "getIsDisabled", "getIsCurrent", "getIsDefault"];
const renderless = (props, { computed, reactive, watch }, { emit, vm }) => {
  const api2 = {};
  const state = reactive({
    tableRows: [[], [], []],
    rows: computed(() => api2.getRows()),
    currentYear: (/* @__PURE__ */ new Date()).getFullYear()
  });
  Object.assign(api2, {
    state,
    handleYearTableClick: index.handleYearTableClick({ emit, props }),
    markRange: index.markRange({ props, state }),
    watchDate: index.watchDate({ api: api2, props }),
    getRows: index.getRows({ props, state, vm }),
    handleMouseMove: index.handleMouseMove({ emit, props, state }),
    getIsDisabled: index.getIsDisabled({ props }),
    getIsCurrent: index.getIsCurrent({ props }),
    getIsDefault: index.getIsDefault({ props })
  });
  watch(
    () => props.rangeState,
    (value, oldValue) => value !== oldValue && api2.markRange(props.minDate, value.endDate),
    { deep: true }
  );
  watch(() => props.minDate, api2.watchDate);
  watch(() => props.maxDate, api2.watchDate);
  return api2;
};
exports.api = api;
exports.renderless = renderless;
