"use strict";
require("../../index.js");
const api = require("../../lib/export/api.js");
const util = require("../../../../../zrender@5.4.1/node_modules/zrender/lib/core/util.js");
function isEmptyObject(obj) {
  for (var key in obj) {
    if (obj.hasOwnProperty(key)) {
      return false;
    }
  }
  return true;
}
api.extendComponentView({
  type: "bmap",
  render: function(bMapModel, ecModel, api2) {
    var rendering = true;
    var bmap = bMapModel.getBMap();
    var viewportRoot = api2.getZr().painter.getViewportRoot();
    var coordSys = bMapModel.coordinateSystem;
    var moveHandler = function(type, target) {
      if (rendering) {
        return;
      }
      var offsetEl = viewportRoot.parentNode.parentNode.parentNode;
      var mapOffset = [-parseInt(offsetEl.style.left, 10) || 0, -parseInt(offsetEl.style.top, 10) || 0];
      var viewportRootStyle = viewportRoot.style;
      var offsetLeft = mapOffset[0] + "px";
      var offsetTop = mapOffset[1] + "px";
      if (viewportRootStyle.left !== offsetLeft) {
        viewportRootStyle.left = offsetLeft;
      }
      if (viewportRootStyle.top !== offsetTop) {
        viewportRootStyle.top = offsetTop;
      }
      coordSys.setMapOffset(mapOffset);
      bMapModel.__mapOffset = mapOffset;
      api2.dispatchAction({
        type: "bmapRoam",
        animation: {
          duration: 0
        }
      });
    };
    function zoomEndHandler() {
      if (rendering) {
        return;
      }
      api2.dispatchAction({
        type: "bmapRoam",
        animation: {
          duration: 0
        }
      });
    }
    bmap.removeEventListener("moving", this._oldMoveHandler);
    bmap.removeEventListener("moveend", this._oldMoveHandler);
    bmap.removeEventListener("zoomend", this._oldZoomEndHandler);
    bmap.addEventListener("moving", moveHandler);
    bmap.addEventListener("moveend", moveHandler);
    bmap.addEventListener("zoomend", zoomEndHandler);
    this._oldMoveHandler = moveHandler;
    this._oldZoomEndHandler = zoomEndHandler;
    var roam = bMapModel.get("roam");
    if (roam && roam !== "scale") {
      bmap.enableDragging();
    } else {
      bmap.disableDragging();
    }
    if (roam && roam !== "move") {
      bmap.enableScrollWheelZoom();
      bmap.enableDoubleClickZoom();
      bmap.enablePinchToZoom();
    } else {
      bmap.disableScrollWheelZoom();
      bmap.disableDoubleClickZoom();
      bmap.disablePinchToZoom();
    }
    var originalStyle = bMapModel.__mapStyle;
    var newMapStyle = bMapModel.get("mapStyle") || {};
    var mapStyleStr = JSON.stringify(newMapStyle);
    if (JSON.stringify(originalStyle) !== mapStyleStr) {
      if (!isEmptyObject(newMapStyle)) {
        bmap.setMapStyle(util.clone(newMapStyle));
      }
      bMapModel.__mapStyle = JSON.parse(mapStyleStr);
    }
    var originalStyle2 = bMapModel.__mapStyle2;
    var newMapStyle2 = bMapModel.get("mapStyleV2") || {};
    var mapStyleStr2 = JSON.stringify(newMapStyle2);
    if (JSON.stringify(originalStyle2) !== mapStyleStr2) {
      if (!isEmptyObject(newMapStyle2)) {
        bmap.setMapStyleV2(util.clone(newMapStyle2));
      }
      bMapModel.__mapStyle2 = JSON.parse(mapStyleStr2);
    }
    rendering = false;
  }
});
