"use strict";
require("../../index.js");
const BMapCoordSys = require("./BMapCoordSys.js");
require("./BMapModel.js");
require("./BMapView.js");
const echarts = require("../../lib/core/echarts.js");
echarts.registerCoordinateSystem("bmap", BMapCoordSys.default);
echarts.registerAction({
  type: "bmapRoam",
  event: "bmapRoam",
  update: "updateLayout"
}, function(payload, ecModel) {
  ecModel.eachComponent("bmap", function(bMapModel) {
    var bmap = bMapModel.getBMap();
    var center = bmap.getCenter();
    bMapModel.setCenterAndZoom([center.lng, center.lat], bmap.getZoom());
  });
});
