"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const SunburstView = require("./SunburstView.js");
const SunburstSeries = require("./SunburstSeries.js");
const sunburstLayout = require("./sunburstLayout.js");
const sunburstVisual = require("./sunburstVisual.js");
const dataFilter = require("../../processor/dataFilter.js");
const util = require("../../../../../../zrender@5.4.1/node_modules/zrender/lib/core/util.js");
const sunburstAction = require("./sunburstAction.js");
function install(registers) {
  registers.registerChartView(SunburstView.default);
  registers.registerSeriesModel(SunburstSeries.default);
  registers.registerLayout(util.curry(sunburstLayout.default, "sunburst"));
  registers.registerProcessor(util.curry(dataFilter.default, "sunburst"));
  registers.registerVisual(sunburstVisual.default);
  sunburstAction.installSunburstAction(registers);
}
exports.install = install;
