"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const conditionalExpression = require("../../util/conditionalExpression.js");
const util = require("../../../../../../zrender@5.4.1/node_modules/zrender/lib/core/util.js");
const log = require("../../util/log.js");
var filterTransform = {
  type: "echarts:filter",
  // PEDING: enhance to filter by index rather than create new data
  transform: function(params) {
    var upstream = params.upstream;
    var rawItem;
    var condition = conditionalExpression.parseConditionalExpression(params.config, {
      valueGetterAttrMap: util.createHashMap({
        dimension: true
      }),
      prepareGetValue: function(exprOption) {
        var errMsg = "";
        var dimLoose = exprOption.dimension;
        if (!util.hasOwn(exprOption, "dimension")) {
          if (process.env.NODE_ENV !== "production") {
            errMsg = log.makePrintable('Relation condition must has prop "dimension" specified.', "Illegal condition:", exprOption);
          }
          log.throwError(errMsg);
        }
        var dimInfo = upstream.getDimensionInfo(dimLoose);
        if (!dimInfo) {
          if (process.env.NODE_ENV !== "production") {
            errMsg = log.makePrintable("Can not find dimension info via: " + dimLoose + ".\n", "Existing dimensions: ", upstream.cloneAllDimensionInfo(), ".\n", "Illegal condition:", exprOption, ".\n");
          }
          log.throwError(errMsg);
        }
        return {
          dimIdx: dimInfo.index
        };
      },
      getValue: function(param) {
        return upstream.retrieveValueFromItem(rawItem, param.dimIdx);
      }
    });
    var resultData = [];
    for (var i = 0, len = upstream.count(); i < len; i++) {
      rawItem = upstream.getRawDataItem(i);
      if (condition.evaluate()) {
        resultData.push(rawItem);
      }
    }
    return {
      data: resultData
    };
  }
};
exports.filterTransform = filterTransform;
