"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const util = require("../../../../../../zrender@5.4.1/node_modules/zrender/lib/core/util.js");
const createSeriesData = require("../../chart/helper/createSeriesData.js");
const axisHelper = require("../../coord/axisHelper.js");
const axisModelCommonMixin = require("../../coord/axisModelCommonMixin.js");
const Model = require("../../model/Model.js");
const layout = require("../../util/layout.js");
const dataStackHelper = require("../../data/helper/dataStackHelper.js");
const innerStore = require("../../util/innerStore.js");
const labelStyle = require("../../label/labelStyle.js");
const createDimensions = require("../../data/helper/createDimensions.js");
const symbol = require("../../util/symbol.js");
const states = require("../../util/states.js");
function createList(seriesModel) {
  return createSeriesData.default(null, seriesModel);
}
var dataStack = {
  isDimensionStacked: dataStackHelper.isDimensionStacked,
  enableDataStack: dataStackHelper.enableDataStack,
  getStackedDimension: dataStackHelper.getStackedDimension
};
function createScale(dataExtent, option) {
  var axisModel = option;
  if (!(option instanceof Model.default)) {
    axisModel = new Model.default(option);
  }
  var scale = axisHelper.createScaleByModel(axisModel);
  scale.setExtent(dataExtent[0], dataExtent[1]);
  axisHelper.niceScaleExtent(scale, axisModel);
  return scale;
}
function mixinAxisModelCommonMethods(Model2) {
  util.mixin(Model2, axisModelCommonMixin.AxisModelCommonMixin);
}
function createTextStyle(textStyleModel, opts) {
  opts = opts || {};
  return labelStyle.createTextStyle(textStyleModel, null, null, opts.state !== "normal");
}
exports.getLayoutRect = layout.getLayoutRect;
exports.getECData = innerStore.getECData;
exports.createDimensions = createDimensions.createDimensions;
exports.createSymbol = symbol.createSymbol;
exports.enableHoverEmphasis = states.enableHoverEmphasis;
exports.createList = createList;
exports.createScale = createScale;
exports.createTextStyle = createTextStyle;
exports.dataStack = dataStack;
exports.mixinAxisModelCommonMethods = mixinAxisModelCommonMethods;
