"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const quill = require("./core/quill.js");
const block = require("./blots/block.js");
const _break = require("./blots/break.js");
const container = require("./blots/container.js");
const cursor = require("./blots/cursor.js");
const embed = require("./blots/embed.js");
const inline = require("./blots/inline.js");
const scroll = require("./blots/scroll.js");
const text = require("./blots/text.js");
const clipboard = require("./modules/clipboard.js");
const history = require("./modules/history.js");
const keyboard = require("./modules/keyboard.js");
const uploader = require("./modules/uploader.js");
const Delta = require("../../../../../_virtual/Delta.js");
const input = require("./modules/input.js");
const uiNode = require("./modules/uiNode.js");
quill.default.register({
  "blots/block": block.default,
  "blots/block/embed": block.BlockEmbed,
  "blots/break": _break.default,
  "blots/container": container.default,
  "blots/cursor": cursor.default,
  "blots/embed": embed.default,
  "blots/inline": inline.default,
  "blots/scroll": scroll.default,
  "blots/text": text.default,
  "modules/clipboard": clipboard.default,
  "modules/history": history.default,
  "modules/keyboard": keyboard.default,
  "modules/uploader": uploader.default,
  "modules/input": input.default,
  "modules/uiNode": uiNode.default
});
exports.default = quill.default;
exports.Delta = Delta.default;
exports.AttributeMap = DeltaExports.AttributeMap;
exports.Op = DeltaExports.Op;
