"use strict";
var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const block = require("../blots/block.js");
const _break = require("../blots/break.js");
const cursor = require("../blots/cursor.js");
const inline = require("../blots/inline.js");
const text = require("../blots/text.js");
const container = require("../blots/container.js");
const quill = require("../core/quill.js");
class CodeBlockContainer extends container.default {
  static create(value) {
    const domNode = super.create(value);
    domNode.setAttribute("spellcheck", "false");
    return domNode;
  }
  code(index, length) {
    return this.children.map((child) => child.length() <= 1 ? "" : child.domNode.innerText).join("\n").slice(index, index + length);
  }
  html(index, length) {
    return `<pre>
${text.escapeText(this.code(index, length))}
</pre>`;
  }
}
class CodeBlock extends block.default {
  static register() {
    quill.default.register(CodeBlockContainer);
  }
}
__publicField(CodeBlock, "TAB", "  ");
class Code extends inline.default {
}
Code.blotName = "code";
Code.tagName = "CODE";
CodeBlock.blotName = "code-block";
CodeBlock.className = "ql-code-block";
CodeBlock.tagName = "DIV";
CodeBlockContainer.blotName = "code-block-container";
CodeBlockContainer.className = "ql-code-block-container";
CodeBlockContainer.tagName = "DIV";
CodeBlockContainer.allowedChildren = [CodeBlock];
CodeBlock.allowedChildren = [text.default, _break.default, cursor.default];
CodeBlock.requiredContainer = CodeBlockContainer;
exports.Code = Code;
exports.CodeBlockContainer = CodeBlockContainer;
exports.default = CodeBlock;
