"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const parchment = require("../../../../parchment@3.0.0/node_modules/parchment/dist/parchment.js");
class ColorAttributor extends parchment.StyleAttributor {
  value(domNode) {
    let value = super.value(domNode);
    if (!value.startsWith("rgb(")) return value;
    value = value.replace(/^[^\d]+/, "").replace(/[^\d]+$/, "");
    const hex = value.split(",").map((component) => `00${parseInt(component, 10).toString(16)}`.slice(-2)).join("");
    return `#${hex}`;
  }
}
const ColorClass = new parchment.ClassAttributor("color", "ql-color", {
  scope: parchment.Scope.INLINE
});
const ColorStyle = new ColorAttributor("color", "color", {
  scope: parchment.Scope.INLINE
});
exports.ColorAttributor = ColorAttributor;
exports.ColorClass = ColorClass;
exports.ColorStyle = ColorStyle;
