"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
require("./core.js");
const align = require("./formats/align.js");
const direction = require("./formats/direction.js");
const indent = require("./formats/indent.js");
const blockquote = require("./formats/blockquote.js");
const header = require("./formats/header.js");
const list = require("./formats/list.js");
const background = require("./formats/background.js");
const color = require("./formats/color.js");
const font = require("./formats/font.js");
const size = require("./formats/size.js");
const bold = require("./formats/bold.js");
const italic = require("./formats/italic.js");
const link = require("./formats/link.js");
const script = require("./formats/script.js");
const strike = require("./formats/strike.js");
const underline = require("./formats/underline.js");
const formula = require("./formats/formula.js");
const image = require("./formats/image.js");
const video = require("./formats/video.js");
const code = require("./formats/code.js");
const syntax = require("./modules/syntax.js");
const table = require("./modules/table.js");
const toolbar = require("./modules/toolbar.js");
const icons = require("./ui/icons.js");
const picker = require("./ui/picker.js");
const colorPicker = require("./ui/color-picker.js");
const iconPicker = require("./ui/icon-picker.js");
const tooltip = require("./ui/tooltip.js");
const bubble = require("./themes/bubble.js");
const snow = require("./themes/snow.js");
const quill = require("./core/quill.js");
quill.default.register({
  "attributors/attribute/direction": direction.DirectionAttribute,
  "attributors/class/align": align.AlignClass,
  "attributors/class/background": background.BackgroundClass,
  "attributors/class/color": color.ColorClass,
  "attributors/class/direction": direction.DirectionClass,
  "attributors/class/font": font.FontClass,
  "attributors/class/size": size.SizeClass,
  "attributors/style/align": align.AlignStyle,
  "attributors/style/background": background.BackgroundStyle,
  "attributors/style/color": color.ColorStyle,
  "attributors/style/direction": direction.DirectionStyle,
  "attributors/style/font": font.FontStyle,
  "attributors/style/size": size.SizeStyle
}, true);
quill.default.register({
  "formats/align": align.AlignClass,
  "formats/direction": direction.DirectionClass,
  "formats/indent": indent.default,
  "formats/background": background.BackgroundStyle,
  "formats/color": color.ColorStyle,
  "formats/font": font.FontClass,
  "formats/size": size.SizeClass,
  "formats/blockquote": blockquote.default,
  "formats/code-block": code.default,
  "formats/header": header.default,
  "formats/list": list.default,
  "formats/bold": bold.default,
  "formats/code": code.Code,
  "formats/italic": italic.default,
  "formats/link": link.default,
  "formats/script": script.default,
  "formats/strike": strike.default,
  "formats/underline": underline.default,
  "formats/formula": formula.default,
  "formats/image": image.default,
  "formats/video": video.default,
  "modules/syntax": syntax.default,
  "modules/table": table.default,
  "modules/toolbar": toolbar.default,
  "themes/bubble": bubble.default,
  "themes/snow": snow.default,
  "ui/icons": icons.default,
  "ui/picker": picker.default,
  "ui/icon-picker": iconPicker.default,
  "ui/color-picker": colorPicker.default,
  "ui/tooltip": tooltip.default
}, true);
exports.default = quill.default;
exports.AttributeMap = DeltaExports.AttributeMap;
exports.Op = DeltaExports.Op;
