"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const hooks = require("vue");
const util = require("../lazyload/vue-lazyload/util.js");
const index_esm = require("../../../../../@vant_use@1.6.0_vue@3.5.13_typescript@5.7.3_/node_modules/@vant/use/dist/index.esm.js");
const index = require("../icon/index.js");
const props = require("../utils/props.js");
const create = require("../utils/create.js");
const basic = require("../utils/basic.js");
const format = require("../utils/format.js");
const dom = require("../utils/dom.js");
const [name, bem] = create.createNamespace("back-top");
const backTopProps = {
  right: props.numericProp,
  bottom: props.numericProp,
  zIndex: props.numericProp,
  target: [String, Object],
  offset: props.makeNumericProp(200),
  immediate: Boolean,
  teleport: {
    type: [String, Object],
    default: "body"
  }
};
var stdin_default = hooks.defineComponent({
  name,
  inheritAttrs: false,
  props: backTopProps,
  emits: ["click"],
  setup(props2, {
    emit,
    slots,
    attrs
  }) {
    let shouldReshow = false;
    const show = hooks.ref(false);
    const root = hooks.ref();
    const scrollParent = hooks.ref();
    const style = hooks.computed(() => basic.extend(format.getZIndexStyle(props2.zIndex), {
      right: format.addUnit(props2.right),
      bottom: format.addUnit(props2.bottom)
    }));
    const onClick = (event) => {
      var _a;
      emit("click", event);
      (_a = scrollParent.value) == null ? void 0 : _a.scrollTo({
        top: 0,
        behavior: props2.immediate ? "auto" : "smooth"
      });
    };
    const scroll = () => {
      show.value = scrollParent.value ? dom.getScrollTop(scrollParent.value) >= +props2.offset : false;
    };
    const getTarget = () => {
      const {
        target
      } = props2;
      if (typeof target === "string") {
        const el = document.querySelector(target);
        if (el) {
          return el;
        }
        if (process.env.NODE_ENV !== "production") {
          console.error(`[Vant] BackTop: target element "${target}" was not found, the BackTop component will not be rendered.`);
        }
      } else {
        return target;
      }
    };
    const updateTarget = () => {
      if (basic.inBrowser) {
        hooks.nextTick(() => {
          scrollParent.value = props2.target ? getTarget() : index_esm.getScrollParent(root.value);
          scroll();
        });
      }
    };
    index_esm.useEventListener("scroll", util.throttle(scroll, 100), {
      target: scrollParent
    });
    hooks.onMounted(updateTarget);
    hooks.onActivated(() => {
      if (shouldReshow) {
        show.value = true;
        shouldReshow = false;
      }
    });
    hooks.onDeactivated(() => {
      if (show.value && props2.teleport) {
        show.value = false;
        shouldReshow = true;
      }
    });
    hooks.watch(() => props2.target, updateTarget);
    return () => {
      const Content = hooks.createVNode("div", hooks.mergeProps({
        "ref": !props2.teleport ? root : void 0,
        "class": bem({
          active: show.value
        }),
        "style": style.value,
        "onClick": onClick
      }, attrs), [slots.default ? slots.default() : hooks.createVNode(index.Icon, {
        "name": "back-top",
        "class": bem("icon")
      }, null)]);
      if (props2.teleport) {
        return [hooks.createVNode("div", {
          "ref": root,
          "class": bem("placeholder")
        }, null), hooks.createVNode(hooks.Teleport, {
          "to": props2.teleport
        }, {
          default: () => [Content]
        })];
      }
      return Content;
    };
  }
});
exports.backTopProps = backTopProps;
exports.default = stdin_default;
