"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const hooks = require("vue");
const useScopeId = require("../composables/use-scope-id.js");
const props = require("../utils/props.js");
const create = require("../utils/create.js");
const constant = require("../utils/constant.js");
const [name, bem] = create.createNamespace("cell-group");
const cellGroupProps = {
  title: String,
  inset: Boolean,
  border: props.truthProp
};
var stdin_default = hooks.defineComponent({
  name,
  inheritAttrs: false,
  props: cellGroupProps,
  setup(props2, {
    slots,
    attrs
  }) {
    const renderGroup = () => {
      var _a;
      return hooks.createVNode("div", hooks.mergeProps({
        "class": [bem({
          inset: props2.inset
        }), {
          [constant.BORDER_TOP_BOTTOM]: props2.border && !props2.inset
        }]
      }, attrs, useScopeId.useScopeId()), [(_a = slots.default) == null ? void 0 : _a.call(slots)]);
    };
    const renderTitle = () => hooks.createVNode("div", {
      "class": bem("title", {
        inset: props2.inset
      })
    }, [slots.title ? slots.title() : props2.title]);
    return () => {
      if (props2.title || slots.title) {
        return hooks.createVNode(hooks.Fragment, null, [renderTitle(), renderGroup()]);
      }
      return renderGroup();
    };
  }
});
exports.cellGroupProps = cellGroupProps;
exports.default = stdin_default;
