"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index_esm = require("../../../../../@vant_use@1.6.0_vue@3.5.13_typescript@5.7.3_/node_modules/@vant/use/dist/index.esm.js");
const hooks = require("vue");
const onPopupReopen = require("./on-popup-reopen.js");
const dom = require("../utils/dom.js");
const useHeight = (element, withSafeArea) => {
  const height = hooks.ref();
  const setHeight = () => {
    height.value = index_esm.useRect(element).height;
  };
  hooks.onMounted(() => {
    hooks.nextTick(setHeight);
    if (withSafeArea) {
      for (let i = 1; i <= 3; i++) {
        setTimeout(setHeight, 100 * i);
      }
    }
  });
  onPopupReopen.onPopupReopen(() => hooks.nextTick(setHeight));
  hooks.watch([dom.windowWidth, dom.windowHeight], setHeight);
  return height;
};
exports.useHeight = useHeight;
