"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const hooks = require("vue");
const useSyncPropRef = (getProp, setProp) => {
  const propRef = hooks.ref(getProp());
  hooks.watch(getProp, (value) => {
    if (value !== propRef.value) {
      propRef.value = value;
    }
  });
  hooks.watch(propRef, (value) => {
    if (value !== getProp()) {
      setProp(value);
    }
  });
  return propRef;
};
exports.useSyncPropRef = useSyncPropRef;
